<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingCobalt extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'cobalt');
			$this->params = new acyParameter( $plugin->params );
		}

		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
	}

	function acymailing_getPluginType(){
		$app = JFactory::getApplication();
	 	if($this->params->get('frontendaccess') == 'none' && !$app->isAdmin()) return;
	 	$onePlugin = new stdClass();
	 	$onePlugin->name = 'Cobalt';
	 	$onePlugin->function = 'acymailing_cobalt_show';
	 	$onePlugin->help = 'plugin-cobalt';
	 	return $onePlugin;
	}

	function acymailing_cobalt_show(){

	 	$config = acymailing_config();
		if($config->get('version') < '4.9.4'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$lang = JFactory::getLanguage();
		$lang->load('com_cobalt',JPATH_SITE);
		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.cobalt';

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order',	'a.id','cmd' );
		$pageInfo->filter->order->dir = $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir',	'desc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->titlelink = $app->getUserStateFromRequest( $paramBase.".titlelink", 'titlelink','1','string' );
		$pageInfo->download = $app->getUserStateFromRequest( $paramBase.".download", 'download','1','string' );
		$pageInfo->contenttype = $app->getUserStateFromRequest( $paramBase.".contenttype", 'contenttype','intro','string' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->autotitlelink = $app->getUserStateFromRequest( $paramBase.".autotitlelink", 'autotitlelink','1','string' );
		$pageInfo->automaxvalue = $app->getUserStateFromRequest( $paramBase.".max", 'max','20','int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id','string' );
		$pageInfo->contentorderdir = $app->getUserStateFromRequest( $paramBase.".contentorderdir", 'contentorderdir','DESC','string' );
		$pageInfo->autocontenttype = $app->getUserStateFromRequest( $paramBase.".autocontenttype", 'autocontenttype','intro','string' );
		$pageInfo->downloadauto = $app->getUserStateFromRequest( $paramBase.".download", 'download','1','string' );
		$pageInfo->clickable = $app->getUserStateFromRequest( $paramBase.".clickable", 'clickable','1','string' );
		$pageInfo->clickableauto = $app->getUserStateFromRequest( $paramBase.".clickableauto", 'clickableauto','1','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->autopict = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight',$this->params->get('maxheight',150),'string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth',$this->params->get('maxwidth',150),'string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->autoreadmore = $app->getUserStateFromRequest( $paramBase.".autoreadmore", 'autoreadmore','1','string' );
		$pageInfo->wrap = $app->getUserStateFromRequest( $paramBase.".wrap", 'wrap','0','string' );

		$db = JFactory::getDBO();

		$searchFields = array('a.id','a.title','b.title','c.username');

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayart','all') == 'onlypub'){
			$filters[] = "a.published = 1";
		}else{
			$filters[] = "a.published != -2";
		}

		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*,b.*,c.*, a.id AS artid,a.title AS arttitle ' .
				'FROM `#__js_res_record` AS a ' .
				'LEFT JOIN #__js_res_categories AS b ' .
					'ON a.categories LIKE CONCAT("%\"",b.id,"\":\"",b.title,"\"%") ' .
				'LEFT JOIN `#__users` AS c ' .
					'ON a.user_id = c.id';

		if(!empty($pageInfo->filter_cat)) $filters[] = 'b.id = '.intval($pageInfo->filter_cat);

		if(!empty($filters)){
			$query .= ' WHERE ('.implode(') AND (',$filters).')';
		}

		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}
		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search,$rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		$type = JRequest::getString('type');
	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass){
				var tmp = selectedContents.indexOf(contentid);
				if(tmp != -1){
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('catall').className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('catall').className = 'selectedrow';
						var key;
						for(key in selectedCat){
							if(isNaN(key)) continue;
							window.document.getElementById('cat'+key).className = rowClass;
							delete selectedCat[key];
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat'+catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp=0;
				for(var i=0; i < document.adminForm.cbaffiche.length; i++){
					 if (document.adminForm.cbaffiche[i].checked){
					 	if(tmp==0){
					 		tmp+=1;
					 		otherinfo += "| display:";
					 		otherinfo += document.adminForm.cbaffiche[i].value;
					 	}else{
					 		otherinfo += ", ";
					 		otherinfo += document.adminForm.cbaffiche[i].value;
					 	}
					 }
				}
				for(var i=0; i < document.adminForm.clickable.length; i++){
					 if (document.adminForm.clickable[i].checked){ otherinfo += '| clickable:'+document.adminForm.clickable[i].value;}
				}
				for(var i=0; i < document.adminForm.readmore.length; i++){
					 if (document.adminForm.readmore[i].checked){
					 	otherinfo += '| readmore:'+document.adminForm.readmore[i].value;
					 }
				}
				for(var i=0; i < document.adminForm.pict.length; i++){
					 if (document.adminForm.pict[i].checked){ otherinfo += '| pict:'+document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized')
						{
					 		document.getElementById('pictsize').style.display = '';
					 		if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
					 		if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
					 	}else{
					 		document.getElementById('pictsize').style.display = 'none';
					 	}
					 }
				}
				if(document.adminForm.wrap.value && document.adminForm.wrap.value!=0){ otherinfo += "| wrap:"+document.adminForm.wrap.value; }

				for(i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{cobalt:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto(){
				var tag = '';
				var otherinfo = '';
				var tmp=0;
				for(var i=0; i < document.adminForm.cbafficheauto.length; i++){
					 if (document.adminForm.cbafficheauto[i].checked){
					 	if(tmp==0){
					 		tmp+=1;
					 		otherinfo += "| display:";
					 		otherinfo += document.adminForm.cbafficheauto[i].value;
					 	}else{
					 		otherinfo += ", ";
					 		otherinfo += document.adminForm.cbafficheauto[i].value;
					 	}
					 }
				}
				for(var i=0; i < document.adminForm.clickableauto.length; i++){
					 if (document.adminForm.clickableauto[i].checked){ otherinfo += '| clickable:'+document.adminForm.clickableauto[i].value;}
				}
				for(var i=0; i < document.adminForm.autoreadmore.length; i++){
					 if (document.adminForm.autoreadmore[i].checked){
					 	otherinfo += '| readmore:'+document.adminForm.autoreadmore[i].value;
					 }
				}
				tmp=0;
				for(var i=0; i < document.adminForm.autopict.length; i++){
					 if (document.adminForm.autopict[i].checked){
					 	otherinfo += '| pict:'+document.adminForm.autopict[i].value;
						if(document.adminForm.autopict[i].value == 'resized'){
					 		document.getElementById('pictsizeauto').style.display = '';
					 		if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidthauto.value;
					 		if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:'+document.adminForm.pictheightauto.value;
					 	}else{
					 		document.getElementById('pictsizeauto').style.display = 'none';
					 	}
					 }
				}
				if(document.adminForm.wrapauto && document.adminForm.wrapauto.value != 0){ otherinfo += "| wrap:"+document.adminForm.wrapauto.value; }
				if(document.adminForm.max_article.value){ otherinfo += "| max_article:"+document.adminForm.max_article.value; }
				if(document.adminForm.cols.value){ otherinfo += "| cols:"+document.adminForm.cols.value; }
				if(document.adminForm.contentorder.value){ otherinfo += "| order:"+document.adminForm.contentorder.value+","+document.adminForm.contentorderdir.value; }
				<?php if($type == 'autonews'){ ?>
				if(document.adminForm.min_article.value){ otherinfo += "| min_article:"+document.adminForm.min_article.value; }
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){ otherinfo += document.adminForm.contentfilter.value; }
				<?php } ?>
				tag = '{autocobalt:';
				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat+'-';
					}
				}
				tag+=otherinfo+'}<br />';
				setTag(tag);
			}
		//-->
		</script>
<?php
//we load cobalt's fields
		$fields = 'SELECT id, label FROM `#__js_res_fields` WHERE field_type != "passwd" ORDER BY label';
		$db->setQuery($fields);
		$fields = $db->loadObjectList();
		if(empty($fields)){
			if($app->isAdmin()) $app->enqueueMessage('The fields could not be loaded','notice');
			return false;
		}
		$clickable = array();
		$clickable[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$clickable[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized",JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$readmore = array();
		$readmore[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$readmore[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$column = array();
		for($i=1;$i<11;$i++){
			$column[] = JHTML::_('select.option', $i,$i);
		}

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane('cobalt_tab');
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), 'cobalt_listings');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="title" id="title" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="title" id="title-lbl"><?php echo JText::_('ACY_TITLE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="create" id="create" onclick="updateTag();"/><label style="margin-left:5px" for="create" id="create-lbl"><?php echo JText::_('CREATED_DATE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="modify" id="modify" onclick="updateTag();"/><label style="margin-left:5px" for="modify" id="modify-lbl"><?php echo JText::_('MODIFIED_DATE');?></label></td>
				<td/>
			</tr>
			<tr>
<?php
				$tmp=0;
				echo '<td/>';
				foreach($fields as $onefield){
					if($tmp==4){
						echo '</tr><tr><td/>';
						$tmp = 0;
					}
					echo '<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="'.intval($onefield->id).'" id="'.intval($onefield->id).'" onclick="updateTag();"/><label style="margin-left:5px" for="'.$onefield->id.'" id="'.$onefield->id.'-lbl">'.$onefield->label.'</label></td>';
					$tmp++;
				}
				while($tmp!=4){
					echo '<td/>';
					$tmp++;
				}
?>
			</tr>
			<tr>
				<td><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $clickable, 'clickable' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>
				<td valign="top"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td><?php echo JHTML::_('acyselect.radiolist', $readmore, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
			</tr>
			<tr>
				<td valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
				<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>
<!--====================================================================================LISTE DOCUMENTS===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th/>
					<th class="title">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );
						?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value );
						?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					for($i = 0;$i<count($rows);$i++){
						$row =& $rows[$i];
				?>
					<tr id="content<?php echo $row->artid; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->artid.",'row$k'"?>);" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
						<?php
							$text = '<b>'.JText::_('JOOMEXT_ALIAS').' : </b>'.$row->arttitle;
							$text .= '<br /><b>'.JText::_('ACY_USERNAME',true).' : </b>'.$row->username;
							echo acymailing_tooltip($text, $row->meta_descr, '', $row->arttitle);
						?>
						</td>
						<td>
						<?php
							if(!empty($row->title)){
								$text = '<b>'.JText::_('TAG_CATEGORIES',true).' : </b>'.$row->title;
								echo acymailing_tooltip($text, $row->title, '', $row->title);
							}
						?>
						</td>
						<td align="center" style="text-align:center" >
							<?php
								echo $row->artid;
							?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
<?php

		echo $tabs->endPanel();
		echo $tabs->startPanel( JText::_('TAG_CATEGORIES'), 'cobalt_auto');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="title" id="titleauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="titleauto" id="titleauto-lbl"><?php echo JText::_('ACY_TITLE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="create" id="createauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="createauto" id="createauto-lbl"><?php echo JText::_('CREATED_DATE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="modify" id="modifyauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="modifyauto" id="modifyauto-lbl"><?php echo JText::_('MODIFIED_DATE');?></label></td>
				<td/>
			</tr>
			<tr>
<?php
				$tmp=0;
				echo '<td/>';
				foreach($fields as $onefield){
					if($tmp==4){
						echo '</tr><tr><td/>';
						$tmp = 0;
					}
					echo '<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="'.$onefield->id.'" id="'.$onefield->id.'auto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$onefield->id.'auto" id="'.$onefield->id.'auto-lbl">'.$onefield->label.'</label></td>';
					$tmp++;
				}
				while($tmp!=4){
					echo '<td/>';
					$tmp++;
				}
?>
			</tr>
			<tr>
				<td><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $clickable, 'clickableauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
				<td valign="top"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td><?php echo JHTML::_('acyselect.radiolist', $readmore, 'autoreadmore' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autoreadmore); ?>
			</tr>
			<tr>
				<td valign="top">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict); ?>
					<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td valign="top"><?php echo JText::_('FIELD_COLUMNS'); ?></td>
				 <td colspan="4">
				 	<?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:75px;"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('MAX_ARTICLE'); ?>
				 </td>
				 <td>
				 	<input type="text" name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
				</td>
				<td>
				<?php echo JText::_('ACY_ORDER'); ?>
				 </td>
				 <td colspan="2">
				 	<?php
						$values = array('id' => 'ACY_ID', 'ctime' => 'CREATED_DATE', 'mtime' => 'MODIFIED_DATE', 'title' => 'FIELD_TITLE');
						echo $this->acypluginsHelper->getOrderingField($values, $pageInfo->contentorder, $pageInfo->contentorderdir);
					?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td>
				<?php 	echo JText::_('MIN_ARTICLE'); ?>
				 </td>
				 <td>
				 <input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td>
				<?php echo JText::_('JOOMEXT_FILTER'); ?>
				 </td>
				 <td colspan="2">
				 	<?php $filter = acymailing_get('type.contentfilter'); $filter->onclick='updateTagAuto();'; echo $filter->display('contentfilter',$pageInfo->contentfilter); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
<!--====================================================================================LISTE CATEGORIES===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<tr id="catall" class="<?php echo "row0"; ?>" onclick="applyAuto('all','<?php echo "row0" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td><?php echo JText::_('ACY_ALL'); ?></td>
			</tr>
		<?php
			$k = 1;
			foreach($this->catvalues as $oneCat){
				if(empty($oneCat->value)) continue;
		?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
		<?php $k = 1 - $k; } ?>
		</table>
<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){
		//select all cats
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$db->setQuery('SELECT id,parent_id,title FROM #__js_res_categories ORDER BY `id` DESC');
		$mosetCats = $db->loadObjectList();
		if(empty($mosetCats)){
			if($app->isAdmin()) $app->enqueueMessage('The categories could not be loaded','notice');
			return false;
		}
		$this->cats = array();
		foreach($mosetCats as $oneCat){
			$this->cats[$oneCat->parent_id][] = $oneCat;
		}
		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist',$this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	function _handleChildrens($parent_id=0,$level=0){
		if(empty($this->cats[$parent_id])) return;
		foreach($this->cats[$parent_id] as $cat){
			if($cat->title!="ROOT"){
				$this->catvalues[] = JHTML::_('select.option', $cat->id,str_repeat(" - - ",$level).$cat->title);
			}
			$this->_handleChildrens($cat->id,$level+1);
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
 		$this->_replaceOne($email);
	}

	private function _replaceOne(&$email){
		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, 'cobalt');
		if(empty($tags)) return;

		//We will need these files to replace fields
		require_once(JPATH_ROOT.DS.'components'.DS.'com_cobalt'.DS.'library'.DS.'php'.DS.'helpers'.DS.'helper.php');
		require_once(JPATH_SITE.DS.'components'.DS.'com_cobalt'.DS.'library'.DS.'php'.DS.'fields'.DS.'cobaltfield.php');
		require_once(JPATH_SITE.DS.'plugins'.DS.'acymailing'.DS.'cobalt'.DS.'cobaltfield.php');

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		//let's determine the Itemid
		$menuid = $this->params->get('itemid');
		if(empty($menuid)){
			$db = JFactory::getDBO();
			$db->setQuery('SELECT id FROM #__menu WHERE link LIKE "%index.php?option=com_cobalt&view=record%" LIMIT 1');
			$menuid = $db->loadResult();
		}
		$this->itemId = empty($menuid) ? '' : '&Itemid='.$menuid;

		$tagsReplaced = array();
		foreach($tags as $i => $oneTag){
			if(isset($tagsReplaced[$i])) continue;
			$tagsReplaced[$i] = $this->_replaceContent($oneTag);
		}

		$this->acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}

	function _replaceContent(&$tag){
		if(!empty($tag->display)){
			$tag->display = explode(',',$tag->display);

			foreach($tag->display as $i => $oneDisplay){
				$tag->display[$i] = trim($oneDisplay);
			}
		}

		//2 : Load the Cobalt article
		$query = 'SELECT * FROM `#__js_res_record` ';
		$query .= 'WHERE id = '.intval($tag->id);
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$article = $db->loadObject();
		//In case of we could not load the article for any reason...
		$app = JFactory::getApplication();
		$resultTitle = '';
		$created = '';
		$modified = '';
		$result = '';
		if(empty($article)){
			if($app->isAdmin()) $app->enqueueMessage('The article "'.$tag->id.'" could not be loaded','notice');
			return $result;
		}

		$link = 'index.php?option=com_cobalt&view=record&id='.$article->id.$this->itemId;
		$varFields['{link}'] = $link;

		if(in_array('title',$tag->display)){
			$styleTitle = '<h2 class="acymailing_title">';
			$styleTitleEnd = '</h2>';
			if(!empty($tag->clickable)){
				$resultTitle = '<tr><td colspan="2"><a href="'.$link.'" target="_blank" >'.$styleTitle.$article->title.$styleTitleEnd.'</a></td></tr>';
			}else{
				$resultTitle = $styleTitle.$article->title.$styleTitleEnd;
			}
		}

		if(in_array('create',$tag->display)) $created = '<tr><td nowrap="nowrap">'.JTEXT::_('CREATED_DATE').' : </td><td>'.$article->ctime.'</td></tr>';
		if(in_array('modify',$tag->display)) $modified = '<tr><td nowrap="nowrap">'.JTEXT::_('MODIFIED_DATE').' : </td><td>'.$article->mtime.'</td></tr>';

		if(empty($this->fieldTypes)){
			$db->setQuery('SELECT * FROM #__js_res_fields');
			$fields = $db->loadObjectList();
			$this->fieldTypes = array();
			foreach($fields as $i => $oneField){
				$this->fieldTypes[$oneField->id][1] = $oneField->field_type;
				$this->fieldTypes[$oneField->id][2] = $oneField;
			}
		}

		if(empty($this->section) || empty($this->section[$article->section_id])){
			$db->setQuery('SELECT * FROM #__js_res_sections WHERE id = '.$article->section_id);
			$this->section[$article->section_id] = $db->loadObjectList();
		}

		$itemfields = json_decode($article->fields);
		foreach($tag->display as $oneFieldToDisplay){
			if(in_array($oneFieldToDisplay, array('title','create','modify'))) continue;
			if(empty($this->fieldTypes[$oneFieldToDisplay]) || !isset($itemfields->$oneFieldToDisplay) || $this->fieldTypes[$oneFieldToDisplay][1] == 'passwd') continue;
			if(!empty($itemfields->$oneFieldToDisplay->image)){
				$CFormField = new AcyCFormField($this->fieldTypes[$oneFieldToDisplay][2],(array)$itemfields->$oneFieldToDisplay);
			}else{
				if(!is_array($itemfields->$oneFieldToDisplay) && preg_match('#{#i',$itemfields->$oneFieldToDisplay)){
					$CFormField = new AcyCFormField($this->fieldTypes[$oneFieldToDisplay][2],(array)json_decode($itemfields->$oneFieldToDisplay));
				}else{
					$CFormField = new AcyCFormField($this->fieldTypes[$oneFieldToDisplay][2],$itemfields->$oneFieldToDisplay);
					$CFormField->values = $itemfields->$oneFieldToDisplay;
					$CFormField->listtype = 2;
					if($this->fieldTypes[$oneFieldToDisplay][1] == 'boolean'){
						if($itemfields->$oneFieldToDisplay == 1) $CFormField->print = JText::_('JOOMEXT_YES');
						else $CFormField->print = JText::_('JOOMEXT_NO');
					}
				}
			}
			$htmlversion = $CFormField->_display_output('full',$article,null,$this->section[$article->section_id]);

			if($this->fieldTypes[$oneFieldToDisplay][1] == 'text' || $this->fieldTypes[$oneFieldToDisplay][1] == 'textarea' || $this->fieldTypes[$oneFieldToDisplay][1] == 'html'){
				$htmlversion = $this->acypluginsHelper->wrapText($htmlversion, $tag);
			}

			$varFields['{'.$CFormField->getLabel().'}'] = $htmlversion;

			if($this->fieldTypes[$oneFieldToDisplay][2]->params->get('core.show_lable') == 2 || $this->fieldTypes[$oneFieldToDisplay][2]->params->get('core.show_lable') == 3){
				$result .= '<tr><td nowrap="nowrap" valign="top">'.$CFormField->getLabel().' :</td><td>'.str_replace('administrator/','/',$htmlversion).'</td></tr>';
			}else{
				$result .= '<tr><td colspan="2">'.str_replace('administrator/','/',$htmlversion).'</td></tr>';
			}
		}

		$varFields['{readmore}'] = '<a class="readmore_link" style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a>';
		if(!empty($tag->readmore)) $result .= '<tr><td colspan="2">'.$varFields['{readmore}'].'</td></tr>';

		$result = '<table cellspacing="1" cellpadding="2" border="0">'.$resultTitle.$created.$modified.$result.'</table>';

		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'cobalt.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'cobalt.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}

		$result = $this->acypluginsHelper->removeJS($result);
		$result = $this->acypluginsHelper->managePicts($tag, $result);

		return $result;
	}

	private function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$this->acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function acymailing_generateautonews(&$email){
		$time = time();

		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email,'autocobalt');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$db = JFactory::getDBO();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;
			$allcats = explode('-',$parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = '\'%"'.intval($oneCat).'":"%\'';
			}

			$query = 'SELECT id FROM #__js_res_record';
			$where = array();

			if(!empty($parameter->featured)) $where[] = 'featured = 1';
			if(!empty($parameter->nofeatured)) $where[] = 'featured = 0';

			if(!empty($selectedArea)) $where[] = '`categories` LIKE '.implode(' OR `categories` LIKE ',$selectedArea);
			if(!empty($parameter->filter)){
				if($parameter->filter == 'modify'){
					$where[] = ' `mtime` > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
				}elseif($parameter->filter == 'created'){
					$where[] = ' `ctime` > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
				}
			}
			$where[] = "published = 1";
			$query .= ' WHERE ('.implode(') AND (',$where).')';

			if(!empty($parameter->order)){
				$ordering = explode(',',$parameter->order);
				if($ordering[0] == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$query .= ' ORDER BY `'.acymailing_secureField(trim($ordering[0])).'` '.acymailing_secureField(trim($ordering[1]));
				}
			}

			$start = '';
			if(!empty($parameter->start)) $start = intval($parameter->start).',';
			if(empty($parameter->max_article)) $parameter->max_article = 100;
			$query .= ' LIMIT '.$start.' '.intval($parameter->max_article);

			//We add a limit for the preview otherwise we could break everything
			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);
			if(!empty($parameter->min_article) && count($allArticles) < intval($parameter->min_article)){
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough Cobalt content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min_article.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
			}

			$stringTag = '';
			if(!empty($allArticles)){
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autocobalt.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autocobalt.php');
					$stringTag = ob_get_clean();
				}else{
					$arrayElements = array();
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = 'cobalt:'.$oneArticleId;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(!empty($parameter->clickable)) $args[] = 'clickable:'.$parameter->clickable;
						if(isset($parameter->readmore)) $args[] = 'readmore:'.$parameter->readmore;
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $this->acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}