<?php
/**
 * @copyright	Copyright (C) 2009-2018 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingdjcatalog2 extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		$this->name = 'djcatalog2';
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new acyParameter( $plugin->params );
		}

		//check if the component is installed
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_djcatalog2');
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
	}

	function acymailing_getPluginType(){
	 	if(!$this->component_installed || ($this->params->get('frontendaccess') == 'none' && !acymailing_isAdmin())) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'DJ-Catalog2';
		$onePlugin->function = 'acymailing_'.$this->name.'_show';
		$onePlugin->help = 'plugin-'.$this->name;
		return $onePlugin;
	}

	function acymailing_djcatalog2_show(){
		$config = acymailing_config();

		if(version_compare($config->get('version'), '5.9.0', '<')){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		
		acymailing_loadLanguageFile('com_djcatalog2', JPATH_ADMINISTRATOR.DS.'components'.DS.'com_djcatalog2');

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.'.$this->name;

		$pageInfo->filter->order->value = acymailing_getUserVar( $paramBase.".filter_order", 'filter_order','a.id','cmd' );
		$pageInfo->filter->order->dir	= acymailing_getUserVar( $paramBase.".filter_order_Dir", 'filter_order_Dir','asc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = acymailing_getUserVar( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = acymailing_getUserVar( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->filter_type = acymailing_getUserVar( $paramBase.".filter_type", 'filter_type','','int' );
		$pageInfo->limit->value = acymailing_getUserVar( $paramBase.'.list_limit', 'limit', acymailing_getCMSConfig('list_limit'), 'int' );
		$pageInfo->limit->start = acymailing_getUserVar( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->contentfilter = acymailing_getUserVar( $paramBase.".contentfilter", 'contentfilter','created','string' );
		$pageInfo->contentorder = acymailing_getUserVar( $paramBase.".contentorder", 'contentorder','id','string' );
		$pageInfo->contentorderdir = acymailing_getUserVar( $paramBase.".contentorderdir", 'contentorderdir','DESC','string' );
		$pageInfo->cols = acymailing_getUserVar( $paramBase.".cols", 'cols','1','string' );
		$pageInfo->pictheight = acymailing_getUserVar( $paramBase.".pictheight", 'pictheight','150','string' );
		$pageInfo->pictwidth = acymailing_getUserVar( $paramBase.".pictwidth", 'pictwidth','150','string' );
		$pageInfo->pict = acymailing_getUserVar( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->pictauto = acymailing_getUserVar( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->readmore = acymailing_getUserVar( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->readmoreauto = acymailing_getUserVar( $paramBase.".readmoreauto", 'readmoreauto','1','string' );
		$pageInfo->wrap = acymailing_getUserVar( $paramBase.".wrap", 'wrap','0','string' );
		$pageInfo->clickable = acymailing_getUserVar( $paramBase.".clickable", 'clickable','1','string' );
		$pageInfo->clickableauto = acymailing_getUserVar( $paramBase.".clickableauto", 'clickableauto','1','string' );

		//the query's start
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.id, a.name AS title, b.name AS cattitle ' .
				'FROM #__djc2_items AS a ' .
				'JOIN #__djc2_categories AS b ON a.cat_id = b.id ';

		//search fields...
		$searchFields = array('a.name','a.id','b.name');

		//apply search fields
		if(!empty($pageInfo->search))
		{
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE ".$searchVal;
		}

		//only published content ?
		if($this->params->get('displaycontent','all') == 'onlypub') $filters[] = 'a.published = 1';

		//if the user filtered by category
		if(!empty($pageInfo->filter_cat)) $filters[] = 'a.cat_id = '.intval($pageInfo->filter_cat);

		//apply filters
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (',$filters).')';

		//apply ordering
		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;

		$rows = acymailing_loadObjectList($query, '', $pageInfo->limit->start,$pageInfo->limit->value);

		//yellow highlighting on search matches
		if(!empty($pageInfo->search)) $rows = acymailing_search($pageInfo->search,$rows);

		//pagination
		$pageInfo->elements->total = acymailing_loadResult('SELECT FOUND_ROWS()');
		$pageInfo->elements->page = count($rows);

		$pagination = new acyPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		//is this a Smart-Newsletter or a simple one ?
		$type = acymailing_getVar('string', 'type');

	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass)
			{
				<?php
					//we insert contents in the order the user selected it
				?>
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1)
				{
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass)
			{
				if(catid == 'all')
				{
					if(window.document.getElementById('cat'+catid).className == 'selectedrow')
					{
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						for(key in selectedCat)
						{
							if(!isNaN(key))
							{
								window.document.getElementById('cat'+key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid])
					{
						window.document.getElementById('cat'+catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				<?php
					//add the fields the user wants to be displayed
				?>
				for(var i=0; i < document.adminForm.cbdisplay.length; i++)
				{
					if(document.adminForm.cbdisplay[i].checked)
					{
						 if(tmp == 0)
						 {
							 tmp += 1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }
					}
				}

				if(document.adminForm.customfields && document.adminForm.customfields.length)
				{
					tmp=0;
					for(var i=0; i < document.adminForm.customfields.length; i++)
					{
						if (document.adminForm.customfields[i].checked)
						{
							 if(tmp==0)
							 {
								 tmp+=1;
								 otherinfo += "| custom:";
								 otherinfo += document.adminForm.customfields[i].value;
							 }else{
								 otherinfo += ", ";
								 otherinfo += document.adminForm.customfields[i].value;
							 }
						}
					}
				}

				<?php
					//is the title clickable ?
				?>
				for(var i=0; i < document.adminForm.clickable.length; i++)
				{
					 if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '0')
					 {
						 otherinfo += '| nolink';
					 }
				}

				<?php
					//do we have to wrap the text ? (description for example...)
				?>
				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value))
				{
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				<?php
					//do we have to add a "read more" button ?
				?>
				for(var i=0; i < document.adminForm.readmore.length; i++)
				{
					 if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '0')
					 {
						 otherinfo += '| noreadmore';
					 }
				}

				<?php
					//picture management
				?>
				for(var i=0; i < document.adminForm.pict.length; i++)
				{
					if (document.adminForm.pict[i].checked)
					{
					 	if(document.adminForm.pict[i].value != '1')
							otherinfo += '| pict:'+document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized')
						{
							 document.getElementById('pictsize').style.display = '';
							 if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
							 if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				<?php
					//insert the tags with the right order
				?>
				for(var i in selectedContents)
				{
					if(selectedContents[i] && !isNaN(i))
					{
						tag = tag + '{<?php echo $this->name; ?>:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				for(var i=0; i < document.adminForm.cbdisplayauto.length; i++)
				{
					if (document.adminForm.cbdisplayauto[i].checked)
					{
						 if(tmp==0)
						 {
							 tmp+=1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }
					}
				}

				if(document.adminForm.customfieldsauto && document.adminForm.customfieldsauto.length)
				{
					tmp=0;
					for(var i=0; i < document.adminForm.customfieldsauto.length; i++)
					{
						if (document.adminForm.customfieldsauto[i].checked)
						{
							 if(tmp==0)
							 {
								 tmp+=1;
								 otherinfo += "| custom:";
								 otherinfo += document.adminForm.customfieldsauto[i].value;
							 }else{
								 otherinfo += ", ";
								 otherinfo += document.adminForm.customfieldsauto[i].value;
							 }
						}
					}
				}

				for(var i=0; i < document.adminForm.clickableauto.length; i++)
				{
					if (document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '0')
					{
						 otherinfo += '| nolink';
					}
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value != 0 && !isNaN(document.adminForm.wrapauto.value))
				{
					otherinfo += "| wrap:"+document.adminForm.wrapauto.value;
				}

				for(var i=0; i < document.adminForm.readmoreauto.length; i++)
				{
					 if (document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '0')
					 {
						 otherinfo += '| noreadmore';
					 }
				}

				tmp=0;
				for(var i=0; i < document.adminForm.autopict.length; i++)
				{
					if (document.adminForm.autopict[i].checked)
					{
						if(document.adminForm.autopict[i].value != '1')
							otherinfo += '| pict:'+document.adminForm.autopict[i].value;

						if(document.adminForm.autopict[i].value == 'resized')
						{
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:'+document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}

				<?php
					//on how many columns do we have to display the contents ?
				?>
				if(document.adminForm.cols.value)
				{
					otherinfo += "| cols:"+document.adminForm.cols.value;
				}

				<?php
					//limit the number of content displayed
				?>
				if(document.adminForm.max_article.value)
				{
					otherinfo += "| max:"+document.adminForm.max_article.value;
				}

				<?php
					//with what order will we display the contents
				?>
				if(document.adminForm.contentorder.value)
				{
					otherinfo += "| order:"+document.adminForm.contentorder.value+","+document.adminForm.contentorderdir.value;
				}

				<?php if($type == 'autonews'){

					//minimum number of content for the newsletter to be displayed... yes, a perfect english !
				?>
					if(document.adminForm.min_article.value)
					{
						otherinfo += "| min:"+document.adminForm.min_article.value;
					}

					<?php
						//filter the content : only newly created/modified
					?>
					if(document.adminForm.contentfilter && document.adminForm.contentfilter.value != 0)
					{
						otherinfo += "| filter:"+document.adminForm.contentfilter.value;
					}
				<?php }
					//insert the tag
				?>
				tag = '{auto<?php echo $this->name; ?>:';
				for(var icat in selectedCat)
				{
					if(selectedCat[icat] == 'selectedone')
					{
						tag += icat+'-';
					}
				}
				tag += otherinfo+'}<br />';

				setTag(tag);
			}
		//-->
		</script>
<?php
		// yes/no for the options
		$choice = array();
		$choice[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$choice[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		// picture options
		$valImages = array();
		$valImages[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$valImages[] = acymailing_selectOption("resized", acymailing_translation('RESIZED'));
		$valImages[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		// filter options
		$contentfilter = array();
		$contentfilter[] = acymailing_selectOption("0", acymailing_translation('ACY_ALL'));
		$contentfilter[] = acymailing_selectOption("created", acymailing_translation('ONLY_NEW_CREATED'));
		$contentfilter[] = acymailing_selectOption("modified", acymailing_translation('ONLY_NEW_MODIFIED'));

		// options for the Nb. columns dropdown (1 to 10)
		$column = array();
		for($i=1;$i<11;$i++){
			$column[] = acymailing_selectOption("$i", $i);
		}

		if(ACYMAILING_J30)
		{
			$paginationNb = array();
			$paginationNb[] = acymailing_selectOption(5, 5);
			$paginationNb[] = acymailing_selectOption(10, 10);
			$paginationNb[] = acymailing_selectOption(15, 15);
			$paginationNb[] = acymailing_selectOption(20, 20);
			$paginationNb[] = acymailing_selectOption(25, 25);
			$paginationNb[] = acymailing_selectOption(30, 30);
			$paginationNb[] = acymailing_selectOption(50, 50);
			$paginationNb[] = acymailing_selectOption(100, 100);
			$paginationNb[] = acymailing_selectOption(0, acymailing_translation('ACY_ALL'));
		}

		$fieldsDisplay = array();
		$fieldsDisplay[] = array('title' => 'title', 'label' => 'ACY_TITLE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'img', 'label' => 'ACY_IMAGE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'intro', 'label' => 'INTRO_TEXT', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'desc', 'label' => 'ACY_DESCRIPTION', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'attach', 'label' => 'COM_DJCATALOG2_FILES', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'price', 'label' => 'COM_DJCATALOG2_PRICE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'pricespe', 'label' => 'COM_DJCATALOG2_SPECIAL_PRICE', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'prod', 'label' => 'COM_DJCATALOG2_PRODUCER', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'categ', 'label' => 'COM_DJCATALOG2_CATEGORY', 'checked' => '');

		$customFields = acymailing_loadObjectList('SELECT id, name FROM #__djc2_items_extra_fields WHERE published = 1');

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane( $this->name.'_tab');

		// start the first tab
		echo $tabs->startPanel( acymailing_translation('TAG_ELEMENTS'), $this->name.'_listings');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo acymailing_translation('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField)
					{
						if($i == 5)
						{
							echo '</tr><tr><td/>';
							$i = 1;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="'.$oneField['title'].'" id="'.$oneField['title'].'" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTag();"/><label style="margin-left:5px" for="'.$oneField['title'].'">'.acymailing_translation($oneField['label']).'</label></td>';
						$i++;
					}
					while($i != 5)
					{
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<?php
				//handle custom fields
				if(!empty($customFields))
				{
					echo '<tr><td>'.acymailing_translation('EXTRA_FIELDS').'</td>';
					$i = 1;
					foreach($customFields as $oneParam)
					{
						if($i == 5)
						{
							$i = 1;
							echo '</tr><tr><td/>' ;
						}
						echo '<td><input value="'.$oneParam->id.'" name="customfields" id="cf_'.$oneParam->id.'" type="checkbox" onclick="updateTag();" /> ';
						echo '<label for="cf_'.$oneParam->id.'">'.$oneParam->name.'</label></td>';
						$i++;
					}
					while($i != 5)
					{
						$i++;
						echo '<td/>';
					}
					echo '</tr>';
				}
			?>
			<tr>
				<td nowrap="nowrap"><?php echo acymailing_translation('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($choice, 'clickable' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>

				<td nowrap="nowrap"><?php echo acymailing_translation('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo acymailing_radio($choice, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo acymailing_translation('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo acymailing_translation('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo acymailing_translation('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo acymailing_translation_sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td nowrap="nowrap" width="100%">
					<input placeholder="<?php echo acymailing_translation('ACY_SEARCH'); ?>"  type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo acymailing_translation( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo acymailing_translation( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th/>
					<th class="title">
						<?php
							echo acymailing_gridSort(acymailing_translation( 'FIELD_TITLE'), 'a.name', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );
						?>
					</th>
					<th class="title">
						<?php echo acymailing_gridSort(acymailing_translation( 'TAG_CATEGORIES'), 'b.name', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php
							echo acymailing_gridSort(acymailing_translation( 'ACY_ID' ), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value );
						?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php
							echo $pagination->getListFooter();
							if(ACYMAILING_J30)
				 				echo 'Display #'.acymailing_select($paginationNb, 'limit' , 'size="1" style="width:60px" onchange="acymailing.submitform();"', 'value', 'text', $pageInfo->limit->value).'<br />';
							echo $pagination->getResultsCounter();
						?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					if(!empty($rows))
					{
						foreach($rows as $row)
						{
				?>
							<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
								<td class="acytdcheckbox"></td>
								<td>
									<?php
										if(!empty($row->title))
										{
											echo $row->title;
										}
									?>
								</td>
								<td>
									<?php
										if(!empty($row->cattitle))
										{
											echo $row->cattitle;
										}
									?>
								</td>
								<td align="center" style="text-align:center" >
									<?php
										echo $row->id;
									?>
								</td>
							</tr>
				<?php
							// this enables to know if we have to set the line background grey or white
							$k = 1-$k;
						}
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
<?php

		echo $tabs->endPanel();

		// start category tab
		echo $tabs->startPanel( acymailing_translation('TAG_CATEGORIES'), $this->name.'_auto');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo acymailing_translation('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField)
					{
						if($i == 5)
						{
							echo '</tr><tr><td/>';
							$i = 1;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="'.$oneField['title'].'" id="'.$oneField['title'].'auto" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneField['title'].'auto">'.acymailing_translation($oneField['label']).'</label></td>';
						$i++;
					}
					while($i != 5)
					{
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<?php
				//handle custom fields
				if(!empty($customFields))
				{
					echo '<tr><td>'.acymailing_translation('EXTRA_FIELDS').'</td>';
					$i = 1;
					foreach($customFields as $oneParam)
					{
						if($i == 5)
						{
							$i = 1;
							echo '</tr><tr><td/>' ;
						}
						echo '<td><input value="'.$oneParam->id.'" name="customfieldsauto" id="cf_'.$oneParam->id.'auto" type="checkbox" onclick="updateTagAuto();" /> ';
						echo '<label for="cf_'.$oneParam->id.'auto">'.$oneParam->name.'</label></td>';
						$i++;
					}
					while($i != 5)
					{
						$i++;
						echo '<td/>';
					}
					echo '</tr>';
				}
			?>
			<tr>
				<td nowrap="nowrap"><?php echo acymailing_translation('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($choice, 'clickableauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
				<td nowrap="nowrap"><?php echo acymailing_translation('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo acymailing_radio($choice, 'readmoreauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top">
					<?php echo acymailing_translation('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
					<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo acymailing_translation('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo acymailing_translation('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo acymailing_translation_sprintf('TRUNCATE_AFTER','<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" nowrap="nowrap">
					<?php echo acymailing_translation('MAX_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <input type="text" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo acymailing_translation('ACY_ORDER'); ?>
				</td>
				<td nowrap="nowrap">
					<?php
						$values = array('id' => 'ACY_ID', 'created' => 'CREATED_DATE', 'checked_out_time' => 'MODIFIED_DATE', 'name' => 'FIELD_TITLE');
						echo $this->acypluginsHelper->getOrderingField($values, $pageInfo->contentorder, $pageInfo->contentorderdir);
					?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td nowrap="nowrap">
					<?php 	echo acymailing_translation('MIN_ARTICLE'); ?>
				</td nowrap="nowrap">
				<td nowrap="nowrap" colspan="2">
					<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td>
					<?php echo acymailing_translation('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo acymailing_select($column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo acymailing_translation('JOOMEXT_FILTER'); ?>
				</td>
				<td nowrap="nowrap" colspan="4">
					 <?php echo acymailing_select($contentfilter, 'contentfilter' , 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentfilter); ?>
				</td>
			</tr>
			<?php }else{ ?>
			<tr>
				<td nowrap="nowrap">
					<?php echo acymailing_translation('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap" colspan="4">
					 <?php echo acymailing_select($column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
<!--====================================================================================LISTE CATEGORIES===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<?php
				$k=0;
			?>
			<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
					<?php
						echo acymailing_translation('ACY_ALL');
					?>
				</td>
			</tr>
			<?php
				if(!empty($this->catvalues))
				{
					foreach($this->catvalues as $oneCat)
					{
						if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
			<?php
						$k = 1 - $k;
					}
				}
			?>
		</table>
<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){
		//select all cats
		$mosetCats = acymailing_loadObjectList('SELECT id, parent_id, name AS title FROM #__djc2_categories ORDER BY id ASC');
		$this->cats = array();
		if(!empty($mosetCats))
			foreach($mosetCats as $oneCat)
				$this->cats[$oneCat->parent_id][] = $oneCat;

		$this->catvalues = array();
		$this->catvalues[] = acymailing_selectOption(0, acymailing_translation('ACY_ALL'));
		$this->_handleChildrens();
		return acymailing_select($this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	function _handleChildrens($parent_id=0, $level=0){
		if(empty($this->cats[$parent_id])) return;
		foreach($this->cats[$parent_id] as $cat){
			$this->catvalues[] = acymailing_selectOption($cat->id,str_repeat(" - - ",$level).$cat->title);
			$this->_handleChildrens($cat->id,$level+1);
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceOne(&$email){
		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, $this->name);
		if(empty($tags)) return;
		include_once(JPATH_SITE.DS.'components'.DS.'com_djcatalog2'.DS.'helpers'.DS.'route.php');

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? acymailing_translation('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.acymailing_translation('JOOMEXT_READ_MORE',true).'" />';

		
		acymailing_loadLanguageFile('com_djcatalog2', JPATH_ADMINISTRATOR.DS.'components'.DS.'com_djcatalog2');
		acymailing_loadLanguageFile('com_djcatalog2', JPATH_SITE.DS.'components'.DS.'com_djcatalog2');

		$djcatalog2Params = JComponentHelper::getParams('com_djcatalog2');
		$currency = $djcatalog2Params->get('price_unit');
		$currencySide = $djcatalog2Params->get('unit_side');
		$this->leftcurrency = $currencySide == 1 ? '' : $currency;
		$this->rightcurrency = $currencySide == 1 ? $currency : '';

		$tagsReplaced = array();
		foreach($tags as $i => $oneTag){
			if(isset($tagsReplaced[$i])) continue;
			$tagsReplaced[$i] = $this->_replaceContent($oneTag);
		}

		$this->acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}

	function _replaceContent(&$tag){
	 	// extract the fields selected
		if(!empty($tag->display))
		{
			$tag->display = explode(',',$tag->display);

			foreach($tag->display as $i => $oneDisplay)
			{
				$oneDisplay = trim($oneDisplay);
				$tag->$oneDisplay = true;
			}
			unset($tag->display);
		}

		if(!empty($tag->custom))
		{
			$tag->custom = explode(',',$tag->custom);

			foreach($tag->custom as $i => $oneDisplay)
			{
				$tag->custom[$i] = trim($oneDisplay);
			}
			acymailing_arrayToInteger($tag->custom);
		}

		// load content

		$query = 'SELECT a.*, b.name AS cattitle, b.alias AS catalias, c.name AS prodname FROM #__djc2_items AS a ' .
				'JOIN #__djc2_categories AS b ' .
				'ON a.cat_id = b.id ' .
				'LEFT JOIN #__djc2_producers AS c ' .
				'ON a.producer_id = c.id ' .
				'WHERE a.id = '.intval($tag->id).' LIMIT 1';
		$content = acymailing_loadObject($query);

		//In case of we could not load the article for any reason...
		if(empty($content)){
			if(acymailing_isAdmin()) acymailing_enqueueMessage('The content "'.$tag->id.'" could not be loaded','notice');
			return '';
		}

		$varFields = array();
		foreach($content as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		// create the link for the title and the read more button
		if(!empty($tag->itemid)) $link = 'index.php?option=com_djcatalog2&view=item&id='.$tag->id.'&Itemid='.$tag->itemid;
		else $link = DJCatalogHelperRoute::getItemRoute($tag->id.':'.$content->alias, $content->catalias);
		$link = acymailing_frontendLink($link);

		$varFields['{link}'] = $link;

		$result = '<div class="acymailing_content acydjcatalog2"><table cellspacing="0" cellpadding="0" border="0" width="100%">';

		// display the title
		if(!empty($tag->title))
		{
			$result .= '<tr><td colspan="2"><h2 class="acymailing_title">';
			if(empty($tag->nolink))
				$result .= '<a href="'.$link.'">';
			$result .= $content->name;
			if(empty($tag->nolink))
				$result .= '</a>';
			$result .= '</h2></td></tr>';
		}

		if(!(empty($tag->img) && (empty($tag->desc) || empty($content->description)) && (empty($tag->intro) || empty($content->intro_desc))))
		{
			$result .= '<tr><td colspan="2" style="text-align:justify;">';
			if(!empty($tag->img))
			{
				$query = 'SELECT a.fullpath ' .
						'FROM #__djc2_images AS a ' .
						'WHERE a.item_id = '.intval($tag->id).' ' .
						'AND a.type LIKE "item" ' .
						'ORDER BY a.ordering ' .
						'LIMIT 1';
				$mainImage = acymailing_loadObject($query);

				if(!empty($mainImage) && file_exists(JPATH_SITE.DS.'media'.DS.'djcatalog2'.DS.'images'.DS.trim(str_replace('/', DS, $mainImage->fullpath))))
				{
					$varFields['{image}'] = 'media/djcatalog2/images/'.trim($mainImage->fullpath);
					$result .= '<a href="'.$link.'"><img style="float:'.(!empty($tag->nofloat) ? 'none' : 'left').';" src="'.$varFields['{image}'].'"/></a>';
				}
			}
			if(!empty($tag->intro) && !empty($content->intro_desc)) $result .= '<span class="intro">'.$this->acypluginsHelper->wrapText($content->intro_desc, $tag).'</span>';
			// display the main text wraped or not
			if(!empty($tag->desc) && !empty($content->description)) $result .= '<span class="desc">'.$this->acypluginsHelper->wrapText($content->description, $tag).'</span>';

			$result .= '</td></tr>';
		}

		// display the category
		if(!empty($tag->categ))
		{
			$result .= '<tr><td colspan="2"><strong>'.acymailing_translation('COM_DJCATALOG2_CATEGORY').' : </strong><a href="index.php?option=com_djcatalog2&view=items&cid='.$content->cat_id.'">'.$content->cattitle.'</a></td></tr>';
		}

		// display the category
		if(!empty($tag->prod) && !empty($content->prodname))
		{
			$result .= '<tr><td colspan="2"><strong>'.acymailing_translation('COM_DJCATALOG2_PRODUCER').' : </strong><a href="index.php?option=com_djcatalog2&view=producer&pid='.$content->producer_id.'">'.$content->prodname.'</a></td></tr>';
		}

		// display the category
		if(!empty($tag->price) && !empty($content->price))
		{
			$result .= '<tr><td colspan="2"><strong>'.acymailing_translation('COM_DJCATALOG2_PRICE').' : </strong>';
			if(!empty($tag->pricespe) && !empty($content->special_price))
				$result .= '<strike>'.$this->leftcurrency.$content->price.$this->rightcurrency.'</strike> '.$this->leftcurrency.$content->special_price.$this->rightcurrency;
			else
				$result .= $this->leftcurrency.$content->price.$this->rightcurrency;
			$result .= '</td></tr>';
		}

		if(!empty($tag->custom))
		{
			$k = 0;
			$result .= '<tr><td colspan="2"><table width="100%" border="0" padding="0">';
			$customFields = acymailing_loadObjectList('SELECT a.name, a.imagelabel, b.value FROM #__djc2_items_extra_fields AS a JOIN #__djc2_items_extra_fields_values_text AS b ON a.id = b.field_id WHERE a.published = 1 AND b.item_id = '.intval($tag->id).' AND a.id IN ('.implode(', ', $tag->custom).')');
			if(!empty($customFields))
			{
				foreach($customFields as $oneField)
				{
					if(!empty($oneField->value))
					{
						if($k == 0)
						{
							if(!empty($oneField->imagelabel))
								$result .= '<tr><td style="background-color:lightgrey;padding:10px;" valign="middle" width="25%"><img src="'.$oneField->imagelabel.'"/></td><td style="background-color:whitesmoke;" valign="middle" >'.$oneField->value.'</td></tr>';
							else
								$result .= '<tr><td style="background-color:lightgrey;padding:10px;" valign="middle" width="25%"><strong>'.$oneField->name.'</strong></td><td style="background-color:whitesmoke;" valign="middle" >'.$oneField->value.'</td></tr>';
						}else{
							if(!empty($oneField->imagelabel))
								$result .= '<tr><td style="background-color:whitesmoke;padding:10px;" valign="middle" width="25%"><img src="'.$oneField->imagelabel.'"/></td><td style="background-color:white;" valign="middle" >'.$oneField->value.'</td></tr>';
							else
								$result .= '<tr><td style="background-color:whitesmoke;padding:10px;" valign="middle" width="25%"><strong>'.$oneField->name.'</strong></td><td style="background-color:white;" valign="middle" >'.$oneField->value.'</td></tr>';
						}
						$k = 1-$k;
					}
				}
			}

			$customFields = acymailing_loadObjectList('SELECT a.name, a.imagelabel, b.value FROM #__djc2_items_extra_fields AS a JOIN #__djc2_items_extra_fields_values_date AS b ON a.id = b.field_id WHERE a.published = 1 AND b.item_id = '.intval($tag->id).' AND a.id IN ('.implode(', ', $tag->custom).')');
			if(!empty($customFields))
			{
				foreach($customFields as $oneField)
				{
					if(empty($oneField->value)) continue;
					$result .= '<tr><td style="background-color:'.($k == 0 ? 'lightgrey' : 'whitesmoke').';padding:10px;" valign="middle" width="25%">'.(!empty($oneField->imagelabel) ? '<img src="'.$oneField->imagelabel.'"/>' : '<strong>'.$oneField->name.'</strong>').'</td><td style="background-color:'.($k == 0 ? 'whitesmoke' : 'white').';" valign="middle" >'.acymailing_getDate(acymailing_getTime($oneField->value), acymailing_translation('DATE_FORMAT_LC')).'</td></tr>';
					$k = 1-$k;
				}
			}

			$query = 'SELECT a.name, a.imagelabel, c.value, c.field_id ' .
					'FROM #__djc2_items_extra_fields AS a ' .
					'JOIN #__djc2_items_extra_fields_values_int AS b ' .
					'ON a.id = b.field_id ' .
					'JOIN #__djc2_items_extra_fields_options AS c ' .
					'ON b.value = c.id ' .
					'WHERE a.published = 1 ' .
					'AND b.item_id = '.intval($tag->id).' ' .
					'AND a.id IN ('.implode(', ', $tag->custom).')';

			$customFields = acymailing_loadObjectList($query);
			if(!empty($customFields))
			{
				$values = array();
				foreach($customFields as $oneField)
				{
					if(empty($values[$oneField->field_id]))
						$values[$oneField->field_id] = array();

					$values[$oneField->field_id][] = $oneField->value;
				}
				foreach($customFields as $oneField)
				{
					if(empty($values[$oneField->field_id]) || !isset($oneField->value)) continue;
					$result .= '<tr><td style="background-color:'.($k == 0 ? 'lightgrey' : 'whitesmoke').';padding:10px;" valign="middle" width="25%">'.(!empty($oneField->imagelabel) ? '<img src="'.$oneField->imagelabel.'"/>' : '<strong>'.$oneField->name.'</strong>').'</td><td style="background-color:'.($k == 0 ? 'whitesmoke' : 'white').';" valign="middle" >'.implode(', ', $values[$oneField->field_id]).'</td></tr>';
					$k = 1-$k;
					unset($values[$oneField->field_id]);
				}
			}
			$result .= '</table></td></tr>';
		}

		if(!empty($tag->attach))
		{
			$attachments = acymailing_loadObjectList('SELECT * FROM #__djc2_files WHERE type LIKE "item" AND item_id = '.intval($tag->id));
			if(!empty($attachments))
			{
				$result .= '<tr><td colspan="2"><strong>'.acymailing_translation('COM_DJCATALOG2_FILES').'</strong><br /><ul>';
				foreach($attachments as $oneFile)
				{
					$result .= '<li><a href="index.php?option=com_djcatalog2&format=raw&task=download&fid='.$oneFile->id.'">'.$oneFile->caption.' ('.$oneFile->ext.')</a></li>';
				}
				$result .= '</ul></td></tr>';
			}
		}

		if(empty($tag->noreadmore))
		{
			$result .= '<tr><td colspan="2"><br /><a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a></td></tr>';
		}

		$result .= '</table></div><br />';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php'))
		{
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}

		// always remove JS, there is no JS in newsletters...
		$result = $this->acypluginsHelper->removeJS($result);

		//resize or remove pictures
		$result = $this->acypluginsHelper->managePicts($tag, $result);
		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$this->acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function acymailing_generateautonews(&$email){
		$time = time();

		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email,'auto'.$this->name);
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;
			$allcats = explode('-',$parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT a.id FROM #__djc2_items AS a JOIN #__djc2_categories AS b ON a.cat_id = b.id ';

			$where = array();

			// load only needed content
			if(!empty($selectedArea)){
				$categories = 'a.cat_id IN ('.implode(',', $selectedArea).')';
				if(!empty($parameter->additionalcats)){
					$query .= 'LEFT JOIN #__djc2_items_categories AS c ON a.id = c.item_id ';
					$categories .= ' OR c.category_id IN ('.implode(',', $selectedArea).')';
				}
				$where[] = $categories;
			}

			// filter results created or modified
			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
				$filter = 'a.created > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
				if($parameter->filter == 'modified') $filter .= ' OR a.cecked_out_time > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
				$where[] = $filter;
			}

			// Only published content
			$where[] = 'a.published = 1';

			if(!empty($parameter->featured)) $where[] = 'a.featured = 1';
			if(!empty($parameter->nofeatured)) $where[] = 'a.featured = 0';

			// Apply filters
			if(!empty($where)) $query .= ' WHERE ('.implode(') AND (',$where).')';

			// Ordering
			if(!empty($parameter->order)){
				$ordering = explode(',',$parameter->order);
				if($ordering[0] == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			// If there is no limit, then we add one
			if(!empty($parameter->max))
				$query .= ' LIMIT '.intval($parameter->max);
			else
				$query .= ' LIMIT 20'; // limit, because we do not want to display one bilion of content in the newsletter...

			// load content IDs
			$allArticles = acymailing_loadResultArray($query);

			// Check the number of results
			if(!empty($parameter->min) && count($allArticles) < $parameter->min)
			{
				//We will not generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough '.$this->name.' content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles))
			{
				// If the user created its own template...
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php'))
				{
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
					$arrayElements = array();
					foreach($allArticles as $oneArticleId)
					{
						$args = array();
						$args[] = $this->name.':'.$oneArticleId;
						if(!empty($parameter->nolink)) $args[] = 'nolink';
						if(!empty($parameter->nofloat)) $args[] = 'nofloat';
						if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						if(!empty($parameter->custom)) $args[] = 'custom:'.$parameter->custom;
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $this->acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}