<?php
/**
 * @copyright    Copyright (C) 2009-2018 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingeasydiscuss extends JPlugin{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'easydiscuss');
			$this->params = new acyParameter($plugin->params);
		}

		//check if the component is installed
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_easydiscuss');
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
	}

	function acymailing_getPluginType(){
		if(!$this->component_installed || ($this->params->get('frontendaccess') == 'none' && !acymailing_isAdmin())) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'EasyDiscuss';
		$onePlugin->function = 'acymailing_easydiscuss_show';
		$onePlugin->help = 'plugin-easydiscuss';
		return $onePlugin;
	}

	function acymailing_easydiscuss_show(){
		$config = acymailing_config();
		if(version_compare($config->get('version'), '5.2.0', '<')){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		acymailing_loadLanguageFile('com_easydiscuss', JPATH_SITE);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.easydiscuss';

		$pageInfo->filter->order->value = acymailing_getUserVar($paramBase.".filter_order", 'filter_order', 'a.id', 'cmd');
		$pageInfo->filter->order->dir = acymailing_getUserVar($paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = acymailing_getUserVar($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = acymailing_getUserVar($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->filter_type = acymailing_getUserVar($paramBase.".filter_type", 'filter_type', '', 'int');
		$pageInfo->limit->value = acymailing_getUserVar($paramBase.'.list_limit', 'limit', acymailing_getCMSConfig('list_limit'), 'int');
		$pageInfo->limit->start = acymailing_getUserVar($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->automaxvalue = acymailing_getUserVar($paramBase.".max", 'max', '20', 'int');
		$pageInfo->contentfilter = acymailing_getUserVar($paramBase.".contentfilter", 'contentfilter', 'created', 'string');
		$pageInfo->contentorder = acymailing_getUserVar($paramBase.".contentorder", 'contentorder', 'id,DESC', 'string');
		$pageInfo->cols = acymailing_getUserVar($paramBase.".cols", 'cols', '1', 'string');
		$pageInfo->pictheight = acymailing_getUserVar($paramBase.".pictheight", 'pictheight', '50', 'string');
		$pageInfo->pictwidth = acymailing_getUserVar($paramBase.".pictwidth", 'pictwidth', '50', 'string');
		$pageInfo->pict = acymailing_getUserVar($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->autopict = acymailing_getUserVar($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->readmore = acymailing_getUserVar($paramBase.".readmore", 'readmore', '1', 'string');
		$pageInfo->readmoreauto = acymailing_getUserVar($paramBase.".readmoreauto", 'readmoreauto', '1', 'string');
		$pageInfo->wrap = acymailing_getUserVar($paramBase.".wrap", 'wrap', '0', 'string');
		$pageInfo->clickable = acymailing_getUserVar($paramBase.".clickable", 'clickable', '1', 'string');
		$pageInfo->clickableauto = acymailing_getUserVar($paramBase.".clickableauto", 'clickableauto', '1', 'string');

		$searchFields = array('a.id', 'a.title', 'b.id', 'b.title');

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displaypost', 'all') == 'onlypub') $filters[] = "a.published = 1";

		if(!empty($pageInfo->filter_cat)) $filters[] = "a.category_id = ".$pageInfo->filter_cat;

		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*, b.*, a.title AS posttitle, a.id AS postid, b.title AS cattitle '.'FROM `#__discuss_posts` AS a '.'JOIN #__discuss_category AS b ON a.category_id = b.id ';

		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (', $filters).')';

		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		$rows = acymailing_loadObjectList($query, '', $pageInfo->limit->start, $pageInfo->limit->value);

		if(!empty($pageInfo->search)) $rows = acymailing_search($pageInfo->search, $rows);

		$pageInfo->elements->total = acymailing_loadResult('SELECT FOUND_ROWS()');
		$pageInfo->elements->page = count($rows);

		$pagination = new acyPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		$type = acymailing_getVar('string', 'type');

		?>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			function applyContent(contentid, rowClass){
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1){
					window.document.getElementById('content' + contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content' + contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid, rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('cat' + catid).className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						for(key in selectedCat){
							if(!isNaN(key)){
								window.document.getElementById('cat' + key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat' + catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;
				for(var i = 0; i < document.adminForm.cbaffiche.length; i++){
					if(document.adminForm.cbaffiche[i].checked){
						if(tmp == 0){
							tmp += 1;
							otherinfo += "|display:";
							otherinfo += document.adminForm.cbaffiche[i].value;
						}else{
							otherinfo += ", ";
							otherinfo += document.adminForm.cbaffiche[i].value;
						}
					}
				}

				for(var i = 0; i < document.adminForm.clickable.length; i++){
					if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '1'){
						otherinfo += '| clickable:' + document.adminForm.clickable[i].value;
					}
				}

				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0){
					otherinfo += "| wrap:" + document.adminForm.wrap.value;
				}

				for(var i = 0; i < document.adminForm.readmore.length; i++){
					if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '1'){
						otherinfo += '| readmore:' + document.adminForm.readmore[i].value;
					}
				}

				for(var i = 0; i < document.adminForm.pict.length; i++){
					if(document.adminForm.pict[i].checked && document.adminForm.pict[i].value != '0'){
						otherinfo += '| pict:' + document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized'){
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:' + document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				for(var i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{easydiscuss:' + selectedContents[i] + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;
				for(var i = 0; i < document.adminForm.cbafficheauto.length; i++){
					if(document.adminForm.cbafficheauto[i].checked){
						if(tmp == 0){
							tmp += 1;
							otherinfo += "| display:";
							otherinfo += document.adminForm.cbafficheauto[i].value;
						}else{
							otherinfo += ", ";
							otherinfo += document.adminForm.cbafficheauto[i].value;
						}
					}
				}

				for(var i = 0; i < document.adminForm.clickableauto.length; i++){
					if(document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '1'){
						otherinfo += '| clickable:' + document.adminForm.clickableauto[i].value;
					}
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value != 0){
					otherinfo += "| wrap:" + document.adminForm.wrapauto.value;
				}

				for(var i = 0; i < document.adminForm.readmoreauto.length; i++){
					if(document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '1'){
						otherinfo += '| readmore:' + document.adminForm.readmoreauto[i].value;
					}
				}

				tmp = 0;
				for(var i = 0; i < document.adminForm.autopict.length; i++){
					if(document.adminForm.autopict[i].checked && document.adminForm.autopict[i].value != '0'){
						otherinfo += '| pict:' + document.adminForm.autopict[i].value;
						if(document.adminForm.autopict[i].value == 'resized'){
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:' + document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}

				if(document.adminForm.cols.value){
					otherinfo += "| cols:" + document.adminForm.cols.value;
				}
				if(document.adminForm.max_article.value){
					otherinfo += "| max:" + document.adminForm.max_article.value;
				}
				if(document.adminForm.contentorder.value){
					otherinfo += "| order:" + document.adminForm.contentorder.value;
				}
				<?php if($type == 'autonews'){ ?>
				if(document.adminForm.min_article.value){
					otherinfo += "| min:" + document.adminForm.min_article.value;
				}
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){
					otherinfo += "| filter:" + document.adminForm.contentfilter.value;
				}
				<?php } ?>
				tag = '{autoeasydiscuss:';
				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat + '-';
					}
				}
				tag += otherinfo + '}<br />';
				setTag(tag);
			}
			//-->
		</script>
		<?php
		$choice = array();
		$choice[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$choice[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		$valImages = array();
		$valImages[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$valImages[] = acymailing_selectOption("resized", acymailing_translation('RESIZED'));
		$valImages[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		$ordering = array();
		$ordering[] = acymailing_selectOption("id,DESC", acymailing_translation('ACY_ID'));
		$ordering[] = acymailing_selectOption("created,DESC", acymailing_translation('CREATED_DATE'));
		$ordering[] = acymailing_selectOption("modified,DESC", acymailing_translation('MODIFIED_DATE'));
		$ordering[] = acymailing_selectOption("title,ASC", acymailing_translation('FIELD_TITLE'));
		$ordering[] = acymailing_selectOption("rand", acymailing_translation('ACY_RANDOM'));

		$contentfilter = array();
		$contentfilter[] = acymailing_selectOption("", acymailing_translation('ACY_ALL'));
		$contentfilter[] = acymailing_selectOption("created", acymailing_translation('ONLY_NEW_CREATED'));
		$contentfilter[] = acymailing_selectOption("modified", acymailing_translation('ONLY_NEW_MODIFIED'));

		$column = array();
		for($i = 1; $i < 11; $i++){
			$column[] = acymailing_selectOption("$i", $i);
		}

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane('easydiscuss_tab');
		echo $tabs->startPanel(acymailing_translation('TAG_ELEMENTS'), 'easydiscuss_listings');
		?>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr>
					<td nowrap="nowrap"><?php echo acymailing_translation('DISPLAY'); ?></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="title" id="title" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="title" id="title-lbl"><?php echo acymailing_translation('ACY_TITLE'); ?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="author" id="author" onclick="updateTag();"/><label style="margin-left:5px" for="author" id="author-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_EMAILTEMPLATE_AUTHOR'); ?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="text" id="text" onclick="updateTag();"/><label style="margin-left:5px" for="text" id="text-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_EMAILTEMPLATE_MESSAGE'); ?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="category" id="category" onclick="updateTag();"/><label style="margin-left:5px" for="category" id="category-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_CATEGORY'); ?></label></td>
				</tr>
				<tr>
					<td/>
					<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="reply" id="reply" onclick="updateTag();"/><label style="margin-left:5px" for="reply" id="reply-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_REPLIES_PLURAL'); ?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="view" id="view" onclick="updateTag();"/><label style="margin-left:5px" for="view" id="view-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_VIEWS_PLURAL'); ?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="vote" id="vote" onclick="updateTag();"/><label style="margin-left:5px" for="vote" id="vote-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_VOTES_STRING_PLURAL'); ?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="like" id="like" onclick="updateTag();"/><label style="margin-left:5px" for="like" id="like-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_SORT_LIKED_MOST'); ?></label></td>
				</tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="resolved" id="resolved" onclick="updateTag();"/><label style="margin-left:5px" for="resolved" id="resolved-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_RESOLVED'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="tags" id="tags" onclick="updateTag();"/><label style="margin-left:5px" for="tags" id="tags-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_TAGS_TITLE'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="lastreply" id="lastreply" onclick="updateTag();"/><label style="margin-left:5px" for="lastreply" id="lastreply-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_VIEW_LAST_REPLY'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="caracteristics" id="caracteristics" onclick="updateTag();"/><label style="margin-left:5px" for="caracteristics" id="caracteristics-lbl"><?php echo acymailing_translation('VIEW_DETAILS'); ?></label></td>
				</tr>
				<tr>
					<td nowrap="nowrap"><?php echo acymailing_translation('CLICKABLE_TITLE'); ?></td>
					<td colspan="2"><?php echo acymailing_radio($choice, 'clickable', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>
					<td nowrap="nowrap"><?php echo acymailing_translation('JOOMEXT_READ_MORE'); ?></td>
					<td nowrap="nowrap"><?php echo acymailing_radio($choice, 'readmore', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
				</tr>
				<!-- ===============================================================================REDIM IMAGE==================================================================================== -->
				<tr>
					<td nowrap="nowrap" valign="top"><?php echo acymailing_translation('DISPLAY_PICTURES'); ?></td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($valImages, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
						<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br/>
							<?php echo acymailing_translation('CAPTCHA_WIDTH') ?>
							<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
					x <?php echo acymailing_translation('CAPTCHA_HEIGHT') ?>
							<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
				</span>
					</td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_translation_sprintf('TRUNCATE_AFTER', '<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
				</tr>
			</table>
		</div>
		<div class="onelineblockoptions">
			<table class="acymailing_table_options">
				<tr>
					<td nowrap="nowrap" width="100%">
						<input placeholder="<?php echo acymailing_translation('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search; ?>" class="text_area" onchange="document.adminForm.submit();"/>
						<button class="acymailing_button_grey" onclick="this.form.submit();"><?php echo acymailing_translation('JOOMEXT_GO'); ?></button>
						<button class="acymailing_button_grey" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo acymailing_translation('JOOMEXT_RESET'); ?></button>
					</td>
					<td nowrap="nowrap">
						<?php echo $this->_categories($pageInfo->filter_cat); ?>
					</td>
				</tr>
			</table>
			<!--====================================================================================LISTE DOCUMENTS===========================================================================-->
			<table class="acymailing_table" cellpadding="1" width="100%">
				<thead>
				<tr>
					<th/>
					<th class="title">
						<?php
						echo acymailing_gridSort(acymailing_translation('FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value);
						?>
					</th>
					<th class="title">
						<?php echo acymailing_gridSort(acymailing_translation('TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title titleid">
						<?php
						echo acymailing_gridSort(acymailing_translation('ACY_ID'), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value);
						?>
					</th>
				</tr>
				</thead>
				<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
				</tfoot>
				<tbody>
				<?php
				$k = 0;
				if(!empty($rows)){
					foreach($rows as $row){
						?>
						<tr id="content<?php echo $row->postid; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->postid.",'row$k'" ?>);" style="cursor:pointer;">
							<td class="acytdcheckbox"></td>
							<td>
								<?php
								$text = '<b>'.acymailing_translation('JOOMEXT_ALIAS').' : </b>'.$row->posttitle;
								echo acymailing_tooltip($text, $row->description, '', $row->posttitle);
								?>
							</td>
							<td>
								<?php
								if(!empty($row->cattitle)){
									echo $row->cattitle;
								}
								?>
							</td>
							<td align="center" style="text-align:center">
								<?php
								echo $row->postid;
								?>
							</td>
						</tr>
						<?php
						$k = 1 - $k;
					}
				}
				?>
				</tbody>
			</table>
		</div>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>
		<?php

		echo $tabs->endPanel();
		echo $tabs->startPanel(acymailing_translation('TAG_CATEGORIES'), 'docman_auto');
		?>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr>
					<td nowrap="nowrap"><?php echo acymailing_translation('DISPLAY'); ?></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="title" id="titleauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="titleauto" id="titleauto-lbl"><?php echo acymailing_translation('ACY_TITLE'); ?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="author" id="authorauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="authorauto" id="authorauto-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_EMAILTEMPLATE_AUTHOR'); ?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="text" id="textauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="textauto" id="textauto-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_EMAILTEMPLATE_MESSAGE'); ?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="category" id="categoryauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="categoryauto" id="categoryauto-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_CATEGORY'); ?></label></td>
				</tr>
				<tr>
					<td/>
					<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="reply" id="replyauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="replyauto" id="replyauto-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_REPLIES_PLURAL'); ?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="view" id="viewauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="viewauto" id="viewauto-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_VIEWS_PLURAL'); ?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="vote" id="voteauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="voteauto" id="voteauto-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_VOTES_STRING_PLURAL'); ?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="like" id="likeauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="likeauto" id="likeauto-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_SORT_LIKED_MOST'); ?></label></td>
				</tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="resolved" id="resolvedauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="resolvedauto" id="resolvedauto-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_RESOLVED'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="tags" id="tagsauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="tagsauto" id="tagsauto-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_TAGS_TITLE'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="lastreply" id="lastreplyauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="lastreplyauto" id="lastreplyauto-lbl"><?php echo acymailing_translation('COM_EASYDISCUSS_VIEW_LAST_REPLY'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="caracteristics" id="caracteristicsauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="caracteristicsauto" id="caracteristicsauto-lbl"><?php echo acymailing_translation('VIEW_DETAILS'); ?></label></td>
				</tr>
				<tr>
					<td nowrap="nowrap"><?php echo acymailing_translation('CLICKABLE_TITLE'); ?></td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($choice, 'clickableauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
					<td nowrap="nowrap"><?php echo acymailing_translation('JOOMEXT_READ_MORE'); ?></td>
					<td nowrap="nowrap"><?php echo acymailing_radio($choice, 'readmoreauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?>
				</tr>
				<tr>
					<td nowrap="nowrap" valign="top">
						<?php echo acymailing_translation('DISPLAY_PICTURES'); ?>
					</td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($valImages, 'autopict', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict); ?>
						<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br/>
							<?php echo acymailing_translation('CAPTCHA_WIDTH') ?>
							<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
					x <?php echo acymailing_translation('CAPTCHA_HEIGHT') ?>
							<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
				</span>
					</td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_translation_sprintf('TRUNCATE_AFTER', '<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
				</tr>
				<tr>
					<td nowrap="nowrap" nowrap="nowrap">
						<?php echo acymailing_translation('MAX_ARTICLE'); ?>
					</td>
					<td nowrap="nowrap" colspan="2">
						<input type="text" name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
					</td>
					<td nowrap="nowrap">
						<?php echo acymailing_translation('ACY_ORDER'); ?>
					</td>
					<td nowrap="nowrap">
						<?php echo acymailing_select($ordering, 'contentorder', 'style="width:150px;" size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
					</td>
				</tr>
				<?php if($type == 'autonews'){ ?>
					<tr>
						<td nowrap="nowrap">
							<?php echo acymailing_translation('MIN_ARTICLE'); ?>
						</td nowrap="nowrap">
						<td nowrap="nowrap" colspan="2">
							<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
						</td>
						<td>
							<?php echo acymailing_translation('FIELD_COLUMNS'); ?>
						</td>
						<td nowrap="nowrap">
							<?php echo acymailing_select($column, 'cols', 'style="width:150px;" size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->cols); ?>
						</td>
					</tr>
				<?php }else{ ?>
					<tr>
						<td>
							<?php echo acymailing_translation('FIELD_COLUMNS'); ?>
						</td>
						<td nowrap="nowrap" colspan="4">
							<?php echo acymailing_select($column, 'cols', 'style="width:150px;" size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->cols); ?>
						</td>
					</tr>
				<?php } ?>
				<?php if($type == 'autonews'){ ?>
					<tr>
						<td nowrap="nowrap">
							<?php echo acymailing_translation('JOOMEXT_FILTER'); ?>
						</td>
						<td nowrap="nowrap" colspan="4">
							<?php echo acymailing_select($contentfilter, 'contentfilter', 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentfilter); ?>
						</td>
					</tr>
				<?php } ?>
			</table>
		</div>
		<div class="onelineblockoptions">
			<!--====================================================================================LISTE CATEGORIES===========================================================================-->
			<table class="acymailing_table" cellpadding="1" width="100%">
				<?php $k = 0;
				?>
				<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td>
						<?php
						echo acymailing_translation('ACY_ALL');
						?>
					</td>
				</tr>
				<?php
				if(!empty($this->catvalues)){
					foreach($this->catvalues as $oneCat){
						if(empty($oneCat->value)) continue;
						?>
						<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
							<td class="acytdcheckbox"></td>
							<td>
								<?php
								echo $oneCat->text;
								?>
							</td>
						</tr>
						<?php $k = 1 - $k;
					}
				} ?>
			</table>
		</div>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){
		$mosetCats = acymailing_loadObjectList('SELECT id,parent_id,title FROM #__discuss_category ORDER BY `id` ASC');
		$this->cats = array();
		if(!empty($mosetCats)){
			foreach($mosetCats as $oneCat){
				$this->cats[$oneCat->parent_id][] = $oneCat;
			}
		}
		$this->catvalues = array();
		$this->catvalues[] = acymailing_selectOption(0, acymailing_translation('ACY_ALL'));
		$this->_handleChildrens();
		return acymailing_select($this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	function _handleChildrens($parent_id = 0, $level = 0){
		if(!empty($this->cats[$parent_id])){
			foreach($this->cats[$parent_id] as $cat){
				$this->catvalues[] = acymailing_selectOption($cat->id, str_repeat(" - - ", $level).$cat->title);
				$this->_handleChildrens($cat->id, $level + 1);
			}
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceOne(&$email){
		require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_easydiscuss'.DS.'includes'.DS.'easydiscuss.php');
		require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_easydiscuss'.DS.'includes'.DS.'parser'.DS.'parser.php');
		$this->imagesPath = trim(DiscussHelper::getConfig()->get('main_avatarpath'), '/');

		$acypluginsHelper = acymailing_get('helper.acyplugins');
		//load the tags
		$tags = $acypluginsHelper->extractTags($email, 'easydiscuss');
		if(empty($tags)){
			return;
		}
		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more text:
		$this->readmore = empty($email->template->readmore) ? acymailing_translation('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.acymailing_translation('JOOMEXT_READ_MORE', true).'" />';

		acymailing_loadLanguageFile('com_easydiscuss', JPATH_SITE);

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($tags as $i => $params){
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content, true);
			$subjectreplace[$i] = strip_tags($content);
		}
		$email->body = str_replace(array_keys($htmlreplace), $htmlreplace, $email->body);
		$email->altbody = str_replace(array_keys($textreplace), $textreplace, $email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace), $subjectreplace, $email->subject);
	}

	function _replaceContent(&$tag){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		if(!empty($tag->display)) $tag->display = explode(',', $tag->display);

		foreach($tag->display as $i => $oneDisplay){
			$oneDisplay = trim($oneDisplay);
			$tag->$oneDisplay = 1;
		}

		$tag->display = '';
		//1 : Load the content

		$data = array();
		$data['post'] = acymailing_loadObject('SELECT * FROM #__discuss_posts WHERE id = '.intval($tag->id).' LIMIT 1');

		//In case of we could not load the article for any reason...
		if(empty($data['post'])){
			if(acymailing_isAdmin()) acymailing_enqueueMessage('The post "'.$tag->id.'" could not be loaded', 'notice');
			return '';
		}

		$data['cat'] = acymailing_loadObject('SELECT * FROM #__discuss_category WHERE id = '.intval($data['post']->category_id).' LIMIT 1');

		$data['user'] = acymailing_loadObject('SELECT * FROM #__discuss_users WHERE id = '.intval($data['post']->user_id).' LIMIT 1');

		$varFields = array();
		foreach($data as $prefix => $oneTable){
			if(empty($oneTable)) continue;
			foreach($oneTable as $alias => $oneField){
				$varFields['{'.$prefix.'|'.$alias.'}'] = $oneField;
			}
		}

		$easydiscussParser = new EasyDiscussParser();
		$varFields['{post|content}'] = nl2br($easydiscussParser->bbcode($varFields['{post|content}']));

		$link = 'index.php?option=com_easydiscuss&view=post&id='.$tag->id;
		if(!empty($tag->itemid)) $link .= '&Itemid='.$tag->itemid;
		$link = acymailing_frontendLink($link);
		$varFields['{link}'] = $link;

		$result = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">';

		if(!empty($tag->title)){
			$result .= '<tr><td colspan="2"><h2 class="acymailing_title">';
			if(!empty($tag->clickable)){
				$result .= '<a href="'.$link.'">';
			}
			if(!empty($tag->resolved) && !empty($varFields['{post|isresolve}'])){
				$result .= '['.acymailing_translation('COM_EASYDISCUSS_FILTER_RESOLVED').']';
			}
			$result .= $varFields['{post|title}'];
			if(!empty($tag->clickable)){
				$result .= '</a>';
			}
			$result .= '</h2></td></tr>';
		}

		if(!empty($tag->author)){
			$userPict = '';
			if(!empty($varFields['{user|avatar}']) && file_exists(JPATH_SITE.DS.$this->imagesPath.DS.$varFields['{user|avatar}'])) $userPict = '<a href="index.php?option=com_easydiscuss&view=profile&id='.$varFields['{user|id}'].'"><img src="'.$this->imagesPath.DS.'original_'.$varFields['{user|avatar}'].'"/></a><br />';
			$result .= '<tr><td colspan="2">'.$userPict.'<a href="index.php?option=com_easydiscuss&view=profile&id='.$varFields['{user|id}'].'">'.$varFields['{user|nickname}'].'</a></td></tr>';
		}

		if(!empty($tag->text) && !empty($varFields['{post|content}'])) $result .= '<tr><td colspan="2">'.$acypluginsHelper->wrapText($varFields['{post|content}'], $tag).'</td></tr>';

		if(!empty($tag->category)){
			$result .= '<tr><td colspan="2">'.acymailing_translation('COM_EASYDISCUSS_POSTED_IN').' <a href="index.php?option=com_easydiscuss&view=categories&layout=listings&category_id='.$varFields['{cat|id}'].'">'.$varFields['{cat|title}'].'</td></tr>';
		}
		if(!empty($tag->reply)){
			$replies = acymailing_loadResultArray('SELECT count(parent_id) FROM #__discuss_posts WHERE parent_id='.intval($tag->id));
			$result .= '<tr><td>'.$replies[0].' '.acymailing_translation('COM_EASYDISCUSS_REPLIES_PLURAL').'</td></tr>';
		}
		if(!empty($tag->view)) $result .= '<tr><td colspan="2">'.$varFields['{post|hits}'].' '.acymailing_translation('COM_EASYDISCUSS_VIEWS_PLURAL').'</td></tr>';

		if(!empty($tag->vote)) $result .= '<tr><td colspan="2">'.$varFields['{post|sum_totalvote}'].' '.acymailing_translation('COM_EASYDISCUSS_VOTES_STRING_PLURAL').'</td></tr>';

		if(!empty($tag->like)) $result .= '<tr><td colspan="2">'.$varFields['{post|num_likes}'].' '.acymailing_translation('COM_EASYDISCUSS_SORT_LIKED_MOST').'</td></tr>';

		if(!empty($tag->caracteristics)){
			$tmp = array();
			$result .= '<tr><td colspan="2">';
			$postPolls = acymailing_loadResultArray('SELECT count(id) FROM #__discuss_polls WHERE post_id='.intval($tag->id));
			if(!empty($postPolls[0])) $tmp[] = acymailing_translation('COM_EASYDISCUSS_WITH_POLLS');
			$postAttachments = acymailing_loadResultArray('SELECT count(id) FROM #__discuss_attachments WHERE uid='.intval($tag->id));
			if(!empty($postAttachments[0])) $tmp[] = acymailing_translation('COM_EASYDISCUSS_WITH_ATTACHMENTS');
			if(!empty($varFields['{post|post_type}']) && $varFields['{post|post_type}'] != "default"){
				$postType = acymailing_loadResultArray('SELECT title FROM #__discuss_post_types WHERE alias LIKE '.acymailing_escapeDB($varFields['{post|post_type}']).' LIMIT 1');
				$tmp[] = acymailing_translation('COM_EASYDISCUSS_POST_TYPES_TITLE').' : '.$postType[0];
			}
			$result .= implode(' - ', $tmp);
			$result .= '</td></tr>';
		}

		if(!empty($tag->tags)){
			$query = 'SELECT a.tag_id, b.title FROM #__discuss_posts_tags AS a '.'JOIN #__discuss_tags AS b '.'ON a.tag_id = b.id '.'WHERE post_id='.intval($tag->id);
			$tags = acymailing_loadObjectList($query);
			if(!empty($tags)){
				$result .= '<tr><td colspan="2">'.acymailing_translation('COM_EASYDISCUSS_TOOLBAR_TAGS').' :';
				$varFields['{post|post_tags}'] = '';
				foreach($tags as $oneTag){
					$varFields['{post|post_tags}'] .= ' <a href="index.php?option=com_easydiscuss&view=tags&id='.$oneTag->tag_id.'">['.$oneTag->title.']</a>';
				}
				$result .= $varFields['{post|post_tags}'].'</td></tr>';
			}
		}

		if(!empty($tag->lastreply)){
			$lastReply = acymailing_loadResultArray('SELECT id FROM #__discuss_posts WHERE parent_id='.intval($tag->id).' AND replied = (SELECT max(replied) FROM #__discuss_posts WHERE parent_id='.intval($tag->id).')');
			if(!empty($lastReply)) $result .= '<tr><td colspan="2">'.'<a href="'.$link.'#reply-'.$lastReply[0].'">'.acymailing_translation('COM_EASYDISCUSS_VIEW_LAST_REPLY').'</td></tr>';
		}

		if(!empty($tag->readmore)){
			$readMoreText = empty($this->readmore) ? acymailing_translation('JOOMEXT_READ_MORE') : $this->readmore;
			$result .= '<tr><td colspan="2"><br /><a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$readMoreText.'</span></a></td></tr>';
		}

		$result .= '</table></div><br />';

		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'easydiscuss.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'easydiscuss.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields), $varFields, $result);
		}

		$result = $acypluginsHelper->removeJS($result);

		//resize pictures
		if(!isset($tag->pict)) $tag->pict = '0';
		$result = $this->acypluginsHelper->managePicts($tag, $result);
		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags), $this->tags, $email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags), $this->tags, $email->altbody);
			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag, strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis', ' | ', $result)), $email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		//load the tags
		$tags = $acypluginsHelper->extractTags($email, 'autoeasydiscuss');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;

			$allcats = explode('-', $parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT a.id FROM #__discuss_posts AS a JOIN #__discuss_category AS b ON a.category_id = b.id ';
			$where = array();
			if(empty($parameter->withreplies)) $where[] = 'a.parent_id = 0';
			if(!empty($selectedArea)) $where[] = 'a.category_id IN ('.implode(',', $selectedArea).')';

			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
				if($parameter->filter == 'created'){
					$where[] = 'a.created > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
				}elseif($parameter->filter == 'modified'){
					$where[] = 'a.created > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\' OR a.modified > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
				}
			}

			$where[] = "a.published = 1";

			if(!empty($where)){
				$query .= ' WHERE ('.implode(') AND (', $where).')';
			}

			if(!empty($parameter->order)){
				if($parameter->order == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',', $parameter->order);
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			if(!empty($parameter->max)){
				$query .= ' LIMIT '.intval($parameter->max);
			}else{
				$query .= ' LIMIT 20';
			}
			$allArticles = acymailing_loadResultArray($query);
			if(!empty($parameter->min) && count($allArticles) < $parameter->min){
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough EasyDiscuss posts for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles)){
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autoeasydiscuss.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autoeasydiscuss.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the article tag one after the other in a table as they are already sorted
					$arrayElements = array();
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = 'easydiscuss:'.$oneArticleId;
						if(!empty($parameter->clickable)) $args[] = 'clickable';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(!empty($parameter->readmore)) $args[] = 'readmore';
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|', $args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements, $parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}

	function onAcyDisplayFilters(&$type){
		if(!$this->component_installed) return '';

		$config = acymailing_config();

		if(version_compare($config->get('version'), '5.2.0', '<')){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this Easy Profile plugin will NOT work', 'error');
			return;
		}

		$posts = acymailing_loadObjectList('SELECT id, title FROM #__discuss_posts WHERE parent_id = 0');
		if(empty($posts)) return;

		$type['easydiscusslike'] = 'Easy Discuss: liked';
		$type['easydiscussfavourite'] = 'Easy Discuss: added in favourites';

		$return = '<div id="filter__num__easydiscusslike">'.acymailing_select($posts, "filter[__num__][easydiscusslike][post]", 'onchange="countresults(__num__)" class="inputbox" size="1"', 'id', 'title').'</div>';
		$return .= '<div id="filter__num__easydiscussfavourite">'.acymailing_select($posts, "filter[__num__][easydiscussfavourite][post]", 'onchange="countresults(__num__)" class="inputbox" size="1"', 'id', 'title').'</div>';

		return $return;
	}

	function onAcyProcessFilter_easydiscussfavourite(&$query, $filter, $num){
		$filter['post'] = intval($filter['post']);
		if(empty($filter['post'])) return 'Esay Discuss: error retrieving the post.';
		$query->join['easydiscussfavourites'.$num] = '#__discuss_favourites AS easydiscussfavourites'.$num.' ON sub.userid = easydiscussfavourites'.$num.'.created_by AND type = "post" AND post_id = '.$filter['post'];
	}

	function onAcyProcessFilterCount_easydiscussfavourite(&$query, $filter, $num){
		$this->onAcyProcessFilter_easydiscussfavourite($query, $filter, $num);
		return acymailing_translation_sprintf('SELECTED_USERS', $query->count());
	}

	function onAcyProcessFilter_easydiscusslike(&$query, $filter, $num){
		$filter['post'] = intval($filter['post']);
		if(empty($filter['post'])) return 'Esay Discuss: error retrieving the conversation.';
		$parent = acymailing_loadResult('SELECT parent_id FROM #__discuss_posts WHERE id = '.$filter['post']);
		$parent = intval($parent);
		$query->join['easydiscusslikes'.$num] = '#__discuss_likes AS easydiscusslikes'.$num.' ON sub.userid = easydiscusslikes'.$num.'.created_by AND type = "post" AND content_id = '.(empty($parent) ? $filter['post'] : $parent);
	}

	function onAcyProcessFilterCount_easydiscusslike(&$query, $filter, $num){
		$this->onAcyProcessFilter_easydiscusslike($query, $filter, $num);
		return acymailing_translation_sprintf('SELECTED_USERS', $query->count());
	}
}//endclass
?>