<?php
/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingFLEXIcontent extends JPlugin{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'FLEXIcontent');
			$this->params = new acyParameter($plugin->params);
		}
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
	}

	function acymailing_getPluginType(){
		if(!file_exists(JPATH_SITE.DS.'components'.DS.'com_flexicontent')) return;
		$app = JFactory::getApplication();
		if($this->params->get('frontendaccess') == 'none' && !$app->isAdmin()) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'FLEXIcontent';
		$onePlugin->function = 'acymailing_FLEXIcontent_show';
		$onePlugin->help = 'plugin-flexicontent';
		return $onePlugin;
	}

	function acymailing_FLEXIcontent_show(){
		$config = acymailing_config();
		if($config->get('version') < '4.9.4'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		$lang = JFactory::getLanguage();
		$lang->load('com_flexicontent', JPATH_SITE);
		$lang->load('com_flexicontent', JPATH_ADMINISTRATOR);
		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.flexicontent';

		$pageInfo->filter->order->value = $app->getUserStateFromRequest($paramBase.".filter_order", 'filter_order', 'a.id', 'cmd');
		$pageInfo->filter->order->dir = $app->getUserStateFromRequest($paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->limit->value = $app->getUserStateFromRequest($paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int');
		$pageInfo->limit->start = $app->getUserStateFromRequest($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->automaxvalue = $app->getUserStateFromRequest($paramBase.".max", 'max', '20', 'int');
		$pageInfo->contentfilter = $app->getUserStateFromRequest($paramBase.".contentfilter", 'contentfilter', '|filter:created', 'string');
		$pageInfo->contentorder = $app->getUserStateFromRequest($paramBase.".contentorder", 'contentorder', 'id', 'string');
		$pageInfo->pict = $app->getUserStateFromRequest($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->autopict = $app->getUserStateFromRequest($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->pictheight = $app->getUserStateFromRequest($paramBase.".pictheight", 'pictheight', $this->params->get('maxheight', 150), 'string');
		$pageInfo->pictwidth = $app->getUserStateFromRequest($paramBase.".pictwidth", 'pictwidth', $this->params->get('maxwidth', 150), 'string');
		$pageInfo->readmore = $app->getUserStateFromRequest($paramBase.".readmore", 'readmore', '1', 'string');
		$pageInfo->autoreadmore = $app->getUserStateFromRequest($paramBase.".autoreadmore", 'autoreadmore', '1', 'string');
		$pageInfo->wrap = $app->getUserStateFromRequest($paramBase.".wrap", 'wrap', '0', 'string');
		$pageInfo->cols = $app->getUserStateFromRequest($paramBase.".cols", 'cols', '1', 'string');
		$pageInfo->clickable = $app->getUserStateFromRequest($paramBase.".clickable", 'clickable', '1', 'string');
		$pageInfo->clickableauto = $app->getUserStateFromRequest($paramBase.".clickableauto", 'clickableauto', '1', 'string');

		$db = JFactory::getDBO();

		$searchFields = array('a.id', 'a.title', 'b.title', 'c.name');
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayart', 'all') == 'onlypub'){
			$filters[] = "a.state = 1";
		}else{
			$filters[] = "a.state != -2";
		}

		//we load the articles
		$query = 'SELECT SQL_CALC_FOUND_ROWS DISTINCT a.*,b.title AS cattitle, c.name AS username FROM #__content AS a ';
		$query .= 'JOIN #__flexicontent_items_ext AS d ON a.id = d.item_id ';
		$query .= 'JOIN #__categories AS b ON a.catid = b.id ';

		$query .= 'LEFT JOIN #__users AS c ON a.created_by = c.id';
		if(!empty($pageInfo->filter_cat)) $filters[] = "a.catid = ".$pageInfo->filter_cat;

		if(!empty($filters)){
			$query .= ' WHERE ('.implode(') AND (', $filters).')';
		}

		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}
		$db->setQuery($query, $pageInfo->limit->start, $pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search, $rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		$type = JRequest::getString('type');

		?>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			function applyContent(contentid, rowClass){
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1){
					window.document.getElementById('content' + contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content' + contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;
				for(var i = 0; i < document.adminForm.cbaffiche.length; i++){
					if(document.adminForm.cbaffiche[i].checked){
						if(tmp == 0){
							otherinfo += '| displays:' + document.adminForm.cbaffiche[i].value;
							tmp++;
						}else{
							otherinfo += '-' + document.adminForm.cbaffiche[i].value;
						}
					}
				}

				for(var i = 0; i < document.adminForm.clickable.length; i++){
					if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == 0){
						otherinfo += '| nolink';
					}
				}

				for(var i = 0; i < document.adminForm.readmore.length; i++){
					if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value != 0){
						otherinfo += '| readmore';
					}
				}

				for(var i = 0; i < document.adminForm.pict.length; i++){
					if(document.adminForm.pict[i].checked){
						if(document.adminForm.pict[i].value != 0){
							otherinfo += '| pict:' + document.adminForm.pict[i].value;
						}
						if(document.adminForm.pict[i].value == 'resized'){
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:' + document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0){
					otherinfo += "| wrap:" + document.adminForm.wrap.value;
				}

				for(var i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{FLEXIcontent:' + selectedContents[i] + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}

			var selectedCat = new Array();
			function applyAuto(catid, rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('cat' + catid).className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						for(key in selectedCat){
							if(!isNaN(key)){
								window.document.getElementById('cat' + key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat' + catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTagAuto(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;
				for(var i = 0; i < document.adminForm.cbafficheauto.length; i++){
					if(document.adminForm.cbafficheauto[i].checked){
						if(tmp == 0){
							otherinfo += '| displays:' + document.adminForm.cbafficheauto[i].value;
							tmp++;
						}else{
							otherinfo += '-' + document.adminForm.cbafficheauto[i].value;
						}
					}
				}

				for(var i = 0; i < document.adminForm.clickableauto.length; i++){
					if(document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == 0){
						otherinfo += '| nolink';
					}
				}

				for(var i = 0; i < document.adminForm.autoreadmore.length; i++){
					if(document.adminForm.autoreadmore[i].checked && +document.adminForm.autoreadmore[i].value != 0){
						otherinfo += '| readmore';
					}
				}

				for(var i = 0; i < document.adminForm.autopict.length; i++){
					if(document.adminForm.autopict[i].checked){
						if(document.adminForm.autopict[i].value != 0){
							otherinfo += '| pict:' + document.adminForm.autopict[i].value;
						}
						if(document.adminForm.autopict[i].value == 'resized'){
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:' + document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}

				if(document.adminForm.autowrap.value && document.adminForm.autowrap.value != 0){
					otherinfo += "| wrap:" + document.adminForm.autowrap.value;
				}

				if(document.adminForm.max_article.value){
					otherinfo += "| max:" + document.adminForm.max_article.value;
				}

				if(document.adminForm.cols.value){
					otherinfo += "| cols:" + document.adminForm.cols.value;
				}

				if(document.adminForm.contentorder.value){
					otherinfo += "| order:" + document.adminForm.contentorder.value;
				}

				<?php if($type == 'autonews'){ ?>

				if(document.adminForm.min_article.value){
					otherinfo += "| min:" + document.adminForm.min_article.value;
				}

				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){
					otherinfo += document.adminForm.contentfilter.value;
				}

				<?php } ?>

				tag = '{autoFLEXIcontent:';
				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat + '-';
					}
				}
				tag += otherinfo + '}<br />';
				setTag(tag);
			}
			//-->
		</script>
		<?php
		$fields = array();

		$addField = new stdClass();
		$addField->id = 'title';
		$addField->label = JText::_('FLEXI_FIELD_TITLE');
		$fields[] = $addField;
		$addField = new stdClass();
		$addField->id = 'text';
		$addField->label = JText::_('FLEXI_FIELD_DESCRIPTION');
		$fields[] = $addField;
		$addField = new stdClass();
		$addField->id = 'created';
		$addField->label = JText::_('FLEXI_FIELD_CREATED');
		$fields[] = $addField;
		$addField = new stdClass();
		$addField->id = 'created_by';
		$addField->label = JText::_('FLEXI_FIELD_CREATED_BY');
		$fields[] = $addField;
		$addField = new stdClass();
		$addField->id = 'modified';
		$addField->label = JText::_('FLEXI_FIELD_MODIFIED');
		$fields[] = $addField;
		$addField = new stdClass();
		$addField->id = 'modified_by';
		$addField->label = JText::_('FLEXI_FIELD_MODIFIED_BY');
		$fields[] = $addField;
		$addField = new stdClass();
		$addField->id = 'hits';
		$addField->label = JText::_('FLEXI_FIELD_HITS');
		$fields[] = $addField;
		$addField = new stdClass();
		$addField->id = 'document_type';
		$addField->label = JText::_('FLEXI_FIELD_DOCUMENT_TYPE');
		$fields[] = $addField;
		$addField = new stdClass();
		$addField->id = 'version';
		$addField->label = JText::_('FLEXI_FIELD_VERSION');
		$fields[] = $addField;
		$addField = new stdClass();
		$addField->id = 'categories';
		$addField->label = JText::_('FLEXI_CATEGORIES');
		$fields[] = $addField;
		$addField = new stdClass();
		$addField->id = 'voting';
		$addField->label = JText::_('FLEXI_VOTES');
		$fields[] = $addField;

		//we load FLEXIcontent's fields
		$db->setQuery('SELECT id,label FROM `#__flexicontent_fields` WHERE iscore = 0 ORDER BY label');
		$fields = array_merge($fields, $db->loadObjectList());

		$ordering = array();
		$ordering[] = JHTML::_('select.option', "id,DESC", JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "created,DESC", JText::_('CREATED_DATE'));
		$ordering[] = JHTML::_('select.option', "modified,DESC", JText::_('MODIFIED_DATE'));
		$ordering[] = JHTML::_('select.option', "title,ASC", JText::_('FIELD_TITLE'));
		$ordering[] = JHTML::_('select.option', "rand", JText::_('ACY_RANDOM'));

		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$column = array();
		for($i = 1; $i < 11; $i++){
			$column[] = JHTML::_('select.option', $i, $i);
		}

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane('docman_tab');
		echo $tabs->startPanel(JText::_('TAG_ELEMENTS'), 'flexi_listings');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<?php
				$tmp = 1;
				foreach($fields as $onefield){
					if($tmp == 5){
						echo '</tr><tr><td/>';
						$tmp = 1;
					}

					echo '<td>'.'<input type="checkbox" name="cbaffiche" value="'.$onefield->id.'" id="'.$onefield->id.'" onclick="updateTag();"/>'.'<label style="margin-left:5px" for="'.$onefield->id.'" id="'.$onefield->id.'-lbl">'.$onefield->label.'</label>'.'</td>';
					$tmp++;
				}

				while($tmp != 5){
					echo '<td/>';
					$tmp++;
				}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td nowrap="nowrap" colspan="2">
					<?php echo JHTML::_('acyselect.radiolist', $choice, 'clickable', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable);?>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER', '<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
			<tr>
				<td valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br/>
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
				</td>
				<td valign="top"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td valign="top"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
			</tr>
			<!-- ==================================================================================FILTRE==================================================================================== -->
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();"/>
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_('JOOMEXT_GO'); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_('JOOMEXT_RESET'); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>
		<!-- ===================================================================================LISTE ITEMS============================================================================== -->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
			<tr>
				<th/>
				<th class="title">
					<?php
					echo JHTML::_('grid.sort', JText::_('FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value);
					?>
				</th>
				<th class="title">
					<?php echo JHTML::_('grid.sort', JText::_('TAG_CATEGORIES'), 'cattitle', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title titleid">
					<?php
					echo JHTML::_('grid.sort', JText::_('ACY_ID'), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value);
					?>
				</th>
			</tr>
			</thead>
			<tfoot>
			<tr>
				<td colspan="5">
					<?php echo $pagination->getListFooter(); ?>
					<?php echo $pagination->getResultsCounter(); ?>
				</td>
			</tr>
			</tfoot>
			<tbody>
			<?php
			$k = 0;
			for($i = 0, $a = count($rows); $i < $a; $i++){
				$row =& $rows[$i];
				?>
				<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td>
						<?php
						$text = '<b>'.JText::_('JOOMEXT_ALIAS').' : </b>'.$row->title;
						$text .= '<br /><b>'.JText::_('ACY_USERNAME', true).' : </b>'.$row->username;
						echo acymailing_tooltip($text, $row->introtext, '', $row->title);
						?>
					</td>
					<td>
						<?php
						if(!empty($row->cattitle)){
							$text = '<b>'.JText::_('TAG_CATEGORIES', true).' : </b>'.$row->cattitle;
							echo acymailing_tooltip($text, $row->cattitle, '', $row->cattitle);
						}
						?>
					</td>
					<td align="center" style="text-align:center">
						<?php
						echo $row->id;
						?>
					</td>
				</tr>
				<?php
				$k = 1 - $k;
			}
			?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>
		<?php echo $tabs->endPanel(); ?>
		<!--====================================================================================PANNEAU CATEGORIES===========================================================================-->
		<?php echo $tabs->startPanel(JText::_('TAG_CATEGORIES'), 'docman_auto'); ?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<?php
				$tmp = 1;
				foreach($fields as $onefield){
					if($tmp == 5){
						echo '</tr><tr><td/>';
						$tmp = 1;
					}

					echo '<td>'.'<input type="checkbox" name="cbafficheauto" value="'.$onefield->id.'" id="'.$onefield->id.'auto" onclick="updateTagAuto();"/>'.'<label style="margin-left:5px" for="'.$onefield->id.'auto" id="'.$onefield->id.'-lbl">'.$onefield->label.'</label>'.'</td>';

					$tmp++;
				}

				while($tmp != 5){
					echo '<td/>';
					$tmp++;
				}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td nowrap="nowrap" colspan="2">
					<?php echo JHTML::_('acyselect.radiolist', $choice, 'clickableauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto);?>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER', '<input type="text" name="autowrap" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
			</tr>
			<tr>
				<td valign="top">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict); ?>
					<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br/>
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
				</td>
				<td valign="top"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td valign="top"><?php echo JHTML::_('acyselect.radiolist', $choice, 'autoreadmore', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autoreadmore); ?>
			</tr>
			<tr>
				<td valign="top"><?php echo JText::_('FIELD_COLUMNS'); ?></td>
				<td colspan="4">
					<?php echo JHTML::_('select.genericlist', $column, 'cols', 'style="width:50px;" size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td>
					<input type="text" name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
				</td>
				<td>
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td colspan="2">
					<?php echo JHTML::_('select.genericlist', $ordering, 'contentorder', 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews'){ ?>
				<tr>
					<td>
						<?php echo JText::_('MIN_ARTICLE'); ?>
					</td>
					<td>
						<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
					</td>
					<td>
						<?php echo JText::_('JOOMEXT_FILTER'); ?>
					</td>
					<td colspan="2">
						<?php $filter = acymailing_get('type.contentfilter');
						$filter->onclick = 'updateTagAuto();';
						echo $filter->display('contentfilter', $pageInfo->contentfilter); ?>
					</td>
				</tr>
			<?php } ?>
		</table>
		<!--====================================================================================LISTE CATEGORIES===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<?php $k = 0;
			?>
			<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
					<?php
					echo JText::_('ACY_ALL');
					?>
				</td>
			</tr>
			<?php
			if(!empty($this->catvalues)){
				foreach($this->catvalues as $oneCat){
					if(empty($oneCat->value)) continue;
					?>
					<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
							<?php
							echo $oneCat->text;
							?>
						</td>
					</tr>
					<?php
					$k = 1 - $k;
				}
			}
			?>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){
		//select all cats
		$db = JFactory::getDBO();
		if(ACYMAILING_J16){
			$db->setQuery('SELECT id,parent_id,title FROM #__categories WHERE extension IN ("com_content","system") ORDER BY `id` DESC');
		}else{
			$query = 'SELECT a.id,a.parent_id,a.title '.'FROM #__categories AS a '.'JOIN #__sections AS b '.'ON a.section = b.id '.'ORDER BY a.id DESC';
			$db->setQuery($query);
		}
		$mosetCats = $db->loadObjectList();
		$this->cats = array();
		foreach($mosetCats as $oneCat){
			$this->cats[$oneCat->parent_id][] = $oneCat;
		}
		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0, JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist', $this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	function _handleChildrens($parent_id = 0, $level = 0){
		if(!empty($this->cats[$parent_id])){
			foreach($this->cats[$parent_id] as $cat){
				if(ACYMAILING_J16){
					if($cat->title != "ROOT"){
						$this->catvalues[] = JHTML::_('select.option', $cat->id, str_repeat(" - - ", $level).$cat->title);
					}
				}else{
					$this->catvalues[] = JHTML::_('select.option', $cat->id, str_repeat(" - - ", $level).$cat->title);
				}
				$this->_handleChildrens($cat->id, $level + 1);
			}
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	private function _replaceOne(&$email){

		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, 'FLEXIcontent');
		if(empty($tags)) return;

		$this->currentcatid = -1;

		//load all fields
		$db = JFactory::getDBO();
		$db->setQuery('SELECT * FROM #__flexicontent_fields');
		$this->fields = $db->loadObjectList('name');
		$this->fieldsId = $db->loadObjectList('id');

		$this->displayLabel = array();
		foreach($this->fields as $oneField){
			if(!empty($oneField->attribs)){
				if(strpos($oneField->attribs, "display_label=") !== false){
					$this->displayLabel[$oneField->name] = substr($oneField->attribs, strpos($oneField->attribs, "display_label=") + 14, 1);
				}else{
					$params_decoded = json_decode($oneField->attribs);
					$this->displayLabel[$oneField->name] = $params_decoded->display_label;
				}
			}
		}

		//let's determine the Itemid
		$menuid = $this->params->get('itemid');
		if(empty($menuid)){
			$db->setQuery('SELECT id FROM #__menu WHERE link LIKE "%index.php?option=com_flexicontent%" LIMIT 1');
			$menuid = $db->loadResult();
		}
		$this->itemId = empty($menuid) ? '' : '&Itemid='.$menuid;

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE', true).'" />';

		$tagsReplaced = array();
		foreach($tags as $i => $oneTag){
			if(isset($tagsReplaced[$i])) continue;
			$tagsReplaced[$i] = $this->_replaceContent($oneTag);
		}

		$this->acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}

	function _replaceContent(&$tag){
		$db = JFactory::getDBO();
		$app = JFactory::getApplication();
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		if(empty($tag->displays) && empty($tag->titleonly)) return '';

		$query = 'SELECT a.*, b.name AS creator, c.name AS modifier, e.name AS doctype, f.title AS cattitle '.'FROM #__content AS a '.'JOIN #__flexicontent_items_ext AS d ON d.item_id = a.id '.'JOIN #__flexicontent_types AS e ON e.id = d.type_id '.'LEFT JOIN #__users AS b ON a.created_by = b.id '.'LEFT JOIN #__users AS c ON a.modified_by = c.id '.'LEFT JOIN #__categories AS f ON a.catid = f.id '.'WHERE a.id = '.intval($tag->id);
		$db->setQuery($query);
		$item = $db->loadObject();

		if(!empty($tag->titleonly)) $result = $item->title;

		if(!empty($tag->displays)){
			$tag->displays = explode('-', $tag->displays);

			$db->setQuery('SELECT a.title FROM #__categories AS a JOIN #__flexicontent_cats_item_relations AS b ON a.id = b.catid WHERE b.itemid = '.intval($tag->id).' ORDER BY a.title');
			$cats = acymailing_loadResultArray($db);

			$allFields = array();
			foreach($item as $field => $value){
				$allFields['{'.$field.'}'] = $value;
			}

			if(empty($item)){
				if($app->isAdmin()) $app->enqueueMessage('The item "'.$tag->id.'" could not be loaded.', 'notice');
				return '';
			}

			$result = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">';

			if(ACYMAILING_J16){
				$link = 'index.php?option=com_flexicontent&view=item&cid='.$item->catid.'&id='.$tag->id.':'.$item->alias.$this->itemId;
			}else{
				$link = 'index.php?option=com_flexicontent&view=items&cid='.$item->catid.'&id='.$tag->id.':'.$item->alias.$this->itemId;
			}

			$allFields['{link}'] = $link;

			if(in_array('title', $tag->displays) || in_array($this->fields['title']->id, $tag->displays)){
				$result .= '<tr><td colspan="2"><h2 class="acymailing_title">';
				if(empty($tag->nolink)){
					$result .= '<a target="_blank" href="'.$link.'">';
				}
				$result .= $item->title;
				if(empty($tag->nolink)){
					$result .= '</a>';
				}
				$result .= '</h2></td></tr>';
			}

			// HANDLE CORE FIELDS

			if((in_array('text', $tag->displays) || in_array($this->fields['text']->id, $tag->displays)) && !(empty($item->introtext) && empty($item->fulltext))){
				$result .= '<tr><td colspan="2">'.$acypluginsHelper->wrapText($item->introtext.$item->fulltext, $tag).'</td></tr>';
			}

			foreach($tag->displays as $oneField){
				if(is_numeric($oneField) && $this->fieldsId[$oneField]->iscore != 1) continue; // Not a core field
				if(is_numeric($oneField)) $oneField = $this->fieldsId[$oneField]->name;
				if($oneField == "title" || $oneField == "text") continue; // Already handled

				if($oneField == "created_by"){
					$displayedValue = $item->creator;
				}elseif($oneField == "modified_by"){
					$displayedValue = $item->modifier;
				}elseif($oneField == "document_type"){
					$displayedValue = $item->doctype;
				}elseif($oneField == "categories"){
					if(empty($cats)){
						$displayedValue = '';
					}else{
						$displayedValue = implode(', ', $cats);
					}
				}elseif($oneField == "created" || $oneField == "modified"){
					if($item->$oneField == '0000-00-00 00:00:00') continue;
					$displayedValue = acymailing_getDate(acymailing_getTime($item->$oneField), JText::_('DATE_FORMAT_LC'));
				}elseif($oneField == "voting"){
					$db->setQuery('SELECT * FROM #__content_rating AS a WHERE content_id = '.intval($tag->id));
					$votesdb = $db->loadObject();
					$displayedValue = empty($votesdb) || empty($votesdb->rating_count) ? JText::_('ACY_NONE') : number_format($votesdb->rating_sum / $votesdb->rating_count, 1).'/5';
				}else{
					$displayedValue = $item->$oneField;
				}

				if(!empty($displayedValue)){
					if($this->displayLabel[$oneField]){
						$result .= '<tr><td valign="top"><strong>'.$this->fields[$oneField]->label.'</strong></td><td valign="top">'.$displayedValue.'</td></tr>';
					}else{
						$result .= '<tr><td colspan="2">'.$displayedValue.'</td></tr>';
					}
				}

				$allFields['{'.$oneField.'}'] = $displayedValue;
			}

			// REMOVE CORE FIELDS FROM THE LIST

			foreach($tag->displays as $i => $one){
				if((!is_numeric($one) && !empty($this->fields[$one]->iscore)) || (is_numeric($one) && !empty($this->fieldsId[$one]->iscore))){
					unset($tag->displays[$i]);
				}
			}

			// HANDLE CUSTOM FIELDS

			if(!empty($tag->displays)){
				//load item's data
				$query = 'SELECT a.id, a.name AS fieldname, a.attribs, b.value '.'FROM `#__flexicontent_fields` AS a '.'JOIN `#__flexicontent_fields_item_relations` AS b '.'ON a.id = b.field_id '.'WHERE b.item_id = '.intval($tag->id).' '.'AND b.field_id IN ('.implode(',', $tag->displays).') '.'AND a.iscore = 0 ';
				'ORDER by a.ordering';

				$db->setQuery($query);
				$results = $db->loadObjectList();
			}

			if(!empty($results)){
				$values = array();
				foreach($results as $oneField){
					if(strlen($oneField->value) < 1 || $oneField->value == '0000-00-00 00:00:00'){
						continue;
					}

					if(!empty($values[$oneField->fieldname]) && is_array($values[$oneField->fieldname])){
						$values[$oneField->fieldname][] = $oneField->value;
					}elseif(!empty($values[$oneField->fieldname])){
						$temp = $values[$oneField->fieldname];
						$values[$oneField->fieldname] = array();
						$values[$oneField->fieldname][] = $temp;
						$values[$oneField->fieldname][] = $oneField->value;
					}else{
						$values[$oneField->fieldname] = $oneField->value;
					}
				}

				//Retrieving the HTML display of FLEXIcontent's fields
				//http://www.flexicontent.org/documentation/faq/item/247-retrieving-the-html-display-of-fc-fields-inside-3rd-party-code.html
				require_once(JPATH_ADMINISTRATOR.DS.'components/com_flexicontent/defineconstants.php');
				JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_flexicontent'.DS.'tables');
				require_once(JPATH_SITE.DS."components/com_flexicontent/classes/flexicontent.fields.php");
				require_once(JPATH_SITE.DS."components/com_flexicontent/classes/flexicontent.helper.php");
				require_once(JPATH_SITE.DS."components/com_flexicontent/models/".FLEXI_ITEMVIEW.".php");
				//we need this to make FC functions work
				$item->favs = $item->fav = $item->vote = $item->tags = $item->type_id = null;
				$db->setQuery('SELECT * FROM #__categories WHERE id = '.intval($item->catid));

				//we need cat's information
				$item->cats = array();
				$item->parameters = JComponentHelper::getParams('com_flexicontent');
				$item->cats[] = $db->loadObject();
				$item->cats[0]->slug = $item->cats[0]->alias;
				$item->creator = null;
				$item->modifier = null;
				$item->typename = null;
				$item->slug = $item->alias;

				ksort($values);
				foreach($values as $i => $onevalue){
					if(!is_array($values[$i])){
						$tmp = $values[$i];
						$values[$i] = array();
						$values[$i][] = $tmp;
						$onevalue = $values[$i];
					}

					//we have to create a copy of the field, otherwise it takes a pointer and it can not take right information
					$myfield = clone($this->fields[$i]);
					$newfield = FlexicontentFields::renderField($item, $myfield, $onevalue);
					if(!empty($newfield->display)){
						if(!empty($newfield->thumbs_src['large'])){
							if(!empty($this->displayLabel[$i])){
								$result .= '<tr><td valign="top" nowrap="nowrap"><strong>'.$newfield->label.'</strong></td><td style="width:60%">';
								foreach($newfield->thumbs_src['large'] as $path){
									$result .= '<a href="'.$link.'"><img src="'.$path.'"/></a>';
								}
								$result .= '</td></tr>';
							}else{
								$result .= '<tr><td colspan="2" style="width:100%">';
								foreach($newfield->thumbs_src['large'] as $path){
									$result .= '<a href="'.$link.'"><img src="'.$path.'"/></a>';
								}
								$result .= '</td></tr>';
							}
							$allFields['{'.$i.'}'] = $path;
						}else{
							// if something is added after the posttext, remove it !
							$newfield->posttext = $newfield->parameters->get('posttext');
							if(!empty($newfield->posttext) && preg_match('#'.$newfield->posttext.'$#i', $newfield->display) == 0){
								$newfield->display = str_replace(substr($newfield->display, strrpos($newfield->display, $newfield->posttext)), $newfield->posttext, $newfield->display);
							}

							if(strlen($newfield->display) < 5 && !empty($newfield->value[0])){
								$newfield->display = $newfield->value[0];
							}
							
							$dispVal = str_replace('/administrator/', '/', $newfield->display);
							$allFields['{'.$i.'}'] = $dispVal;
							if(!empty($this->displayLabel[$i])){
								$result .= '<tr><td valign="top" nowrap="nowrap"><strong>'.$newfield->label.'</strong></td><td>'.$dispVal.'</td></tr>';
							}else{
								$result .= '<tr><td colspan="2">'.$dispVal.'</td></tr>';
							}
						}
					}
				}
			}

			if(!empty($tag->readmore)){
				$readMoreText = (is_string($tag->readmore) && strlen(trim($tag->readmore)) > 1) ? $tag->readmore : $this->readmore;
				$result .= '<tr><td colspan="2"><br /><a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$readMoreText.'</span></a></td></tr>';
			}

			$result .= '</table></div>';

			$result = preg_replace('#<div class="multiBoxDesc[^<>]*> *</div>#i', '', $result);
			$result = preg_replace('#&nbsp;#i', ' ', $result);

			if(!empty($tag->cattitle) && !empty($item->cattitle) && $this->currentcatid != $item->catid){
				$this->currentcatid = $item->catid;
				$result = '<h3 class="cattitle">'.$item->cattitle.'</h3>'.$result;
			}
		}

		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'flexicontent.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'flexicontent.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($allFields), $allFields, $result);
		}

		$result = $acypluginsHelper->removeJS($result);

		//resize pictures
		$pictureHelper = acymailing_get('helper.acypict');
		if(!empty($tag->pict)){
			if($tag->pict == 'resized'){
				$pictureHelper->maxHeight = empty($tag->maxheight) ? 150 : $tag->maxheight;
				$pictureHelper->maxWidth = empty($tag->maxwidth) ? 150 : $tag->maxwidth;
				if($pictureHelper->available()){
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error, 'notice');
				}
			}
		}else{
			$result = $pictureHelper->removePictures($result);
		}
		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$this->acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$db = JFactory::getDBO();
		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, 'autoFLEXIcontent');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;

			if(!empty($parameter->max)) $parameter->max_article = $parameter->max;
			if(!empty($parameter->min)) $parameter->min_article = $parameter->min;

			$allcats = explode('-', $parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT DISTINCT a.id FROM #__content AS a ';
			$query .= 'JOIN #__flexicontent_cats_item_relations AS c ON a.id = c.itemid ';
			$query .= 'JOIN #__flexicontent_items_ext AS b ON a.id = b.item_id ';
			$where = array();

			if(!empty($selectedArea)){
				$where[] = 'c.catid IN ('.implode(',', $selectedArea).')';
			}

			/* START FLEXICONTENT CATEGORIES FILTER */
			$params = JComponentHelper::getParams( 'com_flexicontent' );
			$featured_cats_parent = $params->get('featured_cats_parent', 0);
			global $globalcats;
			$subquery_featured_where = isset($globalcats[$featured_cats_parent]) ? 'cf.catid IN ('.$globalcats[$featured_cats_parent]->descendants.')' : 'cf.catid = '. $featured_cats_parent;
			$subquery_featured = '(SELECT distinct itemid FROM #__flexicontent_cats_item_relations as cf WHERE '.$subquery_featured_where.')';

			if(isset($parameter->flexifeatured)) {
				$where[] = 'a.id IN '.$subquery_featured;
			}

			if(isset($parameter->noflexifeatured)){
				$where[] = 'a.id NOT IN '.$subquery_featured;
			}
			/* END FLEXICONTENT CATEGORIES FILTER */

			if(!empty($parameter->featured)){
				$where[] = 'a.featured = 1';
			}

			if(!empty($parameter->nofeatured)){
				$where[] = 'a.featured = 0';
			}

			if(!empty($parameter->filter)){
				$condition = 'a.`publish_up` >\''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
				$condition .= ' OR a.`created` > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
				if($parameter->filter == 'modify'){
					$condition .= ' OR a.`modified` > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
				}
				$where[] = $condition;
			}

			if(!empty($parameter->maxcreated)){
				$date = $parameter->maxcreated;
				if(strpos($date, '[time]') !== false) $date = acymailing_replaceDate(str_replace('[time]', '{time}', $date));
				if(!is_numeric($date)) $date = strtotime($date);
				if(empty($date)){
					acymailing_display('Wrong date format ('.$parameter->maxcreated.' in '.$oneTag.'), please use YYYY-MM-DD', 'warning');
				}
				$where[] = 'a.`created` < '.$db->Quote(date('Y-m-d H:i:s', $date));
			}

			if(!empty($parameter->mincreated)){
				$date = $parameter->mincreated;
				if(strpos($date, '[time]') !== false) $date = acymailing_replaceDate(str_replace('[time]', '{time}', $date));
				if(!is_numeric($date)) $date = strtotime($date);
				if(empty($date)){
					acymailing_display('Wrong date format ('.$parameter->mincreated.' in '.$oneTag.'), please use YYYY-MM-DD', 'warning');
				}
				$where[] = 'a.`created` > '.$db->Quote(date('Y-m-d H:i:s', $date));
			}

			$where[] = "a.state = 1";
			$query .= ' WHERE ('.implode(') AND (', $where).')';

			if(!empty($parameter->order)){
				if($parameter->order == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',', $parameter->order);
					$query .= ' ORDER BY a.`'.acymailing_secureField(trim($ordering[0])).'` '.acymailing_secureField(trim($ordering[1]));
				}
			}

			if(!empty($parameter->max_article)){
				$query .= ' LIMIT '.intval($parameter->max_article);
			}else{
				$query .= ' LIMIT 20';
			}

			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);
			if(!empty($parameter->min_article) && count($allArticles) < intval($parameter->min_article)){
				$return->status = false;
				$return->message = 'Not enough content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min_article.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
			}
			$stringTag = '';
			if(!empty($allArticles)){
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autoflexicontent.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autoflexicontent.php');
					$stringTag = ob_get_clean();
				}else{
					$arrayElements = array();
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = 'FLEXIcontent:'.$oneArticleId;
						if(!empty($parameter->displays)) $args[] = 'displays:'.$parameter->displays;
						if(isset($parameter->readmore)) $args[] = 'readmore';
						if(isset($parameter->titleonly)) $args[] = 'titleonly';
						if(isset($parameter->nolink)) $args[] = 'nolink';
						if(isset($parameter->cattitle)) $args[] = 'cattitle';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|', $args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements, $parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass
?>