<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingGMapFP extends JPlugin
{
	var $cats = array();
	var $catvalues = array();
	var $newslanguage;
	var $readmore = '';
	var $tags = array();

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'gmapfp');
			$this->params = new acyParameter( $plugin->params );
		}

		$this->db = JFactory::getDBO();
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_gmapfp');
	}

	function acymailing_getPluginType(){
		$app = JFactory::getApplication();
	 	if(!$this->component_installed || ($this->params->get('frontendaccess') == 'none' && !$app->isAdmin())) return;
	 	$onePlugin = new stdClass();
	 	$onePlugin->name = 'GMapFP';
	 	$onePlugin->function = 'acymailingGMapFP_show';
	 	$onePlugin->help = 'plugin-gmapfp';
	 	return $onePlugin;
	}

	function acymailingGMapFP_show(){
	 	$config = acymailing_config();
		if($config->get('version') < '4.9.4'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$lang = JFactory::getLanguage();
		$lang->load('com_gmapfp',JPATH_SITE);
		$lang->load('com_contact',JPATH_SITE);
		$app = JFactory::getApplication();
		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.gmapfp';

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order', 'a.id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->automaxvalue = $app->getUserStateFromRequest( $paramBase.".max", 'max','20','int' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id','string' );
		$pageInfo->contentorderdir = $app->getUserStateFromRequest( $paramBase.".contentorderdir", 'contentorderdir','DESC','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','|cols:1','string' );
		$pageInfo->clickable = $app->getUserStateFromRequest( $paramBase.".clickable", 'clickable','1','string' );
		$pageInfo->clickableauto = $app->getUserStateFromRequest( $paramBase.".clickableauto", 'clickableauto','1','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->autopict = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight',150,'string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth',150,'string' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".filter", 'filter','created','string' );
		$pageInfo->wrap = $app->getUserStateFromRequest( $paramBase.".wrap", 'wrap','0','string' );

		$searchFields = array('a.id','a.nom','a.ville','a.adresse','a.adresse2','b.title');
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayart','all') == 'onlypub')
			$filters[] = "a.published = 1";
		else
			$filters[] = "a.published != -2";

		//we load all places
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*,b.*,a.id AS lID
				FROM `#__gmapfp` AS a
				JOIN #__categories AS b ON a.catid = b.id ';

		if(!empty($pageInfo->filter_cat)) $filters[] = "a.catid = ".intval($pageInfo->filter_cat);
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (',$filters).')';

		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		$this->db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $this->db->loadObjectList();

		if(!empty($rows[0]) && !isset($rows[0]->acy_created)){
			$this->db->setQuery('ALTER TABLE `#__gmapfp` ADD `acy_created` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP');
			$this->db->query();
		}

		if(!empty($pageInfo->search)) $rows = acymailing_search($pageInfo->search,$rows);

		$this->db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $this->db->loadResult();
		$pageInfo->elements->page = count($rows);
		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );
		$type = JRequest::getString('type');
	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass){
				var tmp = selectedContents.indexOf(contentid);
				if(tmp != -1){
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp=0;
				for(var i=0; i < document.adminForm.cbaffiche.length; i++){
					 if (document.adminForm.cbaffiche[i].checked){
					 	if(tmp==0){
					 		tmp+=1;
					 		otherinfo += "| display:"+document.adminForm.cbaffiche[i].value;
					 	}else{
					 		otherinfo += ", "+document.adminForm.cbaffiche[i].value;
					 	}
					 }
				}

				for(var i=0; i < document.adminForm.clickable.length; i++){
					 if (document.adminForm.clickable[i].checked){ otherinfo += '| clickable:'+document.adminForm.clickable[i].value;}
				}

				for(var i=0; i < document.adminForm.pict.length; i++){
					if(document.adminForm.pict[i].checked){ otherinfo += '| pict:'+document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized'){
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				if(document.adminForm.wrap.value && document.adminForm.wrap.value!=0){ otherinfo += "| wrap:"+document.adminForm.wrap.value; }

				for(var key in selectedContents){
					if(selectedContents.hasOwnProperty(key) && selectedContents[key] && !isNaN(key)){
						tag = tag + '{GMapFP:'+selectedContents[key]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('catall').className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('catall').className = 'selectedrow';
						var key;
						for(key in selectedCat){
							if(!selectedCat.hasOwnProperty(key) || isNaN(key)) continue;
							window.document.getElementById('cat'+key).className = rowClass;
							delete selectedCat[key];
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat'+catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTagAuto(){
				var otherinfo = '';
				var tmp=0;
				for(var i=0; i < document.adminForm.cbafficheauto.length; i++){
					 if (document.adminForm.cbafficheauto[i].checked){
					 	if(tmp==0){
					 		tmp+=1;
					 		otherinfo += "| display:"+document.adminForm.cbafficheauto[i].value;
					 	}else{
					 		otherinfo += ", "+document.adminForm.cbafficheauto[i].value;
					 	}
					 }
				}

				for(var i=0; i < document.adminForm.clickableauto.length; i++){
					 if (document.adminForm.clickableauto[i].checked){ otherinfo += '| clickable:'+document.adminForm.clickableauto[i].value;}
				}

				for(var i=0; i < document.adminForm.autopict.length; i++){
					 if (document.adminForm.autopict[i].checked){
					 	otherinfo += '| pict:'+document.adminForm.autopict[i].value;
						if(document.adminForm.autopict[i].value == 'resized'){
					 		document.getElementById('pictsizeauto').style.display = '';
					 		if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidthauto.value;
					 		if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:'+document.adminForm.pictheightauto.value;
					 	}else{
					 		document.getElementById('pictsizeauto').style.display = 'none';
					 	}
					 }
				}

				if(document.adminForm.autowrap.value && document.adminForm.autowrap.value!=0){ otherinfo += "| wrap:"+document.adminForm.autowrap.value; }
				if(document.adminForm.max_article.value){ otherinfo += "| max_article:"+document.adminForm.max_article.value; }
				if(document.adminForm.cols.value){ otherinfo += "| cols:"+document.adminForm.cols.value; }
				if(document.adminForm.contentorder.value){ otherinfo += "| order:"+document.adminForm.contentorder.value+","+document.adminForm.contentorderdir.value; }
				<?php if($type == 'autonews'){ ?>
				if(document.adminForm.min_article.value){ otherinfo += "| min_article:"+document.adminForm.min_article.value; }
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value && document.adminForm.contentfilter.value != 'tous'){ otherinfo += "| filter:"+document.adminForm.contentfilter.value; }
				<?php } ?>

				var tag = '{autoGMapFP:';
				for(var icat in selectedCat){
					if(selectedCat.hasOwnProperty(icat) && selectedCat[icat] == 'selectedone'){
						tag += icat+'-';
					}
				}
				tag += otherinfo+'}<br />';

				setTag(tag);
			}
		//-->
		</script>
		<?php
		$clickable = array();
		$clickable[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$clickable[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$filter = array();
		$filter[] = JHTML::_('select.option', "tous",JText::_('ACY_ALL'));
		$filter[] = JHTML::_('select.option', "created",JText::_('ONLY_NEW_CREATED'));

		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized",JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$column = array();
		for($i=1;$i<11;$i++){
			$column[] = JHTML::_('select.option', "$i",$i);
		}

?><!--==============================================================================Articles=========================================================================================--><?php
		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane( 'gmapfp_tab');
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), 'gmapfp_listings');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="name" id="name" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="name" id="name-lbl"><?php echo JText::_('NAMECAPTION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="intro" id="intro" onclick="updateTag();"/><label style="margin-left:5px" for="intro" id="intro-lbl"><?php echo JText::_('COM_CONTACT_CONTACT_ENTER_MESSAGE_LABEL');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="price" id="price" onclick="updateTag();"/><label style="margin-left:5px" for="price" id="price-lbl"><?php echo JTEXT::_('GMAPFP_HORAIRES_PRIX'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="address" id="adress" onclick="updateTag();"/><label style="margin-left:5px" for="adress" id=""><?php echo JText::_('ADDRESSCAPTION');?></label></td>
			</tr>
			<tr>
				<td></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="tel" id="tel" onclick="updateTag();"/><label style="margin-left:5px" for="tel" id="download-lbl"><?php echo JText::_('PHONECAPTION'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="emailadress" id="emailadress" onclick="updateTag();"/><label style="margin-left:5px" for="emailadress" id="clickable-lbl"><?php echo JText::_('EMAIL_ADDRESS');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="links" id="links" onclick="updateTag();"/><label style="margin-left:5px" for="links" id="clickable-lbl"><?php echo str_replace(' :','',JText::_('GMAPFP_SITE_WEB'));?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="image" id="image" onclick="updateTag();"/><label style="margin-left:5px" for="image" id="image-lbl"><?php echo JText::_('ACY_IMAGE');?></label></td>
			</tr>
			<tr>
				<td/>
				<td colspan="4"><input type="checkbox" name="cbaffiche" value="readmore" id="readmore" onclick="updateTag();"/><label style="margin-left:5px" for="readmore" id="readmore-lbl"><?php echo JText::_('JOOMEXT_READ_MORE');?></label></td>
			</tr>
			<tr>
				<td><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $clickable, 'clickable' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
			<tr>
				<td valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td colspan="4"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th/>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'NAMECAPTION'), 'a.nom', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					for($i = 0;$i<count($rows);$i++){
						$row =& $rows[$i];
				?>
					<tr id="content<?php echo $row->lID; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->lID.",'row$k'"?>);" style="cursor:pointer;">
						<td class="acytdcheckbox"><td>
						<?php
							$text = '<b>'.JText::_('JOOMEXT_ALIAS').' : </b>'.$row->nom;
							$text .= '<br /><b>'.JText::_('ACY_USERNAME',true).' : </b>';
							echo acymailing_tooltip($text, $row->nom, '', $row->nom);
						?>
						</td>
						<td>
						<?php
							if(!empty($row->title)){
								$text = '<b>'.JText::_('TAG_CATEGORIES',true).' : </b>'.$row->title;
								echo acymailing_tooltip($text, $row->title, '', $row->title);
							}
						?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo $row->lID; ?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
	<?php

		echo $tabs->endPanel();
?><!--==============================================================================CATEGORIES=======================================================================================--><?php
		echo $tabs->startPanel( JText::_('TAG_CATEGORIES'), 'gmapfp_auto');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="name" id="nameauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="nameauto" id="nameauto-lbl"><?php echo JText::_('NAMECAPTION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="intro" id="introauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="introauto" id="introauto-lbl"><?php echo JText::_('COM_CONTACT_CONTACT_ENTER_MESSAGE_LABEL');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="price" id="priceauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="priceauto" id="priceauto-lbl"><?php echo JTEXT::_('GMAPFP_HORAIRES_PRIX'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="address" id="adressauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="adressauto" id=""><?php echo JText::_('ADDRESSCAPTION');?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="tel" id="telauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="telauto" id="download-lbl"><?php echo JText::_('PHONECAPTION'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="emailadress" id="emailadressauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="emailadressauto" id="clickable-lbl"><?php echo JText::_('EMAIL_ADDRESS');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="links" id="linksauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="linksauto" id="clickable-lbl"><?php echo str_replace(' :','',JText::_('GMAPFP_SITE_WEB'));?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="image" id="imageauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="imageauto" id="imageauto-lbl"><?php echo JText::_('ACY_IMAGE');?></label></td>
			</tr>
			<tr>
				<td/>
				<td colspan="4"><input type="checkbox" name="cbafficheauto" value="readmore" id="readmoreauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="readmoreauto" id="readmoreauto-lbl"><?php echo JText::_('JOOMEXT_READ_MORE');?></label></td>
			</tr>
			<tr>
				<td><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $clickable, 'clickableauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="autowrap" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td valign="top">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td colspan="4"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict); ?>
					<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
			</tr>
			<tr>
				<td valign="top"><?php echo JText::_('FIELD_COLUMNS'); ?></td>
				<td colspan="4">
				 	<?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" style="width:75px;" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td><?php echo JText::_('MAX_ARTICLE'); ?></td>
				<td colspan="2">
				 	<input type="text" name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
				</td>
				<td><?php echo JText::_('ACY_ORDER'); ?></td>
				<td>
					<?php
						$values = array('id' => 'ACY_ID', 'pay' => 'COUNTRYCAPTION', 'ville' => 'CITYCAPTION', 'nom' => 'NAMECAPTION');
						echo $this->acypluginsHelper->getOrderingField($values, $pageInfo->contentorder, $pageInfo->contentorderdir);
					?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td><?php echo JText::_('MIN_ARTICLE'); ?></td>
				<td colspan="2">
					<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td><?php echo JText::_('JOOMEXT_FILTER'); ?></td>
				<td>
					<?php $filter = acymailing_get('type.contentfilter'); $filter->onclick = 'updateTagAuto();'; echo $filter->display('contentfilter',$pageInfo->contentfilter,false,false); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<tr id="catall" class="<?php echo "row0"; ?>" onclick="applyAuto('all','<?php echo "row0" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td><?php echo JText::_('ACY_ALL'); ?></td>
			</tr>
		<?php $k=1; foreach($this->catvalues as $oneCat){
			 if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"><td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
		<?php $k = 1 - $k; } ?>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){
		//select all cats
		$this->db->setQuery('SELECT id,parent_id,title,extension FROM #__categories ORDER BY `id` DESC');
		$mosetCats = $this->db->loadObjectList();
		$this->cats = array();
		if(!empty($mosetCats)){
			foreach($mosetCats as $oneCat){
				$this->cats[$oneCat->parent_id][] = $oneCat;
			}
		}
		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist', $this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int) $filter_cat);
	}

	function _handleChildrens($parent_id=0,$level=0){
		if(empty($this->cats[$parent_id])) return;

		foreach($this->cats[$parent_id] as $cat){
			if($cat->extension=="com_gmapfp") $this->catvalues[] = JHTML::_('select.option', $cat->id,str_repeat(" - - ",$level).$cat->title);
			$this->_handleChildrens($cat->id,$level+1);
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
 		$this->_replaceOne($email);
	}

	function _replaceOne(&$email){
	 	//we search GMapFP tags
		$tags = $this->acypluginsHelper->extractTags($email, 'GMapFP');
		if(empty($tags)) return;

		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$lang = JFactory::getLanguage();
		$lang->load('com_gmapfp',JPATH_SITE);
		$lang->load('com_contact',JPATH_SITE);

		//let's determine the Itemid
		$menuid = $this->params->get('itemid');
		if(empty($menuid)){
			$this->db->setQuery('SELECT id FROM #__menu WHERE link LIKE "%index.php?option=com_gmapfp&view=gmapfp&layout=article%" LIMIT 1');
			$menuid = $this->db->loadResult();
		}

		$this->itemId = empty($menuid) ? '' : '&Itemid='.$menuid;

		$tagsReplaced = array();
		foreach($tags as $i => $oneTag){
			if(isset($tagsReplaced[$i])) continue;
			$tagsReplaced[$i] = $this->_replaceContent($oneTag);
		}

		$this->acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}

	function _replaceContent(&$tag){
		if(!empty($tag->display)){
			$tag->display = explode(',',$tag->display);

			foreach($tag->display as $i => $oneDisplay){
				$oneDisplay = trim($oneDisplay);
				$tag->$oneDisplay = true;
			}
		}

		//2 : Load the GMapFP article
		$query = 'SELECT a.*,b.*,a.id AS lID FROM `#__gmapfp` AS a ';
		$query .= 'JOIN #__categories AS b ON a.catid = b.id ';
		$query .= 'WHERE a.id = '.intval($tag->id);

		$this->db->setQuery($query);
		$article = $this->db->loadObject();

		$varFields = array();
		foreach($article as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		//In case of we could not load the article for any reason
		if(empty($article)){
			$app = JFactory::getApplication();
			if($app->isAdmin()) $app->enqueueMessage('The GMapFP location "'.$tag->id.'" could not be loaded','notice');
			return '';
		}

		$result = '<div class="acymailing_content">';

		$link = 'index.php?option=com_gmapfp&view=gmapfp&layout=article&id='.$article->lID.$this->itemId;
		$varFields['{link}'] = $link;

		if(!empty($tag->name)){
			$resultTitle = '<h2 class="acymailing_title">'.$article->nom.'</h2>';
			if(!empty($tag->clickable)) $resultTitle = '<a href="'.$link.'" target="_blank" >'.$resultTitle.'</a>';
			$result .= $resultTitle;
		}

		$result .= '<table cellspacing="1" cellpadding="2" border="0">';

		if((!empty($tag->image) && !empty($article->img)) || (!empty($tag->intro) && !empty($article->intro))){
			$result .= '<tr><td class="fieldvalue gmapdescription" colspan="2">';

			if(!empty($tag->image) && !empty($article->img)){
				$imageFolder = trim(JComponentHelper::getParams('com_gmapfp')->get('gmapfp_chemin_img'),"/");
				if(!file_exists(JPATH_SITE.DS.str_replace('/', DS, $imageFolder).DS.$article->img)) $imageFolder = 'images/gmapfp';
				$varFields['{imagePath}'] = $imageFolder.'/'.$article->img;
				$varFields['{imageHTML}'] = '<img '.(empty($tag->nostyle) ? 'style="float:left;" ' : '').'src="'.$imageFolder.'/'.$article->img.'" alt="'.$article->img.'"/>';
				$result .= $varFields['{imageHTML}'];
			}

			if(!empty($tag->intro) && !empty($article->intro)){
				$result .= $this->acypluginsHelper->wrapText($article->intro, $tag);
			}

			$result .= '</td></tr>';
		}

		if(!empty($tag->address)){
			$address = array();

			if(!empty($article->adresse)) $address[] = $article->adresse;
			if(!empty($article->adresse2)) $address[] = $article->adresse2;
			if(!empty($article->codepostal)) $address[] = $article->codepostal;
			if(!empty($article->ville)) $address[] = $article->ville;
			if(!empty($article->departement)) $address[] = $article->departement;
			if(!empty($article->pay)) $address[] = $article->pay;

			if(!empty($address)){
				$varFields['{address}'] = implode('<br/>', $address);
				$result .= '<tr><td class="fieldname gmapaddress" valign="top">'.JText::_('ADDRESSCAPTION').' :</td><td class="fieldvalue">'.implode('<br/>', $address).'</td></tr>';
			}
		}

		if(!empty($tag->tel)){
			$contact = array();

			if(!empty($article->tel)) $contact[] = JText::_('GMAPFP_TEL').$article->tel;
			if(!empty($article->tel2)) $contact[] = JText::_('GMAPFP_TEL2').$article->tel2;
			if(!empty($article->fax)) $contact[] = JText::_('GMAPFP_FAX').$article->fax;

			if(!empty($contact)){
				$varFields['{contact}'] = implode('<br/>', $contact);
				$result .= '<tr><td class="fieldname gmapcontact" valign="top">'.JText::_('COM_CONTACT_DEFAULT_PAGE_TITLE').' :</td><td class="fieldvalue">'.implode('<br/>', $contact).'</td></tr>';
			}
		}

		if(!empty($tag->price) && !empty($article->horaires_prix)){
			$result .= '<tr><td class="fieldname gmapprice">'.JText::_('GMAPFP_HORAIRES_PRIX').' :</td><td class="fieldvalue">'.$article->horaires_prix.'</td></tr>';
		}

		if(!empty($tag->emailadress) && !empty($article->email)){
			$result .= '<tr><td class="fieldname gmapemail">'.JText::_('EMAIL_ADDRESS').' :</td><td class="fieldvalue">'.$article->email.'</td></tr>';
		}

		if(!empty($tag->links) && !empty($article->web)){
			$result .= '<tr><td class="fieldname gmapurl">'.JText::_('GMAPFP_SITE_WEB').'</td><td class="fieldvalue"><a href="'.$article->web.'" target="_blank" >'.$article->web.'</a></td></tr>';
		}

		if(!empty($tag->readmore)){
			$varFields['{readmore}'] = '<a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a>';
			$result .='<tr><td colspan="2">'.$varFields['{readmore}'].'</td></tr>';
		}

		$result .= '</table></div>';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'gmapfp.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'gmapfp.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}

		$result = $this->acypluginsHelper->removeJS($result);
		$result = $this->acypluginsHelper->managePicts($tag, $result);

		return $result;
	}

	private function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$this->acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function acymailing_generateautonews(&$email){
		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email,'autoGMapFP');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$time = time();
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;
			$allcats = explode('-',$parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT a.id FROM #__gmapfp AS a ';

			$where = array();

			// load only needed content
			if(!empty($selectedArea)) $where[] = 'catid IN ('.implode(',',$selectedArea).')';

			if(!empty($parameter->filter) && $parameter->filter == 'created'){
				$where[] = 'acy_created > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
			}

			$where[] = "published = 1";
			$query .= ' WHERE ('.implode(') AND (',$where).')';

			if(!empty($parameter->order)){
				$ordering = explode(',',$parameter->order);
				if($ordering[0] == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$query .= ' ORDER BY `'.acymailing_secureField(trim($ordering[0])).'` '.acymailing_secureField(trim($ordering[1]));
				}
			}

			if(!empty($parameter->max_article)) $query .= ' LIMIT '.intval($parameter->max_article);
			else $query .= ' LIMIT 20';
			//We add a limit for the preview otherwise we could break everything
			$this->db->setQuery($query);
			$allArticles = acymailing_loadResultArray($this->db);

			if(!empty($parameter->min_article) && count($allArticles)< intval($parameter->min_article)){
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min_article.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
			}

			$stringTag = '';
			if(!empty($allArticles)){
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autogmapfp.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autogmapfp.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
					$arrayElements = array();
					unset($parameter->id);
					$numArticle = 1;
					foreach($allArticles as $oneArticleId){
						$numArticle++;
						$args = array();
						$args[] = 'GMapFP:'.$oneArticleId;
						foreach($parameter as $oneParam => $val){
							if(is_bool($val)) $args[] = $oneParam;
							else $args[] = $oneParam.':'.$val;
						}
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $this->acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass