<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingguru extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		$this->name = 'guru';
		$this->db = JFactory::getDBO();
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new JParameter( $plugin->params );
		}

		//check if the component is installed
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_guru');
	}

	function acymailing_getPluginType(){
		$app = JFactory::getApplication();
	 	if(!$this->component_installed || ($this->params->get('frontendaccess') == 'none' && !$app->isAdmin())) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'Guru Pro';
		$onePlugin->function = 'acymailing_'.$this->name.'_show';
		$onePlugin->help = 'plugin-'.$this->name;
		return $onePlugin;
	}

	function acymailing_guru_show(){
		$config = acymailing_config();

		if($config->get('version') < '4.8.1'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$app = JFactory::getApplication();

		$lang = JFactory::getLanguage();
		$lang->load('com_guru',JPATH_SITE);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.'.$this->name;

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order','a.id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir','asc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->filter_type = $app->getUserStateFromRequest( $paramBase.".filter_type", 'filter_type','','int' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id,DESC','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight','150','string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth','150','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->pictauto = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->readmoreauto = $app->getUserStateFromRequest( $paramBase.".readmoreauto", 'readmoreauto','1','string' );
		$pageInfo->wrap = $app->getUserStateFromRequest( $paramBase.".wrap", 'wrap','0','string' );
		$pageInfo->image = $app->getUserStateFromRequest( $paramBase.".image", 'image','image_avatar','string' );
		$pageInfo->clickable = $app->getUserStateFromRequest( $paramBase.".clickable", 'clickable','1','string' );
		$pageInfo->clickableauto = $app->getUserStateFromRequest( $paramBase.".clickableauto", 'clickableauto','1','string' );

		//the query's start
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*, b.name AS cattitle, c.author_title ' .
				'FROM #__guru_program AS a ' .
				'JOIN #__guru_category AS b ON a.catid = b.id ' .
				'JOIN #__guru_authors AS c ON a.author = c.userid';

		//search fields...
		$searchFields = array('a.id','a.name','b.name','c.author_title');

		//apply search fields
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE ".$searchVal;
		}

		//only published content ?
		if($this->params->get('displaycontent','all') == 'onlypub') $filters[] = 'a.published = 1';

		//if the user filtered by category
		if(!empty($pageInfo->filter_cat)) $filters[] = 'a.catid = '.intval($pageInfo->filter_cat);

		//apply filters
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (',$filters).')';

		//apply ordering
		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;

		$this->db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);

		//load results
		$rows = $this->db->loadObjectList();

		if(!$config->get('guru_created')){
			$this->db->setQuery('ALTER TABLE `#__guru_program` ADD `acy_created` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP');
			$this->db->query();

			$newconfig = new stdClass();
			$newconfig->guru_created = true;
			$config->save($newconfig);
		}

		//yellow highlighting on search matches
		if(!empty($pageInfo->search)) $rows = acymailing_search($pageInfo->search,$rows);

		//pagination
		$this->db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $this->db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		//is this a Smart-Newsletter or a simple one ?
		$type = JRequest::getString('type');

	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass){
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1){
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('cat'+catid).className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						for(key in selectedCat)
						{
							if(!isNaN(key))
							{
								window.document.getElementById('cat'+key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat'+catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				<?php
					//add the fields the user wants to be displayed
				?>
				for(var i=0; i < document.adminForm.cbdisplay.length; i++){
					if(document.adminForm.cbdisplay[i].checked){
						 if(tmp == 0){
							 tmp += 1;
							 otherinfo += "| display:" + document.adminForm.cbdisplay[i].value;
						 }else{
							 otherinfo += ", " + document.adminForm.cbdisplay[i].value;
						 }
					}
				}

				<?php
					//is the title clickable ?
				?>
				for(var i=0; i < document.adminForm.clickable.length; i++){
					 if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '0'){
						 otherinfo += '| nolink';
					 }
				}

				<?php
					//do we have to wrap the text ? (description for example...)
				?>
				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value)){
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				<?php
					//do we have to add a "read more" button ?
				?>
				for(var i=0; i < document.adminForm.readmore.length; i++){
					 if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '0'){
						 otherinfo += '| noreadmore';
					 }
				}

				if(document.adminForm.image.value != "0"){
					otherinfo += "| image:"+document.adminForm.image.value;
				}

				<?php
					//picture management
				?>
				for(var i=0; i < document.adminForm.pict.length; i++){
					if (document.adminForm.pict[i].checked){
					 	if(document.adminForm.pict[i].value != '1') otherinfo += '| pict:'+document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized'){
							 document.getElementById('pictsize').style.display = '';
							 if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
							 if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				for(var i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{<?php echo $this->name; ?>:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto(){
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				for(var i=0; i < document.adminForm.cbdisplayauto.length; i++){
					if (document.adminForm.cbdisplayauto[i].checked){
						 if(tmp==0){
							 tmp+=1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }
					}
				}

				for(var i=0; i < document.adminForm.clickableauto.length; i++){
					if (document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '0'){
						 otherinfo += '| nolink';
					}
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value != 0 && !isNaN(document.adminForm.wrapauto.value)){
					otherinfo += "| wrap:"+document.adminForm.wrapauto.value;
				}

				for(var i=0; i < document.adminForm.readmoreauto.length; i++){
					 if (document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '0'){
						 otherinfo += '| noreadmore';
					 }
				}

				if(document.adminForm.autoimage.value != "0"){
					otherinfo += "| image:"+document.adminForm.autoimage.value;
				}

				for(var i=0; i < document.adminForm.autopict.length; i++){
					if (document.adminForm.autopict[i].checked){
						if(document.adminForm.autopict[i].value != '1') otherinfo += '| pict:'+document.adminForm.autopict[i].value;

						if(document.adminForm.autopict[i].value == 'resized'){
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:'+document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}

				<?php
					//on how many columns do we have to display the contents ?
				?>
				if(document.adminForm.cols.value){
					otherinfo += "| cols:"+document.adminForm.cols.value;
				}

				<?php
					//limit the number of content displayed
				?>
				if(document.adminForm.max_article.value){
					otherinfo += "| max:"+document.adminForm.max_article.value;
				}

				<?php
					//with what order will we display the contents
				?>
				if(document.adminForm.contentorder.value){
					otherinfo += "| order:"+document.adminForm.contentorder.value;
				}

				if(document.adminForm.autoteacher.value != "0"){
					otherinfo += "| teacher:"+document.adminForm.autoteacher.value;
				}

				<?php if($type == 'autonews'){
					//minimum number of content for the newsletter to be displayed...
				?>
					if(document.adminForm.min_article.value){
						otherinfo += "| min:"+document.adminForm.min_article.value;
					}

					<?php
						//filter the content : only newly created/modified
					?>
					if(document.adminForm.contentfilter && document.adminForm.contentfilter.value != 0){
						otherinfo += "| filter:"+document.adminForm.contentfilter.value;
					}
				<?php }
					//insert the tag
				?>
				tag = '{auto<?php echo $this->name; ?>:';
				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat+'-';
					}
				}
				tag += otherinfo+'}<br />';

				setTag(tag);
			}

			function updateTagResults(){
				var tag = '{<?php echo $this->name; ?>results:';

				if(document.adminForm.max_results.value){
					tag += "| max:"+document.adminForm.max_results.value;
				}
				<?php if($type == 'autonews'){ ?>
					if(document.adminForm.results_filter.value != 0){
						tag += "| filter:"+document.adminForm.results_filter.value;
					}
				<?php }	?>
				tag += '}';

				setTag(tag);
			}
		//-->
		</script>
<?php
		// yes/no for the options
		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// picture options
		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// here are the possible orderings
		$ordering = array();
		$ordering[] = JHTML::_('select.option', "id,DESC", JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "acy_created,DESC", JText::_('CREATED_DATE'));
		$ordering[] = JHTML::_('select.option', "name,ASC", JText::_('FIELD_TITLE'));
		$ordering[] = JHTML::_('select.option', "rand", JText::_('ACY_RANDOM'));

		// filter options
		$contentfilter = array();
		$contentfilter[] = JHTML::_('select.option', "0", JText::_('ACY_ALL'));
		$contentfilter[] = JHTML::_('select.option', "created", JText::_('ONLY_NEW_CREATED'));
		$additionalFilter = array();
		$additionalFilter[] = JHTML::_('select.option', "published", JText::_('Only newly published'));
		$additionalFilter[] = JHTML::_('select.option', "both", JText::_('Only newly created or published'));

		// options for the Nb. columns dropdown (1 to 10)
		$column = array();
		for($i=1;$i<11;$i++){
			$column[] = JHTML::_('select.option', "$i",$i);
		}

		$fieldsDisplay = array();
		$fieldsDisplay[] = array('title' => 'title', 'label' => 'ACY_TITLE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'intro', 'label' => 'INTRO_TEXT', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'description', 'label' => 'ACY_DESCRIPTION', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'teacher', 'label' => 'GURU_AUTHOR', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'prices', 'label' => 'GURU_PRICE', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'requirements', 'label' => 'GURU_DAY_REQ', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'released', 'label' => 'GURU_RELEASED', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'level', 'label' => 'GURU_TASKS_TASK_DIFFICULTY_LEVEL', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'certificate', 'label' => 'GURU_CERTIFICATE_TERM', 'checked' => 'yes');


		$image = array();
		$image[] = JHTML::_('select.option', "image_avatar", JText::_('GURU_IMAGE_AVATAR'));
		$image[] = JHTML::_('select.option', "image", JText::_('GURU_IMAGE_COVER2'));
		$image[] = JHTML::_('select.option', "0", JText::_('ACY_NONE'));

		$this->db->setQuery('SELECT 0 AS userid, "- - -" AS author_title UNION SELECT userid, author_title FROM #__guru_authors ORDER BY author_title LIMIT 100');
		$authors = $this->db->loadObjectList();

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane( $this->name.'_tab');

		// start the first tab
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), $this->name.'_listings');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField){
						if($i == 5){
							echo '</tr><tr><td/>';
							$i = 1;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="'.$oneField['title'].'" id="'.$oneField['title'].'" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTag();"/><label style="margin-left:5px" for="'.$oneField['title'].'">'.trim(JText::_($oneField['label']), ':').'</label></td>';
						$i++;
					}
					while($i != 5){
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickable' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>

				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top" colspan="3"><?php echo JHTML::_('acyselect.radiolist', $image, 'image' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->image); ?></td>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap" valign="top" rowspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap" colspan="4" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td nowrap="nowrap" width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>"  type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th/>
					<th class="title">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );
						?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value );
						?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="4">
						<?php
							echo $pagination->getListFooter();
							if(ACYMAILING_J30){
								$paginationNb = array();
								foreach(array(5,10,15,20,25,30,50,100) as $oneOption){
									$paginationNb[] = JHTML::_('select.option', $oneOption, $oneOption);
								}
								$paginationNb[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
								echo 'Display #'.JHTML::_('select.genericlist', $paginationNb, 'limit' , 'size="1" style="width:60px" onchange="Joomla.submitform();"', 'value', 'text', $pageInfo->limit->value).'<br />';
							}
							echo $pagination->getResultsCounter();
						?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					if(!empty($rows)){
						foreach($rows as $row){
				?>
							<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
								<td class="acytdcheckbox"></td>
								<td style="text-align:center;">
									<?php
										echo $row->name;
									?>
								</td>
								<td style="text-align:center;">
									<?php
										if(!empty($row->cattitle)) echo $row->cattitle;
									?>
								</td>
								<td style="text-align:center;">
									<?php
										echo $row->id;
									?>
								</td>
							</tr>
				<?php
							// this enables to know if we have to set the line background grey or white
							$k = 1-$k;
						}
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />

		<?php
			echo $tabs->endPanel();
			// start category tab
			echo $tabs->startPanel( JText::_('TAG_CATEGORIES'), $this->name.'_auto');
		?>

		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField){
						if($i == 5){
							echo '</tr><tr><td/>';
							$i = 1;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="'.$oneField['title'].'" id="'.$oneField['title'].'auto" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneField['title'].'auto">'.trim(JText::_($oneField['label']), ':').'</label></td>';
						$i++;
					}
					while($i != 5){
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickableauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top" colspan="3"><?php echo JHTML::_('acyselect.radiolist', $image, 'autoimage' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->image); ?></td>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES');?></td>
				<td nowrap="nowrap" valign="top"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
					<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap" colspan="3"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
				<td><?php echo JText::_('GURU_AUTHOR'); ?></td>
				<td><?php echo JHTML::_('select.genericlist', $authors, 'autoteacher' , 'size="1" onclick="updateTagAuto();" style="width:100px;"', 'userid', 'author_title', 0); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <input type="text" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $ordering, 'contentorder' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews'){ ?>
			<tr>
				<td nowrap="nowrap">
					<?php 	echo JText::_('MIN_ARTICLE'); ?>
				</td nowrap="nowrap">
				<td nowrap="nowrap" colspan="2">
					<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td>
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('JOOMEXT_FILTER'); ?>
				</td>
				<td nowrap="nowrap" colspan="4">
					 <?php echo JHTML::_('select.genericlist', array_merge($contentfilter, $additionalFilter), 'contentfilter' , 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentfilter); ?>
				</td>
			</tr>
			<?php }else{ ?>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap" colspan="4">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
<!--====================================================================================LISTE CATEGORIES===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<?php $k=0; ?>
			<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
					<?php
						echo JText::_('ACY_ALL');
					?>
				</td>
			</tr>
			<?php
				if(!empty($this->catvalues)){
					foreach($this->catvalues as $oneCat){
						if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
			<?php
						$k = 1 - $k;
					}
				}
			?>
		</table>
<?php
		echo $tabs->endPanel();
		echo $tabs->startPanel( JText::_('GURU_RESULTS'), $this->name.'_results');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap" nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap">
					 <input type="text" name="max_results" style="width:50px" value="20" onchange="updateTagResults();"/>
				</td>
			<?php if($type == 'autonews'){ ?>
				<td nowrap="nowrap">
					<?php echo JText::_('JOOMEXT_FILTER'); ?>
				</td>
				<td nowrap="nowrap">
					<?php echo JHTML::_('select.genericlist', $contentfilter, 'results_filter' , 'size="1" onchange="updateTagResults();"', 'value', 'text'); ?>
				</td>
			<?php } ?>
			</tr>
		</table>
<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	private function _categories($filter_cat){
		//select all cats
		$this->db->setQuery('SELECT a.id, b.parent_id, a.name AS title FROM #__guru_category AS a JOIN #__guru_categoryrel AS b ON a.id = b.child_id');
		$cats = $this->db->loadObjectList();
		$this->cats = array();
		if(!empty($cats)){
			foreach($cats as $oneCat){
				$this->cats[$oneCat->parent_id][] = $oneCat;
			}
		}

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist',$this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', intval($filter_cat));
	}

	private function _handleChildrens($parent_id = 0,$level = 0){
		if(empty($this->cats[$parent_id])) return;
		foreach($this->cats[$parent_id] as $cat){
			$this->catvalues[] = JHTML::_('select.option', $cat->id,str_repeat(" - - ",$level).$cat->title);
			$this->_handleChildrens($cat->id,$level+1);
		}
	}

	function acymailing_replaceusertags(&$email,&$user,$send = true){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$time = time();
		$return = new stdClass();
		$return->status = true;
		$return->message = '';

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, $this->name.'results');
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			$query = 'SELECT a.name AS quiz, a.max_score, b.*, c.name AS Student, d.name AS course ' .
					'FROM #__guru_quiz AS a ' .
					'JOIN #__guru_quiz_taken AS b ON a.id = b.quiz_id ' .
					'JOIN #__users AS c ON b.user_id = c.id ' .
					'JOIN #__guru_program AS d ON b.pid = d.id ' .
					'WHERE a.author = '.intval($user->userid).' ';

			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
				$query .= ' AND b.date_taken_quiz > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
			}

			$query .= 'ORDER BY b.user_id ASC, b.date_taken_quiz DESC ';
			$query .= empty($parameter->max) ? 'LIMIT 20' : 'LIMIT '.intval($parameter->max);
			$this->db->setQuery($query);
			$results = $this->db->loadObjectList();
			if(empty($results)) $this->tags[$oneTag] = '';
			else{
				$currentStudent = '';
				$result = '';

				foreach($results as $oneResult){
					if($oneResult->Student != $currentStudent){
						if(!empty($currentStudent)) $result .= '</table></div>';
						$result .= '<div class="guru_result">'.$oneResult->Student.'<table cellspacing="0" cellpadding="5" border="0" width="100%" style="text-align:center;"><tr><th>'.JText::_('GURU_PRODNAME').'</th><th>'.JText::_('GURU_QUIZ_NAME').'</th><th>'.JText::_('GURU_DATE_TAKEN').'</th><th>'.JText::_('GURU_QUIZ_SCORE').'</th><th>'.JText::_('GURU_STATUS').'</th></tr>';
						$currentStudent = $oneResult->Student;
					}
					$scoreVars = explode('|', $oneResult->score_quiz);
					$score = intval($scoreVars[0]/$scoreVars[1]*100);
					$status = $score > $oneResult->max_score ? 'GURU_QUIZ_FAILED_STATUS' : 'GURU_QUIZ_FAILED_STATUS';
					$result .= '<tr><td>'.$oneResult->course.'</td><td>'.$oneResult->quiz.'</td><td>'.acymailing_getDate(acymailing_getTime($oneResult->date_taken_quiz), JText::_('DATE_FORMAT_LC')).'</td><td>'.$score.'% / '.$oneResult->max_score.'%</td><td>'.JText::_($status).'</td></tr>';
				}

				$result .= '</table></div>';
				$this->tags[$oneTag] = $result;
			}
		}

		$acypluginsHelper->replaceTags($email, $this->tags, true);
		return $return;
	}

	function acymailing_replacetags(&$email){
		$lang = JFactory::getLanguage();
		$lang->load('com_guru',JPATH_SITE);
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	private function _replaceOne(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, $this->name);
		if(empty($tags)) return;

		$this->db->setQuery('SELECT currency, currencypos FROM #__guru_config LIMIT 1');
		$guruParams = $this->db->loadObject();
		$this->currency = JText::_("GURU_CURRENCY_".$guruParams->currency);
		$this->currencypos = $guruParams->currencypos;

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$tagsReplaced = array();
		foreach($tags as $i => $oneTag){
			if(isset($tagsReplaced[$i])) continue;
			$tagsReplaced[$i] = $this->_replaceContent($oneTag);
		}

		$acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}

	private function _replaceContent(&$tag){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$app = JFactory::getApplication();

	 	// extract the fields selected
		if(!empty($tag->display)){
			$tag->display = explode(',',$tag->display);

			foreach($tag->display as $i => $oneDisplay){
				$oneDisplay = trim($oneDisplay);
				$tag->$oneDisplay = true;
			}
			unset($tag->display);
		}

		// load content
		$this->db->setQuery('SELECT a.*, b.*, c.email, d.max_score ' .
							'FROM #__guru_program AS a ' .
							'JOIN #__guru_authors AS b ' .
								'ON a.author = b.userid ' .
							'JOIN #__users AS c ' .
								'ON a.author = c.id ' .
							'LEFT JOIN #__guru_quiz AS d ' .
								'ON a.id_final_exam = d.id ' .
							'WHERE a.id = '.intval($tag->id).' ' .
							'LIMIT 1');
		$content = $this->db->loadObject();

		//In case of we could not load the article for any reason...
		if(empty($content)){
			if($app->isAdmin()) $app->enqueueMessage('The course "'.$tag->id.'" could not be loaded','notice');
			return '';
		}

		$varFields = array();
		foreach($content as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		// create the link for the title and the read more button
		$link = 'index.php?option=com_guru&view=guruPrograms&task=view&cid='.$tag->id;
		if(!empty($tag->itemid)) $link .= '&Itemid='.$tag->itemid;
		$link = acymailing_frontendLink($link);
		$varFields['{link}'] = $link;

		$result = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">';

		// display the title
		if(!empty($tag->title) && !empty($content->name)){
			$result .= '<h2 class="acymailing_title">';
			if(empty($tag->nolink)) $result .= '<a href="'.$link.'">';
			$result .= $content->name;
			if(empty($tag->nolink)) $result .= '</a>';
			$result .= '</h2>';
		}

		if(!empty($tag->image)){
			$imageVar = $tag->image;
			if(!empty($content->$imageVar)){
				$varFields['{picthtml}'] = '<img '.(empty($tag->nofloat) ? 'style="float:left;"' : '').' src="'.$content->$imageVar.'"/>';
			}
		}

		$description = '';
		if(!empty($tag->intro) && !empty($content->introtext)){
			$description = $content->introtext;
		}

		if(!empty($tag->description) && !empty($content->description)){
			$description .= $content->description;
		}

		if(!empty($description) || !empty($varFields['{picthtml}'])){
			$result .= '<tr><td colspan="2" style="text-align:justify;">';
			if(!empty($varFields['{picthtml}'])) $result .= $varFields['{picthtml}'];
			if(!empty($description)) $result .= $acypluginsHelper->wrapText($description, $tag);
			$result .= '</td></tr>';
		}

		$classLeft = array(0 => 'guru_infoLabel1', 1 => 'guru_infoLabel2');
		$classRight = array(0 => 'guru_infoClass1', 1 => 'guru_infoClass2');
		$row = 0;

		if(!empty($tag->teacher)){
			$tInfo = array();
			if($content->show_email == 1) $tInfo[] = '<a href="mailto:'.$content->email.'">'.JText::_('GURU_EMAIL').'</a>';
			if($content->show_website == 1 && $content->website != 'http://') $tInfo[] = '<a href="'.$content->website.'">'.JText::_('GURU_SITE').'</a>';
			if($content->show_blog == 1 && $content->blog != 'http://') $tInfo[] = '<a href="'.$content->blog.'">'.JText::_('GURU_BLOG').'</a>';
			if($content->show_twitter == 1 && !empty($content->twitter)) $tInfo[] = '<a href="http://www.twitter.com/'.$content->twitter.'">'.JText::_('GURU_TWITTER').'</a>';
			if($content->show_facebook == 1 && $content->facebook != 'http://') $tInfo[] = '<a href="'.$content->facebook.'">'.JText::_('GURU_FACEBOOK').'</a>';
			if(!empty($tInfo)){
				$result .= '<tr class="rownb'.($row%2).'"><td class="'.$classLeft[$row%2].'" valign="top"><strong>'.JText::_('GURU_AUTHOR').'</strong></td><td class="'.$classRight[$row%2].'" valign="middle">'.$content->author_title.' '.implode(' ', $tInfo).'</td></tr>';
				$row++;
			}
		}

		if(!empty($tag->released)){
			$date = $content->start_release == '0000-00-00 00:00:00' ? 'startpublish' : 'start_release';
			$result .= '<tr class="rownb'.($row%2).'"><td class="'.$classLeft[$row%2].'" valign="top"><strong>'.JText::_('GURU_RELEASED').'</strong></td><td class="'.$classRight[$row%2].'" valign="middle">'.acymailing_getDate(acymailing_getTime($content->$date), JText::_('DATE_FORMAT_LC')).'</td></tr>';
			$row++;
		}

		if(!empty($tag->level)){
			switch ($content->level){
				case "0":
					$level = JText::_('GURU_LEVEL_BEGINER');
					break;
				case "1":
					$level = JText::_('GURU_LEVEL_INTERMEDIATE');
					break;
				case "2":
					$level = JText::_('GURU_LEVEL_ADVANCED');
					break;
			}
			$result .= '<tr class="rownb'.($row%2).'"><td class="'.$classLeft[$row%2].'" valign="top"><strong>'.JText::_('GURU_LEVEL').'</strong></td><td class="'.$classRight[$row%2].'" valign="middle">'.$level.'</td></tr>';
			$row++;
		}

		if(!empty($tag->certificate) && $content->certificate_term != 0){
			$certificateTerm = '';
			if($content->certificate_term == 1){
				$certificateTerm = JText::_("GURU_NO_CERT_GIVEN");
			}elseif($content->certificate_term == 2){
				$certificateTerm = JText::_("GURU_MUST_COLMP_ALL_LESS");
			}elseif($content->certificate_term == 3){
				$certificateTerm = JText::_("GURU_MUST_PASS_FE")." ".$content->max_score."%";
			}elseif($content->certificate_term == 4){
				$certificateTerm = JText::_("GURU_MUST_PASS_QAVG")." ".$content->avg_cert."%";
			}elseif($content->certificate_term == 5){
				$certificateTerm = JText::_("GURU_CERT_TERM_FALFE");
			}elseif($content->certificate_term == 6){
				$certificateTerm = JText::_("GURU_CERT_TERM_FALPQAVG")." ".$content->avg_cert."%";
			}
			$result .= '<tr class="guru_rownb'.($row%2).'"><td class="'.$classLeft[$row%2].'" valign="top"><strong>'.JText::_('GURU_CERTIFICATE_COL').'</strong></td><td class="'.$classRight[$row%2].'" valign="middle">'.$certificateTerm.'</td></tr>';
			$row++;
		}

		if(!empty($tag->requirements)){
			$tInfo = array();
			if(!empty($content->pre_req)) $tInfo[] = '<strong>'.JText::_('GURU_TAB_REQUIREMENTS_OTHERS').':</strong><br/>'.$content->pre_req;
			if(!empty($content->pre_req_books)) $tInfo[] = '<strong>'.JText::_('GURU_TAB_REQUIREMENTS_BOOKS').':</strong><br/>'.$content->pre_req_books;
			if(!empty($content->reqmts)) $tInfo[] = '<strong>'.JText::_('GURU_TAB_REQUIREMENTS_MISC').':</strong><br/>'.$content->reqmts;

			if(!empty($tInfo)){
				$result .= '<tr class="rownb'.($row%2).'"><td class="'.$classLeft[$row%2].'" valign="top"><strong>'.JText::_('GURU_TAB_REQUIREMENTS').'</strong></td><td class="'.$classRight[$row%2].'" valign="middle">'.implode('<br/>', $tInfo).'</td></tr>';
				$row++;
			}
		}

		if(!empty($tag->prices)){
			$this->db->setQuery('SELECT a.price, b.name FROM #__guru_program_plans AS a JOIN #__guru_subplan AS b ON a.plan_id = b.id WHERE b.published = "1" AND a.product_id = '.intval($tag->id).' ORDER BY b.ordering ASC');
			$prices = $this->db->loadObjectList();
			$priceResult = '<table cellspacing="0" cellpadding="5" border="1" width="100%"><tr class="guru_price_fline"><th class="guru_price_pname">'.JText::_("GURU_SUBS_PLAN_NAME").'</th><th class="guru_price_price">'.JText::_("GURU_PROGRAM_DETAILS_PRICE").'</th></tr>';
			foreach($prices as $onePrice){
				$priceResult .= '<tr class="guru_price_line_'.($row%2).'"><td class="guru_price_cell_left_'.($row%2).'">'.$onePrice->name.'</td><td class="guru_price_cell_right_'.($row%2).'">';
				if($this->currencypos == 0) $priceResult .= $this->currency.' '.$onePrice->price;
				else $priceResult .= $onePrice->price.' '.$this->currency;
				$priceResult .= '</td></tr>';
				$row++;
			}
			$priceResult .= '</table>';
			$result .= '<tr class="rownb'.($row%2).'"><td colspan="2">'.$priceResult.'</td></tr>';
		}

		if(empty($tag->noreadmore)) $result .= '<tr><td colspan="2"><a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a></td></tr>';

		$result .= '</table></div><br />';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}

		// always remove JS, there is no JS in newsletters...
		$result = $acypluginsHelper->removeJS($result);

		//resize or remove pictures
		$result = $acypluginsHelper->managePicts($tag, $result);

		return $result;
	}

	private function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'auto'.$this->name);
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;
			$allcats = explode('-',$parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT a.id FROM #__guru_program AS a ';

			$where = array();

			// load only needed content
			if(!empty($selectedArea)) $where[] = 'a.catid IN ('.implode(',',$selectedArea).')';

			// filter results created or modified
			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
				if($parameter->filter == 'created'){
					$where[] = 'a.acy_created > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
				}elseif($parameter->filter == 'published'){
					$where[] = 'a.startpublish > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\' AND a.startpublish < \''.date( 'Y-m-d H:i:s',$time - date('Z')).'\'';
				}elseif($parameter->filter == 'both'){
					$where[] = 'a.acy_created > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\' OR (a.startpublish > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\' AND a.startpublish < \''.date( 'Y-m-d H:i:s',$time - date('Z')).'\')';
				}
			}

			if(!empty($parameter->teacher)){
				if(strpos($parameter->teacher, ',')){
					$teachers = explode(',', $parameter->teacher);
					JArrayHelper::toInteger($teachers);
					$where[] = 'a.author IN ('.implode(',', $teachers).')';
				}else{
					$where[] = 'a.author = '.intval($parameter->teacher);
				}
			}

			// Only published content
			$where[] = empty($parameter->unpublished) ? 'a.published = 1' : 'a.published <> 1';

			// Apply filters
			if(!empty($where)) $query .= ' WHERE ('.implode(') AND (',$where).')';

			// Ordering
			if(!empty($parameter->order)){
				if($parameter->order == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',',$parameter->order);
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			$start = '';
			if(!empty($parameter->start)) $start = intval($parameter->start).',';
			if(empty($parameter->max)) $parameter->max = 20;
			//We add a limit for the preview otherwise we could break everything
			$query .= ' LIMIT '.$start.(int) $parameter->max;

			// load content IDs
			$this->db->setQuery($query);
			$allArticles = acymailing_loadResultArray($this->db);

			// Check the number of results
			if(!empty($parameter->min) && count($allArticles) < $parameter->min){
				//We will not generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough '.$this->name.' courses for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles)){
				// If the user created its own template...
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
					$arrayElements = array();
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = $this->name.':'.$oneArticleId;
						if(!empty($parameter->nolink)) $args[] = 'nolink';
						if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(isset($parameter->image)) $args[] = 'image:'.$parameter->image;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						if(!empty($parameter->itemid)) $args[] = 'itemid:'.$parameter->itemid;
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass
?>