<?php
/**
 * @copyright    Copyright (C) 2009-2014 ACYBA SAS - All rights reserved.
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingIgnitegallery extends JPlugin{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		$this->name = 'ignitegallery';
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new acyParameter($plugin->params);
		}

		//check if the component is installed
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_igallery');
	}

	function acymailing_getPluginType(){
		if(!$this->component_installed || ($this->params->get('frontendaccess') == 'none' && !acymailing_isAdmin())) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'Ignite Gallery';
		$onePlugin->function = 'acymailing_'.$this->name.'_show';
		$onePlugin->help = 'plugin-'.$this->name;
		return $onePlugin;
	}

	function acymailing_ignitegallery_show(){
		$config = acymailing_config();

		if($config->get('version') < '4.9.4'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		
		acymailing_loadLanguageFile('com_igallery', JPATH_ADMINISTRATOR);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.'.$this->name;

		$pageInfo->filter->order->value = acymailing_getUserVar($paramBase.".filter_order", 'filter_order', 'a.id', 'cmd');
		$pageInfo->filter->order->dir = acymailing_getUserVar($paramBase.".filter_order_Dir", 'filter_order_Dir', 'asc', 'word');
		$pageInfo->search = acymailing_getUserVar($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = acymailing_getUserVar($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->filter_type = acymailing_getUserVar($paramBase.".filter_type", 'filter_type', '', 'int');
		$pageInfo->limit->value = acymailing_getUserVar($paramBase.'.list_limit', 'limit', acymailing_getCMSConfig('list_limit'), 'int');
		$pageInfo->limit->start = acymailing_getUserVar($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->contentfilter = acymailing_getUserVar($paramBase.".contentfilter", 'contentfilter', 'created', 'string');
		$pageInfo->contentorder = acymailing_getUserVar($paramBase.".contentorder", 'contentorder', 'id,DESC', 'string');
		$pageInfo->cols = acymailing_getUserVar($paramBase.".cols", 'cols', '1', 'string');
		$pageInfo->pictheight = acymailing_getUserVar($paramBase.".pictheight", 'pictheight', '150', 'string');
		$pageInfo->pictwidth = acymailing_getUserVar($paramBase.".pictwidth", 'pictwidth', '150', 'string');
		$pageInfo->pict = acymailing_getUserVar($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->pictauto = acymailing_getUserVar($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->readmore = acymailing_getUserVar($paramBase.".readmore", 'readmore', '1', 'string');
		$pageInfo->readmoreauto = acymailing_getUserVar($paramBase.".readmoreauto", 'readmoreauto', '0', 'string');
		$pageInfo->wrap = acymailing_getUserVar($paramBase.".wrap", 'wrap', '0', 'string');
		$pageInfo->clickable = acymailing_getUserVar($paramBase.".clickable", 'clickable', '1', 'string');
		$pageInfo->clickableauto = acymailing_getUserVar($paramBase.".clickableauto", 'clickableauto', '1', 'string');

		//the query's start
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*, b.name AS cattitle FROM #__igallery_img AS a JOIN #__igallery AS b ON a.gallery_id = b.id ';

		//search fields...
		$searchFields = array('a.id', 'a.filename', 'a.tags');

		//apply search fields
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchFields)." LIKE ".$searchVal;
		}

		//only published content ?
		if($this->params->get('displaycontent', 'all') == 'onlypub') $filters[] = 'a.published = 1';

		//if the user filtered by category
		if(!empty($pageInfo->filter_cat)) $filters[] = 'a.gallery_id = '.intval($pageInfo->filter_cat);

		//apply filters
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (', $filters).')';

		//apply ordering
		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;

		$rows = acymailing_loadObjectList($query, '', $pageInfo->limit->start, $pageInfo->limit->value);

		//yellow highlighting on search matches
		if(!empty($pageInfo->search)) $rows = acymailing_search($pageInfo->search, $rows);

		//pagination
		$pageInfo->elements->total = acymailing_loadResult('SELECT FOUND_ROWS()');
		$pageInfo->elements->page = count($rows);

		$pagination = new acyPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		//is this a Smart-Newsletter or a simple one ?
		$type = acymailing_getVar('string', 'type');

		?>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			function applyContent(contentid, rowClass){
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1){
					window.document.getElementById('content' + contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content' + contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid, rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('cat' + catid).className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						for(key in selectedCat){
							if(!isNaN(key)){
								window.document.getElementById('cat' + key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat' + catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;

				<?php
					//add the fields the user wants to be displayed
				?>
				for(var i = 0; i < document.adminForm.cbdisplay.length; i++){
					if(!document.adminForm.cbdisplay[i].checked) continue;
					if(tmp == 0){
						tmp += 1;
						otherinfo += "| display:" + document.adminForm.cbdisplay[i].value;
					}else{
						otherinfo += ", " + document.adminForm.cbdisplay[i].value;
					}
				}

				<?php
					//is the title clickable ?
				?>
				for(var i = 0; i < document.adminForm.clickable.length; i++){
					if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '0'){
						otherinfo += '| nolink';
					}
				}

				<?php
					//do we have to wrap the text ? (description for example...)
				?>
				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value)){
					otherinfo += "| wrap:" + document.adminForm.wrap.value;
				}

				<?php
					//do we have to add a "read more" button ?
				?>
				for(var i = 0; i < document.adminForm.readmore.length; i++){
					if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '0'){
						otherinfo += '| noreadmore';
					}
				}

				<?php
					//picture management
				?>
				for(var i = 0; i < document.adminForm.pict.length; i++){
					if(!document.adminForm.pict[i].checked) continue;
					if(document.adminForm.pict[i].value != '1') otherinfo += '| pict:' + document.adminForm.pict[i].value;

					if(document.adminForm.pict[i].value == 'resized'){
						document.getElementById('pictsize').style.display = '';
						if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidth.value;
						if(document.adminForm.pictheight.value) otherinfo += '| maxheight:' + document.adminForm.pictheight.value;
					}else{
						document.getElementById('pictsize').style.display = 'none';
					}
				}

				for(var i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{<?php echo $this->name; ?>:' + selectedContents[i] + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;

				for(var i = 0; i < document.adminForm.cbdisplayauto.length; i++){
					if(!document.adminForm.cbdisplayauto[i].checked) continue;
					if(tmp == 0){
						tmp += 1;
						otherinfo += "| display:" + document.adminForm.cbdisplayauto[i].value;
					}else{
						otherinfo += ", " + document.adminForm.cbdisplayauto[i].value;
					}
				}

				for(var i = 0; i < document.adminForm.clickableauto.length; i++){
					if(document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '0'){
						otherinfo += '| nolink';
					}
				}

				if(document.adminForm.wrapautocat.value && document.adminForm.wrapautocat.value != 0 && !isNaN(document.adminForm.wrapautocat.value)){
					otherinfo += "| wrap:" + document.adminForm.wrapautocat.value;
				}

				for(var i = 0; i < document.adminForm.autopict.length; i++){
					if(!document.adminForm.autopict[i].checked) continue;
					if(document.adminForm.autopict[i].value != '1') otherinfo += '| pict:' + document.adminForm.autopict[i].value;

					if(document.adminForm.autopict[i].value == 'resized'){
						document.getElementById('pictsizeauto').style.display = '';
						if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidthauto.value;
						if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:' + document.adminForm.pictheightauto.value;
					}else{
						document.getElementById('pictsizeauto').style.display = 'none';
					}
				}

				if(document.adminForm.imagesauto.value && document.adminForm.imagesauto.value != 0){
					document.getElementById("imagestable").style.display = "";
					otherinfo += "| images:" + document.adminForm.imagesauto.value;

					if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value != 0 && !isNaN(document.adminForm.wrapauto.value)){
						otherinfo += "| wrapimg:" + document.adminForm.wrapauto.value;
					}

					for(var i = 0; i < document.adminForm.readmoreauto.length; i++){
						if(document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '0'){
							otherinfo += '| noreadmore';
						}
					}
				}else{
					document.getElementById("imagestable").style.display = "none";
				}

				<?php
					//on how many columns do we have to display the contents ?
				?>
				if(document.adminForm.cols.value){
					otherinfo += "| cols:" + document.adminForm.cols.value;
				}

				<?php
					//limit the number of content displayed
				?>
				if(document.adminForm.max_article.value){
					otherinfo += "| max:" + document.adminForm.max_article.value;
				}

				<?php
					//with what order will we display the contents
				?>
				if(document.adminForm.contentorder.value){
					otherinfo += "| order:" + document.adminForm.contentorder.value;
				}

				<?php if($type == 'autonews'){
					//minimum number of content for the newsletter to be displayed...
				?>
				if(document.adminForm.min_article.value){
					otherinfo += "| min:" + document.adminForm.min_article.value;
				}

				<?php
					//filter the content : only newly created/modified
				?>
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value != 0){
					otherinfo += "| filter:" + document.adminForm.contentfilter.value;
				}
				<?php }
					//insert the tag
				?>
				tag = '{auto<?php echo $this->name; ?>:';
				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat + '-';
					}
				}
				tag += otherinfo + '}<br />';

				setTag(tag);
			}
			//-->
		</script>
		<?php
		// yes/no for the options
		$choice = array();
		$choice[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$choice[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		// picture options
		$valImages = array();
		$valImages[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$valImages[] = acymailing_selectOption("resized", acymailing_translation('RESIZED'));
		$valImages[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		// here are the possible orderings
		$ordering = array();
		$ordering[] = acymailing_selectOption("id,DESC", acymailing_translation('ACY_ID'));
		$ordering[] = acymailing_selectOption("date,DESC", acymailing_translation('CREATED_DATE'));
		$ordering[] = acymailing_selectOption("name,ASC", acymailing_translation('FIELD_TITLE'));
		$ordering[] = acymailing_selectOption("rand", acymailing_translation('ACY_RANDOM'));

		// filter options
		$contentfilter = array();
		$contentfilter[] = acymailing_selectOption("0", acymailing_translation('ACY_ALL'));
		$contentfilter[] = acymailing_selectOption("created", acymailing_translation('ONLY_NEW_CREATED'));

		// options for the Nb. columns dropdown (1 to 10)
		$column = array();
		for($i = 1; $i < 11; $i++){
			$column[] = acymailing_selectOption("$i", $i);
		}

		$fieldsDisplay = array();
		$fieldsDisplay[] = array('title' => 'filename', 'label' => 'FILENAME', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'imgdescription', 'label' => 'IMAGE_DESCRIPTIONS', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'category', 'label' => 'ACY_CATEGORY', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'link', 'label' => 'IMAGE_LINK', 'checked' => 'yes');

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane($this->name.'_tab');

		// start the first tab
		echo $tabs->startPanel(acymailing_translation('TAG_ELEMENTS'), $this->name.'_listings');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo acymailing_translation('DISPLAY');?></td>
				<?php
				$i = 1;
				foreach($fieldsDisplay as $oneField){
					if($i == 5){
						echo '</tr><tr><td/>';
						$i = 1;
					}
					echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="'.$oneField['title'].'" id="'.$oneField['title'].'" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTag();"/><label style="margin-left:5px" for="'.$oneField['title'].'">'.trim(acymailing_translation($oneField['label']), ':').'</label></td>';
					$i++;
				}
				while($i != 5){
					echo '<td/>';
					$i++;
				}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo acymailing_translation('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($choice, 'clickable', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>

				<td nowrap="nowrap"><?php echo acymailing_translation('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo acymailing_radio($choice, 'readmore', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" colspan="3" valign="top"><?php echo acymailing_translation_sprintf('TRUNCATE_AFTER', '<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
				<td nowrap="nowrap" valign="top"><?php echo acymailing_translation('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap"><?php echo acymailing_radio($valImages, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br/>
						<?php echo acymailing_translation('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <?php echo acymailing_translation('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
				</td>
			</tr>
		</table>
		<table>
			<tr>
				<td nowrap="nowrap" width="100%">
					<input placeholder="<?php echo acymailing_translation('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();"/>
					<button class="btn" onclick="this.form.submit();"><?php echo acymailing_translation('JOOMEXT_GO'); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo acymailing_translation('JOOMEXT_RESET'); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
			<tr>
				<th/>
				<th class="title">
					<?php
					echo acymailing_gridSort(acymailing_translation('FIELD_TITLE'), 'a.filename', $pageInfo->filter->order->dir, $pageInfo->filter->order->value);
					?>
				</th>
				<th class="title">
					<?php echo acymailing_gridSort(acymailing_translation('TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title titleid">
					<?php
					echo acymailing_gridSort(acymailing_translation('ACY_ID'), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value);
					?>
				</th>
			</tr>
			</thead>
			<tfoot>
			<tr>
				<td colspan="4">
					<?php
					echo $pagination->getListFooter();
					if(ACYMAILING_J30){
						$paginationNb = array();
						$values = array(5, 10, 15, 20, 25, 30, 50, 100);
						foreach($values as $oneOption){
							$paginationNb[] = acymailing_selectOption($oneOption, $oneOption);
						}
						$paginationNb[] = acymailing_selectOption(0, acymailing_translation('ACY_ALL'));
						echo 'Display #'.acymailing_select($paginationNb, 'limit', 'size="1" style="width:60px" onchange="acymailing.submitform();"', 'value', 'text', $pageInfo->limit->value).'<br />';
					}
					echo $pagination->getResultsCounter();
					?>
				</td>
			</tr>
			</tfoot>
			<tbody>
			<?php
			$k = 0;
			if(!empty($rows)){
				foreach($rows as $row){
					?>
					<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td style="text-align:center;">
							<?php echo $row->filename; ?>
						</td>
						<td style="text-align:center;">
							<?php
							if(!empty($row->cattitle)) echo $row->cattitle;
							?>
						</td>
						<td style="text-align:center;">
							<?php
							echo $row->id;
							?>
						</td>
					</tr>
					<?php
					// this enables to know if we have to set the line background grey or white
					$k = 1 - $k;
				}
			}
			?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>

		<?php
		echo $tabs->endPanel();
		// start category tab
		echo $tabs->startPanel(acymailing_translation('TAG_CATEGORIES'), $this->name.'_auto');
		?>

		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<caption style="text-align:left;font-size:19px;margin-bottom:5px;"><?php echo acymailing_translation('ACY_CATEGORY'); ?></caption>
			<tr>
				<td nowrap="nowrap"><?php echo acymailing_translation('DISPLAY');?></td>
				<?php
				$fieldsDisplayCat = array();
				$fieldsDisplayCat[] = array('title' => 'title', 'label' => 'FIELD_TITLE', 'checked' => 'yes');
				$fieldsDisplayCat[] = array('title' => 'mainimg', 'label' => 'MAIN_IMAGE', 'checked' => 'yes');
				$fieldsDisplayCat[] = array('title' => 'menudesc', 'label' => 'MENU_DESCRIPTION', 'checked' => '');
				$fieldsDisplayCat[] = array('title' => 'catdesc', 'label' => 'ACY_DESCRIPTION', 'checked' => 'yes');
				$fieldsDisplayCat[] = array('title' => 'readmorecat', 'label' => 'JOOMEXT_READ_MORE', 'checked' => 'yes');
				$i = 1;
				foreach($fieldsDisplayCat as $oneField){
					if($i == 5){
						echo '</tr><tr><td/>';
						$i = 1;
					}
					echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="'.$oneField['title'].'" id="'.$oneField['title'].'auto" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneField['title'].'auto">'.trim(acymailing_translation($oneField['label']), ':').'</label></td>';
					$i++;
				}
				while($i != 5){
					echo '<td/>';
					$i++;
				}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap" colspan="3"><?php echo acymailing_translation_sprintf('TRUNCATE_AFTER', '<input type="text" name="wrapautocat" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
				<td nowrap="nowrap"><?php echo acymailing_translation('IMAGES'); ?></td>
				<td nowrap="nowrap"><input type="text" name="imagesauto" style="width:50px" value="5" onchange="updateTagAuto();"/></td>
			</tr>
		</table>
		<table width="100%" class="adminform" id="imagestable">
			<caption style="text-align:left;font-size:19px;margin-bottom:5px;"><?php echo acymailing_translation('IMAGES'); ?></caption>
			<tr>
				<td nowrap="nowrap"><?php echo acymailing_translation('DISPLAY');?></td>
				<?php
				$i = 1;
				foreach($fieldsDisplay as $oneField){
					if($i == 5){
						echo '</tr><tr><td/>';
						$i = 1;
					}
					echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="'.$oneField['title'].'" id="'.$oneField['title'].'auto" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneField['title'].'auto">'.trim(acymailing_translation($oneField['label']), ':').'</label></td>';
					$i++;
				}
				while($i != 5){
					echo '<td/>';
					$i++;
				}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap" colspan="3"><?php echo acymailing_translation_sprintf('TRUNCATE_AFTER', '<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
				<td nowrap="nowrap"><?php echo acymailing_translation('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo acymailing_radio($choice, 'readmoreauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?></td>
			</tr>
		</table>
		<table width="100%" class="adminform">
			<caption style="text-align:left;font-size:19px;margin-bottom:5px;"><?php echo acymailing_translation('GENERAL'); ?></caption>
			<tr>
				<td nowrap="nowrap" valign="top">
					<?php echo acymailing_translation('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($valImages, 'autopict', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
					<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br/>
						<?php echo acymailing_translation('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <?php echo acymailing_translation('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
				</td>
				<td nowrap="nowrap" valign="top"><?php echo acymailing_translation('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" valign="top"><?php echo acymailing_radio($choice, 'clickableauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" nowrap="nowrap">
					<?php echo acymailing_translation('MAX_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					<input type="text" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo acymailing_translation('ACY_ORDER'); ?>
				</td>
				<td nowrap="nowrap">
					<?php echo acymailing_select($ordering, 'contentorder', 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews'){ ?>
				<tr>
					<td nowrap="nowrap">
						<?php echo acymailing_translation('MIN_ARTICLE'); ?>
					</td nowrap="nowrap">
					<td nowrap="nowrap" colspan="2">
						<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
					</td>
					<td>
						<?php echo acymailing_translation('FIELD_COLUMNS'); ?>
					</td>
					<td nowrap="nowrap">
						<?php echo acymailing_select($column, 'cols', 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
					</td>
				</tr>
				<tr>
					<td nowrap="nowrap">
						<?php echo acymailing_translation('JOOMEXT_FILTER'); ?>
					</td>
					<td nowrap="nowrap" colspan="4">
						<?php echo acymailing_select($contentfilter, 'contentfilter', 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentfilter); ?>
					</td>
				</tr>
			<?php }else{ ?>
				<tr>
					<td nowrap="nowrap">
						<?php echo acymailing_translation('FIELD_COLUMNS'); ?>
					</td>
					<td nowrap="nowrap" colspan="4">
						<?php echo acymailing_select($column, 'cols', 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
					</td>
				</tr>
			<?php } ?>
		</table>
		<!--====================================================================================LISTE CATEGORIES===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<?php $k = 0; ?>
			<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
					<?php
					echo acymailing_translation('ACY_ALL');
					?>
				</td>
			</tr>
			<?php
			if(!empty($this->catvalues)){
				foreach($this->catvalues as $oneCat){
					if(empty($oneCat->value)) continue;
					?>
					<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
							<?php
							echo $oneCat->text;
							?>
						</td>
					</tr>
					<?php
					$k = 1 - $k;
				}
			}
			?>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	private function _categories($filter_cat){
		//select all cats
		$cats = acymailing_loadObjectList('SELECT id, parent AS parent_id, name AS title FROM #__igallery ORDER BY id ASC');
		$this->cats = array();
		if(!empty($cats)){
			foreach($cats as $oneCat){
				$this->cats[$oneCat->parent_id][] = $oneCat;
			}
		}

		$this->catvalues = array();
		$this->catvalues[] = acymailing_selectOption(0, acymailing_translation('ACY_ALL'));
		$this->_handleChildrens();
		return acymailing_select($this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	private function _handleChildrens($parent_id = 0, $level = 0){
		if(empty($this->cats[$parent_id])) return;
		foreach($this->cats[$parent_id] as $cat){
			$this->catvalues[] = acymailing_selectOption($cat->id, str_repeat(" - - ", $level).$cat->title);
			$this->_handleChildrens($cat->id, $level + 1);
		}
	}

	function acymailing_replacetags(&$email){
		$this->readmore = empty($email->template->readmore) ? acymailing_translation('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.acymailing_translation('JOOMEXT_READ_MORE', true).'" />';
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	private function _replaceOne(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, $this->name);
		if(empty($tags)) return;

		$this->newslanguage = new stdClass();
		if(!empty($email->language)){
			$this->newslanguage = acymailing_loadObject('SELECT lang_id, lang_code FROM #__languages WHERE sef = '.acymailing_escapeDB($email->language).' LIMIT 1');
		}
		require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_igallery'.DS.'helpers'.DS.'file.php');

		$tagsReplaced = array();
		foreach($tags as $i => $oneTag){
			if(isset($tagsReplaced[$i])) continue;
			$tagsReplaced[$i] = $this->_replaceContent($oneTag);
		}

		$acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}

	private function _replaceContent(&$tag){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		// extract the fields selected
		if(!empty($tag->display)){
			$tag->display = explode(',', $tag->display);

			foreach($tag->display as $i => $oneDisplay){
				$oneDisplay = trim($oneDisplay);
				$tag->$oneDisplay = true;
			}
			unset($tag->display);
		}

		if(!empty($tag->custom)){
			$tag->custom = explode(',', $tag->custom);

			foreach($tag->custom as $i => $oneDisplay){
				$tag->custom[$i] = trim($oneDisplay);
			}
			acymailing_arrayToInteger($tag->custom);
		}

		// load content
		$content = acymailing_loadObject('SELECT a.*, b.name AS cattitle FROM #__igallery_img AS a JOIN #__igallery AS b ON a.gallery_id = b.id WHERE a.id = '.intval($tag->id).' LIMIT 1');

		//In case of we could not load the article for any reason...
		if(empty($content)){
			if(acymailing_isAdmin()) acymailing_enqueueMessage('The content "'.$tag->id.'" could not be loaded', 'notice');
			return '';
		}

		$varFields = array();
		foreach($content as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		// create the link for the title and the read more button
		$keyLink = explode('-', $content->filename);
		if(ACYMAILING_J16){
			$link = 'index.php?option=com_igallery&view=category&igid='.$content->gallery_id.'#!'.$keyLink[0];
		}else $link = 'index.php?option=com_igallery&view=igcategory&id='.$content->gallery_id.'#!'.$keyLink[0];
		if(!empty($tag->itemid)) $link .= '&Itemid='.$tag->itemid;
		$link = acymailing_frontendLink($link);
		$varFields['{link}'] = $link;

		$result = '<div class="acymailing_content">';
		$image = '<img src="'.acymailing_frontendLink('images/igallery/original/'.igFileHelper::getFolderName(igFileHelper::getIncrementFromFilename($content->filename)).'/'.$content->filename).'" style="float:left;"/>';
		if(empty($tag->nolink) || !empty($content->link)){
			if(empty($tag->nolink)){
				$image = '<a href="'.$link.'">'.$image.'</a>';
			}else $image = '<a href="'.$content->link.'">'.$image.'</a>';
		}
		$result .= $image.'<span>';

		// display the title
		if(!empty($tag->filename) && !empty($content->filename)){
			$result .= '<h3 class="acymailing_title">';
			if(empty($tag->nolink)) $result .= '<a href="'.$link.'">';
			$result .= $content->filename;
			if(empty($tag->nolink)) $result .= '</a>';
			$result .= '</h3>';
		}

		if(!empty($tag->category)) $result .= '<strong>'.acymailing_translation('ACY_CATEGORY').':</strong> '.$content->cattitle.'<br />';
		if(!empty($tag->imgdescription) && !empty($content->description)) $result .= $acypluginsHelper->wrapText($content->description, $tag).'<br />';
		$varFields['{readmore}'] = '<a class="readmore_link" style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.(empty($tag->readmore) ? $this->readmore : $tag->readmore).'</span></a>';
		if(empty($tag->noreadmore)) $result .= $varFields['{readmore}'];

		$result .= '</span></div>';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields), $varFields, $result);
		}

		// always remove JS, there is no JS in newsletters...
		$result = $acypluginsHelper->removeJS($result);

		//resize or remove pictures
		$result = $acypluginsHelper->managePicts($tag, $result);

		return $result;
	}

	private function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_igallery'.DS.'helpers'.DS.'file.php');

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, 'auto'.$this->name);
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;

			if(!empty($parameter->display)){
				$parameter->display = explode(',', $parameter->display);

				foreach($parameter->display as $i => $oneDisplay){
					$oneDisplay = trim($oneDisplay);
					$parameter->$oneDisplay = true;
				}
				unset($parameter->display);
			}

			$allcats = explode('-', $parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT a.*, b.filename AS mainpict FROM #__igallery AS a LEFT JOIN #__igallery_img AS b ON b.gallery_id = a.id ';

			$where = array();

			// load only needed content
			if(!empty($selectedArea)) $where[] = 'a.id IN ('.implode(',', $selectedArea).')';

			// filter results created or modified
			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate']) && $parameter->filter == 'created'){
				$where[] = 'a.date > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
			}

			// Only published content
			if(empty($parameter->unpublished)) $where[] = '(a.publish_up = "0000-00-00 00:00:00" OR a.publish_up < \''.date('Y-m-d H:i:s').'\') AND (a.publish_down = "0000-00-00 00:00:00" OR a.publish_down > \''.date('Y-m-d H:i:s').'\')';

			// Apply filters
			if(!empty($where)) $query .= ' WHERE ('.implode(') AND (', $where).')';

			$query .= 'GROUP BY a.id ';
			// Ordering
			if(!empty($parameter->order)){
				if($parameter->order == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',', $parameter->order);
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			$start = '';
			if(!empty($parameter->start)) $start = intval($parameter->start).',';
			if(empty($parameter->max)) $parameter->max = 20;
			//We add a limit for the preview otherwise we could break everything
			$query .= ' LIMIT '.$start.(int)intval($parameter->max);


			// load content IDs
			$allGalleries = acymailing_loadObjectList($query);

			// Check the number of results
			if(!empty($parameter->min) && count($allGalleries) < $parameter->min){
				//We will not generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough '.$this->name.' content for the tag '.$oneTag.' : '.count($allGalleries).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allGalleries)){
				//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
				$arrayElements = array();
				foreach($allGalleries as $oneGallery){

					$varFields = array();
					foreach($oneGallery as $fieldName => $oneField){
						$varFields['{'.$fieldName.'}'] = $oneField;
					}

					if(ACYMAILING_J16){
						$link = 'index.php?option=com_igallery&view=category&igid='.$oneGallery->id;
					}else $link = 'index.php?option=com_igallery&view=igcategory&id='.$oneGallery->id;
					if(!empty($parameter->itemid)) $link .= '&Itemid='.$parameter->itemid;
					$link = acymailing_frontendLink($link);
					$varFields['{link}'] = $link;

					$result = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">';
					if(!empty($parameter->title) && !empty($oneGallery->name)){
						$result .= '<tr><td><h2 class="acymailing_title">';
						if(empty($parameter->nolink)) $result .= '<a href="'.$link.'">';
						$result .= $oneGallery->name;
						if(empty($parameter->nolink)) $result .= '</a>';
						$result .= '</h2></td></tr>';
					}
					$result .= '<tr class="description"><td>';
					if(!empty($parameter->mainimg)){
						if(empty($parameter->nolink)) $result .= '<a href="'.$link.'">';
						$imgpath = empty($oneGallery->menu_image_filename) ? 'images/igallery/original/'.igFileHelper::getFolderName(igFileHelper::getIncrementFromFilename($oneGallery->mainpict)).'/'.$oneGallery->mainpict : 'images/igallery/original/'.igFileHelper::getFolderName(igFileHelper::getIncrementFromFilename($oneGallery->menu_image_filename)).'/'.$oneGallery->menu_image_filename;
						$varFields['{mainimg}'] = '<img style="float:left;" src="'.$imgpath.'" />';
						$result .= $varFields['{mainimg}'];
						if(empty($parameter->nolink)) $result .= '</a>';
					}

					if(!empty($parameter->menudesc) && !empty($oneGallery->menu_description)) $result .= $oneGallery->menu_description;
					if(!empty($parameter->catdesc) && !empty($oneGallery->gallery_description)) $result .= $acypluginsHelper->wrapText($oneGallery->gallery_description, $parameter);
					$result .= '</td></tr>';

					if(!empty($parameter->images)){
						$allImages = acymailing_loadObjectList('SELECT * FROM #__igallery_img WHERE gallery_id = '.intval($oneGallery->id).' AND published = 1'.(empty($parameter->allaccess) ? ' AND access = 1' : '').' LIMIT '.intval($parameter->images));

						if(!empty($parameter->imgdescription)){
							foreach($allImages as $oneImage){
								$args = array();
								$args[] = $this->name.':'.$oneImage->id;
								if(!empty($parameter->nolink)) $args[] = 'nolink';
								if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
								if(!empty($parameter->wrapimg)) $args[] = 'wrap:'.$parameter->wrapimg;
								if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
								if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
								if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
								if(!empty($parameter->imgdescription)) $args[] = 'imgdescription';
								if(!empty($parameter->filename)) $args[] = 'filename';
								if(!empty($parameter->itemid)) $args[] = 'itemid:'.$parameter->itemid;
								$result .= '<tr><td>{'.implode('|', $args).'}</td></tr>';
							}
						}else{
							$result .= '<tr class="galleryimages" style="text-align:center;">';

							$curPict = 0;
							$pictures = '';
							foreach($allImages as $oneImage){
								$imghtml = '<img src="images/igallery/original/'.igFileHelper::getFolderName(igFileHelper::getIncrementFromFilename($oneImage->filename)).'/'.$oneImage->filename.'" style="display:inline-block;"/>';
								if(!empty($parameter->link) && empty($parameter->nolink)) $imghtml = '<a href="'.(empty($oneImage->link) ? $link : $oneImage->link).'">'.$imghtml.'</a>';

								if(!empty($parameter->colsimg)){
									if(!empty($curPict) && $curPict % $parameter->colsimg == 0) $pictures .= '</tr><tr class="galleryimages" style="text-align:center;">';
									$curPict++;
									$imghtml = '<td>'.$imghtml.'</td>';
								}
								$pictures .= $imghtml;
							}

							if(!empty($parameter->colsimg)){
								while($curPict % $parameter->colsimg != 0){
									$curPict++;
									$pictures .= '<td/>';
								}
							}else{
								$pictures = '<td>'.$pictures.'</td>';
							}

							$result .= $pictures.'</tr>';
						}
					}
					$varFields['{readmore}'] = '<a class="readmore_link" style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.(empty($parameter->readmore) ? $this->readmore : $parameter->readmore).'</span></a>';
					if(!empty($parameter->readmorecat)) $result .= '<tr><td>'.$varFields['{readmore}'].'</td></tr>';

					$result .= '</table></div>';

					// If the user created its own template...
					if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php')){
						ob_start();
						require(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php');
						$result = ob_get_clean();
						$result = str_replace(array_keys($varFields), $varFields, $result);
					}

					$result = $acypluginsHelper->removeJS($result);
					$result = $acypluginsHelper->managePicts($parameter, $result);

					$arrayElements[] = $result;
				}
				$stringTag = $acypluginsHelper->getFormattedResult($arrayElements, $parameter);
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass
?>