<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingjbjobs extends JPlugin
{
	var $allFields = array();

	function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
		if(!isset($this->params))
		{
			$plugin = JPluginHelper::getPlugin('acymailing', 'jbjobs');
			$this->params = new JParameter( $plugin->params );
		}
	}

	 function acymailing_getPluginType()
	 {
	 	$onePlugin = new stdClass();
	 	$onePlugin->name = 'JoomBah';
	 	$onePlugin->function = 'acymailingJoomBah_show';
	 	$onePlugin->help = 'plugin-jbjobs';

	 	return $onePlugin;
	 }

	 function acymailingJoomBah_show()
	 {
	 	$config = acymailing_config();
		if($config->get('version') < '4.5.0')
		{
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$app = JFactory::getApplication();

		$lang = JFactory::getLanguage();
		$lang->load('com_jbjobs',JPATH_SITE);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.jbjobs';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order', 'a.id', 'cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir',	'desc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->titlelink = $app->getUserStateFromRequest( $paramBase.".titlelink", 'titlelink','1','string' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->autotitlelink = $app->getUserStateFromRequest( $paramBase.".autotitlelink", 'autotitlelink','1','string' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight','150','string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth','150','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->autopict = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->readmoreauto = $app->getUserStateFromRequest( $paramBase.".readmoreauto", 'readmoreauto','1','string' );

		$db = JFactory::getDBO();

		$searchFields = array('a.id','a.job_title','b.specialization','c.comp_name');

		if(!empty($pageInfo->search))
		{
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displaypub','all') == 'onlypub')
		{
			$filters[] = 'a.is_active = "y"';
			$filters[] = 'a.publish_date < "'.acymailing_getDate(time(),'%Y-%m-%d %H:%M:%S').'"';
			$filters[] = "a.expire_date > '".acymailing_getDate(time(),'%Y-%m-%d %H:%M:%S')."'";
		}

		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*, b.specialization, c.comp_name ' .
				'FROM #__jbjobs_job AS a ' .
				'JOIN #__jbjobs_job_spec AS b ' .
				'ON a.id_job_spec = b.id ' .
				'JOIN #__jbjobs_employer AS c ' .
				'ON a.employer_id = c.user_id ';

		if(!empty($pageInfo->filter_cat))
		{
			$filters[] = "a.id_job_spec = ".$pageInfo->filter_cat;
		}

		if(!empty($filters))
		{
			$query .= ' WHERE ('.implode(') AND (',$filters).')';
		}

		if(!empty($pageInfo->filter->order->value))
		{
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($rows[0]) && !isset($rows[0]->acy_created))
		{
			$db->setQuery('ALTER TABLE `#__jbjobs_job` ADD `acy_created` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP');
			$db->query();
		}

		if(!empty($pageInfo->search))
		{
			$rows = acymailing_search($pageInfo->search,$rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		$type = JRequest::getString('type');
	?>

		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass)
			{
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1)
				{
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass)
			{
				if(selectedCat[catid])
				{
					window.document.getElementById('cat'+catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('cat'+catid).className = 'selectedrow';
					selectedCat[catid] = 'selectedone';
				}
				updateTagAuto();
			}

			function updateTag()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;
				for(var i=0; i < document.adminForm.cbdisplay.length; i++)
				{
					if (document.adminForm.cbdisplay[i].checked)
					{
						 if(tmp==0)
						 {
							 tmp+=1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }
					}
				}

				if(document.adminForm.cbdisplaycf)
				{
					tmp=0;
					for(var i=0; i < document.adminForm.cbdisplaycf.length; i++)
					{
						if (document.adminForm.cbdisplaycf[i].checked)
						{
							 if(tmp==0)
							 {
								 tmp+=1;
								 otherinfo += "| cf:";
								 otherinfo += document.adminForm.cbdisplaycf[i].value;
							 }else{
								 otherinfo += ", ";
								 otherinfo += document.adminForm.cbdisplaycf[i].value;
							 }
						}
					}
				}

				for(var i=0; i < document.adminForm.titlelink.length; i++)
				{
					 if (document.adminForm.titlelink[i].checked && document.adminForm.titlelink[i].value == '1')
					 {
					 	otherinfo += '| link';
					 }
				}

				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value))
				{
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				for(var i=0; i < document.adminForm.readmore.length; i++)
				{
					 if (document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '1')
					 {
						 otherinfo += '| readmore';
					 }
				}

				for(var i=0; i < document.adminForm.pict.length; i++)
				{
					if (document.adminForm.pict[i].checked)
					{
						if(document.adminForm.pict[i].value != '0')
							otherinfo += '| pict:'+document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized')
						{
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}
				for(var i in selectedContents)
				{
					if(selectedContents[i] && !isNaN(i))
					{
						tag = tag + '{jbjobs:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto()
			{
				var tmp=0;
				tag = '{autojbjobs:';

				for(var icat in selectedCat)
				{
					if(selectedCat[icat] == 'selectedone')
					{
						tag += icat+'-';
					}
				}

				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value != 0 && !isNaN(document.adminForm.min_article.value))
				{
					tag += '| min:'+document.adminForm.min_article.value;
				}

				if(document.adminForm.max_article.value && document.adminForm.max_article.value != 0 && !isNaN(document.adminForm.max_article.value))
				{
					tag += '| max:'+document.adminForm.max_article.value;
				}

				for(var i=0; i < document.adminForm.cbdisplayauto.length; i++)
				{
					if (document.adminForm.cbdisplayauto[i].checked)
					{
						 if(tmp==0)
						 {
							 tmp+=1;
							 tag += "| display:";
							 tag += document.adminForm.cbdisplayauto[i].value;
						 }else{
							 tag += ", ";
							 tag += document.adminForm.cbdisplayauto[i].value;
						 }
					}
				}

				if(document.adminForm.cbdisplaycfauto)
				{
					tmp = 0;
					for(var i=0; i < document.adminForm.cbdisplaycfauto.length; i++)
					{
						if(document.adminForm.cbdisplaycfauto[i].checked)
						{
							 if(tmp == 0)
							 {
								 tmp = 1;
								 tag += "| cf:"+document.adminForm.cbdisplaycfauto[i].value;
							 }else{
								 tag += ", "+document.adminForm.cbdisplaycfauto[i].value;
							 }
						}
					}
				}

				for(var i=0; i < document.adminForm.autotitlelink.length; i++)
				{
					 if (document.adminForm.autotitlelink[i].checked && document.adminForm.autotitlelink[i].value == '1')
					 {
					 	tag += '| link';
					 }
				}

				for(var i=0; i < document.adminForm.readmoreauto.length; i++)
				{
					 if (document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '1')
					 {
					 	tag += '| readmore';
					 }
				}

				for(var i=0; i < document.adminForm.autopict.length; i++)
				{
					 if (document.adminForm.autopict[i].checked)
					 {
					 	if(document.adminForm.autopict[i].value != '0')
					 		tag += '| pict:'+document.adminForm.autopict[i].value;
						if(document.adminForm.autopict[i].value == 'resized')
						{
					 		document.getElementById('pictsizeauto').style.display = '';
					 		if(document.adminForm.pictwidthauto.value) tag += '| maxwidth:'+document.adminForm.pictwidthauto.value;
					 		if(document.adminForm.pictheightauto.value) tag += '| maxheight:'+document.adminForm.pictheightauto.value;
					 	}else{
					 		document.getElementById('pictsizeauto').style.display = 'none';
					 	}
					 }
				}

				if(document.adminForm.autowrap.value && document.adminForm.autowrap.value != 0 && !isNaN(document.adminForm.autowrap.value))
				{
					tag += "| wrap:"+document.adminForm.autowrap.value;
				}

				if(document.adminForm.cols.value){ tag += "| cols:"+document.adminForm.cols.value; }
				if(document.adminForm.contentorder.value){ tag += "| order:"+document.adminForm.contentorder.value; }
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value && document.adminForm.contentfilter.value != 'all'){ tag += "| filter:"+document.adminForm.contentfilter.value; }

				tag += '}';

				setTag(tag);
			}
		//-->
		</script>
		<?php
		$choice = array();
		$choice[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized",JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$ordering = array();
		$ordering[] = JHTML::_('select.option', "id,DESC",JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "publish_date,DESC",JText::_('JBJOBS_PUBLISHED_DATE'));
		$ordering[] = JHTML::_('select.option', "expire_date,DESC",JText::_('JBJOBS_EXPIRY_DATE'));
		$ordering[] = JHTML::_('select.option', "job_title,ASC",JText::_('ACY_TITLE'));
		$ordering[] = JHTML::_('select.option', "rand",JText::_('ACY_RANDOM'));

		$contentFilter = array();
		$contentFilter[] = JHTML::_('select.option', "all",JText::_('ACY_ALL'));
		$contentFilter[] = JHTML::_('select.option', "created",JText::_('ONLY_NEW_CREATED'));


		$column = array();
		for($i=1;$i<11;$i++)
		{
			$column[] = JHTML::_('select.option', "$i",$i);
		}

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane( 'joombah_tab');
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), 'joombah_jobs');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="title" id="title" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="title" id="title-lbl"><?php echo JText::_('FIELD_TITLE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="intro" id="intro" onclick="updateTag();"/><label style="margin-left:5px" for="intro" id="intro-lbl"><?php echo JText::_('INTRO_TEXT');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="description" id="description" onclick="updateTag();"/><label style="margin-left:5px" for="description" id="description-lbl"><?php echo JText::_('ACY_DESCRIPTION'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="salary" id="salary" onclick="updateTag();"/><label style="margin-left:5px" for="salary" id="salary-lbl"><?php echo JText::_('JBJOBS_APROXIMATE_SALARY');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="location" id="location" onclick="updateTag();"/><label style="margin-left:5px" for="location" id="location-lbl"><?php echo JText::_('JBJOBS_LOCATION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="country" id="country" onclick="updateTag();"/><label style="margin-left:5px" for="country" id="country-lbl"><?php echo JText::_('JBJOBS_COUNTRY'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="industry" id="industry" onclick="updateTag();"/><label style="margin-left:5px" for="industry" id="industry-lbl"><?php echo JText::_('JBJOBS_INDUSTRY');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="specialization" id="specialization" onclick="updateTag();"/><label style="margin-left:5px" for="specialization" id="specialization-lbl"><?php echo JText::_('JBJOBS_SPECIALIZATION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="positiontype" id="positiontype" onclick="updateTag();"/><label style="margin-left:5px" for="positiontype" id="positiontype-lbl"><?php echo JText::_('JBJOBS_POSITION_TYPE'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="experiencelevel" id="experiencelevel" onclick="updateTag();"/><label style="margin-left:5px" for="experiencelevel" id="experiencelevel-lbl"><?php echo JText::_('JBJOBS_EXPERIENCE_LEVEL');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="educationlevel" id="educationlevel" onclick="updateTag();"/><label style="margin-left:5px" for="educationlevel" id="educationlevel-lbl"><?php echo JText::_('JBJOBS_EDUCATION_LEVEL');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="advertiseddate" id="advertiseddate" onclick="updateTag();"/><label style="margin-left:5px" for="advertiseddate" id="advertiseddate-lbl"><?php echo JText::_('JBJOBS_ADVERTISED'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="closingdate" id="closingdate" onclick="updateTag();"/><label style="margin-left:5px" for="closingdate" id="closingdate-lbl"><?php echo JText::_('JBJOBS_CLOSING_DATE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="company" id="company" onclick="updateTag();"/><label style="margin-left:5px" for="company" id="company-lbl"><?php echo JText::_('JBJOBS_COMPANY_NAME');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="nbplaces" id="nbplaces" onclick="updateTag();"/><label style="margin-left:5px" for="nbplaces" id="nbplaces-lbl"><?php echo JText::_('JBJOBS_JOB_AVAILABLE_POSITION');?></label></td>
			</tr>
			<tr>
				<?php
					$db->setQuery('SELECT id, field_title FROM #__jbjobs_custom_field WHERE field_for LIKE "job" AND parent NOT LIKE "0" ORDER BY field_title ASC');
					$customFields = $db->loadObjectList();
					if(!empty($customFields))
					{
						echo '<td nowrap="nowrap">'.JText::_('EXTRA_FIELDS').'</td>';
						$tmp = 0;
						foreach($customFields as $oneCF)
						{
							if($tmp != 3)
							{
								echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplaycf" value="'.$oneCF->id.'" id="'.$oneCF->field_title.'" onclick="updateTag();"/><label style="margin-left:5px" for="'.$oneCF->field_title.'" id="'.$oneCF->field_title.'-lbl">'.$oneCF->field_title.'</label></td>';
								$tmp++;
							}else{
								echo '</tr><tr><td/><td nowrap="nowrap"><input type="checkbox" name="cbdisplaycf" value="'.$oneCF->id.'" id="'.$oneCF->field_title.'" onclick="updateTag();"/><label style="margin-left:5px" for="'.$oneCF->field_title.'" id="'.$oneCF->field_title.'-lbl">'.$oneCF->field_title.'</label></td>';
								$tmp = 1;
							}
						}
						while($tmp != 3)
						{
							echo '<td/>';
							$tmp++;
						}
					}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td nowrap="nowrap" valign="top">
					<?php echo JHTML::_('acyselect.radiolist', $choice, 'titlelink' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->titlelink);?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th class="title">
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('ACY_TITLE'), 'a.job_title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('JBJOBS_COMPANY_NAME'), 'c.comp_name', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('JBJOBS_SPECIALIZATION'), 'b.specialization', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort', JText::_('ACY_ID'), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					for($i = 0 ; $i<count($rows) ; $i++)
					{
						$row =& $rows[$i];
				?>
					<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
						<?php
							echo $row->job_title;
						?>
						</td>
						<td>
						<?php
							echo $row->comp_name;
						?>
						</td>
						<td>
						<?php
							echo $row->specialization;
						?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo $row->id; ?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
	<?php

		echo $tabs->endPanel();
		echo $tabs->startPanel( JText::_('TAG_CATEGORIES'), 'joombah_auto');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="title" id="titleauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="titleauto" id="titleauto-lbl"><?php echo JText::_('FIELD_TITLE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="intro" id="introauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="introauto" id="introauto-lbl"><?php echo JText::_('INTRO_TEXT');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="description" id="descriptionauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="descriptionauto" id="descriptionauto-lbl"><?php echo JText::_('ACY_DESCRIPTION'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="salary" id="salaryauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="salaryauto" id="salaryauto-lbl"><?php echo JText::_('JBJOBS_APROXIMATE_SALARY');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="location" id="locationauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="locationauto" id="locationauto-lbl"><?php echo JText::_('JBJOBS_LOCATION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="country" id="countryauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="countryauto" id="countryauto-lbl"><?php echo JText::_('JBJOBS_COUNTRY'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="industry" id="industryauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="industryauto" id="industryauto-lbl"><?php echo JText::_('JBJOBS_INDUSTRY');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="specialization" id="specializationauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="specializationauto" id="specializationauto-lbl"><?php echo JText::_('JBJOBS_SPECIALIZATION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="positiontype" id="positiontypeauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="positiontypeauto" id="positiontypeauto-lbl"><?php echo JText::_('JBJOBS_POSITION_TYPE'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="experiencelevel" id="experiencelevelauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="experiencelevelauto" id="experiencelevelauto-lbl"><?php echo JText::_('JBJOBS_EXPERIENCE_LEVEL');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="educationlevel" id="educationlevelauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="educationlevelauto" id="educationlevelauto-lbl"><?php echo JText::_('JBJOBS_EDUCATION_LEVEL');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="advertiseddate" id="advertiseddateauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="advertiseddateauto" id="advertiseddateauto-lbl"><?php echo JText::_('JBJOBS_ADVERTISED'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="closingdate" id="closingdateauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="closingdateauto" id="closingdateauto-lbl"><?php echo JText::_('JBJOBS_CLOSING_DATE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="company" id="companyauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="companyauto" id="companyauto-lbl"><?php echo JText::_('JBJOBS_COMPANY_NAME');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="nbplaces" id="nbplacesauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="nbplacesauto" id="nbplacesauto-lbl"><?php echo JText::_('JBJOBS_JOB_AVAILABLE_POSITION');?></label></td>
			</tr>
			<tr>
				<?php
					if(!empty($customFields))
					{
						echo '<td nowrap="nowrap">'.JText::_('EXTRA_FIELDS').'</td>';
						$tmp = 0;
						foreach($customFields as $oneCF)
						{
							if($tmp != 3)
							{
								echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplaycfauto" value="'.$oneCF->id.'" id="'.$oneCF->field_title.'auto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneCF->field_title.'auto" id="'.$oneCF->field_title.'auto-lbl">'.$oneCF->field_title.'</label></td>';
								$tmp++;
							}else{
								echo '</tr><tr><td/><td nowrap="nowrap"><input type="checkbox" name="cbdisplaycfauto" value="'.$oneCF->id.'" id="'.$oneCF->field_title.'auto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneCF->field_title.'auto" id="'.$oneCF->field_title.'auto-lbl">'.$oneCF->field_title.'</label></td>';
								$tmp = 1;
							}
						}
						while($tmp != 3)
						{
							echo '<td/>';
							$tmp++;
						}
					}
				?>
			</tr>
			<tr>
				<td valign="top" nowrap="nowrap">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict); ?>
				<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td nowrap="nowrap" valign="top">
					<?php echo JHTML::_('acyselect.radiolist', $choice, 'autotitlelink' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autotitlelink);?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="autowrap" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('FIELD_COLUMNS'); ?></td>
				<td nowrap="nowrap" colspan="3">
				 	<?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				 </td>
				 <td nowrap="nowrap">
				 	<input type="text" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
				<?php echo JText::_('ACY_ORDER'); ?>
				 </td>
				 <td nowrap="nowrap">
				 	<?php echo JHTML::_('acyselect.genericlist', $ordering, 'contentorder' , 'size="1" style="width:150px" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td nowrap="nowrap">
				<?php 	echo JText::_('MIN_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap">
				<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
				<?php echo JText::_('JOOMEXT_FILTER'); ?>
				</td>
				 <td nowrap="nowrap">
				 	<?php echo JHTML::_('acyselect.genericlist', $contentFilter, 'contentfilter' , 'size="1" style="width:150px" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentfilter); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
		<?php $k=0;
			foreach($this->catvalues as $oneCat)
			{
				if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
		<?php $k = 1 - $k; } ?>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();

	//End of the function
	 }

	function _categories($filter_cat)
	{
		//select all cats
		$db = JFactory::getDBO();
		$query = 'SELECT id, specialization ' .
				'FROM #__jbjobs_job_spec ' .
				'ORDER BY specialization ASC';
		$db->setQuery($query);
		$mosetCats = $db->loadObjectList();

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		foreach($mosetCats as $oneCat)
		{
			$this->catvalues[] = JHTML::_('select.option', $oneCat->id,$oneCat->specialization);
		}

		return JHTML::_('select.genericlist',   $this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int) $filter_cat);
	}

	 function _replaceOne(&$email)
	 {
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'jbjobs');
		if(empty($tags))
		{
			return;
		}
		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more link:
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$htmlreplace = array();
		$textreplace = array();
		foreach($tags as $i => $params)
		{
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content,true);
		}
		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
	 }

	 function _replaceContent(&$tag)
	 {
		$langjgb = JFactory::getLanguage();
		$langjgb->load('com_jbjobs',JPATH_SITE);

		if(!empty($tag->display))
			$tag->display = explode(',',$tag->display);
		foreach($tag->display as $i => $oneDisplay)
		{
			$oneDisplay = trim($oneDisplay);
			$tag->$oneDisplay = 1;
		}
		$tag->display = '';
		//1 : Load the content

		$data = array();

		$db = JFactory::getDBO();
		$query = 'SELECT a.*, b.exp_name, c.degree_level, d.comp_name, d.user_id, e.country, f.nsalary, g.pos_type, h.specialization, i.industry ' .
				'FROM #__jbjobs_job AS a ' .
				'LEFT JOIN #__jbjobs_job_exp AS b ' .
				'ON a.id_job_exp = b.id ' .
				'LEFT JOIN #__jbjobs_degree_level AS c ' .
				'ON a.id_degree_level = c.id ' .
				'LEFT JOIN #__jbjobs_employer AS d ' .
				'ON a.employer_id = d.user_id ' .
				'LEFT JOIN #__jbjobs_country AS e ' .
				'ON a.id_country = e.id ' .
				'LEFT JOIN #__jbjobs_salary_range AS f ' .
				'ON a.id_salary_type = f.id ' .
				'LEFT JOIN #__jbjobs_pos_type AS g ' .
				'ON a.id_pos_type = g.id ' .
				'LEFT JOIN #__jbjobs_job_spec AS h ' .
				'ON a.id_job_spec = h.id ' .
				'LEFT JOIN #__jbjobs_industry AS i ' .
				'ON d.id_industry = i.id ' .
				'WHERE a.id = '.intval($tag->id).' LIMIT 1';
		$db->setQuery($query);
		$job = $db->loadObject();
		//In case of we could not load the article for any reason...
		if(empty($job))
		{
			$app = JFactory::getApplication();
			if($app->isAdmin())
			{
				$app->enqueueMessage('The JoomBah job "'.$tag->id.'" could not be loaded','notice');
			}
			return '';
		}
		$varFields = array();
		foreach($job as $prefix => $oneField)
		{
			$varFields['{'.$prefix.'}'] = $oneField;
		}
		$link = 'index.php?option=com_jbjobs&view=guest&layout=detailjob&id='.$tag->id;
		if(!empty($tag->itemid)) $link .= '&Itemid='.$tag->itemid;

		$result = '';

		$result .= '<div class="acymailing_content">';
		$result .= '<table cellspacing="0" cellpadding="0" border="0" width="100%">';

		if(!empty($tag->title))
		{
			$result .= '<tr><td colspan="2">';
			if(!empty($tag->link))
			{
				$result.= '<a style="text-decoration:none;" href="'.$link.'">';
			}
			$result .= '<h2 class="acymailing_title">'.$job->job_title.'</h2>';
			if(!empty($tag->link))
			{
				$result.= '</a><br />';
			}
			$result .= '</td></tr>';
		}

		if(!empty($tag->company))
		{
			$result .= '<tr><td colspan="2"><a href="index.php?option=com_jbjobs&view=guest&layout=detailcomp&id='.$job->employer_id.'">'.$job->comp_name.'</a><br />';
			if(file_exists(JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.$job->user_id.'.jpg'))
				$result .= '<img src="images/jbjobs/'.$job->user_id.'.jpg"/></td></tr>';
			else
				$result .= '<img src="components/com_jbjobs/images/nophoto.gif"/></td></tr>';
		}

		$text = '';
		if(!empty($tag->intro) && !empty($job->short_desc))
			$text .= $job->short_desc.'<br />';
		if(!empty($tag->description) && !empty($job->long_desc))
			$text .= $job->long_desc.'<br />';

		if(!empty($text))
		{
			if(!empty($tag->wrap))
			{
				$tag->wrap = intval($tag->wrap);
				$newtext = strip_tags($text,'<br>');
				$numChar = strlen($newtext);
				if($numChar > $tag->wrap)
				{
					$stop = strlen($newtext);
					for($i=$tag->wrap ; $i<$numChar ; $i++)
					{
						if($newtext[$i] == " ")
						{
							$stop = $i;
							break;
						}
					}
					$text = substr($newtext,0,$stop).'...';
				}
			}
			$result .= '<tr><td colspan="2">'.$text.'</td></tr>';
		}

		if(!empty($tag->location))
		{
			$result .= '<tr><td>'.JText::_('JBJOBS_LOCATION').'</td><td>'.$job->city.', '.$job->state.'</td></tr>';
		}

		if(!empty($tag->country))
		{
			$result .= '<tr><td>'.JText::_('JBJOBS_COUNTRY').'</td><td>'.$job->country.'</td></tr>';
		}

		if(!empty($tag->salary))
		{
			$result .= '<tr><td>'.JText::_('JBJOBS_APROXIMATE_SALARY').'</td><td>'.$job->nsalary.'</td></tr>';
		}

		if(!empty($tag->positiontype))
		{
			$result .= '<tr><td>'.JText::_('JBJOBS_POSITION').'</td><td>'.$job->pos_type.'</td></tr>';
		}

		if(!empty($tag->industry))
		{
			$result .= '<tr><td>'.JText::_('JBJOBS_INDUSTRY').'</td><td>'.$job->industry.'</td></tr>';
		}

		if(!empty($tag->specialization))
		{
			$result .= '<tr><td>'.JText::_('JBJOBS_SPECIALIZATION').'</td><td>'.$job->specialization.'</td></tr>';
		}

		if(!(empty($tag->experiencelevel) && empty($tag->educationlevel)))
		{
			$result .= '<tr><td colspan="2"><br /><b>'.JText::_('JBJOBS_SKILLS').' :</b></td></tr>';
			if(!empty($tag->experiencelevel))
			{
				$result .= '<tr><td>'.JText::_('JBJOBS_MIN_EXPERIENCE').'</td><td>'.$job->exp_name.'</td></tr>';
			}
			if(!empty($tag->educationlevel))
			{
				$result .= '<tr><td>'.JText::_('JBJOBS_MIN_EDUCATION').'</td><td>'.$job->degree_level.'</td></tr>';
			}
		}

		if(!(empty($tag->advertiseddate) && empty($tag->closingdate) && empty($tag->nbplaces)))
		{
			$result .= '<tr><td colspan="2"><br /><b>'.JText::_('JBJOBS_ADDITIONAL_INFO').' :</b></td></tr>';
			if(!empty($tag->advertiseddate))
			{
				$result .= '<tr><td>'.JText::_('JBJOBS_ADVERTISED').'</td><td>'.acymailing_getDate(acymailing_getTime($job->publish_date),JText::_('DATE_FORMAT_LC')).'</td></tr>';
			}
			if(!empty($tag->closingdate))
			{
				$result .= '<tr><td>'.JText::_('JBJOBS_CLOSING_DATE').'</td><td>'.acymailing_getDate(acymailing_getTime($job->expire_date),JText::_('DATE_FORMAT_LC')).'</td></tr>';
			}
			if(!empty($tag->nbplaces))
			{
				$result .= '<tr><td>'.JText::_('JBJOBS_JOB_AVAILABLE_POSITION').'</td><td>'.$job->available.'</td></tr>';
			}
		}

		if(!empty($tag->cf))
		{
			$query = 'SELECT a.*, b.field_title, b.field_type ' .
					'FROM #__jbjobs_custom_field_value AS a ' .
					'JOIN #__jbjobs_custom_field AS b ' .
					'ON a.fieldid = b.id ' .
					'WHERE a.jobid = '.intval($tag->id).' ' .
					'AND b.id IN ('.$tag->cf.')';
			$db->setQuery($query);
			$customFields = $db->loadObjectList();
			if(!empty($customFields))
			{
				$result .= '<tr><td><br /></td></tr>';
				foreach($customFields as $oneCF)
				{
					if(!(empty($oneCF->value) && empty($oneCF->valuetext)))
					{
						if(!empty($oneCF->value))
						{
							//some custom fields need a different display
							if($oneCF->field_type == 'URL')
								$result .= '<tr><td>'.$oneCF->field_title.'</td><td><a href="'.$oneCF->value.'">'.$oneCF->value.'</a></td></tr>';
							elseif($oneCF->field_type == 'Date')
								$result .= '<tr><td>'.$oneCF->field_title.'</td><td>'.acymailing_getDate(acymailing_getTime($oneCF->value),JText::_('DATE_FORMAT_LC')).'</td></tr>';
							elseif($oneCF->field_type == 'Email')
								$result .= '<tr><td>'.$oneCF->field_title.'</td><td><a href="mailto:'.$oneCF->value.'">'.$oneCF->value.'</a></td></tr>';
							else{
								$oneCF->value = str_replace(';', ', ',$oneCF->value);
								$result .= '<tr><td>'.$oneCF->field_title.'</b></td><td>'.$oneCF->value.'</td></tr>';
							}
						}else{
							$result .= '<tr><td>'.$oneCF->field_title.'</td><td>'.$oneCF->valuetext.'</td></tr>';
						}
					}
				}
			}
		}

		$varFields['{readmore}'] = '<a class="readmore_link" style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a>';
		if(!empty($tag->readmore)) $result .= '<tr><td>'.$varFields['{readmore}'].'</td></tr>';

		$result .= '</table></div><br />';

		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'jbjobs.php'))
		{
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'jbjobs.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}
	 	$acypluginsHelper = acymailing_get('helper.acyplugins');
		$result = $acypluginsHelper->removeJS($result);

		//resize pictures
		$pictureHelper = acymailing_get('helper.acypict');
		if(isset($tag->pict))
		{
			if($tag->pict == 'resized')
			{
				$pictureHelper->maxHeight = empty($tag->maxheight) ? 150 : $tag->maxheight;
				$pictureHelper->maxWidth = empty($tag->maxwidth) ? 150 : $tag->maxwidth;
				if($pictureHelper->available())
				{
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error,'notice');
				}
			}
		}else{
			$result = $pictureHelper->removePictures($result);
		}
		return $result;
	}

	function acymailing_replacetags(&$email,$send = true)
	{
	 	$this->_replaceAuto($email);
	 	$this->_replaceOne($email);
	}

	 function _replaceAuto(&$email)
	 {
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags))
		{
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);
		}
	}

	function acymailing_generateautonews(&$email)
	{
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$db = JFactory::getDBO();
		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'autojbjobs');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags))
		{
			return $return;
		}

		foreach($tags as $oneTag => $parameter)
		{
			if(isset($this->tags[$oneTag]))
				continue;
			$allcats = explode('-',$parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat)
			{
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}
			$query = 'SELECT a.id FROM #__jbjobs_job AS a JOIN #__jbjobs_job_spec AS b ON a.id_job_spec = b.id ';
			$where = array();
			if(!empty($selectedArea))
			{
				$where[] = 'b.id IN ('.implode(',',$selectedArea).')';
			}

			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate']))
			{
				$where[] = 'a.acy_created > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
			}

			$time = time();
			$where[] = 'a.is_active LIKE "y"';
			$where[] = 'a.publish_date < "'.acymailing_getDate(time(),'%Y-%m-%d %H:%M:%S').'"';

			//hidden field : |featured |nofeatured and |hotjob
			if(!empty($parameter->featured))
				$where[] = "a.is_featured = 1";
			if(!empty($parameter->nofeatured))
				$where[] = "a.is_featured = 0";
			if(!empty($parameter->hotjob))
				$where[] = "a.hotjob_expire > '".acymailing_getDate(time(),'%Y-%m-%d %H:%M:%S')."'";
			$where[] = "a.expire_date > '".acymailing_getDate(time(),'%Y-%m-%d %H:%M:%S')."'";

			if(!empty($where))
			{
				$query .= ' WHERE ('.implode(') AND (',$where).')';
			}

			if(!empty($parameter->order))
			{
				if($parameter->order == 'rand')
				{
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',',$parameter->order);
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			if(!empty($parameter->max)) $query .= ' LIMIT '.intval($parameter->max);
			else $query .= ' LIMIT 20';
			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);
			if(!empty($parameter->min) && count($allArticles) < $parameter->min)
			{
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough JoomBah jobs for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			//we load the custom template if it exists
			if(!empty($allArticles))
			{
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autojbjobs.php'))
				{
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autojbjobs.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the article tag one after the other in a table as they are already sorted
					$arrayElements = array();
					foreach($allArticles as $oneArticleId)
					{
						$args = array();
						$args[] = 'jbjobs:'.$oneArticleId;
						if(!empty($parameter->link)) $args[] = 'link';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(!empty($parameter->cf)) $args[] = 'cf:'.$parameter->cf;
						if(!empty($parameter->readmore)) $args[] = 'readmore';
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass