<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingJobgrokboard extends JPlugin
{
	var $allFields = array();

	function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
		if(!isset($this->params))
		{
			$plugin = JPluginHelper::getPlugin('acymailing', 'jobgrokboard');
			$this->params = new JParameter( $plugin->params );
		}
	}

	 function acymailing_getPluginType()
	 {
	 	$onePlugin = new stdClass();
	 	$onePlugin->name = 'JobGrok Board';
	 	$onePlugin->function = 'acymailingjobgrokboard_show';
	 	$onePlugin->help = 'plugin-jobgrokboard';

	 	return $onePlugin;
	 }

	 function acymailingjobgrokboard_show()
	 {
	 	$config = acymailing_config();
		if($config->get('version') < '4.6.0')
		{
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$app = JFactory::getApplication();

		$langjgb = JFactory::getLanguage();
		$langjgb->load('com_jobgrokboard',JPATH_SITE);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.jobgrokboard';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order', 'f.id', 'cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir',	'desc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->filter_comp = $app->getUserStateFromRequest( $paramBase.".filter_comp", 'filter_comp','','int' );
		$pageInfo->titlelink = $app->getUserStateFromRequest( $paramBase.".titlelink", 'titlelink','1','string' );
		$pageInfo->images = $app->getUserStateFromRequest( $paramBase.".images", 'images','1','string' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->autotitlelink = $app->getUserStateFromRequest( $paramBase.".autotitlelink", 'autotitlelink','1','string' );
		$pageInfo->autoimages = $app->getUserStateFromRequest( $paramBase.".autoimages", 'autoimages','1','string' );
		$pageInfo->automaxvalue = $app->getUserStateFromRequest( $paramBase.".max", 'max','','int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','|filter:created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','|order:id','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight','150','string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth','150','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->autopict = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->readmoreauto = $app->getUserStateFromRequest( $paramBase.".readmoreauto", 'readmoreauto','1','string' );

		$db = JFactory::getDBO();

		$searchFields = array('f.id','a.title','b.company','d.category');

		if(!empty($pageInfo->search))
		{
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displaypub','all') == 'onlypub')
		{
			$filters[] = "a.link_published = 1";
		}

		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*, b.company, d.category, f.id AS postingid ' .
				'FROM #__tst_jgboard_jobs AS a ' .
				'JOIN #__tst_jgboard_companies AS b ' .
				'ON a.company_id = b.id ' .
				'JOIN #__tst_jgboard_categories AS e ' .
				'ON a.category_id = e.id ' .
				'JOIN #__tst_jgboard_static_category AS d ' .
				'ON e.code = d.id ' .
				'JOIN #__tst_jgboard_postings AS f ' .
				'ON a.id = f.job_id ';
		if(!empty($pageInfo->filter_cat))
		{
			$filters[] = "d.id = ".$pageInfo->filter_cat;
		}

		if(!empty($pageInfo->filter_comp))
		{
			$filters[] = "a.company_id = ".$pageInfo->filter_comp;
		}

		$filters[] = "f.posting_date < '".acymailing_getDate(time(),'%Y-%m-%d %H:%M:%S')."'";
		$filters[] = "f.closing_date > '".acymailing_getDate(time(),'%Y-%m-%d %H:%M:%S')."' OR f.closing_date = '0000-00-00 00:00:00'";

		if(!empty($filters))
		{
			$query .= ' WHERE ('.implode(') AND (',$filters).')';
		}

		if(!empty($pageInfo->filter->order->value))
		{
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($rows[0]) && !isset($rows[0]->acy_created))
		{
			$db->setQuery('ALTER TABLE `#__tst_jgboard_postings` ADD `acy_created` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP');
			$db->query();
		}

		if(!empty($pageInfo->search))
		{
			$rows = acymailing_search($pageInfo->search,$rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		$type = JRequest::getString('type');
	?>

		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass)
			{
				if(selectedContents[contentid])
				{
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[contentid];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents[contentid] = 'content';
				}

				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass)
			{
				if(selectedCat[catid])
				{
					window.document.getElementById('cat'+catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('cat'+catid).className = 'selectedrow';
					selectedCat[catid] = 'selectedone';
				}
				updateTagAuto();
			}

			function updateTag()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;
				for(var i=0; i < document.adminForm.cbdisplay.length; i++)
				{
					if (document.adminForm.cbdisplay[i].checked)
					{
						 if(tmp==0)
						 {
							 tmp+=1;
							 otherinfo += "|display:";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }
					}
				}
				for(var i=0; i < document.adminForm.titlelink.length; i++)
				{
					 if (document.adminForm.titlelink[i].checked && document.adminForm.titlelink[i].value == '1')
					 {
					 	otherinfo += '| link';
					 }
				}
				if(document.adminForm.wrap.value && document.adminForm.wrap.value!=0)
				{
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				for(var i=0; i < document.adminForm.readmore.length; i++)
				{
					 if (document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '1')
					 {
						 otherinfo += '| readmore';
					 }
				}

				for(var i=0; i < document.adminForm.pict.length; i++)
				{
					if (document.adminForm.pict[i].checked)
					{
						if(document.adminForm.pict[i].value != '0')
							otherinfo += '| pict:'+document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized')
						{
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}
				for(var i in selectedContents)
				{
					if(selectedContents[i] == 'content')
					{
						tag = tag + '{jobgrokboard:'+i+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto()
			{
				var tmp=0;
				tag = '{autojobgrokboard:';

				for(var icat in selectedCat)
				{
					if(selectedCat[icat] == 'selectedone')
					{
						tag += icat+'-';
					}
				}

				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value!=0){ tag += '|min:'+document.adminForm.min_article.value; }
				if(document.adminForm.max_article.value && document.adminForm.max_article.value!=0){ tag += '|max:'+document.adminForm.max_article.value; }
				for(var i=0; i < document.adminForm.cbdisplayauto.length; i++)
				{
					if (document.adminForm.cbdisplayauto[i].checked)
					{
						 if(tmp==0)
						 {
							 tmp+=1;
							 tag += "|display:";
							 tag += document.adminForm.cbdisplayauto[i].value;
						 }else{
							 tag += ", ";
							 tag += document.adminForm.cbdisplayauto[i].value;
						 }
					}
				}
				for(var i=0; i < document.adminForm.autotitlelink.length; i++)
				{
					 if (document.adminForm.autotitlelink[i].checked && document.adminForm.autotitlelink[i].value == '1')
					 {
					 	tag += '| link';
					 }
				}

				for(var i=0; i < document.adminForm.readmoreauto.length; i++)
				{
					 if (document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '1')
					 {
					 	tag += '| readmore';
					 }
				}
				for(var i=0; i < document.adminForm.autopict.length; i++)
				{
					 if (document.adminForm.autopict[i].checked)
					 {
					 	if(document.adminForm.autopict[i].value != '0')
					 		tag += '| pict:'+document.adminForm.autopict[i].value;
						if(document.adminForm.autopict[i].value == 'resized')
						{
					 		document.getElementById('pictsizeauto').style.display = '';
					 		if(document.adminForm.pictwidthauto.value) tag += '| maxwidth:'+document.adminForm.pictwidthauto.value;
					 		if(document.adminForm.pictheightauto.value) tag += '| maxheight:'+document.adminForm.pictheightauto.value;
					 	}else{
					 		document.getElementById('pictsizeauto').style.display = 'none';
					 	}
					 }
				}
				if(document.adminForm.autowrap.value && document.adminForm.autowrap.value!=0){ tag += "| wrap:"+document.adminForm.autowrap.value; }
				if(document.adminForm.cols.value){ tag += "| cols:"+document.adminForm.cols.value; }
				if(document.adminForm.contentorder.value){ tag += document.adminForm.contentorder.value; }
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){ tag += document.adminForm.contentfilter.value; }

				tag += '}';

				setTag(tag);
			}
		//-->
		</script>
		<?php
		$choice = array();
		$choice[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized",JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$ordering = array();
		$ordering[] = JHTML::_('select.option', "|order:id,DESC",JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "|order:ordering,ASC",JText::_('ACY_ORDERING'));
		$ordering[] = JHTML::_('select.option', "|order:posting_date,DESC",JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_POSTED_ON'));
		$ordering[] = JHTML::_('select.option', "|order:closing_date,DESC",JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_CLOSING_ON'));
		$ordering[] = JHTML::_('select.option', "|order:title,ASC",JText::_('ACY_TITLE'));
		$ordering[] = JHTML::_('select.option', "|order:rand",JText::_('ACY_RANDOM'));

		//Title link params
		$titlelink = array();
		$titlelink[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$titlelink[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));


		$column = array();
		for($i=1;$i<11;$i++)
		{
			$column[] = JHTML::_('select.option', "$i",$i);
		}

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane( 'jobgrokboard_tab');
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), 'jobgrokboard_listings');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="title" id="title" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="title" id="title-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_JOB_TITLE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="company" id="company" onclick="updateTag();"/><label style="margin-left:5px" for="company" id="company-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_COMPANY');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="postsumm" id="postsumm" onclick="updateTag();"/><label style="margin-left:5px" for="postsumm" id="postsumm-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_SUMMARY');?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="postedon" id="postedon" onclick="updateTag();"/><label style="margin-left:5px" for="postedon" id="postedon-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_POSTED_ON');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="closeson" id="closeson" onclick="updateTag();"/><label style="margin-left:5px" for="closeson" id="closeson-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_CLOSING_ON');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="code" id="code" onclick="updateTag();"/><label style="margin-left:5px" for="code" id="code-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_JOB_CODE'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="category" id="category" onclick="updateTag();"/><label style="margin-left:5px" for="category" id="category-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_CATEGORY');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="department" id="department" onclick="updateTag();"/><label style="margin-left:5px" for="department" id="department-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_DEPARTMENT');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="shift" id="shift" onclick="updateTag();"/><label style="margin-left:5px" for="shift" id="shift-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_SHIFT'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="location" id="location" onclick="updateTag();"/><label style="margin-left:5px" for="location" id="location-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_LOCATION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="jobtype" id="jobtype" onclick="updateTag();"/><label style="margin-left:5px" for="jobtype" id="jobtype-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_STATICCOMPANYREVENUES_TMPL_DEFAULT_JOB_TYPE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="education" id="education" onclick="updateTag();"/><label style="margin-left:5px" for="education" id="education-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_STATICEDUCATIONS_TMPL_DEFAULT_EDUCATION'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="payrate" id="payrate" onclick="updateTag();"/><label style="margin-left:5px" for="payrate" id="payrate-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_PAY_RATE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="duration" id="duration" onclick="updateTag();"/><label style="margin-left:5px" for="duration" id="duration-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_DURATION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="travel" id="travel" onclick="updateTag();"/><label style="margin-left:5px" for="travel" id="travel-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_TRAVEL'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="jobdesc" id="jobdesc" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="jobdesc" id="jobdesc-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_JOB_DESCRIPTION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="prefferedskills" id="prefferedskills" onclick="updateTag();"/><label style="margin-left:5px" for="prefferedskills" id="prefferedskills-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_PREFERRED_SKILLS');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="apply" id="apply" onclick="updateTag();"/><label style="margin-left:5px" for="apply" id="apply-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_APPLY_NOW'); ?></label></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td nowrap="nowrap">
					<?php echo JHTML::_('acyselect.radiolist', $titlelink, 'titlelink' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->titlelink);?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
			<tr>
				<td width="100%">
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_companies($pageInfo->filter_comp); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th class="title">
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('ACY_TITLE'), 'a.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('COM_JOBGROKBOARD_ADMIN_JOBGROK_COMPANY'), 'b.company', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('COM_JOBGROKBOARD_ADMIN_JOBGROK_CATEGORY'), 'd.category', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort',   JText::_('ACY_ID'), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					for($i = 0 ; $i<count($rows) ; $i++)
					{
						$row =& $rows[$i];
				?>
					<tr id="content<?php echo $row->postingid; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->postingid.",'row$k'"?>);" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
						<?php
							echo $row->title;
						?>
						</td>
						<td>
						<?php
							echo $row->company;
						?>
						</td>
						<td>
						<?php
							echo $row->category;
						?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo $row->postingid; ?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
	<?php

		echo $tabs->endPanel();
		echo $tabs->startPanel( JText::_('TAG_CATEGORIES'), 'jobgrokboard_auto');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="title" id="titleauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="titleauto" id="titleauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_JOB_TITLE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="company" id="companyauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="companyauto" id="companyauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_COMPANY');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="postsumm" id="postsummauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="postsummauto" id="postsummauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_SUMMARY');?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="postedon" id="postedonauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="postedonauto" id="postedonauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_POSTED_ON');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="closeson" id="closesonauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="closesonauto" id="closesonauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_CLOSING_ON');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="code" id="codeauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="codeauto" id="codeauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_JOB_CODE'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="category" id="categoryauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="categoryauto" id="categoryauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_CATEGORY');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="department" id="departmentauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="departmentauto" id="departmentauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_DEPARTMENT');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="shift" id="shiftauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="shiftauto" id="shiftauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_SHIFT'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="location" id="locationauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="locationauto" id="locationauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_LOCATION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="jobtype" id="jobtypeauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="jobtypeauto" id="jobtypeauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_STATICCOMPANYREVENUES_TMPL_DEFAULT_JOB_TYPE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="education" id="educationauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="educationauto" id="educationauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_STATICEDUCATIONS_TMPL_DEFAULT_EDUCATION'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="payrate" id="payrateauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="payrateauto" id="payrateauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_PAY_RATE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="duration" id="durationauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="durationauto" id="durationauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_DURATION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="travel" id="travelauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="travelauto" id="travelauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_TRAVEL'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="jobdesc" id="jobdescauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="jobdescauto" id="jobdescauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_JOB_DESCRIPTION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="prefferedskills" id="prefferedskillsauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="prefferedskillsauto" id="prefferedskillsauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_PREFERRED_SKILLS');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="apply" id="applyauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="applyauto" id="applyauto-lbl"><?php echo JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_APPLY_NOW'); ?></label></td>
			</tr>
			<tr>
				<td valign="top" nowrap="nowrap">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict); ?>
				<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td nowrap="nowrap">
					<?php echo JHTML::_('acyselect.radiolist', $titlelink, 'autotitlelink' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autotitlelink);?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="autowrap" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('FIELD_COLUMNS'); ?></td>
				<td nowrap="nowrap" colspan="3">
				 	<?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				 </td>
				 <td nowrap="nowrap">
				 	<input type="text" name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
				<?php echo JText::_('ACY_ORDER'); ?>
				 </td>
				 <td nowrap="nowrap">
				 	<?php echo JHTML::_('acyselect.genericlist', $ordering, 'contentorder' , 'size="1" style="width:150px" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td nowrap="nowrap">
				<?php 	echo JText::_('MIN_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap">
				<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
				<?php echo JText::_('JOOMEXT_FILTER'); ?>
				</td>
				 <td nowrap="nowrap">
					 <select id="contentfilter" name="contentfilter" size="1" onchange="updateTagAuto();" style="max-width:200px;">
						<option value=""><?php echo JText::_('ACY_ALL'); ?></option>
						<option value="|filter:created" selected="selected"><?php echo JText::_('ONLY_NEW_CREATED'); ?></option>
					</select>
				</td>
			</tr>
			<?php } ?>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
		<?php $k=0;
			foreach($this->catvalues as $oneCat)
			{
				if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
		<?php $k = 1 - $k; } ?>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();

	//End of the function
	 }

	function _categories($filter_cat)
	{
		//select all cats
		$db = JFactory::getDBO();
		$query = 'SELECT id, category ' .
				'FROM #__tst_jgboard_static_category ' .
				'ORDER BY category ASC';
		$db->setQuery($query);
		$mosetCats = $db->loadObjectList();

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		foreach($mosetCats as $oneCat)
		{
			$this->catvalues[] = JHTML::_('select.option', $oneCat->id,$oneCat->category);
		}

		return JHTML::_('select.genericlist',   $this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int) $filter_cat);
	}

	function _companies($filter_comp)
	{
		//select all cats
		$db = JFactory::getDBO();
		$query = 'SELECT id, company ' .
				'FROM #__tst_jgboard_companies ' .
				'ORDER BY company ASC';
		$db->setQuery($query);
		$mosetComps = $db->loadObjectList();

		$this->compvalues = array();
		$this->compvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		foreach($mosetComps as $oneComp)
		{
			$this->compvalues[] = JHTML::_('select.option', $oneComp->id,$oneComp->company);
		}

		return JHTML::_('select.genericlist',   $this->compvalues, 'filter_comp', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int) $filter_comp);
	}

	 function _replaceOne(&$email)
	 {
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'jobgrokboard');
		if(empty($tags))
		{
			return;
		}
		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more link:
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$htmlreplace = array();
		$textreplace = array();
		foreach($tags as $i => $params)
		{
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content,true);
		}
		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
	 }

	 function _replaceContent(&$tag)
	 {
		$langjgb = JFactory::getLanguage();
		$langjgb->load('com_jobgrokboard',JPATH_SITE);

		if(!empty($tag->display))
			$tag->display = explode(',',$tag->display);
		foreach($tag->display as $i => $oneDisplay)
		{
			$oneDisplay = trim($oneDisplay);
			$tag->$oneDisplay = 1;
		}
		$tag->display = '';
		//1 : Load the content

		$data = array();

		$db = JFactory::getDBO();
		$db->setQuery('SELECT * FROM #__tst_jgboard_postings WHERE id = '.intval($tag->id).' LIMIT 1');
		$data['post|'] = $db->loadObject();
		//In case of we could not load the article for any reason...
		if(empty($data['post|']))
		{
			$app = JFactory::getApplication();
			if($app->isAdmin())
			{
				$app->enqueueMessage('The job\'s posting "'.$tag->id.'" could not be loaded','notice');
			}
			return '';
		}
		$db->setQuery('SELECT * FROM #__tst_jgboard_jobs WHERE id = '.intval($data['post|']->job_id).' LIMIT 1');
		$data['job|'] = $db->loadObject();
		if(!empty($data['job|']->company_id))
		{
			$db->setQuery('SELECT * FROM #__tst_jgboard_companies WHERE id = '.intval($data['job|']->company_id).' LIMIT 1');
			$data['comp|'] = $db->loadObject();
		}
		if(!empty($data['job|']->category_id))
		{
			$db->setQuery('SELECT * FROM #__tst_jgboard_categories WHERE id = '.intval($data['job|']->category_id).' LIMIT 1');
			$data['caties|'] = $db->loadObject();
		}
		if(!empty($data['caties|']->code))
		{
			$db->setQuery('SELECT * FROM #__tst_jgboard_static_category WHERE id = '.intval($data['caties|']->code).' LIMIT 1');
			$data['caty|'] = $db->loadObject();
		}
		if(!empty($data['job|']->department_id))
		{
			$db->setQuery('SELECT * FROM #__tst_jgboard_departments WHERE id = '.intval($data['job|']->department_id).' LIMIT 1');
			$data['dept|'] = $db->loadObject();
		}
		if(!empty($data['job|']->shift_id))
		{
			$db->setQuery('SELECT * FROM #__tst_jgboard_shifts WHERE id = '.intval($data['job|']->shift_id).' LIMIT 1');
			$data['shift|'] = $db->loadObject();
		}
		if(!empty($data['job|']->jobtype_id))
		{
			$db->setQuery('SELECT * FROM #__tst_jgboard_jobtypes WHERE id = '.intval($data['job|']->jobtype_id).' LIMIT 1');
			$data['jtype|'] = $db->loadObject();
		}
		if(!empty($data['job|']->education_id))
		{
			$db->setQuery('SELECT * FROM #__tst_jgboard_static_education WHERE id = '.intval($data['job|']->education_id).' LIMIT 1');
			$data['educ|'] = $db->loadObject();
		}
		if(!empty($data['job|']->location_id))
		{
			$db->setQuery('SELECT * FROM #__tst_jgboard_locations WHERE id = '.intval($data['post|']->location_id).' LIMIT 1');
			$data['loc|'] = $db->loadObject();
		}


		$varFields = array();
		foreach($data as $prefix => $oneTable)
		{
			foreach($oneTable as $alias => $oneField)
			{
				$varFields['{'.$prefix.$alias.'}'] = $oneField;
			}
		}

		$link = ACYMAILING_LIVE.'index.php?option=com_jobgrokboard&view=posting&id='.$tag->id;
		if(!empty($tag->itemid)) $link .= '&Itemid='.$tag->itemid;

		$result = '';

		$result .= '<div class="acymailing_content">';
		$result .= '<table cellspacing="0" cellpadding="0" border="0" width="100%">';
		if(!empty($tag->title))
		{
			$result .= '<tr><td colspan="2">';
			if(!empty($tag->link))
			{
				$result.= '<a style="text-decoration:none;" href="'.$link.'">';
			}
			$result .= '<h2 class="acymailing_title">'.$data['job|']->title;
			if(!empty($tag->company) && !empty($data['comp|']->company))
			{
				$result .= '('.$data['comp|']->company.')';
			}
			$result .= '</h2>';
			if(!empty($tag->link))
			{
				$result.= '</a><br />';
			}
			$result .= '</td></tr>';
		}

		if(!empty($tag->postsumm) && !empty($data['post|']->summary))
		{
			$result .= '<tr><td colspan="2">'.$data['post|']->summary.'</td></tr>';
		}
		if(!empty($tag->code) && !empty($data['job|']->job_code))
		{
			$result .= '<tr><td style="width:150px"><b>'.JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_JOB_CODE').' :</b></td><td>'.$data['job|']->job_code.'</td></tr>';
		}
		if(!empty($tag->postedon) && !empty($data['post|']->posting_date) && $data['post|']->posting_date != '0000-00-00 00:00:00')
		{
			$result .= '<tr><td style="width:150px"><b>'.JText::_('COM_JOBGROKBOARD_VIEWS_PANEL_TMPL_DEFAULT_POSTED_ON').' :</b></td><td>'.acymailing_getDate(acymailing_getTime($data['post|']->posting_date),'%d %B %Y').'</td></tr>';
		}
		if(!empty($tag->closeson) && !empty($data['post|']->closing_date) && $data['post|']->closing_date != '0000-00-00 00:00:00')
		{
			$result .= '<tr><td style="width:150px"><b>'.JText::_('COM_JOBGROKBOARD_VIEWS_PANEL_TMPL_DEFAULT_CLOSES_ON').' :</b></td><td>'.acymailing_getDate(acymailing_getTime($data['post|']->closing_date),'%d %B %Y').'</td></tr>';
		}
		if(!empty($tag->category) && !empty($data['caties|']->description))
		{
			$result .= '<tr><td><b>'.JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_CATEGORY').' :</b></td><td>'.$data['caties|']->description.'</td></tr>';
		}
		if(!empty($tag->department) && !empty($data['dept|']->department))
		{
			$result .= '<tr><td><b>'.JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_DEPARTMENT').' :</b></td><td>'.$data['dept|']->department.'</td></tr>';
		}
		if(!empty($tag->shift) && !empty($data['shift|']->shift))
		{
			$result .= '<tr><td><b>'.JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_SHIFT').' :</b></td><td>'.$data['shift|']->shift.'</td></tr>';
		}
		if(!empty($tag->location) && !empty($data['loc|']->location))
		{
			$result .= '<tr><td valign="top"><b>'.JText::_('COM_JOBGROKBOARD_VIEWS_APPLICATION_TMPL_DEFAULT_LOCATION').' :</b></td><td>'.$data['loc|']->location;
			if(!empty($data['loc|']->loc_description))
				$result .= '<br />'.$data['loc|']->loc_description;
			if(!empty($data['loc|']->loc_address))
				$result .= '<br />'.$data['loc|']->loc_address;
			$result .= '</td></tr>';
		}
		if(!empty($tag->jobtype) && !empty($data['jtype|']->jobtype))
		{
			$result .= '<tr><td><b>'.JText::_('COM_JOBGROKBOARD_VIEWS_JOBTYPE_TMPL_DEFAULT_JOB_TYPE').' :</b></td><td>'.$data['jtype|']->jobtype.'</td></tr>';
		}
		if(!empty($tag->education) && !empty($data['educ|']->education))
		{
			$result .= '<tr><td><b>'.JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_EDUCATION').' :</b></td><td>'.$data['educ|']->education.'</td></tr>';
		}
		if(!empty($tag->payrate) && !empty($data['job|']->pay_rate))
		{
			$result .= '<tr><td><b>'.JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_PAY_RATE').' :</b></td><td>'.$data['job|']->pay_rate.'</td></tr>';
		}
		if(!empty($tag->duration) && !empty($data['job|']->duration))
		{
			$result .= '<tr><td><b>'.JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_DURATION').' :</b></td><td>'.$data['job|']->duration.'</td></tr>';
		}
		if(!empty($tag->travel) && !empty($data['job|']->travel))
		{
			$result .= '<tr><td><b>'.JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_TRAVEL').' :</b></td><td>'.$data['job|']->travel.'</td></tr>';
		}
		if(!empty($tag->jobdesc) && !empty($data['job|']->job_description))
		{
			if(!empty($tag->wrap))
			{
				$tag->wrap = intval($tag->wrap);
				$newtext = strip_tags($data['job|']->job_description,'<br>');
				$numChar = strlen($newtext);
				if($numChar > $tag->wrap)
				{
					$stop = strlen($newtext);
					for($i=$tag->wrap ; $i<$numChar ; $i++)
					{
						if($newtext[$i] == " ")
						{
							$stop = $i;
							break;
						}
					}
					$data['job|']->job_description = substr($newtext,0,$stop).'...';
				}
			}
			$result .= '<tr><td valign="top"><b>'.JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_JOB_DESCRIPTION').' :</b></td><td>'.$data['job|']->job_description.'</td></tr>';
		}
		if(!empty($tag->prefferedskills) && !empty($data['job|']->preferred_skills))
		{
			$result .= '<tr><td><b>'.JText::_('COM_JOBGROKBOARD_VIEWS_POSTING_TMPL_DEFAULT_PREFERRED_SKILLS').' :</b></td><td>'.$data['job|']->preferred_skills.'</td></tr>';
		}
		if(!empty($tag->apply)) $result .= '<tr><td colspan="2"><a href="index.php?option=com_jobgrokboard&controller=jobseeker&source=submissions&view=application&Postingid='.$data['post|']->id.'">'.JText::_('COM_JOBGROKBOARD_VIEWS_POSTINGS_TMPL_DEFAULT_XML_APPLY_FOR_JOB').'</a></tr>';

		$varFields['{readmore}'] = '<a class="readmore_link" style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a>';
		if(!empty($tag->readmore)) $result .= '<tr><td>'.$varFields['{readmore}'].'</td></tr>';

		$result .= '</table></div><br />';

		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'jobgrokboard.php'))
		{
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'jobgrokboard.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}
	 	$acypluginsHelper = acymailing_get('helper.acyplugins');
		$result = $acypluginsHelper->removeJS($result);

		//resize pictures
		if(isset($tag->pict))
		{
			$pictureHelper = acymailing_get('helper.acypict');
			$pictureHelper->maxHeight = empty($tag->maxheight) ? 150 : $tag->maxheight;
			$pictureHelper->maxWidth = empty($tag->maxwidth) ? 150 : $tag->maxwidth;
			if($tag->pict == 'resized')
			{
				if($pictureHelper->available())
				{
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error,'notice');
				}
			}
		}else{
			$result = $pictureHelper->removePictures($result);
		}
		return $result;
	}

	function acymailing_replacetags(&$email,$send = true)
	{
	 	$this->_replaceAuto($email);
	 	$this->_replaceOne($email);
	}

	 function _replaceAuto(&$email)
	 {
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags))
		{
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);
		}
	}

	function acymailing_generateautonews(&$email)
	{
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$db = JFactory::getDBO();
		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'autojobgrokboard');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags))
		{
			return $return;
		}

		foreach($tags as $oneTag => $parameter)
		{
			if(isset($this->tags[$oneTag]))
				continue;
			$allcats = explode('-',$parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat)
			{
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT c.id FROM #__tst_jgboard_jobs AS a JOIN #__tst_jgboard_categories AS b ON a.category_id = b.id JOIN #__tst_jgboard_postings AS c ON a.id = c.job_id ';
			$where = array();
			if(!empty($selectedArea))
			{
				$where[] = 'b.code IN ('.implode(',',$selectedArea).')';
			}

			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate']))
			{
				$where[] = 'c.acy_created > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
			}

			$time = time();
			$where[] = "c.posting_date < '".acymailing_getDate(time(),'%Y-%m-%d %H:%M:%S')."'";
			$where[] = "c.closing_date > '".acymailing_getDate(time(),'%Y-%m-%d %H:%M:%S')."' OR c.closing_date = '0000-00-00 00:00:00'";
			$where[] = "c.published = 1";
			//TODO : $where[] = "a.published = 1";

			if(!empty($where))
			{
				$query .= ' WHERE ('.implode(') AND (',$where).')';
			}

			if(!empty($parameter->order))
			{
				if($parameter->order == 'rand')
				{
					$query .= ' ORDER BY rand()';
				}elseif($parameter->order == 'posting_date,DESC' || $parameter->order == 'closing_date,DESC'){
					$ordering = explode(',',$parameter->order);
					$query .= ' ORDER BY c.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}else{
					$ordering = explode(',',$parameter->order);
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			if(!empty($parameter->max)) $query .= ' LIMIT '.(int) $parameter->max;
			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);
			if(!empty($parameter->min) && count($allArticles) < $parameter->min)
			{
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough Jobgrok board job\'s postings for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles))
			{
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autojobgrokboard.php'))
				{
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autojobgrokboard.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the article tag one after the other in a table as they are already sorted
					$arrayElements = array();
					foreach($allArticles as $oneArticleId)
					{
						$args = array();
						$args[] = 'jobgrokboard:'.$oneArticleId;
						if(!empty($parameter->link)) $args[] = 'link';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(!empty($parameter->readmore)) $args[] = 'readmore';
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass