<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingjomestate extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		$this->name = 'jomestate';
		$this->db = JFactory::getDBO();
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new JParameter( $plugin->params );
		}

		//check if the component is installed
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_jomestate');
	}

	function acymailing_getPluginType(){
		$app = JFactory::getApplication();
	 	if(!$this->component_installed || ($this->params->get('frontendaccess') == 'none' && !$app->isAdmin())) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'JomEstate';
		$onePlugin->function = 'acymailing_'.$this->name.'_show';
		$onePlugin->help = 'plugin-'.$this->name;
		return $onePlugin;
	}

	function acymailing_jomestate_show(){
		$config = acymailing_config();

		if($config->get('version') < '4.8.0'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$app = JFactory::getApplication();

		$lang = JFactory::getLanguage();
		$lang->load('com_jomestate',JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jomestate');

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.'.$this->name;

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order','a.id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir','asc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->filter_type = $app->getUserStateFromRequest( $paramBase.".filter_type", 'filter_type','','int' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id,DESC','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight','150','string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth','150','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->pictauto = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->readmoreauto = $app->getUserStateFromRequest( $paramBase.".readmoreauto", 'readmoreauto','1','string' );
		$pageInfo->wrap = $app->getUserStateFromRequest( $paramBase.".wrap", 'wrap','0','string' );
		$pageInfo->clickable = $app->getUserStateFromRequest( $paramBase.".clickable", 'clickable','1','string' );
		$pageInfo->clickableauto = $app->getUserStateFromRequest( $paramBase.".clickableauto", 'clickableauto','1','string' );
		$pageInfo->propertytype = $app->getUserStateFromRequest( $paramBase.".propertytype", 'propertytype','1','string' );
		$pageInfo->pricetype = $app->getUserStateFromRequest( $paramBase.".pricetype", 'pricetype','1','string' );

		//the query's start
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*, b.title AS cattitle, c.name ' .
				'FROM #__cddir_jomestate AS a ' .
				'JOIN #__cddir_categories AS b ON a.categories_id = b.id ' .
				'LEFT JOIN #__cddir_company AS c ON a.company_id = c.id ';
		$filters[] = 'b.extension = "com_jomestate.jomestate"';

		//search fields...
		$searchFields = array('a.title','a.id','b.title');

		//apply search fields
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE ".$searchVal;
		}

		//only published content ?
		if($this->params->get('displaycontent','all') == 'onlypub') $filters[] = 'a.published = 1';

		//if the user filtered by category
		if(!empty($pageInfo->filter_cat)) $filters[] = 'a.categories_id = '.intval($pageInfo->filter_cat);

		//apply filters
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (',$filters).')';

		//apply ordering
		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;

		$this->db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);

		//load results
		$rows = $this->db->loadObjectList();

		//yellow highlighting on search matches
		if(!empty($pageInfo->search)) $rows = acymailing_search($pageInfo->search,$rows);

		//pagination
		$this->db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $this->db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		//is this a Smart-Newsletter or a simple one ?
		$type = JRequest::getString('type');

	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass){
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1){
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('cat'+catid).className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						for(key in selectedCat)
						{
							if(!isNaN(key))
							{
								window.document.getElementById('cat'+key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat'+catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				<?php
					//add the fields the user wants to be displayed
				?>
				for(var i=0; i < document.adminForm.cbdisplay.length; i++){
					if(document.adminForm.cbdisplay[i].checked){
						 if(tmp == 0){
							 tmp += 1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }
					}
				}

				if(document.adminForm.customfields){
					tmp=0;
					for(var i=0; i < document.adminForm.customfields.length; i++){
						if (document.adminForm.customfields[i].checked){
							 if(tmp==0){
								 tmp+=1;
								 otherinfo += "| custom:";
								 otherinfo += document.adminForm.customfields[i].value;
							 }else{
								 otherinfo += ", ";
								 otherinfo += document.adminForm.customfields[i].value;
							 }
						}
					}
				}

				<?php
					//is the title clickable ?
				?>
				for(var i=0; i < document.adminForm.clickable.length; i++){
					 if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '0'){
						 otherinfo += '| nolink';
					 }
				}

				<?php
					//do we have to wrap the text ? (description for example...)
				?>
				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value)){
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				<?php
					//do we have to add a "read more" button ?
				?>
				for(var i=0; i < document.adminForm.readmore.length; i++){
					 if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '0'){
						 otherinfo += '| noreadmore';
					 }
				}

				<?php
					//picture management
				?>
				for(var i=0; i < document.adminForm.pict.length; i++){
					if (document.adminForm.pict[i].checked){
					 	if(document.adminForm.pict[i].value != '1') otherinfo += '| pict:'+document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized'){
							 document.getElementById('pictsize').style.display = '';
							 if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
							 if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				for(var i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{<?php echo $this->name; ?>:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto(){
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				for(var i=0; i < document.adminForm.cbdisplayauto.length; i++){
					if (document.adminForm.cbdisplayauto[i].checked){
						 if(tmp==0){
							 tmp+=1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }
					}
				}

				if(document.adminForm.customfieldsauto){
					tmp=0;
					for(var i=0; i < document.adminForm.customfieldsauto.length; i++){
						if (document.adminForm.customfieldsauto[i].checked){
							 if(tmp==0){
								 tmp+=1;
								 otherinfo += "| custom:";
								 otherinfo += document.adminForm.customfieldsauto[i].value;
							 }else{
								 otherinfo += ", ";
								 otherinfo += document.adminForm.customfieldsauto[i].value;
							 }
						}
					}
				}

				for(var i=0; i < document.adminForm.clickableauto.length; i++){
					if (document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '0'){
						 otherinfo += '| nolink';
					}
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value != 0 && !isNaN(document.adminForm.wrapauto.value)){
					otherinfo += "| wrap:"+document.adminForm.wrapauto.value;
				}

				for(var i=0; i < document.adminForm.readmoreauto.length; i++){
					 if (document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '0'){
						 otherinfo += '| noreadmore';
					 }
				}

				for(var i=0; i < document.adminForm.autopict.length; i++){
					if (document.adminForm.autopict[i].checked){
						if(document.adminForm.autopict[i].value != '1') otherinfo += '| pict:'+document.adminForm.autopict[i].value;

						if(document.adminForm.autopict[i].value == 'resized'){
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:'+document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}

				<?php
					//on how many columns do we have to display the contents ?
				?>
				if(document.adminForm.cols.value){
					otherinfo += "| cols:"+document.adminForm.cols.value;
				}

				<?php
					//limit the number of content displayed
				?>
				if(document.adminForm.max_article.value){
					otherinfo += "| max:"+document.adminForm.max_article.value;
				}

				<?php
					//with what order will we display the contents
				?>
				if(document.adminForm.contentorder.value){
					otherinfo += "| order:"+document.adminForm.contentorder.value;
				}

				if(document.adminForm.propertytype.value != 0){
					otherinfo += "| type:"+document.adminForm.propertytype.value;
				}

				if(window.document.getElementById('jlang') && window.document.getElementById('jlang').value != '')
				{
					otherinfo += '| lang:'+window.document.getElementById('jlang').value;
				}

				<?php if($type == 'autonews'){

					//minimum number of content for the newsletter to be displayed... yes, a perfect english !
				?>
					if(document.adminForm.min_article.value){
						otherinfo += "| min:"+document.adminForm.min_article.value;
					}

					<?php
						//filter the content : only newly created/modified
					?>
					if(document.adminForm.contentfilter && document.adminForm.contentfilter.value != 0){
						otherinfo += "| filter:"+document.adminForm.contentfilter.value;
					}
				<?php }
					//insert the tag
				?>
				tag = '{auto<?php echo $this->name; ?>:';
				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat+'-';
					}
				}
				tag += otherinfo+'}<br />';

				setTag(tag);
			}
		//-->
		</script>
<?php
		// yes/no for the options
		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// picture options
		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// here are the possible orderings
		$ordering = array();
		$ordering[] = JHTML::_('select.option', "id,DESC", JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "date_created,DESC", JText::_('CREATED_DATE'));
		$ordering[] = JHTML::_('select.option', "date_modified,DESC", JText::_('MODIFIED_DATE'));
		$ordering[] = JHTML::_('select.option', "title,ASC", JText::_('FIELD_TITLE'));
		$ordering[] = JHTML::_('select.option', "rand", JText::_('ACY_RANDOM'));

		// filter options
		$contentfilter = array();
		$contentfilter[] = JHTML::_('select.option', "0", JText::_('ACY_ALL'));
		$contentfilter[] = JHTML::_('select.option', "created", JText::_('ONLY_NEW_CREATED'));
		$contentfilter[] = JHTML::_('select.option', "modified", JText::_('ONLY_NEW_MODIFIED'));

		// options for the Nb. columns dropdown (1 to 10)
		$column = array();
		for($i=1;$i<11;$i++){
			$column[] = JHTML::_('select.option', "$i",$i);
		}

		$this->db->setQuery('SELECT id AS value, title AS text FROM #__cddir_categories WHERE extension = "com_jomestate.type" ORDER BY title ASC');
		$propertyTypes = $this->db->loadObjectList();

		$default = JHTML::_('select.option', "0", '- - -');
		array_unshift($propertyTypes, $default);

		if(ACYMAILING_J30){
			$paginationNb = array();
			foreach(array(5,10,15,20,25,30,50,100) as $oneOption){
				$paginationNb[] = JHTML::_('select.option', $oneOption, $oneOption);
			}
			$paginationNb[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		}

		$fieldsDisplay = array();
		$fieldsDisplay[] = array('title' => 'title', 'label' => 'ACY_TITLE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'image', 'label' => 'ACY_IMAGE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'intro', 'label' => 'INTRO_TEXT', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'description', 'label' => 'ACY_DESCRIPTION', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'address', 'label' => 'COM_JOMESTATE_HOME_ADDRESS', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'price', 'label' => 'COM_JOMESTATE_CFG_PRICE_TYPE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'energy', 'label' => 'COM_JOMESTATE_FIELD_ENERGY_CLASS', 'checked' => '');

		$this->db->setQuery('SELECT name, id FROM #__cddir_fields WHERE published = 1');
		$customFields = $this->db->loadObjectList();

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane( $this->name.'_tab');

		// start the first tab
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), $this->name.'_listings');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField){
						if($i == 5){
							echo '</tr><tr><td/>';
							$i = 1;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="'.$oneField['title'].'" id="'.$oneField['title'].'" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTag();"/><label style="margin-left:5px" for="'.$oneField['title'].'">'.trim(JText::_($oneField['label']), ':').'</label></td>';
						$i++;
					}
					while($i != 5){
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<?php
				//handle custom fields
				if(!empty($customFields)){
					echo '<tr><td>'.JText::_('EXTRA_FIELDS').'</td>';
					$i = 1;
					foreach($customFields as $oneParam){
						if($i == 5){
							$i = 1;
							echo '</tr><tr><td/>' ;
						}
						echo '<td><input value="'.$oneParam->id.'" name="customfields" id="cf_'.$oneParam->id.'" type="checkbox" onclick="updateTag();"/>';
						echo '<label for="cf_'.$oneParam->id.'">'.$oneParam->name.'</label></td>';
						$i++;
					}
					while($i != 5){
						$i++;
						echo '<td/>';
					}
					echo '</tr>';
				}
			?>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickable' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>

				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td nowrap="nowrap" width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>"  type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th/>
					<th class="title">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );
						?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'COM_JOMESTATE_COMPANY'), 'a.company_id', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value );
						?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php
							echo $pagination->getListFooter();
							if(ACYMAILING_J30) echo 'Display #'.JHTML::_('select.genericlist', $paginationNb, 'limit' , 'size="1" style="width:60px" onchange="Joomla.submitform();"', 'value', 'text', $pageInfo->limit->value).'<br />';
							echo $pagination->getResultsCounter();
						?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					if(!empty($rows)){
						foreach($rows as $row){
				?>
							<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
								<td class="acytdcheckbox"></td>
								<td style="text-align:center;">
									<?php
										if(!empty($row->title)) echo $row->title;
									?>
								</td>
								<td style="text-align:center;">
									<?php
										if(!empty($row->cattitle)) echo $row->cattitle;
									?>
								</td>
								<td style="text-align:center;">
									<?php
										if(!empty($row->name)) echo $row->name;
									?>
								</td>
								<td style="text-align:center;">
									<?php
										echo $row->id;
									?>
								</td>
							</tr>
				<?php
							// this enables to know if we have to set the line background grey or white
							$k = 1-$k;
						}
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />

		<?php
			echo $tabs->endPanel();
			// start category tab
			echo $tabs->startPanel( JText::_('TAG_CATEGORIES'), $this->name.'_auto');
		?>

		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField){
						if($i%5 == 0){
							echo '</tr><tr><td/>';
							$i++;
						}
						if($i == 4){
							$jflanguages = acymailing_get('type.jflanguages');
							$jflanguages->onclick = 'onchange="updateTagAuto();"';
							$jflanguages->jid = 'jlang';
							echo '<td>'.$jflanguages->displayJLanguages('jlang').'</td></tr><tr><td/>';
							$i += 2;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="'.$oneField['title'].'" id="'.$oneField['title'].'auto" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneField['title'].'auto">'.JText::_($oneField['label']).'</label></td>';
						$i++;
					}
					while($i%5 != 0){
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<?php
				//handle custom fields
				if(!empty($customFields)){
					echo '<tr><td>'.JText::_('EXTRA_FIELDS').'</td>';
					$i = 1;
					foreach($customFields as $oneParam){
						if($i == 5){
							$i = 1;
							echo '</tr><tr><td/>' ;
						}
						echo '<td><input value="'.$oneParam->id.'" name="customfieldsauto" id="autocf_'.$oneParam->id.'auto" type="checkbox" onclick="updateTagAuto();"/>';
						echo '<label for="autocf_'.$oneParam->id.'auto">'.$oneParam->name.'</label></td>';
						$i++;
					}
					while($i != 5){
						$i++;
						echo '<td/>';
					}
					echo '</tr>';
				}
			?>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickableauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
					<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('COM_JOMESTATE_CATEGORY_TYPE'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <?php echo JHTML::_('select.genericlist', $propertyTypes, 'propertytype' , 'size="1" onchange="updateTagAuto();" style="width:150px;"', 'value', 'text', $pageInfo->propertytype); ?>
				</td>
				<td>
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap" nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <input type="text" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $ordering, 'contentorder' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews'){ ?>
			<tr>
				<td nowrap="nowrap">
					<?php 	echo JText::_('MIN_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('JOOMEXT_FILTER'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $contentfilter, 'contentfilter' , 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentfilter); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
<!--====================================================================================LISTE CATEGORIES===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<?php $k=0; ?>
			<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
					<?php
						echo JText::_('ACY_ALL');
					?>
				</td>
			</tr>
			<?php
				if(!empty($this->catvalues)){
					foreach($this->catvalues as $oneCat){
						if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
			<?php
						$k = 1 - $k;
					}
				}
			?>
		</table>
<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	 }

	function _categories($filter_cat){
		//select all cats
		$this->db->setQuery('SELECT id, parent_id, title FROM #__cddir_categories WHERE extension = "com_jomestate.jomestate" ORDER BY id ASC');
		$cats = $this->db->loadObjectList();
		$this->cats = array();
		if(!empty($cats)){
			foreach($cats as $oneCat){
				$this->cats[$oneCat->parent_id][] = $oneCat;
			}
		}

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist',$this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	function _handleChildrens($parent_id=1,$level=0){
		if(!empty($this->cats[$parent_id])){
			foreach($this->cats[$parent_id] as $cat){
				$this->catvalues[] = JHTML::_('select.option', $cat->id,str_repeat(" - - ",$level).$cat->title);
				$this->_handleChildrens($cat->id,$level+1);
			}
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceOne(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, $this->name);
		if(empty($tags)) return;

		$this->db->setQuery('SELECT id, parent_id, title FROM #__cddir_categories WHERE extension = "com_jomcomdev.address"');
		$this->allAddresses = $this->db->loadObjectList('id');

		$this->jomestateParams = JComponentHelper::getParams('com_jomestate');
		$currency = $this->jomestateParams->get('currency');
		$currency_position = $this->jomestateParams->get('currency_position');
		if($currency_position == 1){
			$this->currencyBefore = $currency;
			$this->currencyAfter = '';
		}else{
			$this->currencyBefore = '';
			$this->currencyAfter = $currency;
		}

		$lang = JFactory::getLanguage();
		$lang->load('com_jomestate', JPATH_SITE);
		$lang->load('com_jomestate',JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jomestate');

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$tagsReplaced = array();
		foreach($tags as $i => $oneTag){
			if(isset($tagsReplaced[$i])) continue;
			$tagsReplaced[$i] = $this->_replaceContent($oneTag);
		}

		$acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}

	function _replaceContent(&$tag){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$app = JFactory::getApplication();

	 	// extract the fields selected
		if(!empty($tag->display)){
			$tag->display = explode(',',$tag->display);

			foreach($tag->display as $i => $oneDisplay){
				$oneDisplay = trim($oneDisplay);
				$tag->$oneDisplay = true;
			}
			unset($tag->display);
		}

		if(!empty($tag->custom)){
			$tag->custom = explode(',',$tag->custom);

			foreach($tag->custom as $i => $oneDisplay){
				$tag->custom[$i] = trim($oneDisplay);
			}
			JArrayHelper::toInteger($tag->custom);
		}

		// load content
		$this->db->setQuery('SELECT a.*, b.title AS cattitle FROM #__cddir_jomestate AS a ' .
							'JOIN #__cddir_categories AS b ' .
								'ON a.categories_id = b.id ' .
							'WHERE a.id = '.intval($tag->id).' LIMIT 1');
		$content = $this->db->loadObject();

		//In case of we could not load the article for any reason...
		if(empty($content)){
			if($app->isAdmin()) $app->enqueueMessage('The content "'.$tag->id.'" could not be loaded','notice');
			return '';
		}

		$colorLeft = array(0 => 'lightgrey', 1 => 'whitesmoke');
		$colorRight = array(0 => 'whitesmoke', 1 => 'white');
		$row = 0;

		$varFields = array();
		foreach($content as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		// create the link for the title and the read more button
		$link = ACYMAILING_LIVE.'index.php?option=com_jomestate&view=item&id='.$tag->id;
		if(!empty($tag->itemid)) $link .= '&Itemid='.$tag->itemid;
		$varFields['{link}'] = $link;

		$result = '<div class="acymailing_content"><table cellspacing="2" cellpadding="0" border="0" width="100%">';

		// display the title
		if(!empty($tag->title) && !empty($content->title)){
			$result .= '<tr><td colspan="2"><h2 class="acymailing_title">';
			if(empty($tag->nolink)) $result .= '<a href="'.$link.'">';
			$result .= $content->title;
			if(empty($tag->nolink)) $result .= '</a>';
			$result .= '</h2></td></tr>';
		}

		// display the main text wraped or not
		if(!empty($tag->intro) || !empty($tag->description) || !empty($tag->image)){
			$result .= '<tr><td colspan="2" style="text-align:justify;">';
			if(!empty($tag->image)){
				$this->db->setQuery('SELECT name, path FROM #__cddir_images WHERE extension = "com_jomestate" AND content_id = '.intval($tag->id));
				$images = $this->db->loadObjectList();
				if(!empty($images)){
					$styleVar = empty($tag->style) ? 'float:left;' : $tag->style;
					$varFields['{imagehtml}'] = '<img style="'.$styleVar.'" src="components/com_jomcomdev/images/'.$images[0]->path.'/'.$images[0]->name.'"/>';
					$result .= $varFields['{imagehtml}'];
				}
			}

			$description = '';
			if(!empty($tag->intro)) $description = empty($content->introtext) ? $content->fulltext : $content->introtext;
			if(!empty($tag->description) && (empty($tag->intro) || !empty($content->introtext))) $description .= $content->fulltext;
			if(!empty($description)) $result .= $acypluginsHelper->wrapText($description, $tag);

			$result .= '</td></tr>';
		}

		if(!empty($tag->category)){
			$result .= '<tr><td style="background-color:'.$colorLeft[$row%2].';padding:10px;" valign="middle"><strong>'.JText::_('COM_JOMESTATE_ADM_CATEGORY').'</strong></td><td style="background-color:'.$colorRight[$row%2].';padding:10px;" valign="middle">'.$content->cattitle.'</td></tr>';
			$row++;
		}
		if(!empty($tag->energy) && $content->energy_class != "O"){
			$result .= '<tr><td style="background-color:'.$colorLeft[$row%2].';padding:10px;" valign="middle"><strong>'.JText::_('COM_JOMESTATE_FIELD_ENERGY_CLASS').'</strong></td><td style="background-color:'.$colorRight[$row%2].';padding:10px;" valign="middle">'.$content->energy_class.'</td></tr>';
			$row++;
		}
		if(!empty($tag->address) && !empty($content->categories_address_id)){
			$propAddress = array();
			$i = $content->categories_address_id;
			while(isset($this->allAddresses[$i])){
				$propAddress[] = $this->allAddresses[$i]->title;
				$i = $this->allAddresses[$i]->parent_id == 1 ? -1 : $this->allAddresses[$i]->parent_id;
			}
			$result .= '<tr><td style="background-color:'.$colorLeft[$row%2].';padding:10px;" valign="middle"><strong>'.JText::_('COM_JOMESTATE_FIELD_ADDRESS').'</strong></td><td style="background-color:'.$colorRight[$row%2].';padding:10px;" valign="middle">'.implode(', ', array_reverse($propAddress)).'</td></tr>';
			$row++;
		}

		if(!empty($tag->price)){
			$this->db->setQuery('SELECT a.price_netto, b.title ' .
								'FROM #__cddir_prices AS a ' .
								'JOIN #__cddir_categories AS b ' .
									'ON a.type_id = b.id AND b.extension = "com_jomestate.price" ' .
								'WHERE content_id = '.intval($tag->id) .
									' AND a.extension = "com_jomestate"');
			$propPrices = $this->db->loadObjectList();
			if(!empty($propPrices)){
				$result .= '<tr><td style="background-color:'.$colorLeft[$row%2].';padding:10px;" valign="middle"><strong>'.JText::_('COM_JOMESTATE_CFG_PRICE_TYPE').'</strong></td><td style="background-color:'.$colorRight[$row%2].';padding:10px;" valign="middle">';
				$price = array();
				$varFields['{currencyBefore}'] = $this->currencyBefore;
				$varFields['{currencyAfter}'] = $this->currencyAfter;
				foreach($propPrices as $onePrice){
					$varFields['{'.JText::_($onePrice->title).'}'] = $onePrice->price_netto;
					$result .= JText::_($onePrice->title).': '.$this->currencyBefore.$onePrice->price_netto.$this->currencyAfter.'<br/>';
				}
				$result .= '</td></tr>';
				$row++;
			}
		}

		if(!empty($tag->custom)){
			$this->db->setQuery('SELECT a.*, b.name, b.select ' .
								'FROM #__cddir_content_has_fields AS a ' .
								'JOIN #__cddir_fields AS b ' .
									'ON a.fields_id = b.id ' .
								'WHERE a.content_id = '.intval($tag->id).' ' .
									'AND a.fields_id IN ('.implode(',', $tag->custom).')');
			$custom_fields = $this->db->loadObjectList();
			if(!empty($custom_fields)){
				$valArray = array();
				foreach($custom_fields as $oneCustomField){
					$valArray[$oneCustomField->fields_id][] = $oneCustomField;
				}

				foreach($valArray as $listValues){
					$value = array();
					$possible_values = null;
					foreach($listValues as $oneValue){
						$label = $oneValue->name;
						if($oneValue->value_int !== NULL){
							$value[] = $oneValue->value_int;
						}else{
							if(empty($oneValue->select) || $oneValue->select == 'null'){
								$value[] = $oneValue->value_string;
							}else{
								if(empty($possible_values)) $possible_values = json_decode($oneValue->select);
								$value[] = $possible_values->value[intval($oneValue->value_string)];
							}
						}
					}
					if(empty($value) || (is_array($value) && empty($value[0]))) continue;
					$result .= '<tr><td style="background-color:'.$colorLeft[$row%2].';padding:10px;" valign="middle"><strong>'.JText::_($label).'</strong></td><td style="background-color:'.$colorRight[$row%2].';padding:10px;" valign="middle">'.implode(', ', $value).'</td></tr>';
					$row++;
				}
			}
		}

		if(!empty($tag->images)) $tag->images = intval($tag->images);
		if(!empty($tag->images)){
			if(empty($images)){
				$this->db->setQuery('SELECT name, path FROM #__cddir_images WHERE extension = "com_jomestate" AND content_id = '.intval($tag->id));
				$images = $this->db->loadObjectList();
			}
			if(!empty($images)){
				if(!empty($tag->image)) array_shift($images);
				if(!empty($images)){
					$result .= '<tr><td colspan="2" style="display:inline-block;text-align:center;">';
					foreach($images as $oneImage){
						$result .= '<img style="margin:5px;" src="components/com_jomcomdev/images/'.$oneImage->path.'/'.$oneImage->name.'"/>';
					}
					$result .= '</td></tr>';
				}
			}
		}

		if(empty($tag->noreadmore)) $result .= '<tr><td colspan="2"><a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a></td></tr>';

		$result .= '</table></div><br />';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}

		// always remove JS, there is no JS in newsletters...
		$result = $acypluginsHelper->removeJS($result);

		//resize or remove pictures
		$result = $acypluginsHelper->managePicts($tag, $result);

		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'auto'.$this->name);
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;
			$allcats = explode('-',$parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT a.id FROM #__cddir_jomestate AS a ';

			$where = array();

			// load only needed content
			if(!empty($selectedArea)) $where[] = 'a.categories_id IN ('.implode(',',$selectedArea).')';

			// filter results created or modified
			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
				if($parameter->filter == 'created'){
					$where[] = 'a.created > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
				}elseif($parameter->filter == 'modified'){
					$where[] = 'a.created > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\' OR a.modified > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
				}
			}

			if(!empty($parameter->type)) $where[] = 'a.categories_type_id = '.intval($parameter->type);
			if(!empty($parameter->companyid)) $where[] = 'a.company_id = '.intval($parameter->companyid);
			if(!empty($parameter->agentid)) $where[] = 'a.agent_id = '.intval($parameter->agentid);

			// Only published content
			$where[] = 'a.published = 1';
			$where[] = 'a.approved = 1';

			if(!empty($parameter->featured)) $where[] = 'a.featured = 1';
			if(!empty($parameter->nofeatured)) $where[] = 'a.featured = 0';

			if(!empty($parameter->lang)){
				$where[] = 'a.language = '.$db->Quote($parameter->lang);
			}

			// Apply filters
			if(!empty($where)) $query .= ' WHERE ('.implode(') AND (',$where).')';

			// Ordering
			if(!empty($parameter->order)){
				if($parameter->order == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',',$parameter->order);
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			$start = '';
			if(!empty($parameter->start)) $start = intval($parameter->start).',';
			if(empty($parameter->max)) $parameter->max = 20;
			//We add a limit for the preview otherwise we could break everything
			$query .= ' LIMIT '.$start.(int) $parameter->max;


			// load content IDs
			$this->db->setQuery($query);
			$allArticles = acymailing_loadResultArray($this->db);

			// Check the number of results
			if(!empty($parameter->min) && count($allArticles) < $parameter->min){
				//We will not generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough '.$this->name.' content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles)){
				// If the user created its own template...
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
					$arrayElements = array();
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = $this->name.':'.$oneArticleId;
						if(!empty($parameter->nolink)) $args[] = 'nolink';
						if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
						if(!empty($parameter->category)) $args[] = 'category';
						if(!empty($parameter->images)) $args[] = 'images:'.$parameter->images;
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						if(!empty($parameter->custom)) $args[] = 'custom:'.$parameter->custom;
						if(!empty($parameter->itemid)) $args[] = 'itemid:'.$parameter->itemid;
						if(isset($parameter->style)) $args[] = 'style:'.$parameter->style;
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass
?>