<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingListbingo extends JPlugin
{
	function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
		if(!isset($this->params))
		{
			$plugin =& JPluginHelper::getPlugin('acymailing', 'listbingo');
			$this->params = new JParameter( $plugin->params );
		}

		//check if the component is installed
		if(!file_exists(JPATH_SITE.DS.'components'.DS.'com_listbingo'))
		{
			$this->component_installed = false;
		}else{
			$this->component_installed = true;
		}

		$db = JFactory::getDBO();
		$tables = $db->getTableList();
		$this->listbingo_items = in_array($db->getPrefix().'listbingo_items', $tables);
	}

	function acymailing_getPluginType()
	{
		if(!$this->component_installed)
			return;
		$app = JFactory::getApplication();
	 	if($this->params->get('frontendaccess') == 'none' && !$app->isAdmin()) return;
	 	$onePlugin = new stdClass();
	 	$onePlugin->name = 'Listbingo';
	 	$onePlugin->function = 'acymailinglistbingo_show';
	 	$onePlugin->help = 'plugin-listbingo';
	 	return $onePlugin;
	}

	function acymailinglistbingo_show()
	{
		$config = acymailing_config();
		$db = JFactory::getDBO();

		//We will need the latest developped functions
		if($config->get('version') < '4.6.0'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$lang = JFactory::getLanguage();
		$lang->load('com_listbingo',JPATH_SITE);
		$app = JFactory::getApplication();

		$paramBase = ACYMAILING_COMPONENT.'.listbingo';

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order','a.title','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir',	'desc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->titlelink = $app->getUserStateFromRequest( $paramBase.".titlelink", 'titlelink','1','string' );
		$pageInfo->extra = $app->getUserStateFromRequest( $paramBase.".extra", 'extra','0','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->contenttype = $app->getUserStateFromRequest( $paramBase.".contenttype", 'contenttype','intro','string' );
		$pageInfo->limit = new stdClass();
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->autotitlelink = $app->getUserStateFromRequest( $paramBase.".autotitlelink", 'autotitlelink','1','string' );
		$pageInfo->autopict = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->automaxvalue = $app->getUserStateFromRequest( $paramBase.".max", 'max','20','int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id','string' );
		$pageInfo->autocontenttype = $app->getUserStateFromRequest( $paramBase.".autocontenttype", 'autocontenttype','intro','string' );
		$pageInfo->extraauto = $app->getUserStateFromRequest( $paramBase.".extraauto", 'extraauto','0','string' );

		$query = '';
		$filters = array();

		// Listbingo 1.x
		if (!ACYMAILING_J16 || $this->listbingo_items) $searchFields = array('a.id', 'a.title', 'b.title', 'c.title');
		// Listbingo >= 2.x
		else $searchFields = array('a.listbingo_ad_id', 'a.title', 'b.title', 'c.title');

		if(!empty($pageInfo->search))
		{
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayart','all') == 'onlypub')
		{
			$filters[] = "a.status = 1";
		}else{
			$filters[] = "a.status != -2";
		}

		// Listbingo 1.x
		if(!ACYMAILING_J16)
		{
			$query = 'SELECT a.*,b.*,a.title AS ads_title,a.id as ads_id, b.title as country_title,c.title as cat_title '.
					'FROM `#__gbl_ads` AS a ' .
					'LEFT JOIN `#__gbl_countries` AS b ON a.country_id = b.id ' .
					'LEFT JOIN `#__gbl_categories` AS c ON a.category_id = c.id ';

			if(!empty($pageInfo->filter_cat)) $filters[] = "a.category_id = ".$pageInfo->filter_cat." OR c.parent_id = ".$pageInfo->filter_cat;

		}elseif($this->listbingo_items){
			$query = '
				SELECT
					a.*,
					b.*,
					a.id AS ads_id,
					a.title AS ads_title,
					b.title AS country_title,
					c.title AS cat_title
				FROM `#__listbingo_items` AS a
				LEFT JOIN `#__listbingo_countries` AS b ON a.country_code = b.code
				LEFT JOIN `#__listbingo_categories` AS c ON a.category_id = c.id';

			if(!empty($pageInfo->filter_cat)) $filters[] = "a.category_id = ".$pageInfo->filter_cat." OR c.parent_id = ".$pageInfo->filter_cat;
		}else{ // Listbingo >= 2.x
			$query = '
				SELECT
					a.*,
					b.*,
					a.listbingo_ad_id AS ads_id,
					a.title AS ads_title,
					b.title AS country_title,
					c.title AS cat_title
				FROM `#__listbingo_ads` AS a
				LEFT JOIN `#__listbingo_countries` AS b ON a.listbingo_country_code = b.code
				LEFT JOIN `#__listbingo_categories` AS c ON a.listbingo_category_id = c.listbingo_category_id';

			if(!empty($pageInfo->filter_cat)) $filters[] = "a.listbingo_category_id = ".$pageInfo->filter_cat." OR c.parent_id = ".$pageInfo->filter_cat;
		}

		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (',$filters).')';

		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;

		$db->setQuery($query, $pageInfo->limit->start, $pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search,$rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements = new stdClass();
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		$type = JRequest::getString('type');

	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass)
			{
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1)
				{
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			function updateTag()
			{
				var tag = '';
				var otherinfo = '';
				for(var i=0; i < document.adminForm.contenttype.length; i++)
				{
					 if (document.adminForm.contenttype[i].checked)
					 {
					 	selectedtype = '|type:'+document.adminForm.contenttype[i].value;
					 	otherinfo += '| type:'+document.adminForm.contenttype[i].value;
					 }
				}

				if(selectedtype != '|type:title')
				{
					for(var i=0; i < document.adminForm.pict.length; i++)
					{
						 if(document.adminForm.pict[i].checked)
						 {
						 	otherinfo += '| pict:'+document.adminForm.pict[i].value;
						 }
					}
				}

				for(var i=0; i < document.adminForm.titlelink.length; i++)
				{
					 if(document.adminForm.titlelink[i].checked && document.adminForm.titlelink[i].value == 1)
					 {
					 	otherinfo += '| link';
					 }
				}

				for(var i=0; i < document.adminForm.download.length; i++)
				{
					if(document.adminForm.download[i].checked && document.adminForm.download[i].value == 1)
					{
						otherinfo += '| extra';
					}
				}

				for(var i in selectedContents)
				{
					if(selectedContents[i] && !isNaN(i))
					{
						tag = tag + '{listbingo:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass)
			{
				if(selectedCat[catid])
				{
					window.document.getElementById('cat'+catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('cat'+catid).className = 'selectedrow';
					selectedCat[catid] = 'selectedone';
				}
				updateTagAuto();
			}

			function updateTagAuto()
			{
				tag = '{autolistbingo:';

				for(var icat in selectedCat)
				{
					if(selectedCat[icat] == 'selectedone')
					{
						tag += icat+'-';
					}
				}

				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value!=0)
				{
					tag += '| min:'+document.adminForm.min_article.value;
				}

				if(document.adminForm.max_article.value && document.adminForm.max_article.value!=0)
				{
					tag += '| max:'+document.adminForm.max_article.value;
				}

				for(var i=0; i < document.adminForm.contenttypeauto.length; i++)
				{
					 if(document.adminForm.contenttypeauto[i].checked)
					 {
					 	selectedtype = '|type:'+document.adminForm.contenttypeauto[i].value;
					 	tag += '| type:'+document.adminForm.contenttypeauto[i].value;
					 }
				}

				if(selectedtype != '|type:title')
				{
					for(var i=0; i < document.adminForm.extraauto.length; i++)
					{
						 if(document.adminForm.extraauto[i].checked && document.adminForm.extraauto[i].value == 1)
						 {
						 	tag += '| extra';
						 }
					}

					for(var i=0; i < document.adminForm.autopict.length; i++)
					{
						 if(document.adminForm.autopict[i].checked)
						 {
						 	tag += '| pict:'+document.adminForm.autopict[i].value;
						 }
					}
				}

				for(var i=0; i < document.adminForm.autotitlelink.length; i++)
				{
					 if(document.adminForm.autotitlelink[i].checked && document.adminForm.autotitlelink[i].value == 1)
					 {
					 	tag += '| link';
					 }
				}

				if(document.adminForm.contentorder.value)
				{
					tag += '| order:'+document.adminForm.contentorder.value;
				}

				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value)
				{
					tag += '| filter:'+document.adminForm.contentfilter.value;
				}

				tag += '}';

				setTag(tag);
			}
		//-->
		</script>
		<?php
		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized",JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$ordering = array();
		if(!ACYMAILING_J16 || $this->listbingo_items)
			$ordering[] = JHTML::_('select.option', "id,DESC",JText::_('ACY_ID'));
		else
			$ordering[] = JHTML::_('select.option', "listbingo_ad_id,DESC",JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "ordering,ASC",JText::_('ACY_ORDERING'));
		$ordering[] = JHTML::_('select.option', "created_date,DESC",JText::_('CREATED_DATE'));
		$ordering[] = JHTML::_('select.option', "title,ASC",JText::_('FIELD_TITLE'));

		$contenttype = array();
		$contenttype[] = JHTML::_('select.option', "title",JText::_('TITLE_ONLY'));
		$contenttype[] = JHTML::_('select.option', "intro",JText::_('CATEGORY_VIEW'));
		$contenttype[] = JHTML::_('select.option', "full",JText::_('DETAILS_VIEW'));

		$choice = array();
		$choice[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$acy = new acymailing();

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane( 'listbingo_tab');
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), 'listbingo_listings');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<td colspan="3"><?php echo JHTML::_('acyselect.radiolist', $contenttype, 'contenttype' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->contenttype); ?></td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td>
				 	<?php echo JHTML::_('acyselect.radiolist', $choice, 'titlelink' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->titlelink); ?>
				</td>
				<td>
					<?php echo JText::_('EXTRA_FIELDS'); ?>
				</td>
				<td>
				 	<?php echo JHTML::_('acyselect.radiolist', $choice, 'download' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->extra); ?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td colspan="3">
					<?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', 'resized');?>
				</td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'COUNTRYCAPTION'), 'b.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'TAG_CATEGORIES'), 'c.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), ($this->listbingo_items ? 'a.listbingo_ad_id' : 'a.id'), $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
					<?php
					$k = 0;
					for($i = 0,$a = count($rows);$i<$a;$i++){
						$row =& $rows[$i];
					?>
					<tr id="content<?php echo $row->ads_id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->ads_id.",'row$k'"?>);" style="cursor:pointer;">
						<td>
						<?php
							echo $row->ads_title;
						?>
						</td>
						<td>
						<?php
							$text = '<b>'.JText::_('JOOMEXT_ALIAS').' : </b>'.$row->country_title;
							echo $acy->tooltip($text, $row->country_title, '', $row->country_title);
						?>
						</td>
						<td>
						<?php
							if(!empty($row->cat_title)){
								$text = '<b>'.JText::_('TAG_CATEGORIES',true).' : </b>'.$row->cat_title;
								echo $acy->tooltip($text, $row->cat_title, '', $row->cat_title);
							}
						?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo $row->ads_id; ?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
	<?php
		echo $tabs->endPanel();
		echo $tabs->startPanel( JText::_('TAG_CATEGORIES'), 'listbingo_auto');
	?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<td colspan="3"><?php echo JHTML::_('acyselect.radiolist', $contenttype, 'contenttypeauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autocontenttype); ?></td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td>
				 	<?php echo JHTML::_('acyselect.radiolist', $choice, 'autotitlelink' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autotitlelink); ?>
				</td>
				<td>
				<?php echo JText::_('EXTRA_FIELDS'); ?>
				 </td>
				 <td>
				 	<?php echo JHTML::_('acyselect.radiolist', $choice, 'extraauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->extraauto); ?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td colspan="3">
				<?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict);?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('MAX_ARTICLE'); ?>
				 </td>
				 <td>
				 	<input type="text" name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
				</td>
				<td>
				<?php echo JText::_('ACY_ORDER'); ?>
				 </td>
				 <td>
				 	<?php echo JHTML::_('acyselect.genericlist', $ordering, 'contentorder' , 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td>
				<?php 	echo JText::_('MIN_ARTICLE'); ?>
				 </td>
				 <td>
				 <input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td>
				<?php echo JText::_('ACY_FILTER'); ?>
				 </td>
				 <td>
				 	<?php $filter = acymailing_get('type.contentfilter'); $filter->onclick='updateTagAuto();'; echo $filter->display('contentfilter',$pageInfo->contentfilter); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
		<?php $k=0; foreach($this->catvalues as $oneCat){
			 if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
		<?php $k = 1 - $k; } ?>
		</table>


		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat)
	{
		//select all cats
		$this->cats = array();
		$db = JFactory::getDBO();

		// Joomla < 1.6.0 ?
		if (!ACYMAILING_J16)
		{
			$db->setQuery('SELECT * FROM #__gbl_categories ORDER BY `ordering` ASC');
		}
		elseif($this->listbingo_items)
		{
			$db->setQuery('SELECT * FROM #__listbingo_categories ORDER BY `ordering` ASC');
		}
		else // Joomla 1.6.0 or higher
		{
			$db->setQuery('SELECT *, listbingo_category_id as id FROM #__listbingo_categories ORDER BY `ordering` ASC');
		}

		$mosetCats = $db->loadObjectList();

		foreach($mosetCats as $oneCat){
			$this->cats[$oneCat->parent_id][] = $oneCat;
		}

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		$this->_handleChildrens();

		return JHTML::_('select.genericlist',   $this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int) $filter_cat);

	}

	function _handleChildrens($parentId=0,$level=0){
		if(!empty($this->cats[$parentId])){
			foreach($this->cats[$parentId] as $cat){
				//$cat->name = str_repeat($this->separator,$level).$cat->cat_name;
				$this->catvalues[] = JHTML::_('select.option', $cat->id,str_repeat(" - - ",$level).$cat->title);
				$this->_handleChildrens($cat->id,$level+1);
			}
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
 		$this->_replaceOne($email);
	}

	 function _replaceOne(&$email)
	 {
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		$lang = JFactory::getLanguage();
		$lang->load('com_listbingo',JPATH_SITE);

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, 'listbingo');
		if(empty($tags))
		{
			return;
		}

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($tags as $i => $params)
		{
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content,true);
			$subjectreplace[$i] = strip_tags($content);
		}
		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace),$subjectreplace,$email->subject);
	 }

	function _replaceContent(&$tag)
	{
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$result = '';

		//2 : Load the Joomla article... with the author, the section and the categories to create nice links
		// Listbingo 1.x
		if(!ACYMAILING_J16)
		{
			$query = 'SELECT a.*,a.title AS ads_title,a.id as ads_id,a.description as ads_description, ' .
				'b.title as country_title,c.title as cat_title,d.image,d.extension,r.title as region_title '.
				'FROM `#__gbl_ads` AS a ' .
				'LEFT JOIN `#__gbl_countries` AS b ON a.country_id = b.id ' .
				'LEFT JOIN `#__gbl_categories` AS c ON a.category_id = c.id ' .
				'LEFT JOIN `#__gbl_ads_images` AS d ON d.ad_id = a.id '.
				'LEFT JOIN `#__gbl_regions` AS r ON a.region_id = r.id ' .
				'WHERE a.id = "'.$tag->id.'" LIMIT 1';
		}elseif($this->listbingo_items){
			$query = '
				SELECT
					a.*,
					a.image,
					a.title AS ads_title,
					a.id AS ads_id,
					a.description AS ads_description,
					b.title AS country_title,
					c.title AS cat_title,
					r.title as region_title
				FROM `#__listbingo_items` AS a
				LEFT JOIN `#__listbingo_countries` AS b ON a.country_code = b.code
				LEFT JOIN `#__listbingo_categories` AS c ON a.category_id = c.id
				LEFT JOIN `#__listbingo_regions` AS r ON a.region_id = r.id
				WHERE a.id = "'.$tag->id.'" LIMIT 1';
		}else{ // Listbingo >= 2.x
			$query = '
				SELECT
					a.*,
					a.image,
					a.title AS ads_title,
					a.listbingo_ad_id AS ads_id,
					a.description AS ads_description,
					b.title AS country_title,
					c.title AS cat_title,
					r.title as region_title
				FROM `#__listbingo_ads` AS a
				LEFT JOIN `#__listbingo_countries` AS b ON a.listbingo_country_code = b.code
				LEFT JOIN `#__listbingo_categories` AS c ON a.listbingo_category_id = c.listbingo_category_id
				LEFT JOIN `#__listbingo_regions` AS r ON a.listbingo_region_id = r.listbingo_region_id
				WHERE a.listbingo_ad_id = "'.$tag->id.'" LIMIT 1';
		}

		$db = JFactory::getDBO();
		$db->setQuery($query);
		$article = $db->loadObject();

		// If we were not able to load the article
		$app = JFactory::getApplication();
		if(empty($article))
		{
			if($app->isAdmin())
			{
				$app->enqueueMessage('The document "'.$tag->id.'" could not be loaded','notice');
			}
			return $result;
		}

		$itemid = $this->params->get('ItemId',0);

		if($this->listbingo_items)
			$link = 'index.php?option=com_listbingo&view=item&id='.$article->ads_id;
		else
			$link = 'index.php?option=com_listbingo&task=ads.view&adid='.$article->ads_id;

		if(!empty($itemid))
			$link .= '&Itemid='.$itemid;

		$link = acymailing_frontendLink($link);

		//Add the title with a link or not on it.
		//If we add a link, we add in the same time a name="content-CONTENTID" so that we will be able to parse the content to create a nice summary

		$styleTitle = '<h2 class="acymailing_title">';
		$styleTitleEnd = '</h2>';
		$resultTitle = '';
		if(empty($tag->notitle))
		{
			if(!empty($tag->link))
			{
				$resultTitle .= '<a href="'.$link.'" ';
				if($tag->type != "title") $resultTitle .= 'style="text-decoration:none" name="listbingo-'.$article->ads_id.'" ';
				$resultTitle .= 'target="_blank" >'.$styleTitle.$article->ads_title.$styleTitleEnd.'</a>';
			}else{
				$resultTitle .= $styleTitle.$article->ads_title.$styleTitleEnd;
			}
		}

		$moreFieldsIntro = '';
		$moreFieldsDetail = '';
		if (!empty($tag->extra))
		{
			$query2 = '';

			// Listbingo 1.x
			if (!ACYMAILING_J16)
			{
				$query2 = 'SELECT * FROM #__gbl_ads_fields AS a ' .
					'LEFT JOIN #__gbl_fields as b ON a.field_id = b.id ' .
					'WHERE a.ad_id = '.$tag->id;

				$db->setQuery($query2);
				$extrafields = $db->loadObjectList();

				foreach($extrafields as $field){
					if($field->view_in_summary == 1){
						$moreFieldsIntro .= '<tr><td class="fieldname" >'.$field->title.' :</td><td class="fieldvalue" >'.$field->field_value.'</td></tr>';
					}
					if($field->view_in_detail == 1){
						$moreFieldsDetail .= '<tr><td class="fieldname" >'.$field->title.' :</td><td class="fieldvalue" >'.$field->field_value.'</td></tr>';
					}
				}
			}elseif($this->listbingo_items){
				$query2 = '
					SELECT
						e.label,
						e.fieldcode,
						e.visible_summary,
						e.visible_detail,
						a.extrafield_values
					FROM #__listbingo_extrafields AS e, #__listbingo_items AS a
					WHERE a.id = '.$tag->id.' ' .
							'AND (e.categories = a.category_id OR e.categories LIKE CONCAT("%,", a.category_id) OR e.categories LIKE CONCAT(a.category_id, ",%") OR e.categories LIKE CONCAT("%,", a.category_id, ",%"))';

				$db->setQuery($query2);
				$extrafields = $db->loadObjectList();

				$fieldsValues = array();
				if(!empty($extrafields[0]->extrafield_values))
				{
					$fieldsValues = (array) json_decode($extrafields[0]->extrafield_values);
				}

				foreach($extrafields as $field){

					$fieldValue = !empty($fieldsValues[$field->fieldcode]) ? $fieldsValues[$field->fieldcode] : '';
					if (empty($fieldValue)) continue;

					if($field->visible_summary == 1){
						$moreFieldsIntro .= '<tr><td class="fieldname" >'.$field->label.' :</td><td class="fieldvalue" >'.htmlspecialchars($fieldValue).'</td></tr>';
					}

					if($field->visible_detail == 1){
						$moreFieldsDetail .= '<tr><td class="fieldname" >'.$field->label.' :</td><td class="fieldvalue" >'.htmlspecialchars($fieldValue).'</td></tr>';
					}
				}
			}else{ // Listbingo >= 2.x
				$query2 = '
					SELECT
						e.label,
						e.fieldcode,
						e.visible_summary,
						e.visible_detail,
						a.extrafield_values
					FROM #__listbingo_extrafields AS e
					LEFT JOIN #__listbingo_extrafields_categories AS ec ON e.listbingo_extrafield_id = ec.listbingo_extrafield_id
					LEFT JOIN #__listbingo_ads AS a ON ec.listbingo_category_id = a.listbingo_category_id
					WHERE a.listbingo_ad_id = '.$tag->id;

				$db->setQuery($query2);
				$extrafields = $db->loadObjectList();

				$fieldsValues = array();
				if (!empty($extrafields[0]->extrafield_values))
				{
					$fieldsValues = (array) json_decode($extrafields[0]->extrafield_values);
				}

				foreach($extrafields as $field){

					$fieldValue = !empty($fieldsValues[$field->fieldcode]) ? $fieldsValues[$field->fieldcode] : '';
					if (empty($fieldValue)) continue;

					if($field->visible_summary == 1){
						$moreFieldsIntro .= '<tr><td class="fieldname" >'.$field->label.' :</td><td class="fieldvalue" >'.htmlspecialchars($fieldValue).'</td></tr>';
					}

					if($field->visible_detail == 1){
						$moreFieldsDetail .= '<tr><td class="fieldname" >'.$field->label.' :</td><td class="fieldvalue" >'.htmlspecialchars($fieldValue).'</td></tr>';
					}
				}
			}
		}
		if($tag->type != "title"){
			$result .='<div>';
			if(!empty($article->image)) {
				// Listbingo 2.x
				if (!isset($article->extension)) $result .= '<img src="'.JURI::root().trim($article->image,'/').'" style="float:left;margin:5px" />';
				// Listbingo 1.x
				else $result .= '<img src="'.JURI::root().trim($article->image,'/').'.'.$article->extension.'" style="float:left;margin:5px" />';
			}
			if($tag->type == "intro")
			{
				$tag->wrap = $this->params->get('wordwrap',0);
				$descriptionBeforeWrap = $article->ads_description;
				$article->ads_description = $acypluginsHelper->wrapText($article->ads_description, $tag);
			 	if($article->ads_description != $descriptionBeforeWrap) $forceReadMore = true;
				$result .= $article->ads_description."</div>";
				$result .= '<table width="100%" border="0" cellpadding="0" cellspacing="0" >';
				$result .= $moreFieldsIntro;
				$result .= '</table>';
			}else{
				if(!empty($article->ads_description)){
					$result .= $article->ads_description;
				}
				$result .= '</div><table width="100%" border="0" cellpadding="0" cellspacing="0">';
				if(!empty($article->country_title))
				{
					$address = array();
					if(!empty($article->address1))
						$address[] = $article->address1;
					if(!empty($article->address2))
						$address[] = $article->address2;
					if(!empty($article->zipcode))
						$address[] = $article->zipcode;
					if(!empty($article->country_title))
						$address[] = $article->country_title;
					if(!empty($address))
						$result .= '<tr><td valign="top" class="fieldname" >'.($this->listbingo_items ? JText::_('COM_LISTBINGO_ADDRESS') : JText::_('LOCATION')).' :</td><td valign="top" class="fieldvalue" >'.implode('<br />', $address).'</td></tr>';
				}

				if(!empty($article->pricetype))
				{
					switch ($article->pricetype)
					{
						case 2 :
							$result .= '<tr><td valign="top" colspan=2 class="fieldname" >'.($this->listbingo_items ? JText::_('COM_LISTBINGO_PRICE_FREE') : JText::_ ( 'FREE' )).'</td><td valign="top" class="fieldvalue" ></td></tr>';
							break;
						case 3 :
							$result .= '<tr><td valign="top" colspan=2 class="fieldname" >'.($this->listbingo_items ? JText::_('COM_LISTBINGO_PRICE_NEGOTIABLE') : JText::_ ( 'PRICE_NEGOTIABLE' )).'</td><td valign="top" class="fieldvalue" ></td></tr>';
							break;
						default :
							if ($article->price > 0) {
								$result .= '<tr><td valign="top" class="fieldname" >'.($this->listbingo_items ? JText::_('COM_LISTBINGO_PRICE') : JText::_('PRICE')).' :</td><td valign="top" class="fieldvalue" >'.$article->currencycode.' '.substr($article->price,0,-3).' '.$article->currency.'</td></tr>';
								} else {
								$result .= '<tr><td valign="top" colspan=2 class="fieldname" >'.($this->listbingo_items ? JText::_('COM_LISTBINGO_PRICE_FREE') : JText::_ ( 'FREE' )).'</td><td valign="top" class="fieldvalue" ></td></tr>';
							}
						break;
					}
				}
				if(!empty($article->created_date)){
					$result .= '<tr><td valign="top" class="fieldname" >'.JText::_('ACY_CREATED').' :</td><td valign="top" class="fieldvalue" >'.acymailing_getDate(acymailing_getTime($article->created_date), JText::_('DATE_FORMAT_LC')).'</td></tr>';
				}
				if(!empty($article->modified_date) && $article->modified_date != '0000-00-00 00:00:00'){
					$result .= '<tr><td valign="top" class="fieldname" >'.JText::_('MODIFIED_DATE').' :</td><td valign="top" class="fieldvalue" >'.acymailing_getDate(acymailing_getTime($article->modified_date), JText::_('DATE_FORMAT_LC')).'</td></tr>';
				}

				$result .= $moreFieldsDetail;
				$result .= "</table>";
			}
			$result = $resultTitle.$result;
			$result = '<div class="acymailing_content">'.$result.'</div>';
		}else{
			$result = $resultTitle.$result;
		}


		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'listbingo.php'))
		{
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'listbingo.php');
			$result = ob_get_clean();
		}

		$result = $acypluginsHelper->removeJS($result);

		if(isset($tag->pict))
		{
			$pictureHelper = acymailing_get('helper.acypict');
			$pictureHelper->maxHeight = empty($tag->maxheight) ? $this->params->get('maxheight',150) : $tag->maxheight;
			$pictureHelper->maxWidth = empty($tag->maxwidth) ? $this->params->get('maxwidth',150) : $tag->maxwidth;
			if($tag->pict == '0')
			{
				$result = $pictureHelper->removePictures($result);
			}elseif($tag->pict == 'resized'){
				if($pictureHelper->available())
				{
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error,'notice');
				}
			}
		}
		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);
			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag,strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis',' | ',$result)),$email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email)
	{
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		$db = JFactory::getDBO();
		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'autolistbingo');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags))
		{
			return $return;
		}

		foreach($tags as $oneTag => $parameter)
		{
			if(isset($this->tags[$oneTag]))
				continue;
			$allcats = explode('-',$parameter->id);

			//Load the articles based on all arguments...
			$selectedArea = array();
			foreach($allcats as $oneCat)
			{
				if(empty($oneCat)) continue;
				$selectedArea[] = (int) $oneCat;
			}

			$query = '';

			// Listbingo 1.x
			if (!ACYMAILING_J16)
			{
				$query = 'SELECT id FROM #__gbl_ads ';
			}elseif($this->listbingo_items){
				$query = 'SELECT id FROM #__listbingo_items ';
			}else{ // Listbingo >= 2.x
				$query = 'SELECT listbingo_ad_id AS id FROM #__listbingo_ads ';
			}

			$where = array();
			if(!empty($selectedArea))
			{
				if(!ACYMAILING_J16 || $this->listbingo_items)
				{
					$where[] = 'category_id IN ('.implode(',',$selectedArea).')';
				}else{
					//listbingo >= 2.x
					$where[] = 'listbingo_category_id IN ('.implode(',',$selectedArea).')';
				}
			}

			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate']))
			{
				$datenow = JFactory::getDate($email->params['lastgenerateddate']);
				if(ACYMAILING_J30)
					$date = $datenow->format("%Y-%m-%d %H:%M:%S");
				else
					$date = $datenow->toFormat("%Y-%m-%d %H:%M:%S");
				$condition = ' (`created_date` >\''.$date.'\'';
				if($parameter->filter == 'modify')
				{
					$condition .= ' OR `modified_date` > \''.$date.'\'';
				}
				$condition .= ') AND (`expiry_date` >\''.$date.'\' OR expiry_date = 0 )';
				$where[] = $condition;
			}

			$where[] = "status = 1";

			$query .= ' WHERE ('.implode(') AND (',$where).')';
			if(!empty($parameter->order)){
				$ordering = explode(',',$parameter->order);
				$query .= ' ORDER BY `'.acymailing_secureField($ordering[0]).'` '.acymailing_secureField($ordering[1]);
			}

			//We add a limit for the preview otherwise we could break everything
			if(!empty($parameter->max)) $query .= ' LIMIT '.(int) $parameter->max;
			elseif(empty($email->params['lastgenerateddate'])) $query .= ' LIMIT 20';

			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);

			if(!empty($parameter->min) && count($allArticles)< $parameter->min){
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough Listbingo content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
			}

			$stringTag = '';
			if(!empty($allArticles))
			{
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autolistbingo.php'))
				{
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autolistbingo.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the article tag one after the other in a table as they are already sorted
					$stringTag .= '<table cellspacing="0" cellpadding="0" border="0">';
					foreach($allArticles as $oneArticleId)
					{
						$stringTag .= '<tr><td>';
						$args = array();
						$args[] = 'listbingo:'.$oneArticleId;
						if(!empty($parameter->type)) $args[] = 'type:'.$parameter->type;
						if(!empty($parameter->link)) $args[] = 'link';
						if(!empty($parameter->extra)) $args[] = 'extra';
						if(!empty($parameter->lang)) $args[] = 'lang:'.$parameter->lang;
						if(!empty($parameter->notitle)) $args[] = 'notitle';
						if(!empty($parameter->created)) $args[] = 'created';
						if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						if(!empty($parameter->readmore)) $args[] = 'readmore:'.$parameter->readmore;
						$stringTag .= '{'.implode('|',$args).'}';
						$stringTag .= '</td></tr>';
					}
					$stringTag .= '</table>';
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass