<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingMightyResources extends JPlugin
{

	var $categories;
	//Will store the fields displayed for the intro
	var $types;
	var $fieldsintro = array();
	//Will store the fields displayed for the full detail view
	var $fieldsfull = array();
	//Store the language here
	var $sobiTrans = array();

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'mightyresources');
			$this->params = new JParameter( $plugin->params );
		}
		}

	 function acymailing_getPluginType() {

		 $onePlugin = new stdClass();
		 $onePlugin->name = 'MightyResources';
		 $onePlugin->function = 'acymailingmightyresources_show';
		 $onePlugin->help = 'plugin-mightyresources';

		 return $onePlugin;
	 }

	 function acymailingmightyresources_show(){
		$app = JFactory::getApplication();

		$pageInfo = null;

		$paramBase = ACYMAILING_COMPONENT.'.mightyresources';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order',	'a.ordering','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir',	'DESC',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->filter_type = $app->getUserStateFromRequest( $paramBase.".filter_type", 'filter_type','','int' );
		$pageInfo->contenttype = $app->getUserStateFromRequest( $paramBase.".contenttype", 'contenttype','|type:intro','string' );
		$pageInfo->author = $app->getUserStateFromRequest( $paramBase.".author", 'author','','string' );
		$pageInfo->titlelink = $app->getUserStateFromRequest( $paramBase.".titlelink", 'titlelink','|link','string' );
		$pageInfo->lang = $app->getUserStateFromRequest( $paramBase.".lang", 'lang','','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
	$pageInfo->autotitlelink = $app->getUserStateFromRequest( $paramBase.".autotitlelink", 'autotitlelink','|link','string' );
	$pageInfo->autoimages = $app->getUserStateFromRequest( $paramBase.".autoimages", 'autoimages','|images','string' );
	$pageInfo->automaxvalue = $app->getUserStateFromRequest( $paramBase.".max", 'max','','int' );
	$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','|filter:created','string' );
	$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','|order:id','string' );
	$pageInfo->autocontenttype = $app->getUserStateFromRequest( $paramBase.".autocontenttype", 'autocontenttype','|type:intro','string' );

		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );

		$picts = array();
		$picts[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$pictureHelper = acymailing_get('helper.acypict');
		if($pictureHelper->available()) $picts[] = JHTML::_('select.option', "resized",JText::_('RESIZED'));
		$picts[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$db = JFactory::getDBO();

		$searchFields = array('a.id','a.title','c.name','d.name');

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayart','all') == 'onlypub'){
			$filters[] = "a.published = 1";
		}

		$query = 'SELECT SQL_CALC_FOUND_ROWS a.id AS IdRecord,a.title AS TitleRecord, ';
		$query .= 'c.name AS CategName, c.parent AS CategParent, d.name AS TypeName ';
		$query .= 'FROM `#__js_res_record` as a ';
	$query .= 'JOIN `#__js_res_record_category` as b ON a.id = b.record_id ';
	$query .= 'JOIN `#__js_res_category` as c ON c.id = b.catid ';
	$query .= 'JOIN `#__js_res_types` as d ON d.id = a.type_id';
		if(!empty($pageInfo->filter_cat))$filters[] = "b.catid = ".$pageInfo->filter_cat;
		if(!empty($pageInfo->filter_type))$filters[] = "a.type_id = ".$pageInfo->filter_type;
		if(!empty($filters)){
			$query .= ' WHERE ('.implode(') AND (',$filters).')';
		}

		$query .=' GROUP BY IdRecord';

		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search,$rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		$db->setQuery('SELECT a.name as name, a.id as catid,a.parent as parentid FROM #__js_res_category as a');
		$categories = $db->loadObjectList();

	$db->setQuery('SELECT a.name as name, a.id as typeid FROM #__js_res_types as a');
		$types = $db->loadObjectList();
		$this->type= array();
	$i=0;
		foreach($types as $oneType){
		$this->type[$i] = $oneType;
		$i++;
	}
		$this->cats = array();
		foreach($categories as $oneCat){
		$this->cats[intval($oneCat->parentid)][] = $oneCat;
	}
		$this->_handleChildrens(isset($this->cats[0]) ? '0' : '1');

		//Let's order the categories

	$categories = $this->categories;


	$types = $this->type;

		$allCats = null;
		$allCats->catid=0;
		$allType = null;
		$allType->typeid=0;
		$allType->name = JText::_('ACY_ALL');
		$allCats->name = JText::_('ACY_ALL');

		array_unshift($categories,$allCats);
		array_unshift($types,$allType);

	$contenttype = array();
	$contenttype[] = JHTML::_('select.option', "|type:title",JText::_('TITLE_ONLY'));
	$contenttype[] = JHTML::_('select.option', "|type:intro",JText::_('CATEGORY_VIEW'));
	$contenttype[] = JHTML::_('select.option', "|type:full",JText::_('DETAILS_VIEW'));


		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane( 'mightyresources_tab');
		echo $tabs->startPanel( JText::_( 'TAG_ELEMENTS' ), 'mightyresources_content');

	?>
		<br style="font-size:1px"/>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass){
				if(selectedContents[contentid]){
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[contentid];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents[contentid] = 'content';
				}

				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				for(var i=0; i < document.adminForm.contenttype.length; i++){
					 if (document.adminForm.contenttype[i].checked){ selectedtype = document.adminForm.contenttype[i].value; otherinfo += document.adminForm.contenttype[i].value; }
				}
				for(var i=0; i < document.adminForm.titlelink.length; i++){
					 if (document.adminForm.titlelink[i].checked){ otherinfo += document.adminForm.titlelink[i].value; }
				}
				if(selectedtype != '|type:title'){
					for(var i=0; i < document.adminForm.pict.length; i++){
						 if (document.adminForm.pict[i].checked){ otherinfo += '|pict:'+document.adminForm.pict[i].value; }
					}
				}

				if(window.document.getElementById('jflang')  && window.document.getElementById('jflang').value != ''){
					otherinfo += '|lang:';
					otherinfo += window.document.getElementById('jflang').value;
				}

				for(var i in selectedContents){
					if(selectedContents[i] == 'content'){
						tag = tag + '{mightyresources:'+i+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}
		//-->
		</script>
		<table width="100%" class="adminform">
			<tr>
				<td>
					<?php echo JText::_('DISPLAY');?>
				</td>
				<td colspan="2">
					<?php echo JHTML::_('select.radiolist', $contenttype, 'contenttype' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->contenttype); ?>
				</td>
				<td>

				</td>
			</tr>
			<tr>
				<td>
				<?php echo JText::_('CLICKABLE_TITLE'); ?>
				 </td>
				 <td>
					 <?php $titlelinkType = acymailing_get('type.titlelink'); echo $titlelinkType->display('titlelink',$pageInfo->titlelink);?>
				</td>
				<td>

				 </td>
				 <td>

				</td>
			</tr>
			<tr>
				<td><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td><?php echo JHTML::_('select.radiolist', $picts, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?></td>
				<td></td>
				<td></td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>"  type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					Types : <?php echo JHTML::_('select.genericlist', $types, 'filter_type', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'typeid', 'name', (int) $pageInfo->filter_type );?>

					Category : <?php echo JHTML::_('select.genericlist', $categories, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'catid', 'name', (int) $pageInfo->filter_cat );?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th class="title">
			<?php echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th>
			<?php echo JHTML::_('grid.sort', JText::_( 'FIELD_TYPE'), 'TypeName', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th>
			<?php echo JHTML::_('grid.sort', JText::_( 'TAG_CATEGORIES'), 'CategName', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort',   JText::_( 'ACY_ID' ), 'IdRecord', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="4">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					for($i = 0,$a = count($rows);$i<$a;$i++){
						$row =& $rows[$i];
				?>
					<tr id="content<?php echo $row->IdRecord?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->IdRecord.",'row$k'"?>);" style="cursor:pointer;">
						<td>
						<?php
							echo  $row->TitleRecord;
						?>
						</td>
						<td>
						<?php
							echo  $row->TypeName;
						?>
						</td>
						<td>
						<?php
							echo  $row->CategName;
						?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo $row->IdRecord; ?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
	<?php
	echo $tabs->endPanel();
	echo $tabs->startPanel( JText::_( 'TAG_CATEGORIES' ), 'mightyresources_auto');

	$ordering = array();
	$ordering[] = JHTML::_('select.option', "|order:IdRecord,DESC",JText::_('ACY_ID'));
	$ordering[] = JHTML::_('select.option', "|order:ordering,ASC",JText::_('ACY_ORDERING'));
	$ordering[] = JHTML::_('select.option', "|order:TitleRecord,ASC",JText::_('FIELD_TITLE'));

		$type = JRequest::getString('type');

	?>
		<br style="font-size:1px"/>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedCat = new Array();
			function applyAuto(catid,rowClass){
				if(selectedCat[catid]){
					window.document.getElementById('cat'+catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('cat'+catid).className = 'selectedrow';
					selectedCat[catid] = 'selectedone';
				}

				updateAutoTag();
			}

			function updateAutoTag(){
				tag = '{automightyresources:';

				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat+'-';
					}
				}

				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value!=0){ tag += '|min:'+document.adminForm.min_article.value; }
				if(document.adminForm.max_article.value && document.adminForm.max_article.value!=0){ tag += '|max:'+document.adminForm.max_article.value; }
				if(document.adminForm.contentorder.value){ tag += document.adminForm.contentorder.value; }
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){ tag += document.adminForm.contentfilter.value; }
				if(document.adminForm.meta_article && document.adminForm.meta_article.value){ tag += '|meta:'+document.adminForm.meta_article.value; }

				for(var i=0; i < document.adminForm.contenttypeauto.length; i++){
					 if (document.adminForm.contenttypeauto[i].checked){selectedtype = document.adminForm.contenttypeauto[i].value; tag += document.adminForm.contenttypeauto[i].value; }
				}
				for(var i=0; i < document.adminForm.titlelinkauto.length; i++){
					 if (document.adminForm.titlelinkauto[i].checked){ tag += document.adminForm.titlelinkauto[i].value; }
				}
				if(selectedtype != '|type:title'){
					for(var i=0; i < document.adminForm.pictauto.length; i++){
						 if (document.adminForm.pictauto[i].checked){ tag += '|pict:'+document.adminForm.pictauto[i].value; }
					}
				}
				if(window.document.getElementById('jflangauto')  && window.document.getElementById('jflangauto').value != ''){
					tag += '|lang:';
					tag += window.document.getElementById('jflangauto').value;
				}

				tag += '}';

				setTag(tag);
			}
		//-->
		</script>
		<table width="100%" class="adminform">
			<tr>
				<td>
					<?php echo JText::_('DISPLAY');?>
				</td>
				<td colspan="2">
					<?php echo JHTML::_('select.radiolist', $contenttype, 'contenttypeauto' , 'size="1" onclick="updateAutoTag();"', 'value', 'text', $pageInfo->autocontenttype); ?>
				</td>
				<td>

				</td>
			</tr>
			<tr>
				<td>
				<?php echo JText::_('CLICKABLE_TITLE'); ?>
				 </td>
				 <td>
					 <?php $titlelinkType = acymailing_get('type.titlelink'); $titlelinkType->onclick = "updateAutoTag();"; echo $titlelinkType->display('titlelinkauto','|link');?>
				</td>
				<td>

				 </td>
				 <td>

				</td>
			</tr>
			<tr>
				<td><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td><?php echo JHTML::_('select.radiolist', $picts, 'pictauto' , 'size="1" onclick="updateAutoTag();"', 'value', 'text', "1"); ?></td>
				<td></td>
				<td></td>
			</tr>
			<tr>
				<td>
				<?php echo JText::_('MAX_ARTICLE'); ?>
				 </td>
				 <td>
					 <input type="text" name="max_article" style="width:50px" value="20" onchange="updateAutoTag();" />
				</td>
				<td>
				<?php echo JText::_('ACY_ORDER'); ?>
				 </td>
				 <td>
					 <?php echo JHTML::_('select.genericlist', $ordering, 'contentorder' , 'size="1" onchange="updateAutoTag();"', 'value', 'text'); ?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td>
				<?php 	echo JText::_('MIN_ARTICLE'); ?>
				 </td>
				 <td>
				 <input type="text" name="min_article" style="width:50px" value="1" onchange="updateAutoTag();" />
				</td>
				<td>
				<?php echo JText::_('FILTER'); ?>
				 </td>
				 <td>
					 <?php $filters = array(); $filters[] = JHTML::_('select.option', "",JText::_('ACY_ALL')); $filters[] = JHTML::_('select.option', "|filter:created",JText::_('ONLY_NEW_CREATED'));
				$filters[] = JHTML::_('select.option', "|filter:modified",JText::_('ONLY_NEW_MODIFIED'));
				echo JHTML::_('select.genericlist', $filters, 'contentfilter' , 'size="1" onclick="updateAutoTag();"', 'value', 'text', '|filter:created'); ?>
				</td>
			</tr>
			<?php } ?>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
		<?php $k=0; foreach($this->categories as $oneCat){
			 if(empty($oneCat->catid)) continue;
			?>
			<tr id="cat<?php echo $oneCat->catid ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->catid ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td>
				<?php
					echo $oneCat->name;
				?>
				</td>
			</tr>
		<?php $k = 1 - $k; } ?>
		</table>
	<?php

		echo $tabs->endPanel();
		echo $tabs->endPane();
	//End of the function
	 }

	 function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		 $this->_replaceArticles($email);
	 }

	 function _replaceArticles(&$email){
		$match = '#{mightyresources:(.*)}#Ui';
		$variables = array('subject','body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything...
		if(!$found) return;


		include_once(ACYMAILING_ROOT.'components'.DS.'com_resource'.DS.'api.php');
		include_once(ACYMAILING_ROOT.'plugins'.DS.'joomsuite_content_fields'.DS.'html'.DS.'bbcodeparser.php');
		include_once(ACYMAILING_ROOT.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'html'.DS.'html_stripper.php');
		include_once(ACYMAILING_ROOT.'plugins'.DS.'joomsuite_content_fields'.DS.'picture.php');
		JPluginHelper::importPlugin('joomsuite_content_fields');
	$this->apicall = new MightyResourcesApi();
		$this->apicall->initResourceConfig();

		$this->codeparser = new JS_BBCodeParser();

	//$this->pict = new plgJoomsuite_content_fieldsPicture();

		//We will need the mailer class as well
		$mailerHelper = acymailing_get('helper.mailer');

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				//Don't need to process twice a tag we already have!
				if(isset($htmlreplace[$oneTag])) continue;

				$article = $this->_replaceContent($allresults,$i);
				$htmlreplace[$oneTag] = $article;
				$textreplace[$oneTag] = $mailerHelper->textVersion($article);
				$subjectreplace[$oneTag] = strip_tags($article);
			}
		}

		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace),$subjectreplace,$email->subject);
	 }

	 function _replaceContent(&$results,$i){
		//1 : Transform the tag properly...
		$arguments = explode('|',strip_tags($results[1][$i]));
		$tag = new stdClass();
		$tag->id = (int) $arguments[0];
		for($i=1,$a=count($arguments);$i<$a;$i++){
			$args = explode(':',$arguments[$i]);
			if(isset($args[1])){
				$tag->{$args[0]} = $args[1];
			}else{
				$tag->{$args[0]} = true;
			}
		}

		//2 : Load the Joomla article... with the author, the section and the categories to create nice links
		$query = 'SELECT * FROM #__js_res_record WHERE id = '.$tag->id.' LIMIT 1';

		$db = JFactory::getDBO();
		$db->setQuery($query);
		$article = $db->loadObject();

		$result = '';

		//In case of we could not load the article for any reason...
		if(empty($article)){
			$app = JFactory::getApplication();
			if($app->isAdmin()){
				$app->enqueueMessage('The article "'.$tag->id.'" could not be loaded','notice');
			}
			return $result;
		}


		$link = 'index.php?option=com_resource&controller=article&article='.$tag->id;
		$link = acymailing_frontendLink($link);

		//Add the title with a link or not on it.
		//If we add a link, we add in the same time a name="content-CONTENTID" so that we will be able to parse the content to create a nice summary
		$styleTitle = '';
		$styleTitleEnd = '';
		if($tag->type != "title"){
			$styleTitle = '<h2 class="acymailing_title">';
			$styleTitleEnd = '</h2>';
		}

		if(empty($tag->notitle)){
			if(!empty($tag->link)){
				$result .= '<a href="'.$link.'" ';
				if($tag->type != "title") $result .= 'style="text-decoration:none" name="resourcescontent-'.$article->id.'" ';
				$result .= 'target="_blank" >'.$styleTitle.$article->title.$styleTitleEnd.'</a>';
			}else{
				$result .= $styleTitle.$article->title.$styleTitleEnd;
			}
		}


		//We add the intro text
		if($tag->type != "title"){
			//Do we need to limit the number of characters for the introtext?
			 $condition = '';
			 if($tag->type == 'intro'){
				 $condition = 'a.show_intro=1';
			 }else{
				 $condition = 'a.show_detail=1';
			 }
		//vcard view
		$db->setQuery('SELECT d.catid as catId,a.access, c.user_id as user_id,a.`id` as fid,b.id as id,'.$article->id.' as record_id, b.id AS vid, a.`type_id`, a.`type`, a.`params`, a.`title`, b.`field_value`, b.`params` AS fparams' .
						' FROM #__js_res_fields  as a '.
						'LEFT JOIN #__js_res_record_values as b ON a.id = b.field_id ' .
						'LEFT JOIN #__js_res_record as c ON b.record_id = c.id '.
						'LEFT JOIN #__js_res_record_category as d ON c.id=d.record_id ' .
						'WHERE '.$condition.' AND a.type_id='.intval($article->type_id).
						' AND b.record_id = '.$article->id.' ' .
						'AND a.type NOT IN ("video","audio","mail") '.
						'ORDER BY a.ordering ASC');
		$fieldsintro = $db->loadObjectList();

		$db->setQuery('SELECT catid FROM #__js_res_record_category WHERE record_id='.intval($article->id).' LIMIT 1');
		$category = $db->loadResult();

			 $result.='<table cellspacing="0" cellpadding="0" border="0" width="100%">';
		$stripper = new JSHTMLStripper();
		$pathimg = new jsfilemanager();
			 foreach($fieldsintro as $oneField){
				 $value = $this->apicall->getFieldValue($oneField,$article,$category);

				 if($oneField->type == 'textarea'){
					$params = new acyParameter($oneField->params);
					 $value = $this->codeparser->bb2html($value);
					 $value = $stripper->substr($oneField->field_value, $params->get('length', 0), $params->get('seemore'));
				 }

				 if($oneField->type == 'image' OR $oneField->type == 'address'){
					 $value = str_replace('/administrator/','/',$value);
				 }

				 if($oneField->type == 'picture'){
				$value='images'.DS.$oneField->user_id.DS.'picture'.DS.$oneField->field_value;
				$value = '<img src="'.str_replace('\\','/',$value).'" />';
				 }

			$result .= "<tr><td valign=\"top\" ><span class=\"mightyresources_label\" >".$oneField->title.": </span></td><td class=\"mightyresources_value\">".$value."</td>";
			 }

		$result.='</table>';
			$result = '<div class="acymailing_content">'.$result.'</div>';

		}



		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'mightyresources.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'mightyresources.php');
			$result = ob_get_clean();
		}

		//Should we remove the JS?
		if($tag->type != 'title' AND $this->params->get('removejs','yes') == 'yes'){
			$result = $this->_removeJS($result);
		}

		//We have our content... lets check the pictures options
		if(isset($tag->pict)){
			$pictureHelper = acymailing_get('helper.acypict');
			$pictureHelper->maxHeight = empty($tag->maxheight) ? $this->params->get('maxheight',150) : $tag->maxheight;
			$pictureHelper->maxWidth = empty($tag->maxwidth) ? $this->params->get('maxwidth',150) : $tag->maxwidth;
			if($tag->pict == '0'){
				$result = $pictureHelper->removePictures($result);
			}elseif($tag->pict == 'resized'){
				if($pictureHelper->available()){
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error,'notice');
				}
			}
		}
		return $result;

	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);
			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag,strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis',' | ',$result)),$email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email){

		$return = null;
		$return->status = true;
		$return->message = '';

		$time = time();


		//Check if we should generate the SmartNewsletter or not...
		$match = '#{automightyresources:(.*)}#Ui';
		$variables = array('subject','body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything... so we won't try to stop the generation
		if(!$found) return $return;

		$this->tags = array();
		$db = JFactory::getDBO();

		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset($this->tags[$oneTag])) continue;

				$arguments = explode('|',strip_tags($allresults[1][$i]));
				//The first argument is a list of sections and cats...
				$allcats = explode('-',$arguments[0]);
				$parameter = null;
				for($i=1;$i<count($arguments);$i++){
					$args = explode(':',$arguments[$i]);
					$arg0 = $args[0];
					if(isset($args[1])){
						$parameter->$arg0 = $args[1];
					}else{
						$parameter->$arg0 = true;
					}
				}
				//Load the articles based on all arguments...
				$selectedArea = array();
				foreach($allcats as $oneCat){
					if(empty($oneCat)) continue;
					$selectedArea[] = (int) $oneCat;
				}
				$query = 'SELECT DISTINCT a.id AS IdRecord, a.title as TitleRecord FROM `#__js_res_record` as a LEFT JOIN `#__js_res_record_category` as b ON a.id = b.record_id';
				$where = array();
				if(!empty($selectedArea)){
					$where[] = 'b.`catid` IN ('.implode(',',$selectedArea).')';
				}

				if(!empty($parameter->filter) AND !empty($email->params['lastgenerateddate'])){
				include_once(ACYMAILING_ROOT.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

			$date = ResHelper::getDate(time() - $email->params['lastgenerateddate']);
					$myfilter = 'a.`ctime` >\''.$date.'\'';

					if($parameter->filter == 'modified'){
						$myfilter .= ' OR a.`mtime` >\''.$date.'\'';
					}
					$where[] = $myfilter;
				}

				$where[] = 'a.published = 1';

				$query .= ' WHERE ('.implode(') AND (',$where).')';
				if(!empty($parameter->order)){
					$ordering = explode(',',$parameter->order);
					$query .= ' ORDER BY `'.acymailing_secureField($ordering[0]).'` '.acymailing_secureField($ordering[1]);
				}

				$start = '';
				if(!empty($parameter->start)) $start = intval($parameter->start).',';

				if(!empty($parameter->max)) $query .= ' LIMIT '.$start.(int) $parameter->max;
				elseif(empty($email->params['lastgenerateddate'])) $query .= ' LIMIT '.$start.'20';
				//We add a limit for the preview otherwise we could break everything

				$db->setQuery($query);
				$allArticles = acymailing_loadResultArray($db);

				if(!empty($parameter->min) AND count($allArticles)< $parameter->min){
					//We won't generate the Newsletter
					$return->status = false;
					$return->message = 'Not enough articles for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
				}

				$stringTag = '';
				if(!empty($allArticles)){
					if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'automightyresources.php')){
						ob_start();
						require(ACYMAILING_MEDIA.'plugins'.DS.'automightyresources.php');
						$stringTag = ob_get_clean();
					}else{
						//we insert the article tag one after the other in a table as they are already sorted
						$stringTag .= '<table width="100%" border="0" cellpadding="0" cellspacing="0">';
						foreach($allArticles as $oneArticleId){
							$stringTag .= '<tr><td>';
							$args = array();
							$args[] = 'mightyresources:'.$oneArticleId;
							if(!empty($parameter->type)) $args[] = 'type:'.$parameter->type;
							if(!empty($parameter->link)) $args[] = 'link';
							if(!empty($parameter->author)) $args[] = 'author';
							if(!empty($parameter->lang)) $args[] = 'lang:'.$parameter->lang;
							if(!empty($parameter->notitle)) $args[] = 'notitle';
							if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
							if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
							if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
							$stringTag .= '{'.implode('|',$args).'}';
							$stringTag .= '</td></tr>';
						}
						$stringTag .= '</table>';
					}
				}

				$this->tags[$oneTag] = $stringTag;
			}
		}

		return $return;
	}

	function _removeJS($text){
		//Remove the picture... normal process
		$text = preg_replace("#(onmouseout|onmouseover|onclick|onfocus|onload|onblur) *= *\"(?:(?!\").)*\"#iU",'',$text);
		$text =  preg_replace("#< *script(?:(?!< */ *script *>).)*< */ *script *>#isU",'',$text);
		return $text;
	}


	function _handleChildrens($parentId=0,$level=0){
		if(!empty($this->cats[$parentId])){
			foreach($this->cats[$parentId] as $cat){
				$cat->name = str_repeat(" - - ",$level).$cat->name;
				$this->categories[] = $cat;
				$this->_handleChildrens($cat->catid,$level+1);
			}
		}
	}

}//endclass