<?php
/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingrsdirectory extends JPlugin{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		$this->name = 'rsdirectory';
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new acyParameter($plugin->params);
		}

		//check if the component is installed
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_rsdirectory');
		$this->db = JFactory::getDBO();
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
	}

	function acymailing_getPluginType(){
		if(!$this->component_installed || !ACYMAILING_J16) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'RSDirectory';
		$onePlugin->function = 'acymailing_'.$this->name.'_show';
		$onePlugin->help = 'plugin-'.$this->name;
		return $onePlugin;
	}

	function acymailing_rsdirectory_show(){
		$config = acymailing_config();

		if($config->get('version') < '4.9.4'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.'.$this->name;

		$pageInfo->filter->order->value = $app->getUserStateFromRequest($paramBase.".filter_order", 'filter_order', 'a.id', 'cmd');
		$pageInfo->filter->order->dir = $app->getUserStateFromRequest($paramBase.".filter_order_Dir", 'filter_order_Dir', 'asc', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->filter_type = $app->getUserStateFromRequest($paramBase.".filter_type", 'filter_type', '', 'int');
		$pageInfo->limit->value = $app->getUserStateFromRequest($paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int');
		$pageInfo->limit->start = $app->getUserStateFromRequest($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->contentfilter = $app->getUserStateFromRequest($paramBase.".contentfilter", 'contentfilter', 'created', 'string');
		$pageInfo->contentorder = $app->getUserStateFromRequest($paramBase.".contentorder", 'contentorder', 'id,DESC', 'string');
		$pageInfo->cols = $app->getUserStateFromRequest($paramBase.".cols", 'cols', '1', 'string');
		$pageInfo->pictheight = $app->getUserStateFromRequest($paramBase.".pictheight", 'pictheight', '150', 'string');
		$pageInfo->pictwidth = $app->getUserStateFromRequest($paramBase.".pictwidth", 'pictwidth', '150', 'string');
		$pageInfo->pict = $app->getUserStateFromRequest($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->pictauto = $app->getUserStateFromRequest($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->readmore = $app->getUserStateFromRequest($paramBase.".readmore", 'readmore', '1', 'string');
		$pageInfo->readmoreauto = $app->getUserStateFromRequest($paramBase.".readmoreauto", 'readmoreauto', '1', 'string');
		$pageInfo->wrap = $app->getUserStateFromRequest($paramBase.".wrap", 'wrap', '0', 'string');
		$pageInfo->clickable = $app->getUserStateFromRequest($paramBase.".clickable", 'clickable', '1', 'string');
		$pageInfo->clickableauto = $app->getUserStateFromRequest($paramBase.".clickableauto", 'clickableauto', '1', 'string');

		$db = JFactory::getDBO();

		//the query's start
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.id, a.title, b.title AS cattitle '.'FROM #__rsdirectory_entries AS a '.'JOIN #__categories AS b ON a.category_id = b.id ';

		//search fields...
		$searchFields = array('a.id', 'a.title', 'b.title');

		//apply search fields
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchFields)." LIKE ".$searchVal;
		}

		//only published content ?
		if($this->params->get('displaycontent', 'all') == 'onlypub'){
			$filters[] = 'a.published = 1';
		}

		//if the user filtered by category
		if(!empty($pageInfo->filter_cat)){
			$filters[] = 'a.category_id = '.intval($pageInfo->filter_cat);
		}

		//apply filters
		if(!empty($filters)){
			$query .= ' WHERE ('.implode(') AND (', $filters).')';
		}

		//apply ordering
		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query, $pageInfo->limit->start, $pageInfo->limit->value);

		//load results
		$rows = $db->loadObjectList();

		//yellow highlighting on search matches
		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search, $rows);
		}

		//pagination
		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		//is this a Smart-Newsletter or a simple one ?
		$type = JRequest::getString('type');

		?>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			function applyContent(contentid, rowClass){
				<?php
					//we insert contents in the order the user selected it
				?>
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1){
					window.document.getElementById('content' + contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content' + contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid, rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('cat' + catid).className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						for(key in selectedCat){
							if(!isNaN(key)){
								window.document.getElementById('cat' + key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat' + catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;

				<?php
					//add the fields the user wants to be displayed
				?>
				for(var i = 0; i < document.adminForm.cbdisplay.length; i++){
					if(document.adminForm.cbdisplay[i].checked){
						if(tmp == 0){
							tmp += 1;
							otherinfo += "| display:";
							otherinfo += document.adminForm.cbdisplay[i].value;
						}else{
							otherinfo += ", ";
							otherinfo += document.adminForm.cbdisplay[i].value;
						}
					}
				}

				<?php
					//is the title clickable ?
				?>
				for(var i = 0; i < document.adminForm.clickable.length; i++){
					if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '0'){
						otherinfo += '| nolink';
					}
				}

				<?php
					//do we have to wrap the text ? (description for example...)
				?>
				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value)){
					otherinfo += "| wrap:" + document.adminForm.wrap.value;
				}

				<?php
					//do we have to add a "read more" button ?
				?>
				for(var i = 0; i < document.adminForm.readmore.length; i++){
					if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '0'){
						otherinfo += '| noreadmore';
					}
				}

				<?php
					//picture management
				?>
				for(var i = 0; i < document.adminForm.pict.length; i++){
					if(document.adminForm.pict[i].checked){
						if(document.adminForm.pict[i].value != '1'){
							otherinfo += '| pict:' + document.adminForm.pict[i].value;
						}

						if(document.adminForm.pict[i].value == 'resized'){
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:' + document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				<?php
					//insert the tags with the right order
				?>
				for(var i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{<?php echo $this->name; ?>:' + selectedContents[i] + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;

				for(var i = 0; i < document.adminForm.cbdisplayauto.length; i++){
					if(document.adminForm.cbdisplayauto[i].checked){
						if(tmp == 0){
							tmp += 1;
							otherinfo += "| display:";
							otherinfo += document.adminForm.cbdisplayauto[i].value;
						}else{
							otherinfo += ", ";
							otherinfo += document.adminForm.cbdisplayauto[i].value;
						}
					}
				}

				for(var i = 0; i < document.adminForm.clickableauto.length; i++){
					if(document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '0'){
						otherinfo += '| nolink';
					}
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value != 0 && !isNaN(document.adminForm.wrapauto.value)){
					otherinfo += "| wrap:" + document.adminForm.wrapauto.value;
				}

				for(var i = 0; i < document.adminForm.readmoreauto.length; i++){
					if(document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '0'){
						otherinfo += '| noreadmore';
					}
				}

				tmp = 0;
				for(var i = 0; i < document.adminForm.autopict.length; i++){
					if(document.adminForm.autopict[i].checked){
						if(document.adminForm.autopict[i].value != '1'){
							otherinfo += '| pict:' + document.adminForm.autopict[i].value;
						}

						if(document.adminForm.autopict[i].value == 'resized'){
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:' + document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}

				<?php
					//on how many columns do we have to display the contents ?
				?>
				if(document.adminForm.cols.value){
					otherinfo += "| cols:" + document.adminForm.cols.value;
				}

				<?php
					//limit the number of content displayed
				?>
				if(document.adminForm.max_article.value){
					otherinfo += "| max:" + document.adminForm.max_article.value;
				}

				<?php
					//with what order will we display the contents
				?>
				if(document.adminForm.contentorder.value){
					otherinfo += "| order:" + document.adminForm.contentorder.value;
				}

				<?php if($type == 'autonews'){

					//minimum number of content for the newsletter to be displayed... yes, a perfect english !
				?>
				if(document.adminForm.min_article.value){
					otherinfo += "| min:" + document.adminForm.min_article.value;
				}

				<?php
					//filter the content : only newly created/modified
				?>
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value != 0){
					otherinfo += "| filter:" + document.adminForm.contentfilter.value;
				}
				<?php }
					//insert the tag
				?>
				tag = '{auto<?php echo $this->name; ?>:';
				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat + '-';
					}
				}
				tag += otherinfo + '}<br />';

				setTag(tag);
			}
			//-->
		</script>
		<?php
		// yes/no for the options
		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// picture options
		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// here are the possible orderings
		$ordering = array();
		$ordering[] = JHTML::_('select.option', "id,DESC", JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "created_time,DESC", JText::_('CREATED_DATE'));
		$ordering[] = JHTML::_('select.option', "modified_time,DESC", JText::_('MODIFIED_DATE'));
		$ordering[] = JHTML::_('select.option', "title,ASC", JText::_('FIELD_TITLE'));
		$ordering[] = JHTML::_('select.option', "rand", JText::_('ACY_RANDOM'));

		// filter options
		$contentfilter = array();
		$contentfilter[] = JHTML::_('select.option', "0", JText::_('ACY_ALL'));
		$contentfilter[] = JHTML::_('select.option', "created", JText::_('ONLY_NEW_CREATED'));
		$contentfilter[] = JHTML::_('select.option', "modified", JText::_('ONLY_NEW_MODIFIED'));

		// options for the Nb. columns dropdown (1 to 10)
		$column = array();
		for($i = 1; $i < 11; $i++){
			$column[] = JHTML::_('select.option', "$i", $i);
		}

		$query = 'SELECT a.field_id AS id, a.value AS name, b.core '.'FROM #__rsdirectory_fields_properties AS a '.'JOIN #__rsdirectory_fields AS c '.'ON a.field_id = c.id '.'JOIN #__rsdirectory_field_types AS b '.'ON c.field_type_id = b.id '.'WHERE a.property_name LIKE "form_caption" '.'AND a.value NOT LIKE "" '.'ORDER BY b.core DESC, a.value ASC';

		$db->setQuery($query);
		$customFields = $db->loadObjectList();

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane($this->name.'_tab');

		// start the first tab
		echo $tabs->startPanel(JText::_('TAG_ELEMENTS'), $this->name.'_listings');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<?php
			if(!empty($customFields)){
				echo '<tr><td>'.JText::_('DISPLAY').'</td>';
				$i = 1;
				foreach($customFields as $oneParam){
					if($i == 4){
						$i = 1;
						echo '</tr><tr><td/>';
					}
					echo '<td nowrap><input value="'.$oneParam->id.'" name="cbdisplay" id="rsfield_'.$oneParam->id.'" type="checkbox" onclick="updateTag();" '.(($oneParam->core == 1) ? 'checked' : '').'/> ';
					echo '<label for="rsfield_'.$oneParam->id.'">'.$oneParam->name.'</label></td>';
					$i++;
				}
				while($i != 4){
					$i++;
					echo '<td/>';
				}
				echo '</tr>';
			}
			?>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickable', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>

				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br/>
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
				</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER', '<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td nowrap="nowrap" width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search; ?>" class="text_area" onchange="document.adminForm.submit();"/>
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_('JOOMEXT_GO'); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_('JOOMEXT_RESET'); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
			<tr>
				<th/>
				<th class="title">
					<?php
					echo JHTML::_('grid.sort', JText::_('FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value);
					?>
				</th>
				<th class="title">
					<?php echo JHTML::_('grid.sort', JText::_('TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title titleid">
					<?php
					echo JHTML::_('grid.sort', JText::_('ACY_ID'), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value);
					?>
				</th>
			</tr>
			</thead>
			<tfoot>
			<tr>
				<td colspan="5">
					<?php echo $pagination->getListFooter(); ?>
					<?php echo $pagination->getResultsCounter(); ?>
				</td>
			</tr>
			</tfoot>
			<tbody>
			<?php
			$k = 0;
			if(!empty($rows)){
				foreach($rows as $row){
					?>
					<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'" ?>);" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
							<?php
							if(!empty($row->title)){
								echo $row->title;
							}
							?>
						</td>
						<td>
							<?php
							if(!empty($row->cattitle)){
								echo $row->cattitle;
							}
							?>
						</td>
						<td align="center" style="text-align:center">
							<?php
							echo $row->id;
							?>
						</td>
					</tr>
					<?php
					// this enables to know if we have to set the line background grey or white
					$k = 1 - $k;
				}
			}
			?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>
		<?php

		echo $tabs->endPanel();

		// start category tab
		echo $tabs->startPanel(JText::_('TAG_CATEGORIES'), $this->name.'_auto');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<?php
			if(!empty($customFields)){
				echo '<tr><td>'.JText::_('DISPLAY').'</td>';
				$i = 1;
				foreach($customFields as $oneParam){
					if($i == 4){
						$i = 1;
						echo '</tr><tr><td/>';
					}
					echo '<td nowrap><input value="'.$oneParam->id.'" name="cbdisplayauto" id="rsfield_'.$oneParam->id.'auto" type="checkbox" onclick="updateTagAuto();" '.(($oneParam->core == 1) ? 'checked' : '').'/>';
					echo '<label for="rsfield_'.$oneParam->id.'auto">'.$oneParam->name.'</label></td>';
					$i++;
				}
				while($i != 4){
					$i++;
					echo '<td/>';
				}
				echo '</tr>';
			}
			?>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickableauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('DISPLAY_PICTURES'); ?>
				</td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
					<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br/>
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER', '<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap">
					<input type="text" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td nowrap="nowrap">
					<?php echo JHTML::_('select.genericlist', $ordering, 'contentorder', 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews'){ ?>
				<tr>
					<td nowrap="nowrap">
						<?php echo JText::_('MIN_ARTICLE'); ?>
					</td nowrap="nowrap">
					<td nowrap="nowrap">
						<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
					</td>
					<td nowrap="nowrap">
						<?php echo JText::_('FIELD_COLUMNS'); ?>
					</td>
					<td nowrap="nowrap">
						<?php echo JHTML::_('select.genericlist', $column, 'cols', 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
					</td>
				</tr>
				<tr>
					<td nowrap="nowrap">
						<?php echo JText::_('JOOMEXT_FILTER'); ?>
					</td>
					<td nowrap="nowrap" colspan="3">
						<?php echo JHTML::_('select.genericlist', $contentfilter, 'contentfilter', 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentfilter); ?>
					</td>
				</tr>
			<?php }else{ ?>
				<tr>
					<td nowrap="nowrap">
						<?php echo JText::_('FIELD_COLUMNS'); ?>
					</td>
					<td nowrap="nowrap" colspan="3">
						<?php echo JHTML::_('select.genericlist', $column, 'cols', 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
					</td>
				</tr>
			<?php } ?>
		</table>
		<!--====================================================================================LISTE CATEGORIES===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<?php $k = 0;
			?>
			<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
					<?php
					echo JText::_('ACY_ALL');
					?>
				</td>
			</tr>
			<?php
			if(!empty($this->catvalues)){
				foreach($this->catvalues as $oneCat){
					if(empty($oneCat->value)) continue;
					?>
					<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
							<?php
							echo $oneCat->text;
							?>
						</td>
					</tr>
					<?php $k = 1 - $k;
				}
			} ?>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){
		//select all cats
		$db = JFactory::getDBO();
		$db->setQuery('SELECT id,parent_id,title FROM #__categories WHERE extension LIKE "com_rsdirectory" ORDER BY id ASC');
		$mosetCats = $db->loadObjectList();
		$this->cats = array();
		if(!empty($mosetCats)){
			foreach($mosetCats as $oneCat){
				$this->cats[$oneCat->parent_id][] = $oneCat;
			}
		}

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0, JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist', $this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	function _handleChildrens($parent_id = 1, $level = 0){
		if(empty($this->cats[$parent_id])) return;

		foreach($this->cats[$parent_id] as $cat){
			$this->catvalues[] = JHTML::_('select.option', $cat->id, str_repeat(" - - ", $level).$cat->title);
			$this->_handleChildrens($cat->id, $level + 1);
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceOne(&$email){
		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, $this->name);
		if(empty($tags)){
			return;
		}

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE', true).'" />';

		$db = JFactory::getDBO();
		$db->setQuery('SELECT a.id, a.name FROM #__rsdirectory_fields AS a JOIN #__rsdirectory_field_types AS b ON a.field_type_id = b.id WHERE b.core = 1');
		$this->coreFields = $db->loadObjectList('name');

		$db->setQuery('SELECT a.id, a.column_name, c.value FROM #__rsdirectory_fields AS a JOIN #__rsdirectory_field_types AS b ON a.field_type_id = b.id JOIN #__rsdirectory_fields_properties AS c ON a.id = c.field_id WHERE b.core = 0 AND c.property_name LIKE "listing_caption"');
		$this->customFields = $db->loadObjectList('id');

		$db->setQuery('SELECT value FROM #__rsdirectory_config WHERE name LIKE "currency_sign"');
		$this->currency = $db->loadResult();

		$lang = JFactory::getLanguage();
		$lang->load('com_rsdirectory', JPATH_SITE);

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($tags as $i => $params){
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content, true);
			$subjectreplace[$i] = strip_tags($content);
		}
		$email->body = str_replace(array_keys($htmlreplace), $htmlreplace, $email->body);
		$email->altbody = str_replace(array_keys($textreplace), $textreplace, $email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace), $subjectreplace, $email->subject);
	}

	function _replaceContent(&$tag){
		// extract the fields selected
		if(!empty($tag->display)){
			$tag->display = explode(',', $tag->display);

			foreach($tag->display as $i => $oneDisplay){
				$tag->display[$i] = trim($oneDisplay);
			}
			JArrayHelper::toInteger($tag->display);
		}

		if(empty($tag->display)){
			return '';
		}

		// load content

		$db = JFactory::getDBO();
		$query = 'SELECT a.*, b.* FROM #__rsdirectory_entries AS a '.'LEFT JOIN #__rsdirectory_entries_custom AS b '.'ON a.id = b.entry_id '.'WHERE id = '.intval($tag->id).' LIMIT 1';
		$db->setQuery($query);
		$content = $db->loadObject();

		//In case of we could not load the article for any reason...
		if(empty($content)){
			$app = JFactory::getApplication();
			if($app->isAdmin()){
				$app->enqueueMessage('The content "'.$tag->id.'" could not be loaded', 'notice');
			}
			return '';
		}

		$varFields = array();
		foreach($content as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		// create the link for the title and the read more button
		$link = ACYMAILING_LIVE.'index.php?option=com_rsdirectory&view=entry&id='.$tag->id;
		if(!empty($tag->itemid)) $link .= '&Itemid='.$tag->itemid;

		$result = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">';

		// display the title
		if(!empty($this->coreFields['title']) && in_array($this->coreFields['title']->id, $tag->display)){
			$result .= '<tr><td colspan="2"><h2 class="acymailing_title">';
			if(empty($tag->nolink)){
				$result .= '<a href="'.$link.'">';
			}
			$result .= $content->title;
			if(empty($tag->nolink)){
				$result .= '</a>';
			}
			$result .= ((!empty($this->coreFields['promoted']) && in_array($this->coreFields['promoted']->id, $tag->display) && $content->promoted != 0) ? '<span style="float:right;">'.JText::_('COM_RSDIRECTORY_TOP_ENTRY').'</span>' : '').'</h2></td></tr>';
		}

		if(!empty($this->coreFields['big-subtitle']) && in_array($this->coreFields['big-subtitle']->id, $tag->display)){
			$result .= '<tr><td colspan="2"><h3>'.$content->big_subtitle.'</h3></td></tr>';
		}

		if(!empty($this->coreFields['small-subtitle']) && in_array($this->coreFields['small-subtitle']->id, $tag->display)){
			$result .= '<tr><td colspan="2">'.$content->small_subtitle.'</td></tr>';
		}

		if(!empty($this->coreFields['price']) && in_array($this->coreFields['price']->id, $tag->display)){
			$result .= '<tr><td colspan="2"><strong>'.JText::_('COM_RSDIRECTORY_LISTING_PRICE_LABEL').'</strong>'.$content->price.' '.(empty($this->currency) ? '$' : $this->currency).'</td></tr>';
		}

		if(!empty($this->coreFields['publishing-period']) && in_array($this->coreFields['publishing-period']->id, $tag->display)){
			$result .= '<tr><td colspan="2"><strong>'.JText::_('COM_RSDIRECTORY_LISTING_PUBLISHING_DATE_LABEL').'</strong>'.acymailing_getDate(acymailing_getTime($content->published_time), JText::_('DATE_FORMAT_LC')).'<span style="float:right;"><strong>'.JText::_('COM_RSDIRECTORY_LISTING_EXPIRY_DATE_LABEL').'</strong>'.($content->expiry_time > $content->published_time ? acymailing_getDate(acymailing_getTime($content->expiry_time), JText::_('DATE_FORMAT_LC')) : JText::_('COM_RSDIRECTORY_NO_EXPIRY')).'</span></td></tr>';
		}

		if((!empty($this->coreFields['images']) && in_array($this->coreFields['images']->id, $tag->display)) || (!empty($this->coreFields['description']) && in_array($this->coreFields['description']->id, $tag->display) && !empty($content->description))){
			$result .= '<tr><td colspan="2">';
			if(!empty($this->coreFields['images']) && in_array($this->coreFields['images']->id, $tag->display)){
				$query = 'SELECT a.file_name '.'FROM #__rsdirectory_uploaded_files AS a '.'JOIN #__rsdirectory_uploaded_files_fields_relations AS b '.'ON a.id = b.file_id '.'WHERE b.entry_id = '.intval($tag->id).' '.'AND b.field_id = '.intval($this->coreFields['images']->id).' '.'LIMIT 1';
				$db->setQuery($query);
				$mainImage = $db->loadObject();

				if(!empty($mainImage) && file_exists(JPATH_SITE.DS.'components'.DS.'com_rsdirectory'.DS.'files'.DS.'entries'.DS.$tag->id.DS.$mainImage->file_name)){
					$result .= '<img style="float:left;" src="components/com_rsdirectory/files/entries/'.$tag->id.'/'.$mainImage->file_name.'"/>';
				}
			}
			// display the main text wraped or not
			if(!empty($this->coreFields['description']) && in_array($this->coreFields['description']->id, $tag->display) && !empty($content->description)){
				$result .= $this->acypluginsHelper->wrapText($content->description, $tag);
			}

			$result .= '</td></tr>';
		}

		foreach($tag->display as $oneField){
			if(empty($this->customFields[$oneField])){
				continue;
			}

			$column = $this->customFields[$oneField]->column_name;

			if(empty($content->$column) || $content->$column == '0000-00-00 00:00:00'){
				continue;
			}

			if(!empty($this->customFields[$oneField]->value)){
				$result .= '<tr><td valign="top" style="padding-right:10px;"><strong>'.$this->customFields[$oneField]->value.'</strong></td><td>'.$content->$column.'</td></tr>';
			}else{
				$result .= '<tr><td colspan="2">'.$content->$column.'</td></tr>';
			}
		}

		$varFields['{readmore}'] = '<a class="readmore_link" style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a>';
		if(empty($tag->noreadmore)) $result .= '<tr><td>'.$varFields['{readmore}'].'</td></tr>';

		$result .= '</table></div><br />';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields), $varFields, $result);
		}

		// always remove JS, there is no JS in newsletters...
		$result = $this->acypluginsHelper->removeJS($result);
		$result = $this->acypluginsHelper->managePicts($tag, $result);

		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(empty($this->tags)) return;

		$email->body = str_replace(array_keys($this->tags), $this->tags, $email->body);

		if(!empty($email->altbody)){
			$email->altbody = str_replace(array_keys($this->tags), $this->tags, $email->altbody);
		}

		foreach($this->tags as $tag => $result){
			$email->subject = str_replace($tag, strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis', ' | ', $result)), $email->subject);
		}
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		$db = JFactory::getDBO();
		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, 'auto'.$this->name);
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)){
			return $return;
		}

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])){
				continue;
			}
			$allcats = explode('-', $parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)){
					continue;
				}
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT a.id FROM #__rsdirectory_entries AS a JOIN #__categories AS b ON a.category_id = b.id ';

			$where = array();

			// load only needed content
			if(!empty($selectedArea)){
				$where[] = 'a.category_id IN ('.implode(',', $selectedArea).')';
			}

			// filter results created or modified
			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
				if($parameter->filter == 'created_time'){
					$where[] = 'a.created_time > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
				}elseif($parameter->filter == 'modified'){
					$where[] = 'a.created_time > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\' OR a.modified_time > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
				}
			}

			// Only published content
			$where[] = 'a.published = 1';

			if(!empty($parameter->promoted)){
				$where[] = 'a.promoted = 1';
			}

			if(!empty($parameter->nopromoted)){
				$where[] = 'a.promoted = 0';
			}

			// Apply filters
			if(!empty($where)){
				$query .= ' WHERE ('.implode(') AND (', $where).')';
			}

			// Ordering
			if(!empty($parameter->order)){
				if($parameter->order == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',', $parameter->order);
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			// If there is no limit, then we add one
			if(!empty($parameter->max)){
				$query .= ' LIMIT '.intval($parameter->max);
			}else{
				$query .= ' LIMIT 20';
			} // limit, because we do not want to display one bilion of content in the newsletter...

			// load content IDs
			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);

			// Check the number of results
			if(!empty($parameter->min) && count($allArticles) < $parameter->min){
				//We will not generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough '.$this->name.' content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles)){
				// If the user created its own template...
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
					$arrayElements = array();
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = $this->name.':'.$oneArticleId;
						if(!empty($parameter->nolink)) $args[] = 'nolink';
						if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|', $args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements, $parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}

	function onAcyDisplayFilters(&$type){
		$acyconfig = acymailing_config();
		$type['rsdirectory'] = 'RSDirectory! author';
		if(version_compare($acyconfig->get('version'), '4.9.4', '<')) return '<div id="filter__num__rsdirectory">Please update AcyMailing to the latest version, this plugin may not work properly with this one</div>';
		if(!$this->component_installed) return '<div id="filter__num__rsdirectory">You must install RSDirectory! to use this filter</div>';

		$lang = JFactory::getLanguage();
		$lang->load('com_rsdirectory', JPATH_SITE);

		$db = JFactory::getDBO();
		$db->setQuery('SELECT id, title FROM #__rsdirectory_forms ORDER BY title ASC');
		$allCats = $db->loadObjectList();
		$catList = array();
		$catList[] = JHTML::_('select.option', 0, JText::_('ACY_ANY_CATEGORY'));
		foreach($allCats as $oneCat){
			$catList[] = JHTML::_('select.option', $oneCat->id, $oneCat->title);
		}

		$return = '<div id="filter__num__rsdirectory">';
		$return .= str_replace('%s', '', JText::_('COM_RSDIRECTORY_LISTING_META_CATEGORY')).JHTML::_('select.genericlist', $catList, 'filter[__num__][rsdirectory][cat]', 'class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text');
		$return .= '</div>';
		return $return;
	}

	function onAcyProcessFilterCount_rsdirectory(&$query, $filter, $num){
		$this->onAcyProcessFilter_rsdirectory($query, $filter, $num);
		return JText::sprintf('SELECTED_USERS', $query->count());
	}

	function onAcyProcessFilter_rsdirectory(&$query, $filter, $num){
		if(!$this->component_installed) return;

		$query->join[] = '#__rsdirectory_entries AS rsentries'.$num.' ON sub.userid = rsentries'.$num.'.user_id';
		if(!empty($filter['cat'])) $query->where[] = 'rsentries'.$num.'.form_id = '.intval($filter['cat']);
	}
}