<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingSobi2 extends JPlugin
{

	var $categories;
	//Will store the fields displayed for the intro
	var $fieldsintro = array();
	//Will store the fields displayed for the full detail view
	var $fieldsfull = array();
	//Store the language here
	var $sobiTrans = array();

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'sobi2');
			$this->params = new acyParameter( $plugin->params );
		}
	}

	function acymailing_getPluginType() {

		 $onePlugin = new stdClass();
		 $onePlugin->name = 'Sobi2';
		 $onePlugin->function = 'acymailingsobi2_show';
		 $onePlugin->help = 'plugin-sobi2';

		 return $onePlugin;
	}

	function acymailingsobi2_show(){
		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.sobi2';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order',	'a.itemid','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir',	'desc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->contenttype = $app->getUserStateFromRequest( $paramBase.".contenttype", 'contenttype','|type:intro','string' );
		$pageInfo->author = $app->getUserStateFromRequest( $paramBase.".author", 'author','','string' );
		$pageInfo->titlelink = $app->getUserStateFromRequest( $paramBase.".titlelink", 'titlelink','|link','string' );
		$pageInfo->lang = $app->getUserStateFromRequest( $paramBase.".lang", 'lang','','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->autotitlelink = $app->getUserStateFromRequest( $paramBase.".autotitlelink", 'autotitlelink','|link','string' );
		$pageInfo->autoimages = $app->getUserStateFromRequest( $paramBase.".autoimages", 'autoimages','|images','string' );
		$pageInfo->automaxvalue = $app->getUserStateFromRequest( $paramBase.".max", 'max','','int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','|filter:created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','|order:id','string' );
		$pageInfo->autocontenttype = $app->getUserStateFromRequest( $paramBase.".autocontenttype", 'autocontenttype','|type:intro','string' );

		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );

		$picts = array();
		$picts[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$pictureHelper = acymailing_get('helper.acypict');
		if($pictureHelper->available()) $picts[] = JHTML::_('select.option', "resized",JText::_('RESIZED'));
		$picts[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$db = JFactory::getDBO();

		$searchFields = array('a.itemid','a.title');

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayart','all') == 'onlypub'){
			$filters[] = "a.published = 1";
		}

		$query = 'SELECT SQL_CALC_FOUND_ROWS a.itemid,a.title ';
		$query .= 'FROM `#__sobi2_item` as a INNER JOIN `#__sobi2_cat_items_relations` as b ON a.itemid = b.itemid';
		if(!empty($pageInfo->filter_cat)) $filters[] = "b.catid = ".$pageInfo->filter_cat;

		if(!empty($filters)){
			$query .= ' WHERE ('.implode(') AND (',$filters).')';
		}

		$query .=' GROUP BY a.itemid';

		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search,$rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		$db->setQuery('SELECT a.catid, a.name, b.parentid FROM #__sobi2_categories as a LEFT JOIN #__sobi2_cats_relations as b on a.catid=b.catid');
		$categories = $db->loadObjectList();

		$this->cats = array();
		foreach($categories as $oneCat){
			$this->cats[intval($oneCat->parentid)][] = $oneCat;
		}
		$this->_handleChildrens(isset($this->cats[0]) ? '0' : '1');

		//Let's order the categories

		$categories = $this->categories;

		$allCats = new stdClass();
		$allCats->catid=0;
		$allCats->name = JText::_('ACY_ALL');

		array_unshift($categories,$allCats);

		$contenttype = array();
		$contenttype[] = JHTML::_('select.option', "|type:title",JText::_('TITLE_ONLY'));
		$contenttype[] = JHTML::_('select.option', "|type:intro",JText::_('CATEGORY_VIEW'));
		$contenttype[] = JHTML::_('select.option', "|type:full",JText::_('DETAILS_VIEW'));


		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane( 'sobi2_tab');
		echo $tabs->startPanel( JText::_( 'TAG_ELEMENTS' ), 'sobi2_content');

	?>
		<br style="font-size:1px"/>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass){
				if(selectedContents[contentid]){
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[contentid];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents[contentid] = 'content';
				}

				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				for(var i=0; i < document.adminForm.contenttype.length; i++){
					 if (document.adminForm.contenttype[i].checked){ selectedtype = document.adminForm.contenttype[i].value; otherinfo += document.adminForm.contenttype[i].value; }
				}
				for(var i=0; i < document.adminForm.titlelink.length; i++){
					 if (document.adminForm.titlelink[i].checked){ otherinfo += document.adminForm.titlelink[i].value; }
				}
				if(selectedtype != '|type:title'){
					for(var i=0; i < document.adminForm.pict.length; i++){
						 if (document.adminForm.pict[i].checked){ otherinfo += '|pict:'+document.adminForm.pict[i].value; }
					}
				}

				if(window.document.getElementById('jflang')  && window.document.getElementById('jflang').value != ''){
					otherinfo += '|lang:';
					otherinfo += window.document.getElementById('jflang').value;
				}

				for(var i in selectedContents){
					if(selectedContents[i] == 'content'){
						tag = tag + '{sobi2:'+i+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}
		//-->
		</script>
		<table width="100%" class="adminform">
			<tr>
				<td>
					<?php echo JText::_('DISPLAY');?>
				</td>
				<td colspan="2">
					<?php echo JHTML::_('select.radiolist', $contenttype, 'contenttype' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->contenttype); ?>
				</td>
				<td>

				</td>
			</tr>
			<tr>
				<td>
				<?php echo JText::_('CLICKABLE_TITLE'); ?>
				 </td>
				 <td>
					 <?php $titlelinkType = acymailing_get('type.titlelink'); echo $titlelinkType->display('titlelink',$pageInfo->titlelink);?>
				</td>
				<td>

				 </td>
				 <td>

				</td>
			</tr>
			<tr>
				<td><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td><?php echo JHTML::_('select.radiolist', $picts, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?></td>
				<td></td>
				<td></td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo JHTML::_('select.genericlist', $categories, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'catid', 'name', (int) $pageInfo->filter_cat );?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort',   JText::_( 'ACY_ID' ), 'a.itemid', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="2">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					for($i = 0,$a = count($rows);$i<$a;$i++){
						$row =& $rows[$i];
				?>
					<tr id="content<?php echo $row->itemid?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->itemid.",'row$k'"?>);" style="cursor:pointer;">
						<td>
						<?php
							echo  $row->title;
						?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo $row->itemid; ?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
	<?php
	echo $tabs->endPanel();
	echo $tabs->startPanel( JText::_( 'TAG_CATEGORIES' ), 'sobi2_auto');

	$ordering = array();
	$ordering[] = JHTML::_('select.option', "|order:itemid,DESC",JText::_('ACY_ID'));
	$ordering[] = JHTML::_('select.option', "|order:ordering,ASC",JText::_('ACY_ORDERING'));
	$ordering[] = JHTML::_('select.option', "|order:title,ASC",JText::_('FIELD_TITLE'));

		$type = JRequest::getString('type');

	?>
		<br style="font-size:1px"/>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedCat = new Array();
			function applyAuto(catid,rowClass){
				if(selectedCat[catid]){
					window.document.getElementById('cat'+catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('cat'+catid).className = 'selectedrow';
					selectedCat[catid] = 'selectedone';
				}

				updateAutoTag();
			}

			function updateAutoTag(){
				tag = '{autosobi2:';

				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat+'-';
					}
				}

				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value!=0){ tag += '|min:'+document.adminForm.min_article.value; }
				if(document.adminForm.max_article.value && document.adminForm.max_article.value!=0){ tag += '|max:'+document.adminForm.max_article.value; }
				if(document.adminForm.contentorder.value){ tag += document.adminForm.contentorder.value; }
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){ tag += document.adminForm.contentfilter.value; }
				if(document.adminForm.meta_article && document.adminForm.meta_article.value){ tag += '|meta:'+document.adminForm.meta_article.value; }

				for(var i=0; i < document.adminForm.contenttypeauto.length; i++){
					 if (document.adminForm.contenttypeauto[i].checked){selectedtype = document.adminForm.contenttypeauto[i].value; tag += document.adminForm.contenttypeauto[i].value; }
				}
				for(var i=0; i < document.adminForm.titlelinkauto.length; i++){
					 if (document.adminForm.titlelinkauto[i].checked){ tag += document.adminForm.titlelinkauto[i].value; }
				}
				if(selectedtype != '|type:title'){
					for(var i=0; i < document.adminForm.pictauto.length; i++){
						 if (document.adminForm.pictauto[i].checked){ tag += '|pict:'+document.adminForm.pictauto[i].value; }
					}
				}
				if(window.document.getElementById('jflangauto')  && window.document.getElementById('jflangauto').value != ''){
					tag += '|lang:';
					tag += window.document.getElementById('jflangauto').value;
				}

				tag += '}';

				setTag(tag);
			}
		//-->
		</script>
		<table width="100%" class="adminform">
			<tr>
				<td>
					<?php echo JText::_('DISPLAY');?>
				</td>
				<td colspan="2">
					<?php echo JHTML::_('select.radiolist', $contenttype, 'contenttypeauto' , 'size="1" onclick="updateAutoTag();"', 'value', 'text', $pageInfo->autocontenttype); ?>
				</td>
				<td>

				</td>
			</tr>
			<tr>
				<td>
				<?php echo JText::_('CLICKABLE_TITLE'); ?>
				 </td>
				 <td>
					 <?php $titlelinkType = acymailing_get('type.titlelink'); $titlelinkType->onclick = "updateAutoTag();"; echo $titlelinkType->display('titlelinkauto','|link');?>
				</td>
				<td>

				 </td>
				 <td>

				</td>
			</tr>
			<tr>
				<td><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td><?php echo JHTML::_('select.radiolist', $picts, 'pictauto' , 'size="1" onclick="updateAutoTag();"', 'value', 'text', "1"); ?></td>
				<td></td>
				<td></td>
			</tr>
			<tr>
				<td>
				<?php echo JText::_('MAX_ARTICLE'); ?>
				 </td>
				 <td>
					 <input type="text" name="max_article" style="width:50px" value="20" onchange="updateAutoTag();"/>
				</td>
				<td>
				<?php echo JText::_('ACY_ORDER'); ?>
				 </td>
				 <td>
					 <?php echo JHTML::_('select.genericlist', $ordering, 'contentorder' , 'size="1" onchange="updateAutoTag();"', 'value', 'text'); ?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td>
				<?php 	echo JText::_('MIN_ARTICLE'); ?>
				 </td>
				 <td>
				 <input type="text" name="min_article" style="width:50px" value="1" onchange="updateAutoTag();"/>
				</td>
				<td>
				<?php echo JText::_('FILTER'); ?>
				 </td>
				 <td>
					 <?php $filters = array(); $filters[] = JHTML::_('select.option', "",JText::_('ACY_ALL')); $filters[] = JHTML::_('select.option', "|filter:created",JText::_('ONLY_NEW_CREATED'));
				echo JHTML::_('select.genericlist', $filters, 'contentfilter' , 'size="1" onclick="updateAutoTag();"', 'value', 'text', '|filter:created'); ?>
				</td>
			</tr>
			<?php } ?>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
		<?php $k=0; foreach($this->categories as $oneCat){
			 if(empty($oneCat->catid)) continue;
			?>
			<tr id="cat<?php echo $oneCat->catid ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->catid ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td>
				<?php
					echo $oneCat->name;
				?>
				</td>
			</tr>
		<?php $k = 1 - $k; } ?>
		</table>
	<?php

		echo $tabs->endPanel();
		echo $tabs->endPane();
	//End of the function
	}

	function acymailing_replacetags(&$email,$send = true){
		$this->_replaceAuto($email);
		$this->_replaceArticles($email);
	}

	function _replaceArticles(&$email){
		$match = '#{sobi2:(.*)}#Ui';
		$variables = array('subject','body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything...
		if(!$found) return;

		//We will need the mailer class as well
		$mailerHelper = acymailing_get('helper.mailer');

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				//Don't need to process twice a tag we already have!
				if(isset($htmlreplace[$oneTag])) continue;

				$article = $this->_replaceContent($allresults,$i);
				$htmlreplace[$oneTag] = $article;
				$textreplace[$oneTag] = $mailerHelper->textVersion($article);
				$subjectreplace[$oneTag] = strip_tags($article);
			}
		}

		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace),$subjectreplace,$email->subject);
	}

	function _replaceContent(&$results,$i){
		$app = JFactory::getApplication();
		//1 : Transform the tag properly...
		$arguments = explode('|',strip_tags($results[1][$i]));
		$tag = new stdClass();
		$tag->id = (int) $arguments[0];
		for($i=1,$a=count($arguments);$i<$a;$i++){
			$args = explode(':',$arguments[$i]);
			if(isset($args[1])){
				$tag->{$args[0]} = $args[1];
			}else{
				$tag->{$args[0]} = true;
			}
		}

		//2 : Load the Joomla article... with the author, the section and the categories to create nice links
		$query = 'SELECT a.*,b.catid FROM #__sobi2_item as a INNER JOIN `#__sobi2_cat_items_relations` as b ON a.itemid = b.itemid WHERE a.itemid = '.intval($tag->id).' LIMIT 1';

		$db = JFactory::getDBO();
		$db->setQuery($query);
		$article = $db->loadObject();

		$result = '';

		//In case of we could not load the article for any reason...
		if(empty($article)){
			if($app->isAdmin()) $app->enqueueMessage('The article "'.$tag->id.'" could not be loaded','notice');
			return $result;
		}

		//Load extra fields:
		$db->setQuery('SELECT a.* FROM #__sobi2_fields_data as a WHERE a.itemid = '.intval($tag->id));
		$fieldresults = $db->loadObjectList();
		$extraValues = array();
		if(!empty($fieldresults)){
			foreach($fieldresults as $oneField){
				$extraValues[$oneField->fieldid][] = $oneField;
			}
		}

		$link = 'index.php?option=com_sobi2&sobi2Task=sobi2Details&catid='.$article->catid.'&sobi2Id='.$tag->id;
		$link = acymailing_frontendLink($link);

		//Add the title with a link or not on it.
		//If we add a link, we add in the same time a name="content-CONTENTID" so that we will be able to parse the content to create a nice summary
		$styleTitle = '';
		$styleTitleEnd = '';
		if($tag->type != "title"){
			$styleTitle = '<h2 class="acymailing_title">';
			$styleTitleEnd = '</h2>';
		}

		if(empty($tag->notitle)){
			if(!empty($tag->link)){
				$result .= '<a href="'.$link.'" ';
				if($tag->type != "title") $result .= 'style="text-decoration:none" name="sobi2content-'.$article->itemid.'" ';
				$result .= 'target="_blank" >'.$styleTitle.$article->title.$styleTitleEnd.'</a>';
			}else{
				$result .= $styleTitle.$article->title.$styleTitleEnd;
			}
		}

		//We add the intro text
		if($tag->type != "title"){
			if(empty($this->sobiTrans)){
				$db->setQuery('SELECT langKey,langValue FROM #__sobi2_language WHERE sobi2Section IN (\'fields\',\'field_opt\') AND sobi2Lang = '.$db->Quote($this->_getSobiLanguage()));
				$this->sobiTrans = $db->loadObjectList('langKey');
			}
			//Do we need to limit the number of characters for the introtext?
			if($tag->type == "intro"){
				//vcard view
				$fieldVar = 'fieldsintro';
				$fieldWhere = 'in_vcard';
				$firstPict = 'icon';
				$secondPict = 'image';
			}else{
				//detail view
				$fieldVar = 'fieldsfull';
				$fieldWhere = 'in_details';
				$firstPict = 'image';
				$secondPict = 'icon';
			}
			//vcard view
			if(empty($this->$fieldVar)){
				$db->setQuery('SELECT *,a.fieldid FROM #__sobi2_fields as a LEFT JOIN #__sobi2_language as b ON a.fieldid = b.fieldid AND b.sobi2Lang = '.$db->Quote($this->_getSobiLanguage()).' AND b.sobi2Section = \'fields\' WHERE a.enabled = 1 AND a.'.$fieldWhere.' = 1 ORDER BY a.position ASC');
				$this->$fieldVar = $db->loadObjectList();
			}
			if(!empty($tag->pict)){
				$imagePath = ACYMAILING_LIVE.'images/com_sobi2/clients/'.(empty($article->$firstPict) ? $article->$secondPict : $article->$firstPict);
				if(in_array($db->getPrefix().'sobi2_plugin_jview', $db->getTableList())){
					$db->setQuery('SELECT image FROM #__sobi2_plugin_jview WHERE itemid = '.$tag->id);
					$image = $db->loadResult();
					if(!empty($image)) $imagePath = ACYMAILING_LIVE.'images/com_sobi2/jview/'.$tag->id.'/'.$image;
				}
				if(!empty($image) || !empty($article->$firstPict) || !empty($article->$secondPict)) $result .=  '<img src="'.$imagePath.'" style="float:right;margin:5px" />';
			}
			$result .= $this->_displayFields($extraValues,$this->$fieldVar);

			$result = '<div class="acymailing_content">'.$result.'</div>';
		}

		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'sobi2.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'sobi2.php');
			$result = ob_get_clean();
		}

		//Should we remove the JS?
		if($tag->type != 'title' AND $this->params->get('removejs','yes') == 'yes'){
			$result = $this->_removeJS($result);
		}

		//We have our content... lets check the pictures options
		if(isset($tag->pict)){
			$pictureHelper = acymailing_get('helper.acypict');
			$pictureHelper->maxHeight = empty($tag->maxheight) ? $this->params->get('maxheight',150) : $tag->maxheight;
			$pictureHelper->maxWidth = empty($tag->maxwidth) ? $this->params->get('maxwidth',150) : $tag->maxwidth;
			if($tag->pict == '0'){
				$result = $pictureHelper->removePictures($result);
			}elseif($tag->pict == 'resized'){
				if($pictureHelper->available()){
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error,'notice');
				}
			}
		}
		return $result;

	}

	function _displayFields(&$extraValues,$fields){
		$result = '<p>';
		foreach($fields as $oneField){
			if(!isset($extraValues[$oneField->fieldid][0]) OR strlen($extraValues[$oneField->fieldid][0]->data_txt) < 1) continue;
			if(!empty($oneField->in_newline)) $result .= '<br />';
			$result .= ' <span class="sobi2_field">';

			if(!empty($oneField->with_label) && !empty($oneField->langValue)) $result .= '<span class="'.$oneField->langKey.'_label">'.$oneField->langValue.':</span>';

			$pict = false;
			foreach($extraValues[$oneField->fieldid] as $num => $oneValue){
				if(!empty($num) && !$pict) $result .= ',';
				$result .= ' <span class="'.$oneField->langKey.'_value">';
				$myval = (isset($this->sobiTrans[$oneValue->data_txt]) ? nl2br($this->sobiTrans[$oneValue->data_txt]->langValue) : nl2br($oneValue->data_txt));
				$myval = str_replace(array('\"',"\'"),array('"',"'"),$myval);
				if(strpos($myval,'{img=') !== false){
					$pict = true;
					$myval = '<img src="'.str_replace('{img=','',trim($myval,'}')).'" /> ';
				}
				$result .= $myval;
				$result .= '</span>';
			}
			$result .= '</span>';
		}
		$result .= '</p>';

		return $result;
	}

	function _getSobiLanguage(){
		static $language = '';
		if(empty($language)){
			$db = JFactory::getDBO();
			$db->setQuery("SELECT `configValue` FROM `#__sobi2_config` WHERE `configKey` = 'language'");
			$language = $db->loadResult();
		}

		return $language;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);
			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag,strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis',' | ',$result)),$email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email){

		$return = new stdClass();
		$return->status = true;
		$return->message = '';

		$time = time();


		//Check if we should generate the SmartNewsletter or not...
		$match = '#{autosobi2:(.*)}#Ui';
		$variables = array('subject','body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything... so we won't try to stop the generation
		if(!$found) return $return;

		$this->tags = array();
		$db = JFactory::getDBO();

		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset($this->tags[$oneTag])) continue;

				$arguments = explode('|',strip_tags($allresults[1][$i]));
				//The first argument is a list of sections and cats...
				$allcats = explode('-',$arguments[0]);
				$parameter = new stdClass();
				for($i=1;$i<count($arguments);$i++){
					$args = explode(':',$arguments[$i]);
					$arg0 = $args[0];
					if(isset($args[1])){
						$parameter->$arg0 = $args[1];
					}else{
						$parameter->$arg0 = true;
					}
				}
				//Load the articles based on all arguments...
				$selectedArea = array();
				foreach($allcats as $oneCat){
					if(empty($oneCat)) continue;
					$selectedArea[] = (int) $oneCat;
				}
				$query = 'SELECT DISTINCT a.itemid FROM `#__sobi2_item` as a LEFT JOIN `#__sobi2_cat_items_relations` as b ON a.itemid = b.itemid';
				$where = array();
				if(!empty($selectedArea)){
					$where[] = 'b.`catid` IN ('.implode(',',$selectedArea).')';
				}

				if(!empty($parameter->filter) AND !empty($email->params['lastgenerateddate'])){
					$where[] = 'a.`publish_up` >\''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
				}

				$where[] = 'a.`publish_up` < \'' .date( 'Y-m-d H:i:s',$time - date('Z')).'\'';
				$where[] = 'a.`publish_down` > \''.date( 'Y-m-d H:i:s',$time - date('Z')).'\' OR a.`publish_down` = 0';
				$where[] = 'a.published = 1';

				$query .= ' WHERE ('.implode(') AND (',$where).')';
				if(!empty($parameter->order)){
					$ordering = explode(',',$parameter->order);
					$query .= ' ORDER BY a.`'.acymailing_secureField($ordering[0]).'` '.acymailing_secureField($ordering[1]);
				}

				$start = '';
				if(!empty($parameter->start)) $start = intval($parameter->start).',';

				if(!empty($parameter->max)) $query .= ' LIMIT '.$start.(int) $parameter->max;
				elseif(empty($email->params['lastgenerateddate'])) $query .= ' LIMIT '.$start.'20';
				//We add a limit for the preview otherwise we could break everything

				$db->setQuery($query);
				$allArticles = acymailing_loadResultArray($db);

				if(!empty($parameter->min) AND count($allArticles)< $parameter->min){
					//We won't generate the Newsletter
					$return->status = false;
					$return->message = 'Not enough articles for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
				}

				$stringTag = '';
				if(!empty($allArticles)){
					if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autosobi2.php')){
						ob_start();
						require(ACYMAILING_MEDIA.'plugins'.DS.'autosobi2.php');
						$stringTag = ob_get_clean();
					}else{
						//we insert the article tag one after the other in a table as they are already sorted
						$stringTag .= '<table width="100%" border="0" cellpadding="0" cellspacing="0">';
						foreach($allArticles as $oneArticleId){
							$stringTag .= '<tr><td>';
							$args = array();
							$args[] = 'sobi2:'.$oneArticleId;
							if(!empty($parameter->type)) $args[] = 'type:'.$parameter->type;
							if(!empty($parameter->link)) $args[] = 'link';
							if(!empty($parameter->author)) $args[] = 'author';
							if(!empty($parameter->lang)) $args[] = 'lang:'.$parameter->lang;
							if(!empty($parameter->notitle)) $args[] = 'notitle';
							if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
							if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
							if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
							$stringTag .= '{'.implode('|',$args).'}';
							$stringTag .= '</td></tr>';
						}
						$stringTag .= '</table>';
					}
				}

				$this->tags[$oneTag] = $stringTag;
			}
		}

		return $return;
	}

	function _removeJS($text){
		//Remove the picture... normal process
		$text = preg_replace("#(onmouseout|onmouseover|onclick|onfocus|onload|onblur) *= *\"(?:(?!\").)*\"#iU",'',$text);
		$text =  preg_replace("#< *script(?:(?!< */ *script *>).)*< */ *script *>#isU",'',$text);
		return $text;
	}


	function _handleChildrens($parentId=0,$level=0){
		if(!empty($this->cats[$parentId])){
			foreach($this->cats[$parentId] as $cat){
				$cat->name = str_repeat(" - - ",$level).$cat->name;
				$this->categories[] = $cat;
				$this->_handleChildrens($cat->catid,$level+1);
			}
		}
	}

}//endclass