<?php
/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingTagmosets extends JPlugin{
	var $allFields = array();

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'tagmosets');
			$this->params = new JParameter($plugin->params);
		}
	}

	function acymailing_getPluginType(){
		if(!file_exists(JPATH_SITE.DS.'components'.DS.'com_mtree')) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'Mosets Tree';
		$onePlugin->function = 'acymailingtagmosets_show';
		$onePlugin->help = 'plugin-tagmosets';

		return $onePlugin;
	}

	function acymailingtagmosets_show(){
		$langmt = JFactory::getLanguage();
		$langmt->load('com_mtree', JPATH_SITE);
		$config = acymailing_config();
		if($config->get('version') < '4.9.4'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.tagmosets';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest($paramBase.".filter_order", 'filter_order', 'a.link_id', 'cmd');
		$pageInfo->filter->order->dir = $app->getUserStateFromRequest($paramBase.".filter_order_Dir", 'filter_order_Dir', 'DESC', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->titlelink = $app->getUserStateFromRequest($paramBase.".titlelink", 'titlelink', '1', 'string');
		$pageInfo->contenttype = $app->getUserStateFromRequest($paramBase.".contenttype", 'contenttype', 'intro', 'string');
		$pageInfo->images = $app->getUserStateFromRequest($paramBase.".images", 'images', '1', 'string');
		$pageInfo->limit->value = $app->getUserStateFromRequest($paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int');
		$pageInfo->limit->start = $app->getUserStateFromRequest($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->autotitlelink = $app->getUserStateFromRequest($paramBase.".autotitlelink", 'autotitlelink', '1', 'string');
		$pageInfo->autoimages = $app->getUserStateFromRequest($paramBase.".autoimages", 'autoimages', '1', 'string');
		$pageInfo->automaxvalue = $app->getUserStateFromRequest($paramBase.".max", 'max', '20', 'int');
		$pageInfo->contentfilter = $app->getUserStateFromRequest($paramBase.".contentfilter", 'contentfilter', '|filter:created', 'string');
		$pageInfo->contentorder = $app->getUserStateFromRequest($paramBase.".contentorder", 'contentorder', '|order:id', 'string');
		$pageInfo->autocontenttype = $app->getUserStateFromRequest($paramBase.".contenttypeauto", 'contenttypeauto', 'intro', 'string');
		$pageInfo->cols = $app->getUserStateFromRequest($paramBase.".cols", 'cols', '1', 'string');
		$pageInfo->pictheight = $app->getUserStateFromRequest($paramBase.".pictheight", 'pictheight', '150', 'string');
		$pageInfo->pictwidth = $app->getUserStateFromRequest($paramBase.".pictwidth", 'pictwidth', '150', 'string');
		$pageInfo->pict = $app->getUserStateFromRequest($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->autopict = $app->getUserStateFromRequest($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->readmore = $app->getUserStateFromRequest($paramBase.".readmore", 'readmore', '1', 'string');
		$pageInfo->readmoreauto = $app->getUserStateFromRequest($paramBase.".readmoreauto", 'readmoreauto', '1', 'string');
		$pageInfo->wrap = $app->getUserStateFromRequest($paramBase.".wrap", 'wrap', '0', 'string');

		$db = JFactory::getDBO();

		$searchFields = array('a.link_id', 'a.link_name', 'c.name', 'a.user_id');

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displaypub', 'all') == 'onlypub'){
			$filters[] = 'a.link_published = 1 AND (a.publish_up < \''.date('Y-m-d H:i:s', time() - date('Z')).'\' OR a.publish_up = "0000-00-00 00:00:00") AND (a.publish_down > \''.date('Y-m-d H:i:s', time() - date('Z')).'\' OR a.publish_down = "0000-00-00 00:00:00")';
		}

		$query = 'SELECT SQL_CALC_FOUND_ROWS c.name,c.username,a.user_id,a.link_id,a.link_name ';
		if(empty($pageInfo->filter_cat)){
			$query .= 'FROM `#__mt_links` as a';
		}else{
			$query .= 'FROM `#__mt_cl` as b LEFT JOIN `#__mt_links` as a ON a.link_id = b.link_id';
			$filters[] = "b.cat_id = ".intval($pageInfo->filter_cat);
		}
		$query .= ' LEFT JOIN `#__users` as c ON a.user_id = c.id';

		if(!empty($filters)){
			$query .= ' WHERE ('.implode(') AND (', $filters).')';
		}

		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query, $pageInfo->limit->start, $pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search, $rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		$type = JRequest::getString('type');

		?>

		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			function applyContent(contentid, rowClass){
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1){
					window.document.getElementById('content' + contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content' + contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid, rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('cat' + catid).className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						for(key in selectedCat){
							if(!isNaN(key)){
								window.document.getElementById('cat' + key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat' + catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				for(var i = 0; i < document.adminForm.contenttype.length; i++){
					if(document.adminForm.contenttype[i].checked){
						selectedtype = document.adminForm.contenttype[i].value;
						otherinfo += '| type:' + document.adminForm.contenttype[i].value;
					}
				}
				for(var i = 0; i < document.adminForm.titlelink.length; i++){
					if(document.adminForm.titlelink[i].checked && document.adminForm.titlelink[i].value == '1'){
						otherinfo += '| link';
					}
				}
				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0){
					otherinfo += "| wrap:" + document.adminForm.wrap.value;
				}

				for(var i = 0; i < document.adminForm.readmore.length; i++){
					if(document.adminForm.readmore[i].checked){
						otherinfo += '| readmore:' + document.adminForm.readmore[i].value;
					}
				}

				for(var i = 0; i < document.adminForm.pict.length; i++){
					if(document.adminForm.pict[i].checked){
						otherinfo += '| pict:' + document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized'){
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:' + document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}
				for(var i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{mosets:' + selectedContents[i] + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto(){
				tag = '{automosets:';

				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat + '-';
					}
				}

				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value != 0 && !isNaN(document.adminForm.min_article.value)){
					tag += '| min:' + document.adminForm.min_article.value;
				}
				if(document.adminForm.max_article.value && document.adminForm.max_article.value != 0 && !isNaN(document.adminForm.max_article.value)){
					tag += '| max:' + document.adminForm.max_article.value;
				}
				for(var i = 0; i < document.adminForm.contenttypeauto.length; i++){
					if(document.adminForm.contenttypeauto[i].checked){
						selectedtype = document.adminForm.contenttypeauto[i].value;
						tag += '| type:' + document.adminForm.contenttypeauto[i].value;
					}
				}
				for(var i = 0; i < document.adminForm.autotitlelink.length; i++){
					if(document.adminForm.autotitlelink[i].checked && document.adminForm.autotitlelink[i].value == '1'){
						tag += '| link';
					}
				}

				for(var i = 0; i < document.adminForm.readmoreauto.length; i++){
					if(document.adminForm.readmoreauto[i].checked){
						tag += '| readmore:' + document.adminForm.readmoreauto[i].value;
					}
				}
				for(var i = 0; i < document.adminForm.autopict.length; i++){
					if(document.adminForm.autopict[i].checked){
						tag += '| pict:' + document.adminForm.autopict[i].value;
						if(document.adminForm.autopict[i].value == 'resized'){
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) tag += '| maxwidth:' + document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) tag += '| maxheight:' + document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}
				if(document.adminForm.autowrap.value && document.adminForm.autowrap.value != 0 && !isNaN(document.adminForm.autowrap.value)){
					tag += "| wrap:" + document.adminForm.autowrap.value;
				}
				if(document.adminForm.cols.value){
					tag += "| cols:" + document.adminForm.cols.value;
				}
				if(document.adminForm.contentorder.value){
					tag += "| order:" + document.adminForm.contentorder.value;
				}
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){
					tag += document.adminForm.contentfilter.value;
				}

				tag += '}';

				setTag(tag);
			}
			//-->
		</script>
		<?php
		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$ordering = array();
		$ordering[] = JHTML::_('select.option', "link_id,DESC", JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "ordering,ASC", JText::_('ACY_ORDERING'));
		$ordering[] = JHTML::_('select.option', "link_created,DESC", JText::_('COM_MTREE_ALL_LISTINGS_SORT_OPTION_-LINK_CREATED'));
		$ordering[] = JHTML::_('select.option', "link_modified,DESC", JText::_('COM_MTREE_RECENTLY_UPDATED_LISTINGS'));
		$ordering[] = JHTML::_('select.option', "link_name,ASC", JText::_('ACY_TITLE'));
		$ordering[] = JHTML::_('select.option', "link_rating,DESC", JText::_('COM_MTREE_TOP_RATED_LISTINGS'));
		$ordering[] = JHTML::_('select.option', "link_hits,DESC", JText::_('COM_MTREE_POPULAR_LISTINGS'));
		$ordering[] = JHTML::_('select.option', "link_featured,DESC", JText::_('COM_MTREE_PATHWAY_LISTFEATURED'));
		$ordering[] = JHTML::_('select.option', "link_votes,DESC", JText::_('COM_MTREE_MOST_RATED_LISTINGS'));
		$ordering[] = JHTML::_('select.option', "rand", JText::_('ACY_RANDOM'));

		//Title link params
		$titlelink = array();
		$titlelink[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$titlelink[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$contenttype = array();
		$contenttype[] = JHTML::_('select.option', "title", JText::_('TITLE_ONLY'));
		$contenttype[] = JHTML::_('select.option', "intro", JText::_('CATEGORY_VIEW'));
		$contenttype[] = JHTML::_('select.option', "full", JText::_('DETAILS_VIEW'));

		$column = array();
		for($i = 1; $i < 11; $i++){
			$column[] = JHTML::_('select.option', "$i", $i);
		}

		if(ACYMAILING_J30){
			$paginationNb = array();
			$paginationNb[] = JHTML::_('select.option', 5, 5);
			$paginationNb[] = JHTML::_('select.option', 10, 10);
			$paginationNb[] = JHTML::_('select.option', 15, 15);
			$paginationNb[] = JHTML::_('select.option', 20, 20);
			$paginationNb[] = JHTML::_('select.option', 25, 25);
			$paginationNb[] = JHTML::_('select.option', 30, 30);
			$paginationNb[] = JHTML::_('select.option', 50, 50);
			$paginationNb[] = JHTML::_('select.option', 100, 100);
			$paginationNb[] = JHTML::_('select.option', 0, JText::_('ACY_ALL'));
		}

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane('mosets_tab');
		echo $tabs->startPanel(JText::_('TAG_ELEMENTS'), 'mosets_listings');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<td colspan="3"><?php echo JHTML::_('acyselect.radiolist', $contenttype, 'contenttype', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->contenttype); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br/>
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
				</td>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td nowrap="nowrap" valign="top">
					<?php echo JHTML::_('acyselect.radiolist', $titlelink, 'titlelink', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->titlelink);?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER', '<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();"/>
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_('JOOMEXT_GO'); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_('JOOMEXT_RESET'); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
			<tr>
				<th class="title">
				</th>
				<th class="title">
					<?php echo JHTML::_('grid.sort', JText::_('ACY_TITLE'), 'a.link_name', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title">
					<?php echo JHTML::_('grid.sort', JText::_('ACY_AUTHOR'), 'c.name', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title titleid">
					<?php echo JHTML::_('grid.sort', JText::_('ACY_ID'), 'a.link_id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
			</tr>
			</thead>
			<tbody>
			<?php
			$k = 0;
			for($i = 0; $i < count($rows); $i++){
				$row =& $rows[$i];
				?>
				<tr id="content<?php echo $row->link_id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->link_id.",'row$k'"?>);" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td>
						<?php
						echo $row->link_name;
						?>
					</td>
					<td>
						<?php
						if(!empty($row->name)){
							$text = '<b>'.JText::_('NAME', true).' : </b>'.$row->name;
							$text .= '<br /><b>'.JText::_('USERNAME', true).' : </b>'.$row->username;
							$text .= '<br /><b>'.JText::_('ACY_ID', true).' : </b>'.$row->user_id;
							echo acymailing_tooltip($text, $row->name, '', $row->name);
						}
						?>
					</td>
					<td align="center" style="text-align:center">
						<?php echo $row->link_id; ?>
					</td>
				</tr>
				<?php
				$k = 1 - $k;
			}
			?>
			</tbody>
			<tfoot>
			<tr>
				<td colspan="4">
					<?php
					echo $pagination->getListFooter();
					if(ACYMAILING_J30){
						echo 'Display #'.JHTML::_('select.genericlist', $paginationNb, 'limit', 'size="1" style="width:60px" onchange="Joomla.submitform();"', 'value', 'text', $pageInfo->limit->value).'<br />';
					}

					echo $pagination->getResultsCounter();
					?>
				</td>
			</tr>
			</tfoot>
		</table>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>
		<?php
		echo $tabs->endPanel();
		echo $tabs->startPanel(JText::_('TAG_CATEGORIES'), 'mosets_auto');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<td colspan="3"><?php echo JHTML::_('acyselect.radiolist', $contenttype, 'contenttypeauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autocontenttype); ?></td>
			</tr>
			<tr>
				<td valign="top" nowrap="nowrap">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict); ?>
					<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br/>
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
				</span>
				</td>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td nowrap="nowrap" valign="top">
					<?php echo JHTML::_('acyselect.radiolist', $titlelink, 'autotitlelink', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autotitlelink);?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER', '<input type="text" name="autowrap" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('FIELD_COLUMNS'); ?></td>
				<td nowrap="nowrap" colspan="3">
					<?php echo JHTML::_('select.genericlist', $column, 'cols', 'size="1" style="width:50px" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap">
					<input type="text" name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td nowrap="nowrap">
					<?php echo JHTML::_('acyselect.genericlist', $ordering, 'contentorder', 'size="1" style="width:150px" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews'){ ?>
				<tr>
					<td nowrap="nowrap">
						<?php echo JText::_('MIN_ARTICLE'); ?>
					</td>
					<td nowrap="nowrap">
						<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
					</td>
					<td nowrap="nowrap">
						<?php echo JText::_('JOOMEXT_FILTER'); ?>
					</td>
					<td nowrap="nowrap">
						<?php $filter = acymailing_get('type.contentfilter');
						$filter->onclick = 'updateTagAuto();';
						echo $filter->display('contentfilter', $pageInfo->contentfilter); ?>
					</td>
				</tr>
			<?php } ?>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<?php $k = 0; ?>
			<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
					<?php
					echo JText::_('ACY_ALL');
					?>
				</td>
			</tr>
			<?php foreach($this->catvalues as $oneCat){
				if(empty($oneCat->value)) continue;
				?>
				<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td>
						<?php
						echo $oneCat->text;
						?>
					</td>
				</tr>
				<?php $k = 1 - $k;
			} ?>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
		//End of the function
	}

	function _categories($filter_cat){
		//select all cats
		$db = JFactory::getDBO();
		$db->setQuery('SELECT * FROM `#__mt_cats` ORDER BY `ordering` ASC');
		$mosetCats = $db->loadObjectList();
		$this->cats = array();
		foreach($mosetCats as $oneCat){
			$this->cats[$oneCat->cat_parent][] = $oneCat;
		}

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0, JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist', $this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int)$filter_cat);
	}

	function _handleChildrens($parentId = 0, $level = 0){
		if(!empty($this->cats[$parentId])){
			foreach($this->cats[$parentId] as $cat){
				$cat->name = $cat->cat_name;
				$this->catvalues[] = JHTML::_('select.option', $cat->cat_id, str_repeat(" - - ", $level).$cat->name);
				$this->_handleChildrens($cat->cat_id, $level + 1);
			}
		}
	}

	function _replaceOne(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		//load the tags
		$tags = $acypluginsHelper->extractTags($email, 'mosets');
		if(empty($tags)){
			return;
		}
		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more link:
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE', true).'" />';

		$htmlreplace = array();
		$textreplace = array();
		foreach($tags as $i => $params){
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content, true);
		}
		$email->body = str_replace(array_keys($htmlreplace), $htmlreplace, $email->body);
		$email->altbody = str_replace(array_keys($textreplace), $textreplace, $email->altbody);
	}

	function _replaceContent(&$tag){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		if(empty($tag->type)){
			$tag->type = 'full';
		}

		//2 : Load the content
		$query = 'SELECT b.name , b.email , b.username , d.cat_name, d.cat_id, a.* FROM `#__mt_links` as a ';
		$query .= 'LEFT JOIN `#__users` as b ON a.user_id = b.id ';
		$query .= 'LEFT JOIN `#__mt_cl` as c ON a.link_id = c.link_id AND main = 1 ';
		$query .= 'LEFT JOIN `#__mt_cats` as d ON c.cat_id = d.cat_id ';
		$query .= 'WHERE a.link_id = '.intval($tag->id).' LIMIT 1';

		$db = JFactory::getDBO();
		$db->setQuery($query);
		$content = $db->loadObject();

		//In case of we could not load the article for any reason...
		if(empty($content)){
			$app = JFactory::getApplication();
			if($app->isAdmin()){
				$app->enqueueMessage('The listing "'.$tag->id.'" could not be loaded', 'notice');
			}
			return '';
		}

		$link = ACYMAILING_LIVE.'index.php?option=com_mtree&task=viewlink&link_id='.$tag->id;

		if($tag->type == 'title'){
			$result = '';
			if(!empty($tag->link)){
				$result .= '<a style="text-decoration:none;" href="'.$link.'">';
			}
			$result .= $content->link_name;
			if(!empty($tag->link)){
				$result .= '</a>';
			}
			return $result;
		}

		if(empty($this->allFields)){
			//Load the rest of the content
			$query = 'SELECT a.* FROM `#__mt_customfields` as a WHERE a.`published` = 1 ORDER BY a.`ordering` ASC';
			$db->setQuery($query);
			$this->allFields = $db->loadObjectList();
		}
		//Load the rest of the content
		$db->setQuery('SELECT * FROM `#__mt_cfvalues` WHERE `link_id` = '.$tag->id);
		$contentValues = $db->loadObjectList('cf_id');

		if(!empty($tag->pict)){
			$db->setQuery('SELECT filename FROM `#__mt_images` WHERE `link_id` = '.$tag->id.' ORDER BY `ordering` ASC');
			$images = acymailing_loadResultArray($db);
		}

		//We will store all elements in this variable so it can be used with the templating system
		$varFields = array();
		foreach($content as $field => $value){
			$varFields['{'.$field.'}'] = $value;
		}
		$varFields['{link}'] = $link;

		//No template so we will do it by ourself...
		$result = '<div class="acymailing_content" style="clear:both">';
		$result .= '<table cellspacing="0" cellpadding="0" border="0" width="100%"><tr><td>';
		if(!empty($tag->link)) $result .= '<a style="text-decoration:none;" href="'.$link.'">';
		$result .= '<h2 class="acymailing_title">'.$content->link_name.'</h2>';
		if(!empty($tag->link)) $result .= '</a>';
		$result .= '</td></tr>';

		foreach($this->allFields as $numField => $oneField){
			if(($tag->type == 'intro' && empty($oneField->summary_view)) || ($tag->type == 'full' && empty($oneField->details_view)) || $oneField->field_type == 'corename') continue;
			//Explode params...
			if(is_string($oneField->params)){
				$params = explode("\n", $oneField->params);
				$this->allFields[$numField]->params = new stdClass();
				//That's a default value for description field
				if($oneField->field_type == 'coredesc'){
					$this->allFields[$numField]->params->summaryChars = 225;
				}
				foreach($params as $oneParam){
					$paramfields = explode('=', $oneParam);
					if(count($paramfields) != 2 || empty($paramfields[0]) || empty($paramfields[1])) continue;
					$paramname = trim($paramfields[0]);
					$paramvalue = trim($paramfields[1]);
					$this->allFields[$numField]->params->$paramname = $paramvalue;
				}
			}

			if($oneField->iscore){
				if($oneField->field_type == 'coredesc'){
					$currentValue = $content->link_desc;
				}else{
					$name = str_replace('core', '', $oneField->field_type);
					$currentValue = @$content->$name;
				}
			}else{
				$currentValue = @$contentValues[$oneField->cf_id]->value;
			}

			//Should we limit the number of chars?
			if($tag->type == 'intro' && !empty($this->allFields[$numField]->params->summaryChars) && strlen($currentValue) > $this->allFields[$numField]->params->summaryChars){
				$currentValue = substr($currentValue, 0, $this->allFields[$numField]->params->summaryChars).' ...';
			}

			if($oneField->field_type == 'image'){
				$db->setQuery('SELECT raw_filename FROM #__mt_cfvalues_att WHERE cf_id = '.intval($oneField->cf_id).' AND link_id = '.intval($tag->id));
				$currentValue = $db->loadResult();
			}

			//handle the special "category" custom field
			if($oneField->field_type == 'category'){
				$currentValue = '<a class="catmosets" href="index.php?option=com_mtree&task=listcats&cat_id='.$content->cat_id.'">'.$content->cat_name.'</a>';
			}

			if(empty($oneField->details_view) || strlen($currentValue) < 1){
				$varFields['{cf|'.$oneField->alias.'}'] = $currentValue;
				continue;
			}

			//Handle radio and lists with pictures
			if((!empty($oneField->params->images) || (!empty($oneField->params->captions)) && !empty($oneField->field_elements))){
				$textValues = empty($oneField->field_elements) ? array() : explode('|', $oneField->field_elements);
				$pictValues = empty($oneField->params->images) ? array() : explode('|', $oneField->params->images);
				$labelValues = empty($oneField->params->captions) ? array() : explode('|', $oneField->params->captions);
				$allVals = empty($currentValue) ? array() : explode('|', $currentValue);
				$myvals = array();
				foreach($allVals as $oneVal){
					$pos = array_search($oneVal, $textValues);
					if($pos === false){
						$myvals[] = $oneVal;
						continue;
					}
					$label = isset($labelValues[$pos]) ? $labelValues[$pos].' ' : '';
					$pict = '';
					if(!empty($pictValues[$pos])){
						$pict = '<img src="'.str_replace('{live_site}', rtrim(ACYMAILING_LIVE, '/'), $pictValues[$pos]).'" alt="'.$oneVal.'" />';
					}
					if(empty($label) && empty($pict)){
						$myvals[] = $oneVal;
						continue;
					}
					$tmp = '';
					if(!empty($oneField->params->useCaptions) && $oneField->params->useCaptions == 1){
						$tmp .= $label;
					}
					if(!empty($oneField->params->showImages) && $oneField->params->showImages == 1){
						$tmp .= $pict;
					}
					$myvals[] = $tmp;
				}
				$currentValue = implode(' ', $myvals);
			}
			$varFields['{cf|'.$oneField->alias.'}'] = $currentValue;

			$result .= '<tr><td '.($oneField->field_type == "coredesc" ? ' style="text-align:justify;"' : '').'><div class="mosetfield">';
			if(empty($oneField->hide_caption)){
				$result .= '<span class="mosetcaption"><strong>'.$oneField->caption.' : </strong></span>';
			}

			$result .= '<span class="mosetvalue">';

			if(!empty($oneField->prefix_text_display)){
				$result .= $oneField->prefix_text_display;
			}

			if($oneField->field_type == "corewebsite"){
				$result .= "<a href=\"$currentValue\">".$currentValue."</a>";
			}elseif($oneField->field_type == 'image'){
				$result .= '<a href="media/com_mtree/attachments/'.$currentValue.'"><img src="media/com_mtree/attachments/'.$currentValue.'"/></a>';
			}elseif($oneField->field_type == "coredesc"){
				if(!empty($images) && !empty($tag->pict)){
					//Old version or new version?
					$pictpath = file_exists(ACYMAILING_ROOT.'components'.DS.'com_mtree'.DS.'img'.DS.'listings'.DS.'s'.DS.$images[0]) ? ACYMAILING_LIVE.'components/com_mtree/img/listings/s/'.$images[0] : ACYMAILING_LIVE.'media/com_mtree/images/listings/m/'.$images[0];
					$result .= '<a href="'.$link.'"><img style="padding:5px;float:left" src="'.$pictpath.'" /></a>';
				}
				$result .= $acypluginsHelper->wrapText($currentValue, $tag);
			}else{
				$result .= $currentValue;
			}

			if($oneField->caption == "Tags"){
				$tags = $currentValue;
			}

			if(!empty($oneField->suffix_text_display)){
				$result .= $oneField->suffix_text_display;
			}
			$result .= '</span>';
			$result .= '</div></td></tr>';
		}

		if(!empty($images) && !empty($tag->pict)){
			$result .= '<tr><td><div class="mosetimages">';
			foreach($images as $onePath){
				//Old version or new version?
				$pictpath = file_exists(ACYMAILING_ROOT.'components'.DS.'com_mtree'.DS.'img'.DS.'listings'.DS.'s'.DS.$onePath) ? ACYMAILING_LIVE.'components/com_mtree/img/listings/s/'.$onePath : ACYMAILING_LIVE.'media/com_mtree/images/listings/s/'.$onePath;
				$pictpathlarge = file_exists(ACYMAILING_ROOT.'components'.DS.'com_mtree'.DS.'img'.DS.'listings'.DS.'o'.DS.$onePath) ? ACYMAILING_LIVE.'components/com_mtree/img/listings/o/'.$onePath : ACYMAILING_LIVE.'media/com_mtree/images/listings/o/'.$onePath;
				$result .= '<a href="'.$pictpathlarge.'"><img style="padding:5px;float:left" alt="" hspace="2" vspace="2" src="'.$pictpath.'" /></a>';
			}
			$result .= '</div></td></tr>';
		}

		if(!empty($tag->readmore)){
			$readMoreText = empty($this->readmore) ? JText::_('JOOMEXT_READ_MORE') : $this->readmore;
			$result .= '<tr><td><br /><a target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$readMoreText.'</span></a></td></tr>';
		}

		$result .= '</table><br />';

		$query = 'SELECT b.value, a.alias, a.caption, a.field_type, b.cf_id FROM `#__mt_customfields` AS a '.'JOIN `#__mt_cfvalues` AS b '.'ON a.cf_id = b.cf_id '.'WHERE a.`published` = 1 AND b.link_id = '.intval($tag->id);
		$db->setQuery($query);
		$customfields = $db->loadObjectList();
		$query = 'SELECT COUNT(rev_id) FROM `#__mt_reviews` WHERE link_id = '.intval($tag->id);
		$db->setQuery($query);
		$reviews = acymailing_loadResultArray($db);
		$varFields['{reviews}'] = $reviews[0];

		if(!empty($content->link_template) && file_exists(ACYMAILING_MEDIA.'plugins'.DS.'tagmosets_'.$content->link_template.'.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'tagmosets_'.$content->link_template.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields), $varFields, $result);
		}elseif(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'tagmosets_default.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'tagmosets_default.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields), $varFields, $result);
		}

		$result = $acypluginsHelper->removeJS($result);
		$result = $acypluginsHelper->managePicts($tag, $result);

		return $result;
	}

	function acymailing_replacetags(&$email, $send = true){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags), $this->tags, $email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags), $this->tags, $email->altbody);
		}
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$db = JFactory::getDBO();
		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, 'automosets');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)){
			return $return;
		}

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])){
				continue;
			}
			$allcats = explode('-', $parameter->id);

			//Load the articles based on all arguments...
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT DISTINCT a.`link_id` FROM `#__mt_links` as a LEFT JOIN `#__mt_cl` as b ON a.link_id = b.link_id';
			$where = array();
			if(!empty($selectedArea)){
				$where[] = 'b.`cat_id` IN ('.implode(',', $selectedArea).')';
			}

			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
				$condition = ' a.`link_created` >\''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
				if($parameter->filter == 'modify'){
					$condition .= ' OR a.`link_modified` > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
				}
				$where[] = $condition;
			}

			$where[] = 'a.`publish_up` < \''.date('Y-m-d H:i:s', $time - date('Z')).'\'';
			$where[] = 'a.`publish_down` > \''.date('Y-m-d H:i:s', $time - date('Z')).'\' OR `publish_down` = 0';
			$where[] = 'a.`link_published` = 1';

			//Only featured or standard events...
			if(!empty($parameter->featured)) $where[] = 'a.link_featured = 1';
			if(!empty($parameter->nofeatured)) $where[] = 'a.link_featured = 0';

			$query .= ' WHERE ('.implode(') AND (', $where).')';

			if(!empty($parameter->order)){
				if($parameter->order == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',', $parameter->order);
					$query .= ' ORDER BY `'.acymailing_secureField($ordering[0]).'` '.acymailing_secureField($ordering[1]);
				}
			}

			if(empty($parameter->max)) $parameter->max = 20;
			$start = empty($parameter->start) ? '' : intval($parameter->start).',';
			$query .= ' LIMIT '.$start.intval($parameter->max);

			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);

			if(!empty($parameter->min) && count($allArticles) < $parameter->min){
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough mosets listings for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles)){
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'automosets.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'automosets.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the article tag one after the other in a table as they are already sorted
					//$stringTag .= '<table>';
					$arrayElements = array();
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = 'mosets:'.$oneArticleId;
						if(!empty($parameter->link)) $args[] = 'link';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->readmore)) $args[] = 'readmore:'.$parameter->readmore;
						if(!empty($parameter->type)) $args[] = 'type:'.$parameter->type;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|', $args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements, $parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass
