<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingYooRecipe extends JPlugin
{
	var $cats = array();
	var $catvalues = array();
	var $newslanguage;
	var $readmore = '';
	var $tags = array();

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		$this->name = 'yoorecipe';
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new acyParameter( $plugin->params );
		}

		$this->db = JFactory::getDBO();
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_yoorecipe');
	}

	function acymailing_getPluginType(){
		$app = JFactory::getApplication();
	 	if(!$this->component_installed || ($this->params->get('frontendaccess') == 'none' && !$app->isAdmin())) return '';
		$onePlugin = new stdClass();
		$onePlugin->name = 'YooRecipe';
		$onePlugin->function = 'acymailing_'.$this->name.'_show';
		$onePlugin->help = 'plugin-'.$this->name;
		return $onePlugin;
	}

	function acymailing_yoorecipe_show(){
		$config = acymailing_config();

		if($config->get('version') < '4.9.3'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$app = JFactory::getApplication();

		$lang = JFactory::getLanguage();
		$lang->load('com_yoorecipe',JPATH_SITE);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.'.$this->name;

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order','a.id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir','asc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->filter_type = $app->getUserStateFromRequest( $paramBase.".filter_type", 'filter_type','','int' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id','string' );
		$pageInfo->contentorderdir = $app->getUserStateFromRequest( $paramBase.".contentorderdir", 'contentorderdir','DESC','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight','150','string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth','150','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->pictauto = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->readmoreauto = $app->getUserStateFromRequest( $paramBase.".readmoreauto", 'readmoreauto','1','string' );
		$pageInfo->wrap = $app->getUserStateFromRequest( $paramBase.".wrap", 'wrap','0','string' );
		$pageInfo->clickable = $app->getUserStateFromRequest( $paramBase.".clickable", 'clickable','1','string' );
		$pageInfo->clickableauto = $app->getUserStateFromRequest( $paramBase.".clickableauto", 'clickableauto','1','string' );

		//the query's start
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*, GROUP_CONCAT(c.title SEPARATOR ", ") AS cattitle FROM #__yoorecipe AS a JOIN #__yoorecipe_categories AS b ON a.id = b.recipe_id JOIN #__categories AS c ON c.id = b.cat_id ';

		//search fields...
		$searchFields = array('a.id','a.title','c.title');

		//apply search fields
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE ".$searchVal;
		}

		//only published content ?
		if($this->params->get('displaycontent','all') == 'onlypub') $filters[] = 'a.published = 1';

		//if the user filtered by category
		if(!empty($pageInfo->filter_cat)) $filters[] = 'a.cat_id = '.intval($pageInfo->filter_cat);

		//apply filters
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (',$filters).')';

		$query .= ' GROUP BY a.id ';

		//apply ordering
		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;

		$this->db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);

		//load results
		$rows = $this->db->loadObjectList();

		//yellow highlighting on search matches
		if(!empty($pageInfo->search)) $rows = acymailing_search($pageInfo->search,$rows);

		//pagination
		$this->db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $this->db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		//is this a Smart-Newsletter or a simple one ?
		$type = JRequest::getString('type');

	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass){
				var tmp = selectedContents.indexOf(contentid);
				if(tmp != -1){
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('catall').className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('catall').className = 'selectedrow';
						var key;
						for(key in selectedCat){
							if(isNaN(key)) continue;
							window.document.getElementById('cat'+key).className = rowClass;
							delete selectedCat[key];
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat'+catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				<?php
					//add the fields the user wants to be displayed
				?>
				for(var i=0; i < document.adminForm.cbdisplay.length; i++){
					if(!document.adminForm.cbdisplay[i].checked) continue;
					if(tmp == 0){
						tmp += 1;
						otherinfo += "| display:" + document.adminForm.cbdisplay[i].value;
					}else{
						otherinfo += ", " + document.adminForm.cbdisplay[i].value;
					}
				}

				<?php
					//is the title clickable ?
				?>
				for(i=0; i < document.adminForm.clickable.length; i++){
					 if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '0'){
						 otherinfo += '| nolink';
					 }
				}

				<?php
					//do we have to wrap the text ? (description for example...)
				?>
				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value)){
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				<?php
					//do we have to add a "read more" button ?
				?>
				for(i=0; i < document.adminForm.readmore.length; i++){
					if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '0'){
						otherinfo += '| noreadmore';
					}
				}

				<?php
					//picture management
				?>
				for(i=0; i < document.adminForm.pict.length; i++){
					if(!document.adminForm.pict[i].checked) continue;
				 	if(document.adminForm.pict[i].value != '1') otherinfo += '| pict:'+document.adminForm.pict[i].value;

					if(document.adminForm.pict[i].value == 'resized'){
						document.getElementById('pictsize').style.display = '';
						if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
						if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
					}else{
						document.getElementById('pictsize').style.display = 'none';
					}
				}

				for(i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{<?php echo $this->name; ?>:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto(){
				var otherinfo = '';
				var tmp=0;

				for(var i=0; i < document.adminForm.cbdisplayauto.length; i++){
					if(!document.adminForm.cbdisplayauto[i].checked) continue;
					if(tmp==0){
						tmp+=1;
						otherinfo += "| display:"+document.adminForm.cbdisplayauto[i].value;
					}else{
						otherinfo += ", "+document.adminForm.cbdisplayauto[i].value;
					}
				}

				for(i=0; i < document.adminForm.clickableauto.length; i++){
					if (document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '0'){
						 otherinfo += '| nolink';
					}
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value != 0 && !isNaN(document.adminForm.wrapauto.value)){
					otherinfo += "| wrap:"+document.adminForm.wrapauto.value;
				}

				for(i=0; i < document.adminForm.readmoreauto.length; i++){
					 if (document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '0'){
						 otherinfo += '| noreadmore';
					 }
				}

				for(i=0; i < document.adminForm.autopict.length; i++){
					if(!document.adminForm.autopict[i].checked) continue;
					if(document.adminForm.autopict[i].value != '1') otherinfo += '| pict:'+document.adminForm.autopict[i].value;

					if(document.adminForm.autopict[i].value == 'resized'){
						document.getElementById('pictsizeauto').style.display = '';
						if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidthauto.value;
						if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:'+document.adminForm.pictheightauto.value;
					}else{
						document.getElementById('pictsizeauto').style.display = 'none';
					}
				}

				<?php
					//on how many columns do we have to display the contents ?
				?>
				if(document.adminForm.cols.value){
					otherinfo += "| cols:"+document.adminForm.cols.value;
				}

				<?php
					//limit the number of content displayed
				?>
				if(document.adminForm.max_article.value){
					otherinfo += "| max:"+document.adminForm.max_article.value;
				}

				<?php
					//with what order will we display the contents
				?>
				if(document.adminForm.contentorder.value){
					otherinfo += "| order:"+document.adminForm.contentorder.value+","+document.adminForm.contentorderdir.value;
				}

				if(window.document.getElementById('jlang')  && window.document.getElementById('jlang').value != '')
				{
					otherinfo += '| lang:'+window.document.getElementById('jlang').value;
				}

				<?php if($type == 'autonews'){
					//minimum number of content for the newsletter to be displayed...
				?>
					if(document.adminForm.min_article.value){
						otherinfo += "| min:"+document.adminForm.min_article.value;
					}

					<?php
						//filter the content : only newly created/modified
					?>
					if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){
						otherinfo += "| filter:"+document.adminForm.contentfilter.value;
					}
				<?php }
					//insert the tag
				?>
				var tag = '{auto<?php echo $this->name; ?>:';
				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat+'-';
					}
				}
				tag += otherinfo+'}<br />';

				setTag(tag);
			}
		//-->
		</script>
<?php
		// yes/no for the options
		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// picture options
		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// options for the Nb. columns dropdown (1 to 10)
		$column = array();
		for($i=1;$i<11;$i++){
			$column[] = JHTML::_('select.option', "$i",$i);
		}

		$fieldsDisplay = array();
		$fieldsDisplay[] = array('title' => 'title', 'label' => 'ACY_TITLE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'image', 'label' => 'ACY_IMAGE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'description', 'label' => 'ACY_DESCRIPTION', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'direction', 'label' => 'COM_YOORECIPE_YOORECIPE_PREPARATION_LABEL', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'rating', 'label' => 'COM_YOORECIPE_RECIPE_NOTE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'price', 'label' => 'COM_YOORECIPE_YOORECIPE_MAX_PRICE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'video', 'label' => 'YouTube', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'cat', 'label' => 'TAG_CATEGORIES', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'author', 'label' => 'ACY_AUTHOR', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'season', 'label' => 'COM_YOORECIPE_YOORECIPE_SEASON_LABEL', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'difficulty', 'label' => 'COM_YOORECIPE_RECIPES_DIFFICULTY', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'cost', 'label' => 'COM_YOORECIPE_RECIPES_COST', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'ptime', 'label' => 'COM_YOORECIPE_RECIPES_PREPARATION_TIME', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'ctime', 'label' => 'COM_YOORECIPE_RECIPES_COOK_TIME', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'wtime', 'label' => 'COM_YOORECIPE_RECIPES_WAIT_TIME', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'tags', 'label' => 'TAGS', 'checked' => '');

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane( $this->name.'_tab');

		// start the first tab
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), $this->name.'_listings');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField){
						if($i == 5){
							echo '</tr><tr><td/>';
							$i = 1;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="'.$oneField['title'].'" id="'.$oneField['title'].'" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTag();"/><label style="margin-left:5px" for="'.$oneField['title'].'">'.trim(JText::_($oneField['label']), ':').'</label></td>';
						$i++;
					}
					while($i != 5){
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickable' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>

				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
						<label for="pictwidth"><?php echo JText::_('CAPTCHA_WIDTH') ?></label>
						<input id="pictwidth" name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <label for="pictheight"><?php echo JText::_('CAPTCHA_HEIGHT') ?></label>
						<input id="pictheight" name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td nowrap="nowrap" width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>"  type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th></th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="4">
						<?php
							echo $pagination->getListFooter();
							if(ACYMAILING_J30){
								$paginationNb = array();
								foreach(array(5,10,15,20,25,30,50,100) as $oneOption){
									$paginationNb[] = JHTML::_('select.option', $oneOption, $oneOption);
								}
								$paginationNb[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
								echo 'Display #'.JHTML::_('select.genericlist', $paginationNb, 'limit' , 'size="1" style="width:60px" onchange="Joomla.submitform();"', 'value', 'text', $pageInfo->limit->value).'<br />';
							}
							echo $pagination->getResultsCounter();
						?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					if(!empty($rows)){
						foreach($rows as $row){
				?>
							<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
								<td class="acytdcheckbox"></td>
								<td style="text-align:center;">
									<?php
										if(!empty($row->title)) echo $row->title;
									?>
								</td>
								<td style="text-align:center;">
									<?php
										if(!empty($row->cattitle)) echo $row->cattitle;
									?>
								</td>
								<td style="text-align:center;">
									<?php
										echo $row->id;
									?>
								</td>
							</tr>
				<?php
							// this enables to know if we have to set the line background grey or white
							$k = 1-$k;
						}
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />

		<?php
			echo $tabs->endPanel();
			// start category tab
			echo $tabs->startPanel( JText::_('TAG_CATEGORIES'), $this->name.'_auto');
		?>

		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField){
						if($i%5 == 0){
							echo '</tr><tr><td/>';
							$i++;
						}
						if($i == 4){
							$jflanguages = acymailing_get('type.jflanguages');
							$jflanguages->onclick = 'onchange="updateTagAuto();"';
							$jflanguages->jid = 'jlang';
							echo '<td>'.$jflanguages->displayJLanguages('jlang').'</td></tr><tr><td/>';
							$i += 2;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="'.$oneField['title'].'" id="'.$oneField['title'].'auto" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneField['title'].'auto">'.JText::_($oneField['label']).'</label></td>';
						$i++;
					}
					while($i%5 != 0){
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickableauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
					<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br />
						<label for="pictwidthauto"><?php echo JText::_('CAPTCHA_WIDTH') ?></label>
						<input id="pictwidthauto" name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <label for="pictheightauto"><?php echo JText::_('CAPTCHA_HEIGHT') ?></label>
						<input id="pictheightauto" name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" nowrap="nowrap">
					<label for="max_article"><?php echo JText::_('MAX_ARTICLE'); ?></label>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <input type="text" id="max_article" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td nowrap="nowrap">
					<?php
						$values = array('id' => 'ACY_ID', 'creation_date' => 'CREATED_DATE', 'note' => 'COM_YOORECIPE_RECIPE_NOTE', 'title' => 'FIELD_TITLE');
						echo $this->acypluginsHelper->getOrderingField($values, $pageInfo->contentorder, $pageInfo->contentorderdir);
					?>
				</td>
			</tr>
			<?php if($type == 'autonews'){ ?>
			<tr>
				<td nowrap="nowrap">
					<label for="min_article"><?php echo JText::_('MIN_ARTICLE'); ?></label>
				</td nowrap="nowrap">
				<td nowrap="nowrap" colspan="2">
					<input type="text" id="min_article" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td>
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('JOOMEXT_FILTER'); ?>
				</td>
				<td nowrap="nowrap" colspan="4">
				 	<?php $filter = acymailing_get('type.contentfilter'); $filter->onclick = 'updateTagAuto();'; echo $filter->display('contentfilter',$pageInfo->contentfilter,false); ?>
				</td>
			</tr>
			<?php }else{ ?>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap" colspan="4">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<tr id="catall" class="<?php echo "row0"; ?>" onclick="applyAuto('all','<?php echo "row0" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td><?php echo JText::_('ACY_ALL'); ?></td>
			</tr>
			<?php
				$k = 1;
				if(!empty($this->catvalues)){
					foreach($this->catvalues as $oneCat){
						if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
			<?php
						$k = 1 - $k;
					}
				}
			?>
		</table>
<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	 }

	private function _categories($filter_cat){
		//select all cats
		$this->db->setQuery('SELECT id, parent_id, title FROM #__categories WHERE extension = "com_yoorecipe" ORDER BY id ASC');
		$cats = $this->db->loadObjectList();
		if(!empty($cats)){
			foreach($cats as $oneCat){
				$this->cats[$oneCat->parent_id][] = $oneCat;
			}
		}

		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		$this->_handleChildren();
		return JHTML::_('select.genericlist',$this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	private function _handleChildren($parent_id = 1, $level = 0){
		if(empty($this->cats[$parent_id])) return;
		foreach($this->cats[$parent_id] as $cat){
			$this->catvalues[] = JHTML::_('select.option', $cat->id,str_repeat(" - - ",$level).$cat->title);
			$this->_handleChildren($cat->id,$level+1);
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	private function _replaceOne(&$email){
		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, $this->name);
		if(empty($tags)) return;

		$lang = JFactory::getLanguage();
		$lang->load('com_yoorecipe',JPATH_SITE);
		$lang->load('com_yoorecipe',JPATH_ADMINISTRATOR);

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$tagsReplaced = array();
		foreach($tags as $i => $oneTag){
			if(isset($tagsReplaced[$i])) continue;
			$tagsReplaced[$i] = $this->_replaceContent($oneTag);
		}

		$this->acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}

	private function _replaceContent(&$tag){
		$app = JFactory::getApplication();

	 	// extract the fields selected
		if(!empty($tag->display)){
			$tag->display = explode(',',$tag->display);

			foreach($tag->display as $i => $oneDisplay){
				$oneDisplay = trim($oneDisplay);
				$tag->$oneDisplay = true;
			}
		}

		// load content
		$this->db->setQuery('SELECT a.*, GROUP_CONCAT(CONCAT(c.id, ",acy,", c.title) SEPARATOR "|") AS categories, u.name
							FROM #__yoorecipe AS a
							JOIN #__yoorecipe_categories AS b ON a.id = b.recipe_id
							JOIN #__categories AS c ON c.id = b.cat_id
							LEFT JOIN #__users AS u ON a.created_by = u.id
							WHERE a.id = '.intval($tag->id).'
							GROUP BY a.id LIMIT 1');
		$content = $this->db->loadObject();

		//In case of we could not load the article for any reason...
		if(empty($content)){
			if($app->isAdmin()) $app->enqueueMessage('The content "'.$tag->id.'" could not be loaded','notice');
			return '';
		}

		$varFields = array();
		foreach($content as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		// create the link for the title and the read more button
		$link = 'index.php?option=com_yoorecipe&view=recipe&id='.$tag->id;
		if(!empty($tag->itemid)) $link .= '&Itemid='.$tag->itemid;
		$link = acymailing_frontendLink($link);
		$varFields['{link}'] = $link;

		$result = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">';

		// display the title
		if(!empty($tag->title) && !empty($content->title)){
			$result .= '<tr><td colspan="2"><h2 class="acymailing_title">';
			if(empty($tag->nolink)) $result .= '<a href="'.$link.'">';
			$result .= $content->title;
			if(!empty($tag->price) && !empty($content->price)) $result .= ' <span class="yooprice">'.$content->price.JComponentHelper::getParams('com_yoorecipe')->get('currency').'</span>';
			if(empty($tag->nolink)) $result .= '</a>';
			$result .= '</h2></td></tr>';
		}

		if(!empty($tag->author) && !empty($content->name)) $result .= '<tr class="yoorow yooauthor"><td colspan="2">'.JText::_('COM_YOORECIPE_BY').' <a href="index.php?option=com_yoorecipe&view=recipes&layout=chef&id='.$content->created_by.'">'.$content->name.'</a></td></tr>';

		if((!empty($tag->image) && !empty($content->picture)) || (!empty($tag->description) && !empty($content->description))){
			$result .= '<tr class="yoorow yoodescription"><td colspan="2">';
			if(!empty($tag->image) && !empty($content->picture)){
				$varFields['{image}'] = '<img src="'.$content->picture.'" alt="" style="float:left;" />';
				$result .= $varFields['{image}'];
			}
			if(!empty($tag->description) && !empty($content->description)) $result .= $this->acypluginsHelper->wrapText($content->description, $tag);
			$result .= '</td></tr>';
		}
		if(!empty($tag->direction) && !empty($content->preparation)) $result .= '<tr class="yoorow yoodirection"><td colspan="2">'.JText::_('COM_YOORECIPE_YOORECIPE_PREPARATION_LABEL').':<br/>'.$this->acypluginsHelper->wrapText($content->preparation, $tag).'</td></tr>';

		// display the category
		if(!empty($tag->cat)){
			$categories = explode('|', $content->categories);
			$result .= '<tr class="yoorow yoocategories"><td class="yoofirstcell">'.JText::_('TAG_CATEGORIES').'</td><td class="yoosecondcell">';
			$arrayCats = array();
			foreach($categories as $oneCat){
				$thiscat = explode(',acy,', $oneCat);
				$arrayCats[] = '<a href="index.php?option=com_yoorecipe&view=categories&id='.$thiscat[0].'">'.$thiscat[1].'</a>';
			}
			$varFields['{categories}'] = implode(', ', $arrayCats);
			$result .= $varFields['{categories}'].'</td></tr>';
		}

		if(!empty($tag->season)){
			$this->db->setQuery('SELECT month_id FROM #__yoorecipe_seasons WHERE recipe_id = '.intval($tag->id));
			$seasons = acymailing_loadResultArray($this->db);
			if(!empty($seasons)){
				$result .= '<tr class="yoorow yooseason"><td class="yoofirstcell">'.JText::_('COM_YOORECIPE_SEASONS').'</td><td class="yoosecondcell">';
				$arraySeasons = array();
				foreach($seasons as $oneSeasons){
					$arraySeasons[] = '<a href="index.php?option=com_yoorecipe&view=recipes&layout=seasons&month_id='.$oneSeasons.'">'.JText::_('COM_YOORECIPE_'.$oneSeasons).'</a>';
				}
				$varFields['{seasons}'] = implode(', ', $arraySeasons);
				$result .= $varFields['{seasons}'].'</td></tr>';
			}
		}

		if(!empty($tag->rating) && !empty($content->note)) $result .= '<tr class="yoorow yoorate"><td class="yoofirstcell">'.JText::_('COM_YOORECIPE_RECIPE_NOTE').'</td><td class="yoosecondcell">'.$content->note.'/5</td></tr>';
		if(!empty($tag->video) && !empty($content->video)){
			$varFields['{youtube}'] = '<a href="https://www.youtube.com/watch?v='.$content->video.'"><img src="media/com_acymailing/images/video.png" alt="Youtube" /></a>';
			$result .= '<tr class="yoorow yoovideo"><td colspan="2">'.$varFields['{youtube}'].'</td></tr>';
		}

		if(!empty($tag->ptime)) $result .= '<tr class="yoorow yoopreparation"><td class="yoofirstcell">'.JText::_('COM_YOORECIPE_RECIPES_PREPARATION_TIME').'</td><td class="yoosecondcell">'.$content->preparation_time.' '.JText::_('ACY_MINUTES').'</td></tr>';
		if(!empty($tag->ctime)) $result .= '<tr class="yoorow yoocooking"><td class="yoofirstcell">'.JText::_('COM_YOORECIPE_RECIPES_COOK_TIME').'</td><td class="yoosecondcell">'.$content->cook_time.' '.JText::_('ACY_MINUTES').'</td></tr>';
		if(!empty($tag->wtime)) $result .= '<tr class="yoorow yoowaiting"><td class="yoofirstcell">'.JText::_('COM_YOORECIPE_RECIPES_WAIT_TIME').'</td><td class="yoosecondcell">'.$content->wait_time.' '.JText::_('ACY_MINUTES').'</td></tr>';

		if(!empty($tag->difficulty) && !empty($content->difficulty)){
			$varFields['{difficultyimages}'] = str_repeat('<img src="media/com_yoorecipe/images/star-icon.png" alt="" />', intval($content->difficulty));
			$result .= '<tr class="yoorow yoodifficulty"><td class="yoofirstcell">'.JText::_('COM_YOORECIPE_RECIPES_DIFFICULTY').'</td><td class="yoosecondcell">'.$varFields['{difficultyimages}'].'</td></tr>';
		}
		if(!empty($tag->cost) && !empty($content->cost)){
			$varFields['{costimages}'] = str_repeat('<img src="media/com_yoorecipe/images/star-icon.png" alt="" />', intval($content->cost));
			$result .= '<tr class="yoorow yoocost"><td class="yoofirstcell">'.JText::_('COM_YOORECIPE_RECIPES_COST').'</td><td class="yoosecondcell">'.$varFields['{costimages}'].'</td></tr>';
		}

		if(!empty($tag->season)){
			$this->db->setQuery('SELECT tag_value FROM #__yoorecipe_tags WHERE recipe_id = '.intval($tag->id));
			$tags = acymailing_loadResultArray($this->db);
			if(!empty($tags)){
				$result .= '<tr class="yoorow yootags"><td class="yoofirstcell">'.JText::_('COM_YOORECIPE_TAGS').'</td><td class="yoosecondcell">';
				$arrayTags = array();
				foreach($tags as $oneTag){
					$arrayTags[] = '<a href="index.php?option=com_yoorecipe&view=recipes&layout=tags&value='.$oneTag.'">'.$oneTag.'</a>';
				}
				$varFields['{tags}'] = implode(', ', $arrayTags);
				$result .= $varFields['{tags}'].'</td></tr>';
			}
		}

		$varFields['{readmore}'] = '<a class="readmore_link" style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a>';
		if(empty($tag->noreadmore)) $result .= '<tr><td>'.$varFields['{readmore}'].'</td></tr>';

		$result .= '</table></div>';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}

		// always remove JS, there is no JS in newsletters...
		$result = $this->acypluginsHelper->removeJS($result);

		//resize or remove pictures
		$result = $this->acypluginsHelper->managePicts($tag, $result);

		return $result;
	}

	private function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$this->acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function acymailing_generateautonews(&$email){
		$time = time();

		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email,'auto'.$this->name);
		$return = new stdClass();
		$return->status = true;
		$return->message = '';

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;
			$allcats = explode('-',$parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT DISTINCT a.id FROM #__yoorecipe AS a JOIN #__yoorecipe_categories AS b ON a.id = b.recipe_id ';

			$where = array();

			// load only needed content
			if(!empty($selectedArea)) $where[] = 'b.cat_id IN ('.implode(',',$selectedArea).')';

			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
				$condition = '(`publish_up` > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\' AND `publish_up` < \''.date('Y-m-d H:i:s',$time - date('Z')).'\')';
				$condition .= ' OR (`creation_date` > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\' AND `creation_date` < \''.date('Y-m-d H:i:s',$time - date('Z')).'\')';

				$where[] = $condition;
			}

			// Only published content
			if(empty($parameter->unpublished)) $where[] = 'a.published = 1';
			if(empty($parameter->invalid)) $where[] = 'a.validated = 1';
			if(!empty($parameter->featured)) $where[] = 'a.featured = 1';
			if(!empty($parameter->nofeatured)) $where[] = 'a.featured = 0';
			if(!empty($parameter->lang)) $where[] = 'a.language = '.$this->db->Quote($parameter->lang);

			// Apply filters
			if(!empty($where)) $query .= ' WHERE ('.implode(') AND (',$where).')';

			// Ordering
			if(!empty($parameter->order)){
				$ordering = explode(',',$parameter->order);
				if($ordering[0] == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			$start = '';
			if(!empty($parameter->start)) $start = intval($parameter->start).',';
			if(empty($parameter->max)) $parameter->max = 20;
			//We add a limit for the preview otherwise we could break everything
			$query .= ' LIMIT '.$start.intval($parameter->max);


			// load content IDs
			$this->db->setQuery($query);
			$allArticles = acymailing_loadResultArray($this->db);

			// Check the number of results
			if(!empty($parameter->min) && count($allArticles) < $parameter->min){
				//We will not generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough '.$this->name.' content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles)){
				// If the user created its own template...
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
					$arrayElements = array();
					unset($parameter->id);
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = $this->name.':'.$oneArticleId;
						foreach($parameter as $oneParam => $val){
							if(is_bool($val)) $args[] = $oneParam;
							else $args[] = $oneParam.':'.$val;
						}
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $this->acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass
?>